"""

Dussan Service Object

"""

import _RootObject, _Utils
import _InitTypes

class DusService(_RootObject.RootObject):
    table_name = 'dus_services'
    field_name = 'service_id'
    item_type_id = _InitTypes.ITEM_TYPE_DUSSERVICE
    is_container = 0
    object_fields = {
'service_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'language_set':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'unit_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'unit_price':	{ 'type': _Utils.sql_cast_float,	'simple_type': float,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'unit_count':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'service_flags':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'service_article':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['description']

    def get_name(self):
        if self.get('description') is not None:
            return self.get('description')
        else:
            return "N/A"

