# Exceptions.
# $Id: _Exceptions.py,v 1.2 2004/02/18 11:30:36 incxcvs Exp $

import exceptions

class BaseError(exceptions.StandardError):
    pass

###
# Core errors
###

class PleaseAuthenticate(BaseError):
    pass

class SystemExpired(BaseError):
    pass

class InvalidVariable(BaseError):
    pass

class RootObjectError(BaseError):
    pass

class AccessError(BaseError):
    pass

class IndexerError(BaseError):
    pass

class RequestError(BaseError):
    pass

###
# Object errors
###

class OrganizationError(BaseError):
    pass

class FolderError(BaseError):
    pass

class DocumentError(BaseError):
    pass

###
# Component errors
###

class AdminError(BaseError):
    pass

class CalendarError(BaseError):
    pass

###
# DAV
###

class DAV_noshow(BaseError):
    pass

class DAV_notimpl(BaseError):
    pass

