import _Conf, _Utils, urllib, cStringIO, _Indexer

def get_object_edit_fields(REQUEST, obj, index):
    obj_id = obj.get_id()
    toporg_id = obj.get_top_parent().get_id()
    type_id = obj.get('item_type_id')
    SQL = "SELECT f.field_id, f.field_name, r.contents from custom_fields f left join custom_rows r on f.field_id=r.field_id and r.item_id=%d where f.toporg_id=%d and f.item_type_id=%d order by priority asc""" % (obj_id, toporg_id, type_id)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchall()
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    ndx = 0
    while(1):
        try:
            row = res[ndx]
            field_1 = _Utils.html_quote_show(row['field_name'].decode('UTF8'))
            if field_1:
                field_1 = field_1 + ":"
            val_1 = """<INPUT type="text" class="textfield4" name="custom_%s" value="%s">""" % (row['field_id'], _Utils.html_quote_edit((row['contents'] or "").decode('UTF8')))
        except:
            break

        ndx = ndx + 1

        try:
            row = res[ndx]
            field_2 = _Utils.html_quote_show(row['field_name'].decode('UTF8'))
            if field_2:
                field_2 = field_2 + ":"
            val_2 = """<INPUT type="text" class="textfield4" name="custom_%s" value="%s">""" % (row['field_id'], _Utils.html_quote_show((row['contents'] or "").decode('UTF8')))
        except:
            field_2 = "&nbsp;"
            val_2 = "&nbsp;"

        ndx = ndx + 1
        if index%2==0:
            td_class = 1
        else:
            td_class = 0

        output.append(u"""
  <TR>
    <TD class="td_listing%(td_class)ske" nowrap>%(field_1)s</TD>
    <TD class="td_listing%(td_class)sve">%(val_1)s</TD>
    <TD class="td_listing%(td_class)ske" nowrap>%(field_2)s</TD>
    <TD class="td_listing%(td_class)sve">%(val_2)s</TD>
    <TD class="td_listing%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
""" % locals())
        index = index + 1
    return "\n".join(output)

def get_object_search_fields(REQUEST, toporg_id, type_id, index):
    SQL = "SELECT f.field_id, f.field_name from custom_fields f where f.toporg_id=%d and f.item_type_id=%d order by priority asc""" % (toporg_id, type_id)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchall()
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    ndx = 0
    while(1):
        try:
            row = res[ndx]
            field_1 = _Utils.html_quote_show(row['field_name'].decode('UTF8'))
            val_1 = """<INPUT type="text" class="textfield4" name="custom_%s" value="">""" % row['field_id']
            if field_1:
                field_1 = field_1 + ":"
        except:
            break

        ndx = ndx + 1

        try:
            row = res[ndx]
            field_2 = _Utils.html_quote_show(row['field_name'].decode('UTF8'))
            val_2 = """<INPUT type="text" class="textfield4" name="custom_%s" value="">""" % row['field_id']
            if field_2:
                field_2 = field_2 + ":"
        except:
            field_2 = "&nbsp;"
            val_2 = "&nbsp;"

        ndx = ndx + 1
        if index%2==0:
            td_class = 1
        else:
            td_class = 0

        output.append(u"""
  <TR>
    <TD class="td_listing%(td_class)ske" nowrap>%(field_1)s</TD>
    <TD class="td_listing%(td_class)sve">%(val_1)s</TD>
    <TD class="td_listing%(td_class)ske" nowrap>%(field_2)s</TD>
    <TD class="td_listing%(td_class)sve">%(val_2)s</TD>
    <TD class="td_listing%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
""" % locals())
        index = index + 1
    return "\n".join(output)

def get_object_show_fields(REQUEST, obj, index):
    obj_id = obj.get_id()
    toporg_id = obj.get_top_parent().get_id()
    type_id = obj.get('item_type_id')
    SQL = "SELECT f.field_id, f.field_name, r.contents from custom_fields f left join custom_rows r on f.field_id=r.field_id and r.item_id=%d where f.toporg_id=%d and f.item_type_id=%d order by priority asc""" % (obj_id, toporg_id, type_id)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchall()
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    ndx = 0
    while(1):
        try:
            row = res[ndx]
            field_1 = _Utils.html_quote_show(row['field_name'].decode('UTF8')) + ":"
            val_1 = _Utils.html_quote_show((row['contents'] or "&nbsp;").decode('UTF8'))
        except:
            break

        ndx = ndx + 1

        try:
            row = res[ndx]
            field_2 = _Utils.html_quote_show(row['field_name'].decode('UTF8')) + ":"
            val_2 = _Utils.html_quote_show((row['contents'] or "&nbsp;").decode('UTF8'))
        except:
            field_2 = "&nbsp;"
            val_2 = "&nbsp;"

        ndx = ndx + 1
        if index%2==0:
            td_class = 1
        else:
            td_class = 0

        output.append(u"""
  <TR>
    <TD class="td_listing%(td_class)skv" nowrap>%(field_1)s</TD>
    <TD class="td_listing%(td_class)svv">%(val_1)s</TD>
    <TD class="td_listing%(td_class)skv" nowrap>%(field_2)s</TD>
    <TD class="td_listing%(td_class)svv">%(val_2)s</TD>
    <TD class="td_listing%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
""" % locals())
        index = index + 1
    return "\n".join(output)


def save_custom_vals(REQUEST, item_id):
    save_ids = []
    ftifp = None
    for key in REQUEST.form.keys():
        if key[:7] == 'custom_':
            try:
                save_ids.append([int(key[7:]), REQUEST.form[key].value.strip()])
            except:
                pass
    DEL_SQL = "DELETE FROM custom_rows where item_id=%d" % item_id
    REQUEST.db.execute(DEL_SQL)
    for row in save_ids:
        INSERT_SQL = "INSERT INTO custom_rows (item_id, field_id, contents) values (%d, %d, %s)" % (item_id, row[0], _Utils.sql_quote(row[1]))
        REQUEST.db.execute(INSERT_SQL)
        # Update metadata indexes
        ftifp = cStringIO.StringIO()
    for row in save_ids:
        val = row[1].decode('UTF8')
        if val and isinstance(val, unicode):
            ftifp.write(val.encode('UTF8') + ' ')
        elif val and isinstance(val, int):
            ftifp.write(str(val) + ' ')
        elif val and isinstance(val, float):
            ftifp.write(str(val) + ' ')
    if ftifp:
        ftifp.seek(0)
        _Indexer.index_file(REQUEST, ftifp, 'a.txt', item_id, ftitype='true')
        ftifp.close()
        del ftifp


def get_listing(REQUEST, item_type_id, toporg_id, menu, returl):
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    tls_priority = REQUEST.TLS('tls_priority')
    tls_fieldname = REQUEST.TLS('custom_fieldname')
    tls_add = REQUEST.TLS('custom_addfield')
    tls_fieldlist = REQUEST.TLS('custom_fieldlist')
    tls_reorder = REQUEST.TLS('custom_changepri')
    pri = 0
    if REQUEST.form.has_key('pri') and REQUEST.form.has_key('field_id') and REQUEST.form['field_id'].value.strip():
        pri = 1
        pri_field_id = int(REQUEST.form['field_id'].value.strip())
    output.append("""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_fieldlist)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1b" nowrap>%(tls_fieldname)s</TD>
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD class="td_listing1b" nowrap>%(tls_priority)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    SQL = "SELECT field_id, priority, field_name, item_type_id from custom_fields where toporg_id=%d and item_type_id=%d order by priority asc" % (toporg_id, item_type_id)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
        index = index + 1
        if index%2<>0:
            td_class = "0"
        else:
            td_class = "1"
        field_name = row['field_name'].decode('UTF8')
        field_id = row['field_id']
        priority = row['priority']
        item_type_id = row['item_type_id']
        link = u"""<a href="%scontact_fields.py/edit_field?field_id=%d&menu=%s&returl=%s">%s</a>""" % (_Conf.BASE_CONTACT_URL, field_id, menu, returl, field_name)
        if pri and pri_field_id==field_id:
            priority_link = u"""<select class="priority_select" name="sort" onchange="document.location='%scontact_fields.py/swap?item_type_id=%d&returl=%s&old_pri=%d&new_pri='+this.value">""" % (_Conf.BASE_CONTACT_URL, item_type_id, returl, priority)
            SQL = "SELECT priority from custom_fields where toporg_id=%d and item_type_id=%d order by priority asc" % (toporg_id, item_type_id)
            REQUEST.db.execute(SQL)
            dbres = REQUEST.db.fetchall()
            for dbrow in dbres:
                sel = ""
                if dbrow[0]==priority:
                    sel = " SELECTED "
                priority_link = priority_link + u"""<option value="%d"%s>%d</option>""" % (dbrow[0], sel, dbrow[0])
            priority_link = priority_link + u"&nbsp;%s" % priority
        else:
            priority_link = u"""<a href="%s?pri=1&field_id=%d&menu=%s&returl=%s&item_type_id=%d"><img src="%ssort.gif" title="%s" width="11" height="11" border="0" alt=""></a>&nbsp;%s""" % (urllib.unquote(returl), field_id, menu, returl, item_type_id, _Conf.BASE_ICON_URL, tls_reorder, priority)
        
        output.append(u"""
  <TR>
    <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing%(td_class)s" nowrap>%(link)s</TD>
    <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height=1 border=0 alt=""></TD>
    <TD class="td_listing%(td_class)s" align="center" nowrap>%(priority_link)s</TD>
    <TD class="td_listing%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    
    index = index + 1
    if index%2<>0:
        td_class = "0"
    else:
        td_class = "1"
    output.append(u"""
  <TR>
    <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing%(td_class)s" colspan="3" nowrap><input class="input2" type="button" value="%(tls_add)s" onclick="document.location='%(BASE_CONTACT_URL)scontact_fields.py/add_field?item_type_id=%(item_type_id)s&menu=%(menu)s&returl=%(returl)s'"></TD>
    <TD class="td_listing%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>"""%locals())
    return "\n".join(output)


def get_custom_search_query(REQUEST, item_type_id):
    toporg_id = REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id()
    search_fields = []
    for key in REQUEST.form.keys():
        if key[:7] == 'custom_' and REQUEST.form[key].value.decode('UTF8').strip():
            search_fields.append(" exists(select cr.field_id from custom_rows cr where cr.item_id=i.item_id and cr.field_id=%d and lower(cr.contents) like '%%%s%%') " % (int(key[7:]), _Utils.sql_quote_simple(REQUEST.form[key].value.decode('UTF8').strip().lower())))
    if search_fields:
        search_fields = u" AND %s " % "AND".join(search_fields)
    else:
        search_fields = u""
    return search_fields