import _Conf, standard_html
from Menus import get_admin_menu

MY_MENU_ID = 5

def index(REQUEST):
    ns = {'BASE_URL':_Conf.BASE_URL, 'BASE_WEB_URL':_Conf.BASE_WEB_URL, 'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'form_params':REQUEST.get_formstring()}
    ns['app_name'] = _Conf.APP_NAME
    return """\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN"
   "http://www.w3.org/TR/html4/frameset.dtd">
<HTML>
  <HEAD>
    <TITLE>%(app_name)s</TITLE>
    <LINK rel="stylesheet" href="%(BASE_URL)sconflux.css">
  </HEAD>
<FRAMESET rows="30, *" BORDER=0>
  <FRAME name="framemenu" src="%(BASE_ADMIN_URL)saccessframe.py/index3" frameborder="0" scrolling="no">
  <FRAME name="framebody" src="%(BASE_ADMIN_URL)saccessframe.py/index2%(form_params)s" frameborder="0">
  <NOFRAMES>
    This document requires a browser that supports frames.
  </NOFRAMES>
</FRAMESET>
</HTML>""" % ns

def index2(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    ns = {'BASE_URL':_Conf.BASE_URL, 'BASE_WEB_URL':_Conf.BASE_WEB_URL, 'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'form_params':REQUEST.get_formstring()}
    ns['app_name'] = _Conf.APP_NAME
    return """\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN"
   "http://www.w3.org/TR/html4/frameset.dtd">
<HTML>
  <HEAD>
    <TITLE>%(app_name)s</TITLE>
    <LINK rel="stylesheet" href="%(BASE_URL)sconflux.css">
  </HEAD>
<FRAMESET cols="35%%, 65%%" BORDER=0>
  <FRAME name="frametree" src="%(BASE_ADMIN_URL)saccesstree.py%(form_params)s" frameborder="0">
  <FRAME name="framecontents" src="%(BASE_WEB_URL)sempty.html" frameborder="0">
  <NOFRAMES>
    This document requires a browser that supports frames.
  </NOFRAMES>
</FRAMESET>
</HTML>""" % ns

def index3(REQUEST):
    output = []
    ns = {'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL}
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

