import standard_html, _Access, _InitTypes, _Conf, Menus, _Utils
import mx.DateTime

MY_MENU_ID = 4

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL  = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_reports = "REPORTS"
    tls_chooseperiod = "PLAESE CHOOSE REPORT PERIOD"
    tls_fromto_from = "FROM:"
    tls_fromto_to = "TO:"
    tls_show = "SHOW"

    now = mx.DateTime.now()   
    if not REQUEST.form.has_key('rep_date_start') or not REQUEST.form['rep_date_start'].value:
        dt1 = REQUEST.iso2userdate(now - mx.DateTime.DateTimeDelta(7+now.day_of_week))
    else:
        dt1 = REQUEST.form['rep_date_start'].value
    if not REQUEST.form.has_key('rep_date_end') or not REQUEST.form['rep_date_end'].value:
        dt2 = REQUEST.iso2userdate(now - mx.DateTime.DateTimeDelta(1+now.day_of_week))
    else:
        dt2 = REQUEST.form['rep_date_end'].value



    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""
<FORM method="POST" action="%(BASE_ADMIN_URL)sadm_reports.py">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD><span class="t3">%(tls_reports)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD nowrap class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD nowrap class="td_listing1">%(tls_chooseperiod)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD nowrap class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD nowrap class="td_listing0">
    %(tls_fromto_from)s <INPUT size="10" value="%(dt1)s" type="text" class="textfield1" name="rep_date_start" id="rep_date_start" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('rep_date_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A> 
    %(tls_fromto_to)s   <INPUT size="10" value="%(dt2)s" type="text" class="textfield1" name="rep_date_end" id="rep_date_end" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('rep_date_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A>
  </TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD nowrap class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD nowrap class="td_listing1"><input type="submit" name="show" value="%(tls_show)s" class="input2"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    if REQUEST.form.has_key('show'):
       output.append(u"""kala""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
