from mod_python import apache

import mx.DateTime
import standard_html, _calendar
import _Event, _InitTypes, _Conf, _Access, _Utils, _Resource, relations, _mail, _eventlib
import urllib
import base64, cPickle
from Menus import get_calendar_menu

MY_MENU_ID=3


def index(REQUEST):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        returl = """<input name="returl" type="hidden" value="%s">""" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""
    rel_contact_id = ""
    if REQUEST.form.has_key('rel_contact_id') and REQUEST.form['rel_contact_id']:
      rel_contact_id = int(REQUEST.form['rel_contact_id'])
    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None
    try:
        show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        show_resources = None
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None


    tls_sendrelated = REQUEST.TLS('cal_sendrelated')
    tls_addevent = REQUEST.TLS('cal_addevent')
    tls_subject = REQUEST.TLS('tls_title')
    tls_activity = REQUEST.TLS('cal_showas')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_save = REQUEST.TLS('tls_save')
    tls_email = REQUEST.TLS('tls_email')
    tls_sms = REQUEST.TLS('tls_sms')
    tls_starttime = REQUEST.TLS('cal_starttime')
    tls_endtime = REQUEST.TLS('cal_endtime')
    tls_startdate = REQUEST.TLS('cal_startdate')
    tls_enddate = REQUEST.TLS('cal_enddate')
    tls_desc = REQUEST.TLS('tls_description')
    tls_private = REQUEST.TLS('tls_private')
    tls_remind = REQUEST.TLS('cal_reminder')
    tls_remindtime = REQUEST.TLS('cal_remindtime')
    tls_reptyp = REQUEST.TLS('cal_repeattype')
    tls_repint = REQUEST.TLS('cal_repeatinterval')
    tls_repweek = REQUEST.TLS('cal_repweek')
    tls_repmonth = REQUEST.TLS('cal_repmonth')
    tls_repyear = REQUEST.TLS('cal_repyear')
    tls_onthe = REQUEST.TLS('cal_onthe')
    tls_repmonthstr = REQUEST.TLS('cal_repmonthstr')
    tls_dayof = REQUEST.TLS('cal_dayof')
    tls_every = REQUEST.TLS('cal_every')
    tls_mon = REQUEST.TLS('day_monday')
    tls_tue = REQUEST.TLS('day_tuesday')
    tls_wed = REQUEST.TLS('day_wednesday')
    tls_thu = REQUEST.TLS('day_thursday')
    tls_fri = REQUEST.TLS('day_friday')
    tls_sat = REQUEST.TLS('day_saturday')
    tls_sun = REQUEST.TLS('day_sunday')
    tls_minutes = REQUEST.TLS('cal_minutes')
    tls_doesnot = REQUEST.TLS('cal_doesnotrepeat')
    tls_daily = REQUEST.TLS('cal_daily')
    tls_monthly = REQUEST.TLS('cal_monthly')
    tls_weekly = REQUEST.TLS('cal_weekly')
    tls_yearly = REQUEST.TLS('cal_yearly')
    tls_dayevery = REQUEST.TLS('cal_dayevery')
    tls_weekevery = REQUEST.TLS('cal_weekevery')
    tls_monthevery = REQUEST.TLS('cal_monthevery')
    tls_yearevery = REQUEST.TLS('cal_yearevery')
    tls_off = REQUEST.TLS('cal_off')
    tls_1 = REQUEST.TLS('tls_month_1')
    tls_2 = REQUEST.TLS('tls_month_2')
    tls_3 = REQUEST.TLS('tls_month_3')
    tls_4 = REQUEST.TLS('tls_month_4')
    tls_5 = REQUEST.TLS('tls_month_5')
    tls_6 = REQUEST.TLS('tls_month_6')
    tls_7 = REQUEST.TLS('tls_month_7')
    tls_8 = REQUEST.TLS('tls_month_8')
    tls_9 = REQUEST.TLS('tls_month_9')
    tls_10 = REQUEST.TLS('tls_month_10')
    tls_11 = REQUEST.TLS('tls_month_11')
    tls_12 = REQUEST.TLS('tls_month_12')
    tls_onday = REQUEST.TLS('cal_onday')
    tls_onweek = REQUEST.TLS('cal_onweek')
    tls_onmonth = REQUEST.TLS('cal_onmonth')
    tls_onyear = REQUEST.TLS('cal_onyear')
    tls_resources = REQUEST.TLS('tls_resources')
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    REQ_FIELD = _Conf.REQ_FIELD
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_relgroups = REQUEST.TLS('cal_inviteg')
    tls_show_rels = REQUEST.TLS('cal_show_rels')
    tls_hide_rels = REQUEST.TLS('cal_hide_rels')
    div_help = REQUEST.TLS('cal_div_help')
    tls_rel_persons = REQUEST.TLS('cal_invitep')
    tls_rel_contacts = REQUEST.TLS('type_Contacts')
    tls_scheduling = REQUEST.TLS('cal_scheduling')
    tls_conflux_popup = REQUEST.TLS('tls_conflux_popup')
    
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    timecheck_js = REQUEST.timecheck_js()

    if show_groups:
        dic = {}
        REQUEST.db.execute("""SELECT members from calendar_groups where group_id in (%s)""" % ",".join(map(str, show_groups)))
        group_members = map(lambda x:_Utils.sql_parse_array(REQUEST, x[0]), REQUEST.db.fetchall())
        for gr in group_members:
            for member in gr:
                dic[member]=1
        group_members = dic.keys()
        if show_users:
            show_users+=group_members
        else:
            show_users=group_members
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" title="win2k-1" />' % _Conf.BASE_WEB_URL))
    output.append(get_calendar_menu(REQUEST,MY_MENU_ID))
    output.append(standard_html.window_script(height=600,width=600,resizable='yes'))
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())

    if REQUEST.form.has_key('year') and REQUEST.form.has_key('month') and REQUEST.form.has_key('day'):
        start_stamp =  mx.DateTime.DateTime(int(REQUEST.form['year'].value), int(REQUEST.form['month'].value), int(REQUEST.form['day'].value), int(REQUEST.form['hour'].value))
        end_stamp =  mx.DateTime.DateTime(int(REQUEST.form['year'].value), int(REQUEST.form['month'].value), int(REQUEST.form['day'].value), int(REQUEST.form['hour'].value), 30)
    elif REQUEST.form.has_key('date') and REQUEST.form['date'].value:
        year, month, day = map(int, REQUEST.form['date'].value.split("-"))
        now = _Utils.utc_now_mx()
        start_stamp = mx.DateTime.DateTime(year, month, day, now.hour)
        end_stamp = mx.DateTime.DateTime(year, month, day, now.hour, 30)
        del now
    else:
        now = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
        start_stamp = mx.DateTime.DateTime(now.year, now.month, now.day, now.hour)
        end_stamp = mx.DateTime.DateTime(now.year, now.month, now.day, now.hour, 30)
        del now
    start_stamp_d, start_stamp_t = REQUEST.iso2userdatetime(REQUEST, start_stamp, is_utc=0).split(' ')
    end_stamp_d, end_stamp_t = REQUEST.iso2userdatetime(REQUEST, end_stamp, is_utc=0).split(' ')

    
    REQUEST.db.execute("""SELECT group_id, group_name, members FROM calendar_groups where parent_id=%s""" % REQUEST.USER.get_id())
    related_groups = REQUEST.db.dictfetchall()
    relcount = len(related_groups)
    related_groups = """<SELECT class="textfield1" name="related_groups2" multiple size="4">\n%s</SELECT>""" % "\n".join(map(lambda x: """<OPTION value="%d">%s""" % (x['group_id'], x['group_name'].decode('UTF8')), related_groups))
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_RESOURCE])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT r.resource_name, r.resource_id FROM items i, resources r WHERE r.resource_id=i.item_id%s""" % right_param).encode('UTF8'))
    resources = REQUEST.db.dictfetchall()
    rescount = len(resources)
    resources = """<SELECT class="textfield1" name="cal_resources" multiple size="4">\n%s</SELECT>""" % "\n".join(map(lambda x: """<OPTION value="%d">%s""" % (x['resource_id'], x['resource_name'].decode('UTF8')), resources))

    if rescount:
      res1 = tls_resources + ":"
      res2 = resources
    else:
      res1 = "&nbsp;"
      res2 = "&nbsp;"
    if relcount:
      rel1 = tls_relgroups + ":"
      rel2 = related_groups
    else:
      rel1 = "&nbsp;"
      rel2 = "&nbsp;"
    if relcount or rescount:
      res_groups = u"""
        <TR class="tr_listing1">
          <TD class="td_listing1ke">%(rel1)s</TD>
          <TD class="td_listing1" align="center">%(rel2)s</TD>
          <TD class="td_listing1ke">%(res1)s</TD>
          <TD class="td_listing1" align="center">%(res2)s</TD>
        </TR>""" % locals()
    else:
      res_groups = u""

    priorities = _Utils.make_setting_selection(REQUEST, None, 'event_priority', 'cal_priorities')
    activities = """
<SELECT name="event_activity">
  <OPTION value="0">%s</OPTION>
  <OPTION SELECTED value="1">%s</OPTION>
  <OPTION value="2">%s</OPTION>
  <OPTION value="3">%s</OPTION>
</SELECT>""" % (REQUEST.TLS('cal_showas_0'),REQUEST.TLS('cal_showas_1'),REQUEST.TLS('cal_showas_2'),REQUEST.TLS('cal_showas_3'))

    if REQUEST._translator.dateformat=='en_US_12':
        timestruct = ['12:00AM','12:15AM','12:30AM','12:45AM','1:00AM','1:15AM','1:30AM','1:45AM','2:00AM','2:15AM','2:30AM','2:45AM','3:00AM','3:15AM','3:30AM','3:45AM','4:00AM','4:15AM','4:30AM','4:45AM','5:00AM','5:15AM','5:30AM','5:45AM','6:00AM','6:15AM','6:30AM','6:45AM','7:00AM','7:15AM','7:30AM','7:45AM','8:00AM','8:15AM','8:30AM','8:45AM','9:00AM','9:15AM','9:30AM','9:45AM','10:00AM','10:15AM','10:30AM','10:45AM','11:00AM','11:15AM','11:30AM','11:45AM','12:00PM','12:15PM','12:30PM','12:45PM','1:00PM','1:15PM','1:30PM','1:45PM','2:00PM','2:15PM','2:30PM','2:45PM','3:00PM','3:15PM','3:30PM','3:45PM','4:00PM','4:15PM','4:30PM','4:45PM','5:00PM','5:15PM','5:30PM','5:45PM','6:00PM','6:15PM','6:30PM','6:45PM','7:00PM','7:15PM','7:30PM','7:45PM','8:00PM','8:15PM','8:30PM','8:45PM','9:00PM','9:15PM','9:30PM','9:45PM','10:00PM','10:15PM','10:30PM','10:45PM','11:00PM','11:15PM','11:30PM','11:45PM']
        if start_stamp_t[0]=="0":
            start_stamp_t = start_stamp_t[1:]
        if end_stamp_t[0]=="0":
            end_stamp_t = end_stamp_t[1:]
    else:
        timestruct = ['00:00','00:15','00:30','00:45','01:00','01:15','01:30','01:45','02:00','02:15','02:30','02:45','03:00','03:15','03:30','03:45','04:00','04:15','04:30','04:45','05:00','05:15','05:30','05:45','06:00','06:15','06:30','06:45','07:00','07:15','07:30','07:45','08:00','08:15','08:30','08:45','09:00','09:15','09:30','09:45','10:00','10:15','10:30','10:45','11:00','11:15','11:30','11:45','12:00','12:15','12:30','12:45','13:00','13:15','13:30','13:45','14:00','14:15','14:30','14:45','15:00','15:15','15:30','15:45','16:00','16:15','16:30','16:45','17:00','17:15','17:30','17:45','18:00','18:15','18:30','18:45','19:00','19:15','19:30','19:45','20:00','20:15','20:30','20:45','21:00','21:15','21:30','21:45','22:00','22:15','22:30','22:45','23:00','23:15','23:30','23:45']
    start_time = u"""<SELECT class="textfield1" name="start_stamp_t">"""
    #raise RuntimeError, start_stamp_t
    for time in timestruct:
        if time==start_stamp_t:
            start_time = start_time + u"""<option selected value="%s">%s</option>""" % (time, time)
        else:
            start_time = start_time + u"""<option value="%s">%s</option>""" % (time, time)
    start_time = start_time + u"""</SELECT>"""

    end_time = u"""<SELECT class="textfield1" name="end_stamp_t">"""
    for time in timestruct:
        if time==end_stamp_t:
            end_time = end_time + u"""<option selected value="%s">%s</option>""" % (time, time)
        else:
            end_time = end_time + u"""<option value="%s">%s</option>""" % (time, time)
    end_time = end_time + u"""</SELECT>"""

    output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
%(datecheck_js)s
%(timecheck_js)s
  function check_values()
  {
    if (!document.addform.event_name.value ||
        !document.addform.start_stamp_d.value ||
        !document.addform.end_stamp_d.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
  function show()
  {
    inte=document.getElementById('1');
    week=document.getElementById('2');
    mont=document.getElementById('3');
    year=document.getElementById('4');
    butt=document.getElementById('5');
    word=document.getElementById('6');
    word2=document.getElementById('7');
    if(document.addform.repeat_type.value=="")
    {
       inte.style.display="none";
       week.style.display="none";
       mont.style.display="none";
       year.style.display="none";
       butt.style.display="none";
       word.value="";
       word2.value="";
    }
    else if(document.addform.repeat_type.value=="0")
    {
       inte.style.display="block";
       week.style.display="none";
       mont.style.display="none";
       year.style.display="none";
       butt.style.display="block";
       word.value="%(tls_onday)s";
       word2.value="%(tls_dayevery)s";
    }
    else if(document.addform.repeat_type.value=="1")
    {
       inte.style.display="block";
       week.style.display="block";
       mont.style.display="none";
       year.style.display="none";
       butt.style.display="block";
       word.value="%(tls_onweek)s";
       word2.value="%(tls_weekevery)s";
    }
    else if(document.addform.repeat_type.value=="2")
    {
       inte.style.display="block";
       week.style.display="none";
       mont.style.display="block";
       year.style.display="none";
       butt.style.display="block";
       word.value="%(tls_onmonth)s";
       word2.value="%(tls_monthevery)s";
    }
    else if(document.addform.repeat_type.value=="5")
    {
       inte.style.display="block";
       week.style.display="none";
       mont.style.display="none";
       year.style.display="block";
       butt.style.display="block";
       word.value="%(tls_onyear)s";
       word2.value="%(tls_yearevery)s";
    }
  }
function show_rel()
{
  s1 = document.getElementById('91');
  if(s1.style.display=='block')
  {
    s1.style.display='none';
    document.forms[0].sbtn.value="%(tls_show_rels)s";
  }
  else
  {
    s1.style.display='block';
    document.forms[0].sbtn.value="%(tls_hide_rels)s";
  }
}
  function urlstring()
  {
    url_str = "";
    url_str = url_str + '?date='+document.forms[0]['start_stamp_d'].value;
    users= document.forms[0]['rel_persons'].value;
    url_str = url_str + '&users=' + users;
    group_str = "";
    if(document.forms[0]['related_groups2'])
    {
      groups = document.forms[0]['related_groups2'];
      for(i=0;i<groups.length;i++)
      {
        if(groups[i].selected)
          group_str = group_str + groups[i].value + ",";
      }
      if(group_str)
      {
        group_str = group_str.substring(0, group_str.length-1);
        url_str = url_str + '&groups=' + group_str
      }
    }
    return url_str
  }
function cal_popup(url, fieldname)
{
    window.date_result = document.forms[0][fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
// -->
</SCRIPT>
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<FORM method="POST" action="%(BASE_CALENDAR_URL)saddevent.py/add" name="addform" onsubmit="return check_values();">
<input type="hidden" name="rel_id" value="%(rel_id)s">
%(returl)s
<TR>
<TD width="450">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_addevent)s</b>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="#" onclick="open_window('%(BASE_CALENDAR_URL)sschedule.py'+urlstring())">%(tls_scheduling)s</a>&nbsp;&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="300" height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_subject)s</TD>
    <TD class="td_listing1" colspan="4"><INPUT size="35" type="text" class="textfield1" name="event_name"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0ke" nowrap>%(tls_activity)s:</TD>
    <TD class="td_listing0">%(activities)s</TD>
    <TD class="td_listing0ke" nowrap>%(tls_priority)s:</TD>
    <TD class="td_listing0">%(priorities)s</TD>
    <TD class="td_listing0" width="40%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="5"><input type="button" value="%(tls_show_rels)s" name="sbtn" class="input2" onclick="show_rel()"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD colspan="6">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="91" style="display: none">
        <TR class="tr_listing1" valign="top">
          <TD class="td_listing1" width="15%%"><input class="input6" type="button" value="%(tls_rel_persons)s" onclick="open_window('%(BASE_CALENDAR_URL)spopup_persons.py?persons='+document.forms[0].rel_persons.value)"></TD>
          <TD class="td_listing1" width="35%%" align="left"><div id="98">%(div_help)s</div>&nbsp;<input type="hidden" name="rel_persons" value=""></TD>
          <TD class="td_listing1" width="15%%"><input class="input6" type="button" value="%(tls_rel_contacts)s" onclick="open_window('%(BASE_CALENDAR_URL)spopup_contacts.py?persons='+document.forms[0].rel_contacts.value)"></TD>
          <TD class="td_listing1" width="35%%" align="left"><div id="99">%(div_help)s</div>&nbsp;<input type="hidden" name="rel_contacts" value="%(rel_contact_id)s"></TD>
        </TR>
        %(res_groups)s
      </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_startdate)s:</TD>
    <TD class="td_listing0" nowrap><INPUT size="10" type="text" class="textfield1" onchange="this.form.end_stamp_d.value=this.value;" id="start_stamp_d" name="start_stamp_d" value="%(start_stamp_d)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_stamp_d', '%(dformat)s', 'end_stamp_d');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
    <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_starttime)s:</TD>
    <TD class="td_listing0" nowrap colspan="2">%(start_time)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_enddate)s:</TD>
    <TD class="td_listing1" nowrap><INPUT size="10" type="text" class="textfield1" name="end_stamp_d" id="end_stamp_d" value="%(end_stamp_d)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('end_stamp_d', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_endtime)s:</TD>
    <TD class="td_listing1" nowrap colspan="2">%(end_time)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0b" colspan="5">%(tls_desc)s<BR><TEXTAREA class="textarea4" name="description" rows="6" cols="65"></TEXTAREA></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(tls_private)s:</TD>
    <TD class="td_listing1" colspan="4"><INPUT type="checkbox" name="event_is_private"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0ke" nowrap>%(tls_remind)s:</TD>
    <TD class="td_listing0">
      <SELECT class="textfield1" name="remind_type">
        <OPTION value="0">%(tls_off)s
        <OPTION value="1">%(tls_email)s</OPTION>
        <OPTION value="2">%(tls_sms)s</OPTION>
        <OPTION value="3">%(tls_conflux_popup)s</OPTION>
      </SELECT>
    </TD>
    <TD class="td_listing0ke" nowrap>%(tls_remindtime)s:</TD>
    <TD class="td_listing0" colspan="2">
      <SELECT class="textfield1" name="remind_time">
        <OPTION value="5 minutes">5 %(tls_minutes)s
        <OPTION value="10 minutes">10 %(tls_minutes)s
        <OPTION value="15 minutes">15 %(tls_minutes)s
        <OPTION value="20 minutes">20 %(tls_minutes)s
        <OPTION value="30 minutes">30 %(tls_minutes)s
      </SELECT>
    </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1ke" colspan="3">%(tls_sendrelated)s:</TD>
    <TD class="td_listing1" colspan="3"><INPUT type="checkbox" name="sendrelated"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(tls_reptyp)s:</TD>
    <TD class="td_listing1" colspan="4"><SELECT class="textfield1" name="repeat_type" onchange="show();">
<OPTION value="">%(tls_doesnot)s
<OPTION value="0">%(tls_daily)s
<OPTION value="1">%(tls_weekly)s
<OPTION value="2">%(tls_monthly)s
<OPTION value="5">%(tls_yearly)s
</SELECT>
</TD>
  </TR>
  <TR>
    <TD colspan="6">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="1" style="display: none">
        <TR class="tr_listing0">
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD class="td_listing0ke" nowrap>%(tls_repint)s:</TD>
          <TD class="td_listing0" nowrap width="100%%"><input size="8" readonly type="text" value="" name="textinterval2" id="7" class="textinterval">&nbsp;&nbsp;<INPUT class="textfield1" type="text" name="repeat_interval" size="2" value="1"> &nbsp;<input size="8" readonly type="text" value="" name="textinterval" id="6" class="textinterval"></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
    <TD colspan="6">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="2" style="display: none">
        <TR class="tr_listing0">
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD class="td_listing0ke" nowrap>%(tls_repweek)s:</TD>
          <TD class="td_listing0" width="100%%">
            <TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
              <TR>
                <TD><INPUT type="checkbox" name="weekly_monday"></TD>
                <TD>%(tls_mon)s</TD>
                <TD><INPUT type="checkbox" name="weekly_tuesday"></TD>
                <TD>%(tls_tue)s</TD>
                <TD><INPUT type="checkbox" name="weekly_wednesday"></TD>
                <TD>%(tls_wed)s</TD>
                <TD colspan="2">&nbsp;</TD>
              </TR>
              <TR>
                <TD><INPUT type="checkbox" name="weekly_thursday"></TD>
                <TD>%(tls_thu)s</TD>
                <TD><INPUT type="checkbox" name="weekly_friday"></TD>
                <TD>%(tls_fri)s</TD>
                <TD><INPUT type="checkbox" name="weekly_saturday"></TD>
                <TD>%(tls_sat)s</TD>
                <TD><INPUT type="checkbox" name="weekly_sunday"></TD>
                <TD>%(tls_sun)s</TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
    <TD colspan="6">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="3" style="display: none">
        <TR class="tr_listing0">
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD class="td_listing0ke" nowrap>%(tls_repmonth)s:</TD>
          <TD class="td_listing0" nowrap width="100%%">%(tls_onthe)s <INPUT type="text" class="textfield1" name="monthly_dayofmonth" size="2" value="1"> %(tls_repmonthstr)s</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
    <TD colspan="6">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="4" style="display: none">
        <TR class="tr_listing0">
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD class="td_listing0ke" nowrap>%(tls_repyear)s:</TD>
          <TD class="td_listing0" nowrap width="100%%">%(tls_onthe)s <INPUT type="text" class="textfield1" name="yearly_dayofmonth" size="2" value="1"> %(tls_dayof)s 
             <SELECT class="textfield1" name="monthofyear">
            <OPTION value="1">%(tls_1)s
            <OPTION value="2">%(tls_2)s
            <OPTION value="3">%(tls_3)s
            <OPTION value="4">%(tls_4)s
            <OPTION value="5">%(tls_5)s
            <OPTION value="6">%(tls_6)s
            <OPTION value="7">%(tls_7)s
            <OPTION value="8">%(tls_8)s
            <OPTION value="9">%(tls_9)s
            <OPTION value="10">%(tls_10)s
            <OPTION value="11">%(tls_11)s
            <OPTION value="12">%(tls_12)s
            </SELECT>
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
    <TD colspan="6">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="5" style="display: none">
        <TR class="tr_listing1">
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD class="td_listing_noborder" width="100%%"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
</FORM>
</TD>
<TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
""" % locals())
    
    if REQUEST.form.has_key('date'):
        try:
            year, month, day = map(int, REQUEST.form['date'].value.decode('UTF8').split('-'))
        except:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        data = _calendar.DayHandler(REQUEST, year, month, day, show_users, show_resources)
    elif REQUEST.form.has_key('year') and REQUEST.form.has_key('month') and REQUEST.form.has_key('day'):
        try:
            year = int(REQUEST.form['year'].value)
            month = int(REQUEST.form['month'].value)
            day = int(REQUEST.form['day'].value)
        except:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        data = _calendar.DayHandler(REQUEST, year, month, day, show_users, show_resources)
    else:
        data = 0
    output.append(_calendar.mini_calendar(REQUEST, data, "addevent.py", "addevent.py", 0))
    output.append("""
</TD>
<TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TABLE>
""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add(REQUEST):
    output = []
    event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_REQ)
    if not event.get('event_name'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    event.set('parent_id', REQUEST.USER.get_id())
    if REQUEST.form.has_key('start_stamp_d') and REQUEST.form.has_key('start_stamp_t') and REQUEST.form['start_stamp_d'].value.decode('UTF8').strip() and REQUEST.form['start_stamp_t'].value.decode('UTF8').strip():
        event.set('start_stamp', REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['start_stamp_d'].value.decode('UTF8'), REQUEST.form['start_stamp_t'].value.decode('UTF8'))))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if REQUEST.form.has_key('end_stamp_d') and REQUEST.form.has_key('end_stamp_t') and REQUEST.form['end_stamp_d'].value.decode('UTF8').strip() and REQUEST.form['end_stamp_t'].value.decode('UTF8').strip():
        event.set('end_stamp', REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['end_stamp_d'].value.decode('UTF8'), REQUEST.form['end_stamp_t'].value.decode('UTF8'))))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['start_stamp_d'].value.decode('UTF8'), REQUEST.form['start_stamp_t'].value.decode('UTF8'))) > REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['end_stamp_d'].value.decode('UTF8'), REQUEST.form['end_stamp_t'].value.decode('UTF8'))):
        raise RuntimeError, REQUEST.TLS('cal_wrongstamp')


    if REQUEST.form.has_key('rel_persons') and REQUEST.form['rel_persons'].value:
        related_persons = map(int, REQUEST.form['rel_persons'].value.split(","))
        event.set('related_persons', related_persons)
    else:
        event.set('related_persons', [])


    if REQUEST.form.has_key('related_groups2'):
        try:
            event.set('related_groups', [int(REQUEST.form['related_groups2'].value)])
        except AttributeError:
            event.set('related_groups', REQUEST.form['related_groups2'])
    else:
        event.set('related_groups', [])


    if REQUEST.form.has_key('event_is_private'):
        event.set('is_private', 1)
    else:
        event.set('is_private', 0)

    event.set('repeat_interval', None)
    event.set('dayofmonth', None)
    event.set('monthofyear', None)
    event.set('repeat_type', None)
    if REQUEST.form.has_key('repeat_type') and REQUEST.form['repeat_type'].value:
        if not REQUEST.form.has_key('repeat_interval') or not REQUEST.form['repeat_interval'].value: # add int check FIXME
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')
        if int(REQUEST.form['repeat_type'].value) == _Event.REPEAT_DAY:
            event.set('repeat_interval', int(REQUEST.form['repeat_interval'].value))
            event.set('repeat_type', _Event.REPEAT_DAY)
        elif int(REQUEST.form['repeat_type'].value) == _Event.REPEAT_WEEK:
            event.set('repeat_interval', int(REQUEST.form['repeat_interval'].value))
            # Check for days
            days_map = 0
            if REQUEST.form.has_key('weekly_monday'):
                days_map = days_map | _Event.DAYS[0]
            if REQUEST.form.has_key('weekly_tuesday'):
                days_map = days_map | _Event.DAYS[1]
            if REQUEST.form.has_key('weekly_wednesday'):
                days_map = days_map | _Event.DAYS[2]
            if REQUEST.form.has_key('weekly_thursday'):
                days_map = days_map | _Event.DAYS[3]
            if REQUEST.form.has_key('weekly_friday'):
                days_map = days_map | _Event.DAYS[4]
            if REQUEST.form.has_key('weekly_saturday'):
                days_map = days_map | _Event.DAYS[5]
            if REQUEST.form.has_key('weekly_sunday'):
                days_map = days_map | _Event.DAYS[6]
            if days_map == 0:
                raise RuntimeError, REQUEST.TLS('cal_nodayselected')
            event.set('dayofweek', days_map)
            event.set('repeat_type', _Event.REPEAT_WEEK)
        elif int(REQUEST.form['repeat_type'].value) == _Event.REPEAT_MONTH:
            if not REQUEST.form.has_key('monthly_dayofmonth') or not REQUEST.form['monthly_dayofmonth'].value: # add int check FIXME
                raise RuntimeError, REQUEST.TLS('required_parameters_missing')
            event.set('repeat_interval', int(REQUEST.form['repeat_interval'].value))
            event.set('dayofmonth', int(REQUEST.form['monthly_dayofmonth'].value))
            event.set('repeat_type', _Event.REPEAT_MONTH)
        elif int(REQUEST.form['repeat_type'].value) == _Event.REPEAT_YEAR:
            if not REQUEST.form.has_key('yearly_dayofmonth') or not REQUEST.form['yearly_dayofmonth'].value or not REQUEST.form.has_key('monthofyear') or not REQUEST.form['monthofyear'].value: # add int check FIXME
                raise RuntimeError, REQUEST.TLS('required_parameters_missing')
            event.set('repeat_interval', int(REQUEST.form['repeat_interval'].value))
            event.set('dayofmonth', int(REQUEST.form['yearly_dayofmonth'].value))
            event.set('monthofyear', int(REQUEST.form['monthofyear'].value))
            event.set('repeat_type', _Event.REPEAT_YEAR)
        else:
            raise RuntimeError, REQUEST.TLS('cal_unsuprep')
        event.set('master_id', 1)
    if REQUEST.form.has_key('sendrelated'):
        event.set('event_flags', _Event.EVENT_REMINDER_OTHERS)
    event.save()
    if REQUEST.form.has_key('rel_contacts') and REQUEST.form['rel_contacts'].value:
        related_contacts = map(int, REQUEST.form['rel_contacts'].value.split(","))
        for contact_id in related_contacts:
            relations.add_relation(REQUEST, contact_id, event.get_id())
    event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, event.get_id())
    if REQUEST.form.has_key('cal_resources') and isinstance(REQUEST.form['cal_resources'], list):
        res_ids = map(int, REQUEST.form['cal_resources'])
        for res_id in res_ids:
            res = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, res_id)
            res.add_to_event(event.get_id())
    elif REQUEST.form.has_key('cal_resources') and REQUEST.form['cal_resources'].value:
        res = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['cal_resources'].value))
        res.add_to_event(event.get_id())
    conflicts = _Resource.check_for_conflicts(REQUEST, event)
    if conflicts:
        error_output = []
        for (conflict_resource, conflict_event) in conflicts:
            error_output.append(REQUEST.TLS('resource_conflictmsg') % (conflict_resource.get_name(),conflict_event.get_name()))
        error_output = u"\n%s" % "\n".join(error_output)
        raise RuntimeError, error_output
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = int(REQUEST.form['rel_id'].value)
      relations.add_relation(REQUEST, rel_id, event.get_id())
    try:
        _mail.send_invitation(REQUEST, event, 1)
    except:
        raise RuntimeError, REQUEST.TLS('eventinverror')
    if event.get('master_id')==1:
        _eventlib.insert_events(REQUEST, event.get_id(), 30)
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sday.py" % _Conf.BASE_CALENDAR_URL
    return apache.HTTP_MOVED_TEMPORARILY

def quickadd(REQUEST):
    if not REQUEST.form.has_key('content') or not REQUEST.form['content'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    data = cPickle.loads(base64.decodestring(REQUEST.form['content'].value))
    SQL = """SELECT e.event_id from events e, items i where e.event_id=i.item_id and i.creator_id=%d and e.event_name='%s' and e.start_stamp='%s' and e.end_stamp='%s'""" % (REQUEST.USER.get_id(), data['title'], data['start_stamp'], data['end_stamp'])
    REQUEST.db.execute(SQL.encode('UTF8'))
    res = REQUEST.db.fetchone()
    if not res:
        event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_NEW)
        event.set('event_name', data['title'])
        date, time = data['start_stamp'].split(" ")
        y, m, d = map(int, date.split("-"))
        ho, mi = map(int, time.split(":"))
        data['start_stamp'] = mx.DateTime.DateTime(y, m, d, ho, mi)
        data['start_stamp'] = _Utils.local2utc_mx(REQUEST, data['start_stamp'])
        event.set('start_stamp', data['start_stamp'])
        date, time = data['end_stamp'].split(" ")
        y, m, d = map(int, date.split("-"))
        ho, mi = map(int, time.split(":"))
        data['end_stamp'] = mx.DateTime.DateTime(y, m, d, ho, mi)
        data['end_stamp'] = _Utils.local2utc_mx(REQUEST, data['end_stamp'])
        event.set('end_stamp', data['end_stamp'])
        event.set('description', data['description'])
        event.set('parent_id', REQUEST.USER.get_id())
        event.save()
    return " "
