from mod_python import apache

import standard_html, _InitTypes, _Access, _Conf, _Utils
import Menus, _Resource, MultiForm

MY_MENU_ID = 6

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> REQUEST.USER.get_parent(REQUEST).get_top_parent().get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL

    tls_resourceadd = REQUEST.TLS('resource_add')
    tls_save = REQUEST.TLS('tls_save')
    tls_name = REQUEST.TLS('tls_name')
    tls_resources = REQUEST.TLS('tls_resources')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    doc_rename = REQUEST.TLS('doc_rename')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(standard_html.window_script(height=625,width=550))
    output.append(Menus.get_calendar_menu(REQUEST, MY_MENU_ID))
    output.append(u"""\
<FORM action="%(BASE_CALENDAR_URL)scalcats.py/edit" method="POST">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_resources)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
""" % (locals()))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_RESOURCE])
    if right_param:
        right_param = u" AND " + right_param
    QUERY = u"""SELECT r.*, i.* FROM resources r, items i WHERE i.item_id=r.resource_id%s""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    index = 0
    for row in dbresult:
        if(index%2 == 0):
          row['td_class']="td_listing1"
        else:
          row['td_class']="td_listing0"
        index = index + 1
        row['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        row['resource_name'] = _Utils.html_quote(row['resource_name'].decode('UTF8'))
        output.append(u"""
  <TR>
    <TD class="%(td_class)s" nowrap><INPUT type="checkbox" name="sel_%(item_id)d"></TD>
    <TD class="%(td_class)s" nowrap>%(resource_name)s</TD>
    <TD class="%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % row)
    output.append(u"""
  <TR>
    <TD class="td_listing_noborder" colspan="2" nowrap><INPUT class="input2" type="submit" value="%(tls_deletesel)s" name="_delete">&nbsp;<INPUT class="input2" type="submit" value="%(doc_rename)s" name="_rename"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
<BR>""" % locals())

    output.append(u"""\
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_CALENDAR_URL)scalcats.py/add" method="POST">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_resourceadd)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1ke" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1" nowrap><INPUT type="text" class="textfield1" name="resource_name"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing_noborder" colspan="2" nowrap><INPUT class="input2" type="submit" value="%(tls_save)s" name="_save"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add(REQUEST):
    if REQUEST.form.has_key('resource_name') and REQUEST.form['resource_name'].value.decode('UTF8').strip():
        res = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_NEW)
        res.set('parent_id', REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id())
        res.set('resource_name', REQUEST.form['resource_name'].value.decode('UTF8').strip())
        res.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    REQUEST.mod_req.headers_out["Location"] = "%scalcats.py" % _Conf.BASE_CALENDAR_URL
    return apache.HTTP_MOVED_TEMPORARILY


def edit(REQUEST):
    del_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            del_ids.append(int(key[4:]))

    if REQUEST.form.has_key('_delete'):
        for del_id in del_ids:
            obj = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            obj.delete()
    elif REQUEST.form.has_key('_rename'):
        BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
        REQ_FIELD = _Conf.REQ_FIELD
        tls_name = REQUEST.TLS('tls_name')
        tls_save = REQUEST.TLS('tls_save')
        tls_rename = REQUEST.TLS('doc_rename')
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        output = []
        output.append(standard_html.html_header(REQUEST))
        output.append(Menus.get_calendar_menu(REQUEST, MY_MENU_ID))
        output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_CALENDAR_URL)scalcats.py/edit">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_rename)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
""" % locals())
        ndx = 0
        for del_id in del_ids:
            if(ndx%2 == 0):
              td_class="td_listing1"
            else:
              td_class="td_listing0"
            obj = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            obj_name = obj.get_name()
            output.append(u"""<INPUT type="hidden" name="form_%(ndx)d_resourceid" value="%(del_id)d">
  <TR>
    <TD class="%(td_class)ske" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
    <TD class="%(td_class)s" nowrap><INPUT type="text" size=30 class="textfield1" value="%(obj_name)s" name="form_%(ndx)d_resname"></TD>
    <TD class="%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
            ndx += 1
        output.append(u"""
  <TR>
    <TD class="td_listing_noborder" colspan="2"><INPUT type="submit" name="_saverename" value="%(tls_save)s" class="input2"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)

    elif REQUEST.form.has_key('_saverename'):
        form = MultiForm.MultiForm(REQUEST)
        for row in form.get_rows():
            obj = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, int(row['resourceid']))
            obj.set('resource_name', row['resname'])
            obj.save()

    REQUEST.mod_req.headers_out["Location"] = "%scalcats.py" % _Conf.BASE_CALENDAR_URL
    return apache.HTTP_MOVED_TEMPORARILY

