from mod_python import apache
import time, calendar

import mx.DateTime
import _Conf, _Exceptions, _Utils, _RootObject, _Access, _InitTypes
from Menus import get_calendar_menu
import standard_html
import _calendar
import urllib

MY_MENU_ID = 5

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(standard_html.window_script(height=670,width=550))
    output.append(get_calendar_menu(REQUEST, MY_MENU_ID))


    tls_groups = REQUEST.TLS('cal_groups')
    tls_name = REQUEST.TLS('tls_name')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_save = REQUEST.TLS('tls_save')

    tls_newgroup = REQUEST.TLS('cal_newgroup')
    tls_grouptitle = REQUEST.TLS('cal_grouptitle')
    tls_view = REQUEST.TLS('cal_inmygroup')
    tls_others = REQUEST.TLS('cal_allpeople')
    tls_missing_input = REQUEST.TLS('tls_missing_input')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    REQ_FIELD = _Conf.REQ_FIELD

    SQL = """ SELECT group_name FROM calendar_groups where parent_id=%d """ % REQUEST.USER.get_id()
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchall()

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.person_id, i.item_name, o.organization_name FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND p.is_deleted=0 AND o.organization_id=i.parent_id%s ORDER BY p.last_name, p.first_name""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()



    userlist=[]
    for p in dbresult:
        userlist.append(u"""<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
    ulist = "\n".join(userlist)


    output.append(u"""\
<SCRIPT type="text/javascript">
function move_1()
{
	var the_select1 = window.document.vorm.show_users_set2;
	var the_select2 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_2()
{
	var the_select1 = window.document.vorm.show_users_set;
	var the_select2 = window.document.vorm.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function select_all()
{
    if (!document.vorm.title.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    var the_select1 = window.document.vorm.show_users_set;
    for (loop=0; loop < the_select1.options.length; loop++) {
        the_select1.options[loop].selected = true;
    }
}
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_groups)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b" nowrap>%(tls_name)s</TD>
  <TD class="td_listing1b" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
  """ % locals())
    
    index = 0
    for row in res:
        row['group_name'] = _Utils.html_quote(row['group_name'].decode('UTF8'))
        row['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        row['BASE_CALENDAR_URL'] = _Conf.BASE_CALENDAR_URL
        row['url_name'] = urllib.quote(row['group_name'].encode('UTF8'))
        index = index + 1
        if index%2==0:
            row['class']=1
        else:
            row['class']=0
        output.append(u"""\
<TR>
  <TD class="td_listing%(class)s" nowrap><li><a class="grouplinks" href="%(BASE_CALENDAR_URL)scalgroups.py/edit?name=%(url_name)s">%(group_name)s</a></li></TD>
  <TD class="td_listing%(class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
  """ % row)
    output.append(u"""\
</TABLE>
<br>""" % locals())


    output.append(u"""\
<BR>
<FORM name="vorm" action="%(BASE_CALENDAR_URL)scalgroups.py/save_users_list" onsubmit="return select_all();">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_newgroup)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD colspan="6" class="td_listing1b" nowrap width="100%%">%(REQ_FIELD)s%(tls_name)s: &nbsp;&nbsp;&nbsp;&nbsp;<input name="title" class="textfield4 size=35"></TD>
</TR>
<TR class="tr_listing0">
  <TD colspan="6" class="td_listing0b" nowrap width="100%%">%(tls_grouptitle)s</TD>
</TR>
<TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=200 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=200 border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=20 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan=2 align="center">%(tls_view)s</TD>
  <TD class="td_listing1b" colspan=2 align="center">%(tls_others)s</TD>
  <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
  <TD class="td_listing0" align="center"><SELECT name="show_users_set" multiple size="5"></SELECT></TD>
  <TD class="td_listing0" align="center"><a href="#" onclick="move_1();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
  <TD class="td_listing0" align="center"><a href="#" onclick="move_2();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
  <TD class="td_listing0" align="center"><SELECT name="show_users_set2" multiple size="5">%(ulist)s</SELECT></TD>
  <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="5" width="100%%"><INPUT type="submit" class="input2" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save_users_list(REQUEST):
    if not REQUEST.form.has_key('show_users_set'):
        raise RuntimeError, REQUEST.TLS('tls_nousers')
    if not isinstance(REQUEST.form['show_users_set'], list):
        users = [REQUEST.form['show_users_set'].value]
    else:
        users = REQUEST.form['show_users_set']


    parentid = REQUEST.USER.get_id()
    group_name = _Utils.sql_cast_str(REQUEST, REQUEST.form['title'].value.decode('UTF8'))
    group_contents = _Utils.sql_cast_array(REQUEST, users)

    SQL = "INSERT into calendar_groups (parent_id, group_name, members) values (%d, %s, %s)" % (parentid, group_name, group_contents)
    REQUEST.db.execute(SQL.encode('UTF8'))

    REQUEST.mod_req.headers_out["Location"] = _Conf.BASE_CALENDAR_URL + "calgroups.py".encode('UTF8')
    return apache.HTTP_MOVED_TEMPORARILY

def edit(REQUEST):
    if not REQUEST.form.has_key('name') or not REQUEST.form['name'].value:
        raise RuntimeError, REQUEST.TLS('cal_nogroupname')
    SQL = "SELECT group_name, members FROM calendar_groups WHERE parent_id=%d and group_name='%s'" % (REQUEST.USER.get_id(), _Utils.sql_quote_simple(_Utils.html_unquote(urllib.unquote(REQUEST.form['name'])).decode('UTF8')))
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.dictfetchone()
    if not dbres:
        raise RuntimeError, REQUEST.TLS('cal_nogroup')
    
    groupname = _Utils.html_quote(dbres['group_name'].decode('UTF8'))
    members   = _Utils.sql_parse_array(REQUEST, dbres['members'])

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST, MY_MENU_ID))

    tls_groups = REQUEST.TLS('cal_groups')
    tls_group = REQUEST.TLS('tls_group')
    tls_name = REQUEST.TLS('tls_name')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_save = REQUEST.TLS('tls_save')
    tls_delete = REQUEST.TLS('tls_delete')

    tls_newgroup = REQUEST.TLS('cal_newgroup')
    tls_grouptitle = REQUEST.TLS('cal_grouptitle')
    tls_view = REQUEST.TLS('cal_inmygroup')
    tls_others = REQUEST.TLS('cal_allpeople')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_confirm_del = REQUEST.TLS('email_confirm_del')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    REQ_FIELD = _Conf.REQ_FIELD


    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.person_id, i.item_name, o.organization_name FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND p.is_deleted=0 AND o.organization_id=i.parent_id%s ORDER BY p.last_name, p.first_name""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    

    userlist1=[]
    userlist2=[]
    for p in dbresult:
        if p['person_id'] in members:
            userlist1.append(u"""<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
        else:
            userlist2.append(u"""<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
    ulist1 = "\n".join(userlist1)
    ulist2 = "\n".join(userlist2)

    output.append(u"""\
<SCRIPT type="text/javascript">
function move_1()
{
	var the_select1 = window.document.vorm.show_users_set2;
	var the_select2 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_2()
{
	var the_select1 = window.document.vorm.show_users_set;
	var the_select2 = window.document.vorm.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function select_all()
{
    if (!document.vorm.title.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    var the_select1 = window.document.vorm.show_users_set;
    for (loop=0; loop < the_select1.options.length; loop++) {
        the_select1.options[loop].selected = true;
    }
}
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="vorm" action="%(BASE_CALENDAR_URL)scalgroups.py/edit_users_list" onsubmit="return select_all();">
<input type="hidden" name="oldname" value="%(groupname)s">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_group)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
 <TD class="td_listing1b" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
 <TD class="td_listing1" width="100%%"><input name="title" value="%(groupname)s" class="textfield3"></TD>
</TR>
<TR>
  <TD colspan="2">
   <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
     <TR>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=250 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=250 border=0 alt=""></TD>
       <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing0">
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=20 border=0 alt=""></TD>
       <TD class="td_listing0b">%(tls_view)s</TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0b">%(tls_others)s</TD>
       <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing1">
       <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set" multiple size="5">%(ulist1)s</SELECT>
       </TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_1();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_2();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set2" multiple size="5">%(ulist2)s</SELECT>
       </TD>
       <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
     </TR>
   </TABLE>
  </TD>
</TR>
<TR class="tr_listing0">
 <TD class="td_listing0"><INPUT type="submit" name="_save" class="input2" value="%(tls_save)s"></TD>
 <TD class="td_listing0" width="100%%" align="right"><INPUT type="submit" name="_delete" class="input2" onClick="return confirm('%(tls_confirm_del)s');" value="%(tls_delete)s">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_users_list(REQUEST):
    if REQUEST.form.has_key('_delete'):
        REQUEST.db.execute((u"DELETE from calendar_groups where group_name='%s' and parent_id=%d" % (_Utils.sql_quote_simple(REQUEST.form['oldname'].decode('UTF8')), REQUEST.USER.get_id())).encode('UTF8'))
        REQUEST.mod_req.headers_out["Location"] = _Conf.BASE_CALENDAR_URL + "calgroups.py".encode('UTF8')
        return apache.HTTP_MOVED_TEMPORARILY
    if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value:
        raise RuntimeError, REQUEST.TLS('tls_notitle')
    if not REQUEST.form.has_key('show_users_set'):
        raise RuntimeError, REQUEST.TLS('tls_nousers')
    if not isinstance(REQUEST.form['show_users_set'], list):
        users = [REQUEST.form['show_users_set'].value]
    else:
        users = REQUEST.form['show_users_set']


    parentid = REQUEST.USER.get_id()
    group_name = _Utils.sql_cast_str(REQUEST, REQUEST.form['title'].value.decode('UTF8'))
    group_contents = _Utils.sql_cast_array(REQUEST, users)
    oldname = _Utils.sql_cast_str(REQUEST, REQUEST.form['oldname'].value.decode('UTF8'))

    SQL = "UPDATE calendar_groups  set group_name=%s, members=%s where parent_id=%d and group_name=%s" % (group_name, group_contents, parentid, oldname)
    REQUEST.db.execute(SQL.encode('UTF8'))

    REQUEST.mod_req.headers_out["Location"] = _Conf.BASE_CALENDAR_URL + "calgroups.py".encode('UTF8')
    return apache.HTTP_MOVED_TEMPORARILY
