import urllib
import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Access
import _Contact, _RootObject, _InitTypes, custom_fields
import mx.DateTime

MY_MENU_ID = 2

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))

    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    tls_batches = REQUEST.TLS('contact_resbatch')
    tls_first_name = REQUEST.TLS('tls_first_name')
    tls_last_name = REQUEST.TLS('tls_last_name')
    tls_middle_names = REQUEST.TLS('tls_middle_names')
    tls_company = REQUEST.TLS('contact_company')
    tls_department = REQUEST.TLS('contact_department')
    tls_job = REQUEST.TLS('contact_job')
    tls_phone_work = REQUEST.TLS('tls_phone_work')
    tls_phone_cell = REQUEST.TLS('tls_phone_cell')
    tls_phone_home = REQUEST.TLS('tls_phone_home')
    tls_phone_fax = REQUEST.TLS('tls_phone_fax')
    tls_email = REQUEST.TLS('tls_email')
    tls_category = REQUEST.TLS('tls_category')
    tls_dateofbirth = REQUEST.TLS('contact_dateofbirth')
    tls_sex = REQUEST.TLS('contact_sex')
    tls_private = REQUEST.TLS('tls_private')
    tls_address = REQUEST.TLS('contact_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_search = REQUEST.TLS('tls_search')
    tls_description = REQUEST.TLS('tls_description')
    tls_searchcontact = REQUEST.TLS('contact_searchcontact')
    tls_homepage = REQUEST.TLS('contact_homepage')
    tls_fromto_to = REQUEST.TLS('tls_fromto_to')
    tls_male = REQUEST.TLS('contact_male')
    tls_female = REQUEST.TLS('contact_female')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_asearch = REQUEST.TLS('tls_adv_search')
    tls_dsearch = REQUEST.TLS('tls_dupe_search')
    tls_keyword = REQUEST.TLS('tls_keyword')
    
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    contact_category = _Utils.make_setting_selection(REQUEST, None, 'contact_category', 'contact_categories', is_multiple=1)
    c_fields = custom_fields.get_object_search_fields(REQUEST, REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id(), _InitTypes.ITEM_TYPE_CONTACT, 1)
    output.append("""\
<SCRIPT type="text/JavaScript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.searchform2[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
function change(numb)
{
  el1 = document.getElementById('1');
  el2 = document.getElementById('2');
  if(numb=='1')
  {
    el1.style.visibility='visible';
    el2.style.visibility='hidden';
  }
  else if(numb=='2')
  {
    el1.style.visibility='hidden';
    el2.style.visibility='visible';  }
}
%(datecheck_js)s
// -->
</SCRIPT>
<DIV id="1" style="position: absolute; width: 95%%; margin-left: auto; margin-right: auto; left: 0px; top: 50px; visibility: visible;">
<FORM name="searchform1" method="POST" action="%(BASE_CONTACT_URL)scontactsearch.py/search">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(tls_keyword)s:</TD>
    <TD class="td_listing1ve" nowrap><INPUT type="text" class="textfield4" name="search_keyword"></TD>
    <TD class="td_listing1" nowrap><INPUT type="submit" name="_search" value="%(tls_search)s" class="input2"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
<DIV id="2" style="position: absolute; width: 95%%; margin-left: auto; margin-right: auto; left: 0px; top: 50px; visibility: hidden;">
<FORM name="searchform2" method="POST" action="%(BASE_CONTACT_URL)scontactsearch.py/search">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1ke" nowrap>%(tls_first_name)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="first_name"></TD>
    <TD class="td_listing1ke" nowrap>%(tls_company)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="company"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(tls_middle_names)s:</TD>
    <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="middle_name"></TD>
    <TD class="td_listing0ke" nowrap>%(tls_department)s:</TD>
    <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="department"></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke" nowrap >%(tls_last_name)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="last_name"></TD>
    <TD class="td_listing1ke" nowrap>%(tls_job)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="jobtitle"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(tls_phone_work)s:</TD>
    <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="phone_work"></TD>
    <TD class="td_listing0ke" nowrap>%(tls_phone_fax)s:</TD>
    <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="phone_fax"></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke" nowrap>%(tls_phone_cell)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="phone_cell"></TD>
    <TD class="td_listing1ke" nowrap>%(tls_phone_home)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="phone_home"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(tls_email)s:</TD>
    <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="e_mail"></TD>
    <TD class="td_listing0ke" nowrap>%(tls_homepage)s:</TD>
    <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="homepage"></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke" nowrap>%(tls_address)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="mailing_address"></TD>
    <TD class="td_listing1ke" nowrap>%(tls_description)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="description"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(tls_dateofbirth)s:</TD>
    <TD class="td_listing0ve" colspan="3"><INPUT size="10" type="text" class="textfield1" name="birth_date_start" id="birth_date_start" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('birth_date_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A> %(tls_fromto_to)s <INPUT size="10" type="text" class="textfield1" name="birth_date_end" id="birth_date_end" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('birth_date_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_sex)s:</TD>
    <TD class="td_listing1ve">
      <SELECT name="contact_sex">
      <OPTION value="0">&nbsp;</OPTION>
      <OPTION value="1">%(tls_male)s</OPTION>
      <OPTION value="2">%(tls_female)s</OPTION>
      </SELECT>
    </TD>
    <TD class="td_listing1ke">%(tls_category)s:</TD>
    <TD class="td_listing1ve">%(contact_category)s:</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  %(c_fields)s
  <TR>
    <TD class="td_listing_noborder" colspan="4"><INPUT type="submit" name="_search" value="%(tls_search)s" class="input2"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))

    try:
        contact_view = REQUEST.get_setting('contact_view')
    except:
        contact_view = "0"

    if contact_view and contact_view=="1":
        sortby = [
'lower(last_name) ASC, lower(first_name) ASC', 'lower(last_name) DESC, lower(first_name) DESC',
'lower(company) ASC', 'lower(company) DESC',
'e_mail ASC', 'e_mail DESC',
'phone_work ASC', 'phone_work DESC',
'phone_fax ASC', 'phone_fax DESC',
]
    else:
        sortby = [
'lower(first_name) ASC, lower(last_name) ASC', 'lower(first_name) DESC, lower(last_name) DESC',
'lower(company) ASC', 'lower(company) DESC',
'e_mail ASC', 'e_mail DESC',
'phone_work ASC', 'phone_work DESC',
'phone_fax ASC', 'phone_fax DESC',
]
    
    tls_name = REQUEST.TLS('tls_name')
    tls_company = REQUEST.TLS('contact_company')
    tls_email = REQUEST.TLS('tls_email')
    tls_phone_work = REQUEST.TLS('tls_phone_work')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_contacts = REQUEST.TLS('tls_contacts')

    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_name = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=0">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    sortby_company = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=2">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_company)
    sortby_email = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=4">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_email)
    sortby_work = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=6">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_phone_work)
    sortby_fax = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=8">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_fax)
    if sortby_id == 0:
        sortby_name = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=1">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=0">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_company = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=3">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_company)
    elif sortby_id == 3:
        sortby_company = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=2">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_company)
    elif sortby_id == 4:
        sortby_email = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=5">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_email)
    elif sortby_id == 5:
        sortby_email = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=4">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_email)
    elif sortby_id == 6:
        sortby_work = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=7">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_phone_work)
    elif sortby_id == 7:
        sortby_work = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=6">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_phone_work)
    elif sortby_id == 8:
        sortby_fax = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=9">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_fax)
    elif sortby_id == 9:
        sortby_fax = u"""<A class="blackboldlink" href="%scontactsearch.py/search%ssort_by=8">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_fax)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('search_keyword'):
        w = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.strip().decode('UTF8').lower())
        if len(w)>=3:
            search_params = u""" AND i.item_id in (SELECT item_id FROM fti_search WHERE word = '%s' and fti_type=true)""" % w
        else:
            search_params = u"""AND (
lower(c.first_name) like '%%%s%%' OR 
lower(c.middle_name) like '%%%s%%' OR 
lower(c.last_name) like '%%%s%%' OR 
lower(c.company) like '%%%s%%' OR 
lower(c.department) like '%%%s%%' OR 
lower(c.jobtitle) like '%%%s%%' OR 
lower(c.phone_work) like '%%%s%%' OR 
lower(c.phone_home) like '%%%s%%' OR 
lower(c.phone_cell) like '%%%s%%' OR 
lower(c.phone_fax) like '%%%s%%' OR 
lower(c.e_mail) like '%%%s%%' OR 
lower(c.e_mail2) like '%%%s%%' OR 
lower(c.e_mail3) like '%%%s%%' OR 
lower(c.mailing_address) like '%%%s%%' OR 
lower(c.description) like '%%%s%%' OR 
lower(c.homepage) like '%%%s%%' OR 
lower(c.contact_category) like '%%%s%%')""" % (w, w, w, w, w, w, w, w, w, w, w, w, w, w, w, w, w)
    else:
        search_params = []
        if REQUEST.form.has_key('first_name') and REQUEST.form['first_name'].value:
            search_params.append(u"lower(c.first_name) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['first_name'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('last_name') and REQUEST.form['last_name'].value:
            search_params.append(u"lower(c.last_name) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['last_name'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('middle_name') and REQUEST.form['middle_name'].value:
            search_params.append(u"lower(c.middle_name) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['middle_name'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('company') and REQUEST.form['company'].value:
            search_params.append(u"lower(c.company) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['company'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('department') and REQUEST.form['department'].value:
            search_params.append(u"lower(c.department) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['department'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('jobtitle') and REQUEST.form['jobtitle'].value:
            search_params.append(u"lower(c.jobtitle) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['jobtitle'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('phone_work') and REQUEST.form['phone_work'].value:
            search_params.append(u"lower(c.phone_work) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['phone_work'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('phone_home') and REQUEST.form['phone_home'].value:
            search_params.append(u"lower(c.phone_home) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['phone_home'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('phone_cell') and REQUEST.form['phone_cell'].value:
            search_params.append(u"lower(c.phone_cell) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['phone_cell'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('phone_fax') and REQUEST.form['phone_fax'].value:
            search_params.append(u"lower(c.phone_fax) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['phone_fax'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('e_mail') and REQUEST.form['e_mail'].value:
            search_params.append(u"(lower(c.e_mail) like '%%%s%%' OR lower(c.e_mail2) like '%%%s%%' OR lower(c.e_mail3) like '%%%s%%')" % (_Utils.sql_quote_simple(REQUEST.form['e_mail'].value.decode('UTF8').lower()), _Utils.sql_quote_simple(REQUEST.form['e_mail'].value.decode('UTF8').lower()), _Utils.sql_quote_simple(REQUEST.form['e_mail'].value.decode('UTF8').lower())))
        if REQUEST.form.has_key('homepage') and REQUEST.form['homepage'].value:
            search_params.append(u"lower(c.homepage) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['homepage'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('mailing_address') and REQUEST.form['mailing_address'].value:
            search_params.append(u"lower(c.mailing_address) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['mailing_address'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('description') and REQUEST.form['description'].value:
            search_params.append(u"lower(c.description) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['description'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('contact_sex') and REQUEST.form['contact_sex'].value and int(REQUEST.form['contact_sex'].value):
            search_params.append(u"c.contact_sex = %d" % int(REQUEST.form['contact_sex'].value))
        if REQUEST.form.has_key('birth_date_start') and REQUEST.form['birth_date_start'].value.decode('UTF8').strip():
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['birth_date_start'].value.decode('UTF8').strip()).split('-'))
            date = _Utils.local2utc_mx(REQUEST, mx.DateTime.DateTime(year, month, day))
            search_params.append(u"c.birth_date>=%s" % _Utils.sql_quote(str(date)))
        if REQUEST.form.has_key('birth_date_end') and REQUEST.form['birth_date_end'].value.decode('UTF8').strip():
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['birth_date_end'].value.decode('UTF8').strip()).split('-'))
            date = _Utils.local2utc_mx(REQUEST, mx.DateTime.DateTime(year, month, day, 23, 59))
            search_params.append(u"c.birth_date<=%s" % _Utils.sql_quote(str(date)))

        contact_search = []
        if REQUEST.form.has_key('contact_category') and isinstance(REQUEST.form['contact_category'], list) and REQUEST.form['contact_category']:
            for itemval in REQUEST.form['contact_category']:
                contact_search.append(u"c.contact_category like '%%|%s|%%'" % _Utils.sql_quote_simple(itemval.decode('UTF8')))
        elif REQUEST.form.has_key('contact_category') and not isinstance(REQUEST.form['contact_category'], list) and REQUEST.form['contact_category'].value.decode('UTF8'):
            contact_search.append(u"c.contact_category like '%%|%s|%%'" % _Utils.sql_quote_simple(REQUEST.form['contact_category'].value.decode('UTF8')))
        if contact_search:
            search_params.append(u"(%s)" % u" OR ".join(contact_search))

        if search_params:
            search_params = u" AND %s" % " AND ".join(search_params)
        else:
            search_params = u""

    custom_pars = custom_fields.get_custom_search_query(REQUEST, _InitTypes.ITEM_TYPE_CONTACT)

    QUERY = """SELECT count(*) AS count_all FROM contacts c, items i WHERE c.contact_id=i.item_id %s%s%s""" % (right_param, search_params, custom_pars)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%scontactsearch.py/search%sqs=" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%scontactsearch.py/search%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%scontactsearch.py/search%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = None


    QUERY = """SELECT c.*, i.parent_id FROM contacts c, items i WHERE c.contact_id=i.item_id %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, search_params, custom_pars, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    tls_confirm = REQUEST.TLS('email_confirm_del')
    output.append(u"""
<script type="text/javascript">
function subm(numb)
{
  if(numb=='1')
  {
    if(confirm('%(tls_confirm)s'))
    {
      document.forms[0].action='%(BASE_CONTACT_URL)scontactindex.py';
    }
  }
  else
  {
    document.forms[0].action='%(BASE_EMAIL_URL)scompose.py/contactmail';
    document.forms[0].submit();
  }
}
function markAll(formvar){ for(var x=0;x<formvar.elements.length;x++) { var y=formvar.elements[x]; if(y.name != 'all') y.checked = formvar.all.checked; } }
</script>
<FORM action="%(BASE_EMAIL_URL)scompose.py/contactmail" method="POST">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_7.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_contacts)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal">
<TR>
  <TD class="td_listing1b" width="1%%"><INPUT type="checkbox" name="all" onClick="javascript:markAll(this.form);"></TD>
  <TD class="td_listing1b" width="29%%">%(sortby_name)s</TD>
  <TD class="td_listing1b" width="25%%">%(sortby_company)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_email)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_work)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_fax)s</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_CONTACT_URL'] = _Conf.BASE_CONTACT_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        if item['company'] is None: item['company'] = ""
        if item['e_mail'] is None: item['e_mail'] = ""
        if item['phone_work'] is None: item['phone_work'] = ""
        if item['phone_fax'] is None: item['phone_fax'] = ""

        item['company'] = _Utils.html_quote(item['company'].decode('UTF8'))
        item['first_name'] = _Utils.html_quote(item['first_name'].decode('UTF8'))
        item['last_name'] = _Utils.html_quote(item['last_name'].decode('UTF8'))
        item['phone_work'] = _Utils.html_quote(item['phone_work'].decode('UTF8'))
        item['phone_fax'] = _Utils.html_quote(item['phone_fax'].decode('UTF8'))
        item['e_mail'] = _Utils.html_quote(item['e_mail'].decode('UTF8'))
        if item['e_mail']:
            item['e_mail']= """<a href="%scompose.py?mail_to=%s%%20%s%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, item['first_name'], item['last_name'], item['e_mail'], item['e_mail'])
        if contact_view and contact_view=="1":
            item['c_name'] = """<A class="td_listing" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)d">%(last_name)s,&nbsp;%(first_name)s</A>""" % item
        else:
            item['c_name'] = """<A class="td_listing" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)d">%(first_name)s&nbsp;%(last_name)s</A>""" % item

        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d"><INPUT type="checkbox" name="sel_%(contact_id)d"></TD>
  <TD class="td_listing%(class_type)d" nowrap>%(c_name)s</TD>
  <TD class="td_listing%(class_type)d">%(company)s</TD>
  <TD class="td_listing%(class_type)d">%(e_mail)s</TD>
  <TD class="td_listing%(class_type)d">%(phone_work)s</TD>
  <TD class="td_listing%(class_type)d">%(phone_fax)s</TD>
</TR>""" % item)
    
    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)

    access_str = _Utils.get_module_access(REQUEST)
    types_menus = {_InitTypes.ITEM_TYPE_EMAIL: _Conf.MODULES_EMAIL}

    if access_str[types_menus[_InitTypes.ITEM_TYPE_EMAIL]]=="1":
      email_str = u"""<INPUT type="button" class="input6" onclick="subm('2');" value="%s">""" % (REQUEST.TLS('contact_sendemail'))
    else:
      email_str = ""

    merge_str = u"""&nbsp;<INPUT type="submit" onclick="this.form.action='%scontactindex.py'" class="input2" name="_merge" value="%s">""" % (_Conf.BASE_CONTACT_URL, REQUEST.TLS('tls_merge'))

    output.append(u"""
<BR>
<TABLE class="td_normal_noborder">
<TR>
  <TD><img src="%sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD width="50%%">%s%s</TD>
  <TD width="50%%" align="right"><INPUT type="submit" onclick="subm('1');" class="input2" name="_delete" value="%s">&nbsp;&nbsp;</TD>
  <TD><img src="%sspacer.gif" width=10 height=20 border=0 alt=""></TD>
</TR>
</TABLE>
<BR>""" % (_Conf.BASE_ICON_URL, email_str, merge_str, REQUEST.TLS('tls_deletesel'), _Conf.BASE_ICON_URL))
    output.append(u"""</FORM>""")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
