from mod_python import apache
import standard_html
import _InitTypes, _Conf, _Utils, Menus

import _DiscCategory, _RootObject, _Access, MultiForm
import mx.DateTime

MY_MENU_ID = 3

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
    output.append(standard_html.window_script(height=300,width=300))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_DISCCATEGORY])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT d.*, i.*, it.item_name AS parent_name FROM disccategories d, items i, items it WHERE d.disccategory_id=i.item_id AND i.parent_id=it.item_id%s ORDER BY parent_name, item_name""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    catrows = []
    ndx = 1
    for dbrow in dbresult:
        ndx += 1
        dbrow['class'] = ndx % 2
        dbrow['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        dbrow['item_name'] = _Utils.html_quote(dbrow['item_name'].decode('UTF8'))
        dbrow['parent_name'] = _Utils.html_quote(dbrow['parent_name'].decode('UTF8'))
        catrows.append(u"""
<TR>
  <TD nowrap class="td_listing%(class)d"><INPUT type="checkbox" name="sel_%(item_id)d"></TD>
  <TD nowrap class="td_listing%(class)d">%(item_name)s</TD>
  <TD nowrap class="td_listing%(class)d">%(parent_name)s</TD>
  <TD  class="td_listing%(class)d" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>""" % dbrow)
    if catrows:
        catrows = "\n".join(catrows)
    else:
        catrows = u""

    try:
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.getCookie('activediscFolder')))
        while obj.get('item_type_id') <> _InitTypes.ITEM_TYPE_ORGANIZATION:
            obj = obj.get_parent()
        my_parent_id = obj.get_id()
        my_parent_name = obj.get_virtual_path()
    except:
        my_parent_id = REQUEST.USER.get_parent_id(REQUEST)
        my_parent_name = REQUEST.USER.get_parent(REQUEST).get_virtual_path()
    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_delcat = REQUEST.TLS('disc_delcat')
    tls_addcat = REQUEST.TLS('disc_addcat')
    tls_name = REQUEST.TLS('tls_name')
    tls_parent = REQUEST.TLS('admin_organization')
    tls_save = REQUEST.TLS('tls_save')
    tls_rename = REQUEST.TLS('doc_rename')
    tls_del = REQUEST.TLS('tls_deletesel')
    folder_tls = REQUEST.TLS("doc_folder")
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_confirm = REQUEST.TLS('email_confirm_del')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.disccategory_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DISCUSSION_URL)scatadd.py/add" onsubmit="return check_values();">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_addcat)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1ke" style="border-top: 1px solid #CCCCCC" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing1ve" style="border-top: 1px solid #CCCCCC" nowrap><INPUT type="text" size=35 class="textfield1" name="disccategory_name"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0ke" nowrap>%(folder_tls)s:</TD>
  <TD class="td_listing0ve" nowrap><INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DISCUSSION_URL)sdisctree.py/frametree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" alt="" border="0"></A></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1" colspan="2"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
<BR>
<BR>
<FORM name="delform" method="POST" action="%(BASE_DISCUSSION_URL)scatadd.py/delcat">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_delcat)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" nowrap>%(tls_name)s</TD>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" nowrap colspan="2">%(tls_parent)s</TD>
</TR>
%(catrows)s
<TR>
  <TD class="td_listing_noborder" colspan="3"><INPUT type="submit" name="_delete" value="%(tls_del)s" onclick="return confirm('%(tls_confirm)s');" class="input6">&nbsp;<INPUT type="submit" name="_rename" value="%(tls_rename)s" class="input6"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add(REQUEST):
    if REQUEST.form.has_key('disccategory_name') and REQUEST.form['disccategory_name'].value.decode('UTF8').strip():
        cat = _DiscCategory.DiscCategory(REQUEST, _InitTypes.INIT_TYPE_REQ)
        cat.set('disccategory_name', REQUEST.form['disccategory_name'].value.decode('UTF8').strip())
        cat.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_DISCUSSION_URL+"catadd.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
    output.append(u"""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function change_url()
{
   return;
}
change_url();
// --> 
</script>
""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def delcat(REQUEST):
    del_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            del_ids.append(int(key[4:]))

    if REQUEST.form.has_key('_delete'):
        for del_id in del_ids:
            obj = _DiscCategory.DiscCategory(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            obj.delete()
    elif REQUEST.form.has_key('_rename'):
        BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
        REQ_FIELD = _Conf.REQ_FIELD
        tls_name = REQUEST.TLS('tls_name')
        tls_save = REQUEST.TLS('tls_save')
        tls_rename = REQUEST.TLS('doc_rename')
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        output = []
        output.append(standard_html.html_header(REQUEST))
        output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
        output.append(u"""
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DISCUSSION_URL)scatadd.py/delcat">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_rename)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
""" % locals())
        ndx = 0
        for del_id in del_ids:
            obj = _DiscCategory.DiscCategory(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            obj_name = obj.get_name()
            if ndx%2 == 0:
                td_class = 1
            else:
                td_class = 0
            output.append(u"""<INPUT type="hidden" name="form_%(ndx)d_contactid" value="%(del_id)d">
<TR>
  <TD class="td_listing%(td_class)skb" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing%(td_class)svb" nowrap><INPUT type="text" size=30 class="textfield1"  value="%(obj_name)s" name="form_%(ndx)d_catname"></TD>
  <TD class="td_listing%(td_class)svb" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>""" % locals())
            ndx += 1
        output.append(u"""
<TR>
  <TD class="td_listing_noborder" colspan="2"><INPUT type="submit" name="_saverename" value="%(tls_save)s" class="input2"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)

    elif REQUEST.form.has_key('_saverename'):
        output = []
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_DISCUSSION_URL+"catadd.py"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
        form = MultiForm.MultiForm(REQUEST)
        for row in form.get_rows():
            obj = _DiscCategory.DiscCategory(REQUEST, _InitTypes.INIT_TYPE_ID, int(row['contactid']))
            obj.set('disccategory_name', row['catname'])
            obj.save()
            output.append(u"""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function change_url()
{
   return;
}
change_url();
// --> 
</script>
""")
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_DISCUSSION_URL+"catadd.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
    output.append(u"""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function change_url()
{
   return;
}
change_url();
// --> 
</script>
""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

    REQUEST.mod_req.headers_out["Location"] = "%scatadd.py" % _Conf.BASE_DISCUSSION_URL
    return apache.HTTP_MOVED_TEMPORARILY

