import standard_html

import SQLTree, _InitTypes, _Conf, Menus

def index(REQUEST):
    return " "

def frametree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))

    a = SQLTree.SQLTree(REQUEST, "disctree2")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION])
    a.set_param('tree_url', _Conf.BASE_DISCUSSION_URL + 'disctree.py/frametree')
    a.set_param('target_url', _Conf.BASE_DISCUSSION_URL + 'discindex.py')
    a.set_param('target', 'framecontents')
    a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.addform.parent_id.value=%(item_id)d; window.opener.document.forms.addform.parent_name.value='%(item_name)s'; window.close();\">""")
    a.maketree()

    output.append(a.getTree())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
