import os, mx.DateTime
from mod_python import apache

import standard_html
import _Document, _InitTypes, _Conf, _Utils, Menus, _Folder, _RootObject, urllib, relations, custom_fields
import email, _RootObject, smtplib, _mail

MY_MENU_ID_FILE = 2
MY_MENU_ID_FOLDER = 3

def index(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID_FILE))
    output.append(standard_html.window_script(height=300,width=300))
    categories = _Utils.make_setting_selection(REQUEST, None, 'doc_category', 'doc_categories')
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""
    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    try:
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.getCookie('activeFolder')))
        my_parent_id = obj.get_id()
        my_parent_name = obj.get_virtual_path()
    except:
        my_parent_id = REQUEST.USER.get_parent_id(REQUEST)
        my_parent_name = REQUEST.USER.get_parent(REQUEST).get_virtual_path()
    add_file_tls = REQUEST.TLS("doc_addfile")
    file_tls = REQUEST.TLS("doc_file")
    save_tls = REQUEST.TLS("tls_save")
    title_tls = REQUEST.TLS("tls_title")
    author_tls = REQUEST.TLS("doc_author")
    folder_tls = REQUEST.TLS("doc_folder")
    desc_tls = REQUEST.TLS("tls_description")
    comments_tls = REQUEST.TLS("tls_comments")
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_category = REQUEST.TLS('tls_category')
    tls_simple = REQUEST.TLS('doc_simple')
    tls_advanced = REQUEST.TLS('doc_advanced')
    REQ_FIELD = _Conf.REQ_FIELD
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    c_fields = custom_fields.get_object_search_fields(REQUEST, REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id(), _InitTypes.ITEM_TYPE_DOCUMENT, 1)

    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values1()
  {
    vorm=document.getElementById('c3');
    if (!vorm.filepointer.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
  function check_values2()
  {
    vorm=document.getElementById('c4');
    if (!vorm.filepointer.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
  function change()
  {
    simple=document.getElementById('c1');
    advanced=document.getElementById('c2');
    if(simple.style.visibility=='visible')
    {
    simple.style.visibility='hidden';
    advanced.style.visibility='visible';
    }
    else
    {
    advanced.style.visibility='hidden';
    simple.style.visibility='visible';
    }
  }
// -->
</SCRIPT>
<BR>
<div style="position:absolute; top:50px; width: 95%%; margin-left: auto; margin-right: auto; left:0px; visibility: visible" id="c1">
<FORM name="addform1" id="c3" method="POST" action="%(BASE_DOCUMENT_URL)sdocadd.py/addfile" ENCTYPE="multipart/form-data" onSubmit="return check_values1();">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_4.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(add_file_tls)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD width="100%%">
  <TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border=0 alt=""></TD>
      <TD nowrap><a class="blacklink" href="#" onclick="change();">&laquo; %(tls_advanced)s &raquo;</a></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  </TABLE>
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(file_tls)s:</TD>
    <TD class="td_listing1" width="100%%"><INPUT size=35 class="textfield1" type="file" name="filepointer"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0ke" nowrap>%(title_tls)s:</TD>
    <TD class="td_listing0"><INPUT  size=35 class="textfield1" type="text" name="title" maxlength=100></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(author_tls)s:</TD>
    <TD class="td_listing1"><INPUT  size=35 class="textfield1" type="text" name="author"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0ke" nowrap>%(folder_tls)s:</TD>
    <TD class="td_listing0"><INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/frametree?form=addform1" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" alt="" border="0"></A></TD>
  </TR>
  <TR class="tr_listing1">
    <TD colspan="2" class="td_listing_noborder"><INPUT type="submit" class="input2" name="_save" value="%(save_tls)s"></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
<DIV style="position:absolute; top:50px; width: 95%%; margin-left: auto; margin-right: auto; left:0px; visibility: hidden" id="c2">
<FORM name="addform" id="c4" method="POST" action="%(BASE_DOCUMENT_URL)sdocadd.py/addfile" ENCTYPE="multipart/form-data" onSubmit="return check_values2();">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_4.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(add_file_tls)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD width="100%%">
  <TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border=0 alt=""></TD>
      <TD nowrap><a class="blacklink" href="#" onclick="change();">&laquo; %(tls_simple)s &raquo;</a></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  </TABLE>
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1ke">%(REQ_FIELD)s%(file_tls)s:</TD>
  <TD class="td_listing1" width="100%%" colspan="4"><INPUT size=35 class="textfield1" type="file" name="filepointer"></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke">%(title_tls)s:</TD>
  <TD class="td_listing0" colspan="4"><INPUT  size=35 class="textfield1" type="text" name="title" maxlength=100></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke">%(author_tls)s:</TD>
  <TD class="td_listing1" colspan="4"><INPUT  size=35 class="textfield1" type="text" name="author"></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke">%(tls_category)s:</TD>
  <TD class="td_listing0" colspan="4">%(categories)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke">%(folder_tls)s:</TD>
  <TD class="td_listing1" colspan="4"<INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/frametree?form=addform" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" alt="" border="0"></A></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0b" colspan="5">%(desc_tls)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20"></TEXTAREA></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1b" colspan="5">%(comments_tls)s<BR><TEXTAREA class="textarea1" name="comments" rows="3" cols="20"></TEXTAREA></TD>
</TR>
%(c_fields)s
<TR class="tr_listing0">
  <TD colspan="5" class="td_listing_noborder"><INPUT type="submit" class="input2" name="_save" value="%(save_tls)s"></TD>
</TR>
</TABLE>
</FORM>
</DIV>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def addfolderform(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID_FOLDER))
    output.append(standard_html.window_script(height=300,width=300))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""
    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    add_folder_tls = REQUEST.TLS("doc_addfolder")
    name_tls = REQUEST.TLS("doc_foldername")
    folder_tls = REQUEST.TLS("doc_folder")
    comments_tls = REQUEST.TLS("tls_comments")
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    save_tls = REQUEST.TLS("tls_save")
    try:
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.getCookie('activeFolder')))
        my_parent_id = obj.get_id()
        my_parent_name = obj.get_virtual_path()
    except:
        my_parent_id = REQUEST.USER.get_parent_id(REQUEST)
        my_parent_name = REQUEST.USER.get_parent(REQUEST).get_virtual_path()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.folder_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(add_folder_tls)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DOCUMENT_URL)sdocadd.py/addfolder" onSubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(name_tls)s:</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="text" size="35" class="textfield1" name="folder_name" maxlength=50></TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="3" class="td_listing0b">%(comments_tls)s<BR><TEXTAREA class="textarea1" name="comments" rows="3" cols="20"></TEXTAREA></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(folder_tls)s:</TD>
    <TD class="td_listing1"><INPUT size=67 type="text" class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/frametree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" alt="" border="0"></A></TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="3" class="td_listing_noborder"><INPUT type="submit" class="input2" name="_save" value="%(save_tls)s"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def addfile(REQUEST):
    output = []
    if not REQUEST.form.has_key('filepointer'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    if REQUEST.form['filepointer'].filename.find('\\') <> -1:
        filename = REQUEST.form['filepointer'].filename.decode('UTF8').split('\\')[-1]
    else:
        filename = REQUEST.form['filepointer'].filename.decode('UTF8')
    filename = _Utils.make_path(os.path.split(filename)[-1])
    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_REQ)
    if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
        doc.set('title', filename)
    doc.set('filename', filename)
    if os.path.exists(doc.get_path().encode('UTF8')):
        # Try adding a new unique number:
        origpath = doc.get_path()
        splitpath = os.path.splitext(origpath)
        newname = None
        for i in range(1,100):
            tmppath = splitpath[0] + ('-%d'%i) + splitpath[1]
            if not os.path.exists(tmppath.encode('UTF8')):
                newname = os.path.split(splitpath[0] + ('-%d'%i) + splitpath[1])[1]
                break
        if newname is None:
            raise RuntimeError, REQUEST.TLS('doc_rename_exists')
        else:
            if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
                doc.set('title', newname)
            doc.set('filename', newname)
    doc.save()
    custom_fields.save_custom_vals(REQUEST, doc.get_id())
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = int(REQUEST.form['rel_id'].value)
      relations.add_relation(REQUEST, rel_id, doc.get_id())

    _mail.email_notify(REQUEST, doc, 1)
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      ref_url = urllib.unquote(REQUEST.form['returl'].value.strip())
      extra_head = u"""
<script type="text/javascript">
function change_url()
{
top.frames['topcontents'].location.href='%s';
}
</script>""" % ref_url
      extra_body = " onload='change_url()'"
      output.append(standard_html.html_header_popup(REQUEST, extra_head, extra_body))
      output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID_FILE))
      output.append(standard_html.html_footer3(REQUEST))
    else:
      output.append(standard_html.html_header(REQUEST))
      ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(doc.get_parent_id())
      output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
      output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID_FILE))
      output.append(REQUEST.TLS('doc_fileadded2') % doc.get_virtual_path())
      output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)

def addfolder(REQUEST):
    output = []
    if not REQUEST.form.has_key('folder_name') or not  REQUEST.form['folder_name'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if REQUEST.form['folder_name'].value.decode('UTF8').strip().find('/') <> -1:
        raise RuntimeError, REQUEST.TLS('docinvalidrename')
    folder = _Folder.Folder(REQUEST, _InitTypes.INIT_TYPE_NEW)
    folder.set('parent_id', int(REQUEST.form['parent_id'].value))
    folder.set('folder_name', REQUEST.form['folder_name'].value.decode('UTF8').strip())
    folder.set('comments', REQUEST.form['comments'].value.decode('UTF8'))
    if os.path.exists(folder.get_path().encode('UTF8')):
        raise RuntimeError, REQUEST.TLS('doc_rename_exists')
    folder.save()
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = int(REQUEST.form['rel_id'].value)
      relations.add_relation(REQUEST, rel_id, folder.get_id())

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      ref_url = urllib.unquote(REQUEST.form['returl'].value.strip())
      extra_head = u"""
<script type="text/javascript">
function change_url()
{
top.frames['topcontents'].location.href='%s';
}
</script>""" % ref_url
      extra_body = " onload='change_url()'"
      output.append(standard_html.html_header_popup(REQUEST, extra_head, extra_body))
      output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID_FILE))
      output.append(standard_html.html_footer3(REQUEST))
    else:
      output.append(standard_html.html_header(REQUEST))
      ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(folder.get_parent_id())
      output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
      output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID_FOLDER))
      output.append(REQUEST.TLS('doc_folderadded'))
      output.append(u"""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function change_url()
{
   parent.frametree.location.href='%sdoctree.py?timestamp=%s';
}
change_url();
// -->
</script>
""" % (_Conf.BASE_DOCUMENT_URL, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
      output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)
