from mod_python import apache
import standard_html
import urllib
import _Conf, _Utils, Menus, _InitTypes, _Exceptions, _RootObject

MY_MENU_ID = 4

ITEM_TYPE_ID = _InitTypes.ITEM_TYPE_DOCUMENT

def index(REQUEST):
    output = []

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_subscribed = REQUEST.TLS('tls_subscribed')
    tls_name = REQUEST.TLS('tls_name')
    tls_owner = REQUEST.TLS('tls_creator')
    tls_edit = REQUEST.TLS('tls_edittime')
    tls_create = REQUEST.TLS('tls_createtime')
    tls_action = REQUEST.TLS('email_action')
    tls_add = REQUEST.TLS('tls_add')
    tls_delete = REQUEST.TLS('tls_remove')
    tls_short_edit = REQUEST.TLS('admin_edit')
    tls_short_del = REQUEST.TLS('email_short_del')
    BASE_DOCUMENT_URL = _Conf. BASE_DOCUMENT_URL



    if(REQUEST.form.has_key('_delete')):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
        del_id_1 = REQUEST.USER.get_id()
        for del_id_2 in del_ids:
            SQL = "DELETE FROM item_rels WHERE relation_flags=%d AND (left_item_id = %d AND right_item_id = %d) OR (left_item_id = %d AND right_item_id = %d)" % (0, del_id_1, del_id_2, del_id_2, del_id_1)
            REQUEST.db.execute(SQL)

    SQL = """\
SELECT
 ir.*,
CASE WHEN i.item_id=ir.right_item_id THEN i.item_name ELSE i2.item_name END AS right_item_name,
CASE WHEN i.item_id=ir.right_item_id THEN i2.item_name ELSE i.item_name END AS left_item_name,
CASE WHEN i.item_id=ir.right_item_id THEN i.item_type_id ELSE i2.item_type_id END AS right_type_id,
CASE WHEN i.item_id=ir.right_item_id THEN i2.item_type_id ELSE i.item_type_id END AS left_type_id,
CASE WHEN i.item_id=ir.right_item_id THEN i.edit_time ELSE i2.edit_time END AS right_edit_time,
CASE WHEN i.item_id=ir.right_item_id THEN i2.edit_time ELSE i.edit_time END AS left_edit_time
FROM
 item_rels ir,
 items i,
 items i2
WHERE
 ir.relation_flags=%d AND
 (i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d)
  OR
 (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d)
""" % (0, REQUEST.USER.get_id(), REQUEST.USER.get_id())
    REQUEST.db.execute(SQL)
    relations = REQUEST.db.dictfetchall()
    relations_dict = {}
    for relation in relations:
        try:
            if REQUEST.USER.get_id() == relation['left_item_id']:
                relations_dict[relation['right_type_id']].append(relation)
            else:
                relations_dict[relation['left_type_id']].append(relation)
        except KeyError:
            if REQUEST.USER.get_id() == relation['left_item_id']:
                relations_dict[relation['right_type_id']] = []
                relations_dict[relation['right_type_id']].append(relation)
            else:
                relations_dict[relation['left_type_id']] = []
                relations_dict[relation['left_type_id']].append(relation)


    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(u"""
<FORM name="addform" method="POST" action="%(BASE_DOCUMENT_URL)sdocsubscribed.py?rel=1" onsubmit="return check_values();">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_3.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_subscribed)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">&nbsp;</TD>
  <TD class="td_listing1b">&nbsp;</TD>
  <TD class="td_listing1b">%(tls_name)s</TD>
  <TD class="td_listing1b">%(tls_owner)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    index = 0
    for itemlist in relations_dict:
        for data in relations_dict[itemlist]:
            tmp_id = REQUEST.USER.get_id()
            REQUEST.su_by_id(_Conf.SUPERUSER)
            try:
                if tmp_id == data['left_item_id']:
                    obj = _RootObject.dispatch_item(REQUEST, data['right_item_id'])
                else:
                    obj = _RootObject.dispatch_item(REQUEST, data['left_item_id'])
            except _Exceptions.RootObjectError:
                REQUEST.unsu()
                continue
            REQUEST.unsu()
            temp_name = obj.get_name()
            obj_name = _Utils.html_quote_show((_Utils.shorten_string(obj.get_virtual_path()[:-len(temp_name)], 25)+"/"+obj.get_name()).replace("//", "/"))
            obj_id = obj.get_id()
            SQL="""select item_type_icon from item_types where item_type_id = %d""" %(obj.get('item_type_id'))
            REQUEST.db.execute(SQL)
            item_info = REQUEST.db.dictfetchall()
            obj_icon = item_info[0]['item_type_icon']
            if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
                file_ext = os.path.splitext(obj.get('filename') or '')[-1]
                if(_Conf.MIME_TYPES.has_key(file_ext)):
                    obj_icon =  _Conf.MIME_TYPES[file_ext]
                else:
                    obj_icon =  _Conf.MIME_TYPES["unknown_ext"]
            REQUEST.su_by_id(_Conf.SUPERUSER)
            try:
                obj_creator = _RootObject.dispatch_item(REQUEST, obj.get('creator_id')).get_name()
            except _Exceptions.RootObjectError:
                obj_creator = u"N/A"
            REQUEST.unsu()
            obj_edit = REQUEST.iso2userdatetime(REQUEST, obj.get('edit_time'))
            obj_create = REQUEST.iso2userdatetime(REQUEST, obj.get('create_time'))
            items = {'item_id':obj_id, 'BASE_CALENDAR_URL':_Conf.BASE_CALENDAR_URL}
            if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_FOLDER:
                link = _Conf.BASE_DOCUMENT_URL + "docframe.py?doc_url=" + urllib.quote(_Conf.BASE_DOCUMENT_URL + 'folder.py?parent_id=%(item_id)d' % items)
                view_link = u"""<a class="td_listing" href="%(link)s">""" % locals()
                ed_link = _Conf.BASE_DOCUMENT_URL + "docframe.py?doc_url=" + urllib.quote(_Conf.BASE_GENERAL_URL + 'info.py?item_id=%(item_id)d' % items)
                edit_link = u"""<a class="td_listing" href="%(ed_link)s">""" % locals()
            else:
                try:
                    view_link = link_dict[obj.get('item_type_id')] % items
                except:
                    view_link = '#'
                try:
                    edit_link = edit_dict[obj.get('item_type_id')] % items
                except:
                    link = '#'
            if index%2==0:
              td_class = "0"
            else:
              td_class = "1"
            index = index + 1
            output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"     width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s"     width="1%%"><input type="checkbox" name="sel_%(obj_id)s"></TD>
  <TD class="td_listing_rel%(td_class)s" width="1%%" style="border-bottom: 1px solid #CCCCCC;"><IMG src="%(BASE_ICON_URL)s%(obj_icon)s" border="0" alt=""></TD>
  <TD class="td_listing%(td_class)s"     width="76%%"><a href="%(BASE_DOCUMENT_URL)sfolder.py?parent_id=%(obj_id)s">%(obj_name)s</a></TD>
  <TD class="td_listing%(td_class)s"     width="20%%" nowrap>%(obj_creator)s</TD>
  <TD class="td_listing%(td_class)s"     width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    item_add = u"""onclick="open_window('%sselectrel.py?item_id=%d&item_type_id=%d');" """ % (_Conf.BASE_GENERAL_URL, REQUEST.USER.get_id(), _InitTypes.ITEM_TYPE_FOLDER)
    output.append(u"""
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing_noborder" width="50%%" colspan="2"><input type="button" class="input6" value=" %(tls_add)s " %(item_add)s></TD>
  <TD class="td_listing_noborder" width="50%%" colspan="2" align="right"><input type="submit" class="input6" name="_delete" value=" %(tls_delete)s "></TD>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())


    output.append(standard_html.window_script(target='relwin',height=550, width=600))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)