import standard_html

import SQLTree, _InitTypes, _Conf, Menus

def index(REQUEST):
    output = []
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    app_name = _Conf.APP_NAME
    output.append(u"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <TITLE>%(app_name)s</TITLE>
    <LINK rel="stylesheet" href="%(BASE_WEB_URL)sconflux.css">
    <LINK REL="SHORTCUT ICON" HREF="%(BASE_WEB_URL)sfavicon.ico">
</HEAD>
<BODY  onload=initf(); background="%(BASE_WEB_URL)sicons/treebg.gif">""" % locals())
    output.append(Menus.get_document_tree_menu(REQUEST, 1))
    tls_hidetree = REQUEST.TLS('doc_hidetree')
    tls_doctree = REQUEST.TLS('compmenu_doc_tree')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    try:
        interface = REQUEST.get_setting('interface_type')
    except:
        interface = "0"
    if interface and interface=="1":
        output.append(u"""
<script type="text/javascript">
function show_startmenu(){ var ie=document.all && !window.opera; var dom=document.getElementById; iebody=(document.compatMode=="CSS1Compat")?document.documentElement : document.body; objref=(dom)?document.getElementById("start_menu"):document.all.start_menu; var scroll_top=(ie)?iebody.scrollTop : window.pageYOffset; docheight=(ie)? iebody.clientHeight: window.innerHeight; objheight=objref.offsetHeight; objref.style.left=1+"px"; objref.style.top=scroll_top+docheight-objheight+"px"; showonscrollvar=setInterval("mv_mnu()", 50); }
function mv_mnu(){ var ie=document.all && !window.opera; var scroll_top=(ie)? iebody.scrollTop : window.pageYOffset; objref.style.top=scroll_top+docheight-objheight+"px"; }
function initf(){  setTimeout("show_startmenu()", 25); } if (window.addEventListener)        window.addEventListener("load", initf, false); else if (window.attachEvent)        window.attachEvent("onload", initf); else if (document.getElementById)   window.onload=initf;
</script>
<DIV style="position: absolute; top: 0px; left: 0px; width: 150px;">
<TABLE cellpadding=0 width="100%%" cellspacing=0 class="table_menu" style="background-image: url('%(BASE_ICON_URL)streetopbg.gif')">
  <TR>
    <TD width="8" class="td_menu" ><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD valign=top nowrap style="padding: 1px;" class="topmenu_link"><IMG src="%(BASE_ICON_URL)streeicon.gif" width="17" height="16" border="0" alt="" style="position: relative; top -1px;">&nbsp;&nbsp;%(tls_doctree)s</TD>
    <TD width="10" class="td_menu"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD align="right" width="100%%">&nbsp;</TD>
  </TR>
</TABLE>
</DIV>""" % locals())
    else:
        output.append(u"""
<script type="text/javascript">function initf() { return true; }</script>
<DIV style="position: absolute; top: 0px; left: 0px; width: 150px;">
<TABLE cellpadding=0 width="100%%" cellspacing=0 class="table_menu" style="background-image: url('%(BASE_ICON_URL)streetopbg.gif')">
  <TR>
    <TD width="8" class="td_menu" ><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD valign=top nowrap style="padding: 1px;"><IMG src="%(BASE_ICON_URL)streeicon.gif" width="17" height="16" border="0" alt="" style="position: relative; top -1px;">&nbsp;&nbsp;<A class="topmenu_link" href="#" onclick="parent.document.getElementById('1212').cols='0,*'; parent.framecontents.document.getElementById('1213').style.display='block';">%(tls_hidetree)s</A></TD>
    <TD width="10" class="td_menu"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD align="right" width="100%%">&nbsp;</TD>
  </TR>
</TABLE>
</DIV>""" % locals())

    a = SQLTree.SQLTree(REQUEST, "doctree1")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_FOLDER])
    a.set_param('tree_url', _Conf.BASE_DOCUMENT_URL + 'doctree.py')
    a.set_param('target_url', _Conf.BASE_DOCUMENT_URL + 'folder.py')
    a.set_param('target', 'framecontents')
    a.set_param('urlparams', 'parent_id=%(item_id)d')
    a.set_param('shorten', 1)
    a.maketree()
    output.append(a.getTree())
    output.append(standard_html.html_footer2(REQUEST))
    return "\n".join(output)

def frametree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    if REQUEST.form.has_key('form') and REQUEST.form['form'].value.decode('UTF8').strip():
        form_name = REQUEST.form['form'].value.decode('UTF8').strip()
    else:
        form_name = ""
    a = SQLTree.SQLTree(REQUEST, "doctree2")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_FOLDER])
    a.set_param('tree_url', _Conf.BASE_DOCUMENT_URL + 'doctree.py/frametree')
    a.set_param('target_url', _Conf.BASE_DOCUMENT_URL + 'folder.py')
    a.set_param('target', 'framecontents')
    if form_name=='addform1':
      a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.addform1.parent_id.value=%(item_id)d; window.opener.document.forms.addform1.parent_name.value='%(item_path)s'; window.close();\">""")
    else:
      a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.addform.parent_id.value=%(item_id)d; window.opener.document.forms.addform.parent_name.value='%(item_path)s'; window.close();\">""")
    a.maketree()
    output.append(a.getTree())
    output.append(standard_html.html_footer2(REQUEST))
    return "\n".join(output)

def simplesearchtree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    a = SQLTree.SQLTree(REQUEST, "doctree2")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_FOLDER])
    a.set_param('tree_url', _Conf.BASE_DOCUMENT_URL + 'doctree.py/simplesearchtree')
    a.set_param('target_url', _Conf.BASE_DOCUMENT_URL + 'folder.py')
    a.set_param('target', 'framecontents')
    a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.simple_search_form.parent_id.value=%(item_id)d; window.opener.document.forms.simple_search_form.parent_name.value='%(item_name)s'; window.close();\">""")
    a.maketree()
    output.append(a.getTree())
    output.append(standard_html.html_footer2(REQUEST))
    return "\n".join(output)

def complexsearchtree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    a = SQLTree.SQLTree(REQUEST, "doctree2")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_FOLDER])
    a.set_param('tree_url', _Conf.BASE_DOCUMENT_URL + 'doctree.py/complexsearchtree')
    a.set_param('target_url', _Conf.BASE_DOCUMENT_URL + 'folder.py')
    a.set_param('target', 'framecontents')
    a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.complex_search_form.parent_id.value=%(item_id)d; window.opener.document.forms.complex_search_form.parent_name.value='%(item_name)s'; window.close();\">""")
    a.maketree()
    output.append(a.getTree())
    output.append(standard_html.html_footer2(REQUEST))
    return "\n".join(output)
