"""

$Id: compose.py,v 1.14 2004/02/15 13:10:56 incxcvs Exp $
"""

from mod_python import apache
import urllib
import base64, email, email.Header, email.MIMEMultipart, email.MIMEText, mx.DateTime, smtplib, email.Utils, email.MIMEMessage
import _Conf, _Utils, _mail, _InitTypes, _Email, _Efolder, _Document, _Contact, _Access, _InitTypes, _Eaccount
from Menus import get_email_menu
import standard_html
import MIMEFile
import popen2
import re

MY_MENU_ID=2

def index(REQUEST):
    try:
        tmp = REQUEST.get_setting('email_sender_name')
        tmp = REQUEST.get_setting('email_sender_email')
    except:
        raise RuntimeError, REQUEST.TLS('email_nosettings')
    if REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '1':
        return delete(REQUEST)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '2':
        return forward(REQUEST)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '3':
        return reply(REQUEST)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '5':
        return forward(REQUEST, attach=1)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '4':
        return replyall(REQUEST)
    elif REQUEST.form.has_key('email_delete'):
        return delete(REQUEST)
    elif REQUEST.form.has_key('email_forward'):
        return forward(REQUEST)
    elif REQUEST.form.has_key('email_reply'):
        return reply(REQUEST)
    elif REQUEST.form.has_key('email_forward2'):
        return forward(REQUEST, attach=1)
    elif REQUEST.form.has_key('email_replyall'):
        return replyall(REQUEST)
    elif REQUEST.form.has_key('email_contact'):
        return contactmail(REQUEST)
    else:
        return compose(REQUEST)

def parse_obj_addresses(msg, val, include_groups=1):
    if val is None: return ""
    val = val.replace('"{', '{').replace('}"', '}')
    val = val.replace("{", '"{').replace("}", '}"')
    to_emails = email.Utils.getaddresses([val])
    to = []
    for r in to_emails:
        if r[0]:
            n = _mail.parse_quoted_string(msg, r[0])
            if n.find('"') == -1:
                to.append('%s <%s>' % (email.Header.Header(u'"%s"'%n).encode().strip(), r[1].strip().encode('UTF8')))
            else:
                to.append('%s <%s>' % (email.Header.Header(u'"%s"'%r[0]).encode().strip(), r[1].strip().encode('UTF8')))
            if to[-1].find('"=?') <> -1: # Double-quoting issue. Maybe FIXME?
                to[-1] = to[-1].replace('"=?', '=?').replace('?="', '?=')
        else:
            if ((r[1] and r[1][0]=="{") or r[1][:2] == '"{') and ((r[1] and r[1][-1]=="}") or r[1][-2:]=='}"') and include_groups:
                to.append(email.Header.Header(u'%s'%r[1]).encode().strip())               
                if to[-1].find('"=?') <> -1: # Double-quoting issue. Maybe FIXME?
                    to[-1] = to[-1].replace('"=?', '=?').replace('?="', '?=')
            elif ((r[1] and r[1][0]=="{") or r[1][:2] == '"{') and ((r[1] and r[1][-1]=="}") or r[1][-2:]=='}"') and not include_groups:
                pass
            else:
                try:
                    if isinstance(r[1], unicode):
                        to.append(r[1].encode('UTF8'))
                    else:
                        to.append(r[1])
                except:
                    raise RuntimeError, [r[1], type(r[1])]
    return ", ".join(to)


def compose(REQUEST):
    # Find out drafts id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DRAFTS))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodraftsfolder')
    DRAFT_ID = result['efolder_id']

    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"

    REQUEST.db.execute("""SELECT e.email_id, e.email_to, e.email_subject FROM items i, emails e WHERE i.item_id=e.email_id AND i.parent_id=%d AND (e.email_flags & %d) <> 0""" % (DRAFT_ID, _Email.EMAIL_DRAFT))
    result = REQUEST.db.dictfetchall()
    drafts = []
    for draft in result:
        drafts.append(u"""<OPTION value="%d">%s""" % (draft['email_id'], _Utils.html_quote(draft['email_subject'].decode('UTF8'))))
    if drafts:
        drafts = u"""
 <TR class="tr_listing1">
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b">%s:</TD>
  <TD class="td_listing1"><SELECT name="select_draft" onChange="change_url(document.composeform.select_draft[document.composeform.select_draft.selectedIndex].value)"><OPTION value="">&nbsp;&nbsp;&nbsp;\n%s\n</SELECT></TD>
 </TR>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('email_drafts'), "\n".join(drafts))
    else:
        drafts = u""

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        if msg.get('email_contacts'):
            return contactmail(REQUEST)
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&type_compose=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))
        if attach_output:
            attach_output = """
 <TR>
  <TD><img src="%sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        attach_output = u""
        mail_id = u""
        if REQUEST.form.has_key('mail_to') and REQUEST.form['mail_to'].value.strip():
            mail_to = urllib.unquote(REQUEST.form['mail_to'].value.decode('UTF8').strip())
        else:
            mail_to = u""
        mail_cc = u""
        mail_bcc = u""
        mail_contents = u""
        mail_subject = u""

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_selectdoc = REQUEST.TLS('email_selectdoc')
    tls_choose = REQUEST.TLS('email_choose')
    output = []
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))
    hiddenstr = ""
    if REQUEST.form.has_key('read_mail_id') and REQUEST.form['read_mail_id'].value:
        hiddenstr = """<input type="hidden" name="read_mail_id" value="%s"><input type="hidden" name="type_reply" value="1">""" % (REQUEST.form['read_mail_id'].value)
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    output.append(form_html(REQUEST, mail_id, drafts, attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def contactmail(REQUEST):
    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        con_ids = msg.get('email_contacts') or u''
        con_ids = map(int, con_ids.split(u','))
        cons = "&".join(map(lambda x: u"sel_%d=1" % x, con_ids))
        if cons:
            cons = u"&%s" % cons
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&type_contact=1&part=%s%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), attach['conflux-ident'], cons, REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """
 <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)

        contact_list = []
        contact_hidden = []
        for con_id in con_ids:
            con_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, con_id)
            if con_obj.get('e_mail'):
                contact_list.append(u"""%s %s &lt;%s&gt;""" % (con_obj.get('first_name'), con_obj.get('last_name'), con_obj.get('e_mail')))
                contact_hidden.append(u"""<INPUT type="hidden" name="sel_%d" value="1">""" % con_id)
        if contact_list:
            contact_list = u"<BR>%s" % u"<BR>".join(contact_list)
            contact_hidden = "\n".join(contact_hidden)
        else:
            contact_list = u""
            contact_hidden = u""
    else:
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append(int(key[4:]))

        contact_list = []
        contact_hidden = []
        cons = "&".join(map(lambda x: u"sel_%d=1" % x, con_ids))
        if cons:
            cons = u"&%s" % cons
        for con_id in con_ids:
            con_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, con_id)
            if con_obj.get('e_mail'):
                contact_list.append(u"""%s %s &lt;%s&gt;""" % (con_obj.get('first_name'), con_obj.get('last_name'), con_obj.get('e_mail')))
                contact_hidden.append(u"""<INPUT type="hidden" name="sel_%d" value="1">""" % con_id)
        if contact_list:
            contact_list = u"<BR>%s" % u"<BR>".join(contact_list)
            contact_hidden = "\n".join(contact_hidden)
        else:
            contact_list = u""
            contact_hidden = u""
        
        attach_output = u""
        mail_id = u""
        if REQUEST.form.has_key('mail_to') and REQUEST.form['mail_to'].value.strip():
            mail_to = urllib.unquote(REQUEST.form['mail_to'].value.decode('UTF8').strip())
        else:
            mail_to = u""
        mail_cc = u""
        mail_bcc = u""
        mail_contents = u""
        mail_subject = u""
        if not mail_to:
            try:
                mail_to = REQUEST.get_setting('email_sender_email')
            except:
                pass

    output = []
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_or = REQUEST.TLS('tls_or')
    tls_contacts = REQUEST.TLS('tls_contacts')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="type_contact" value="1">
%(contact_hidden)s""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, "", contact_list))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def delete(REQUEST):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    # Find out delete-items id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DELETED))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodeletedfolder')
    DELBOX_ID = result['efolder_id']

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"efolder1.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_email_menu(REQUEST, -1))

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    if msg.get_parent_id() == DELBOX_ID:
        msg.delete()
        output.append(REQUEST.TLS('email_msgdeleted2'))
    else:
        msg.set('parent_id',DELBOX_ID)
        msg.set('is_private', 1)
        msg.save()
        output.append(REQUEST.TLS('email_msgdeleted'))

    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def reply(REQUEST):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []

    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))

    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    mail_contents = []
    msg_reply = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    message_reply = _mail.message_from_string(base64.decodestring(msg_reply.get('email_contents')))
    mail_contents.append(u"On %s, %s wrote:" % (REQUEST.iso2userdatetime(REQUEST, msg_reply.get('email_date')), (email.Utils.parseaddr(msg_reply.get('email_from'))[0] or msg_reply.get('email_from')))) # FIXME
    mail_contents.append(u" ")
    mail_contents.append(_mail.reply_message(REQUEST, message_reply))
    mail_contents = "\n".join(mail_contents)
    mail_contents = mail_contents.replace('\r', '')
    ndx = mail_contents.find('\n\n\n')
    while ndx <> -1:
        mail_contents = mail_contents.replace('\n\n\n', '\n\n')
        ndx = mail_contents.find('\n\n\n')
    mail_contents = mail_contents.replace('\n', '<br>&gt; ')


    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_replymessage = REQUEST.TLS('email_replymessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    reply_mail_id = msg_reply.get_id()

    mail_to = _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['from']))

    mail_subject = "Re: %s" % msg_reply.get('email_subject') # FIXME
    if isinstance(mail_subject, str):
        mail_subject = mail_subject.decode('UTF8')
    mail_subject = _Utils.html_quote(mail_subject)

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(message) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """
 <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
#        mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        attach_output = u""
        mail_id = u""
        mail_cc = u""
        mail_bcc = u""
        

    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="read_mail_id" value="%(reply_mail_id)s">
<INPUT type="hidden" name="type_reply" value="1">""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def forward(REQUEST, attach=0):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DRAFTS))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodraftsfolder')
    DRAFT_ID = result['efolder_id']

    output = []

    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))

    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    mail_contents = []
    msg_reply = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    message_reply = _mail.message_from_string(base64.decodestring(msg_reply.get('email_contents')))
    if not attach:
        mail_contents.append(u"")
        mail_contents.append(u"----- Forwarded message -----")
        mail_contents.append(u"&gt; Date: %s" % REQUEST.iso2userdatetime(REQUEST, msg_reply.get('email_date')))
        try:
            email_from_addr = email.Utils.getaddresses([message_reply['from']])[0]
            if email_from_addr[0]:
                mail_contents.append(u"&gt; From: %s &lt;%s&gt;" % (msg_reply.get('email_from'), email_from_addr[1]))
            else:
                mail_contents.append(u"&gt; From: %s" % msg_reply.get('email_from'))
        except:
            mail_contents.append(u"&gt; From: %s" % msg_reply.get('email_from'))
        mail_contents.append(u"&gt; Subject: %s" % msg_reply.get('email_subject'))

        try:
            tmp = u"&gt; To: "
            start = 0
            email_to_addr = email.Utils.getaddresses([message_reply['to']])
            for i in email_to_addr:
                if i[0] and i[0] <> i[1]:
                    tmp += u"%s%s &lt;%s&gt;" % ((((start <> 0 and ", ") or ""), _mail.parse_quoted_string(message_reply, i[0]), i[1]))
                else:
                    tmp += u"%s%s" % ((((start <> 0 and ", ") or ""), i[1]))
                start = 1
            mail_contents.append(tmp)
        except:
            mail_contents.append(u"&gt; To: %s" % msg_reply.get('email_to'))
        mail_contents.append(u"&gt; ")
        mail_contents.append(_mail.reply_message(REQUEST, message_reply))
        mail_contents.append(u"----- End forwarded message -----")
    mail_contents = "\n".join(mail_contents)
    if email_format == "2":
        mail_contents = mail_contents.replace('\n', '\n&gt; ')
        mail_contents = _Utils.strip_html(mail_contents, valid_tags=[])#.replace('\n', '<br>')
    else:
        mail_contents = mail_contents.replace('\n', '<br>&gt; ')

    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_forwardmessage = REQUEST.TLS('email_forwardmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    reply_mail_id = msg_reply.get_id()
    mail_subject = "Fwd: %s" % msg_reply.get('email_subject') # FIXME
    if isinstance(mail_subject, str):
        mail_subject = mail_subject.decode('UTF8')

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """ <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
#        mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
        msg.set('index_this_item', 1)
        msg.set('parent_id', DRAFT_ID)
        message = email.MIMEMultipart.MIMEMultipart()
        message['Subject'] = mail_subject
        try:
            msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
            del message['from']
            message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
        except:
            raise RuntimeError, REQUEST.TLS('email_nosettings')

        submsg = email.MIMEText.MIMEText(mail_contents.encode('UTF8'))
        del submsg['content-type']
        if REQUEST.form.has_key('is_html'):
            email_format = REQUEST.form['is_html'].value
        else:
            try:
                email_format = REQUEST.get_setting('email_format')
            except:
                email_format = "1"

        if email_format == "1":
            submsg['Content-Type'] = 'text/html; charset="utf-8"' 
        else:
            submsg['Content-Type'] = 'text/plain; charset="utf-8"'
        message.attach(submsg)
        if attach: # if attach, send whole old message.
            submsg = email.MIMEMessage.MIMEMessage(message_reply)
            message.attach(submsg)
        else: # else add attachments of the old message
            for attachobj in _mail.get_attachments(REQUEST, message_reply, show_messages=0):
                submsg = MIMEFile.MIMEFile(attachobj.get_payload(decode=1), _mail.parse_quoted_string(attachobj, (_mail.parse_quoted_string(attachobj, attachobj.get_filename() or _mail.get_alt_name(attachobj) or 'noname.bin'))))
                message.attach(submsg)

        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))
        msg.set('email_to', u'')
        msg.set('email_flags', _Email.EMAIL_READ)
        msg.set('email_subject', mail_subject)
        msg.set('is_private', 1)
        msg.save()
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))
        if attach_output:
            attach_output = """ <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_to = u""
        mail_cc = u""
        mail_bcc = u""


    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="read_mail_id" value="%(reply_mail_id)s">
<INPUT type="hidden" name="type_forward" value="1">""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, REQUEST.TLS('email_forwardmessage')))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def replyall(REQUEST):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    mail_contents = []
    msg_reply = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    message_reply = _mail.message_from_string(base64.decodestring(msg_reply.get('email_contents')))
    mail_contents.append(u"On %s, %s wrote:" % (REQUEST.iso2userdatetime(REQUEST, msg_reply.get('email_date')), (email.Utils.parseaddr(msg_reply.get('email_from'))[0] or msg_reply.get('email_from')))) # FIXME
    mail_contents.append(u" ")
    mail_contents.append(_mail.reply_message(REQUEST, message_reply))
    mail_contents = "\n".join(mail_contents)
    if email_format == "1":
        mail_contents = _Utils.strip_html(mail_contents, valid_tags=[])
    mail_contents = mail_contents.replace('\r', '')
    ndx = mail_contents.find('\n\n\n')
    while ndx <> -1:
        mail_contents = mail_contents.replace('\n\n\n', '\n\n')
        ndx = mail_contents.find('\n\n\n')
    mail_contents = mail_contents.replace('\n', '<br>&gt; ')



    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_replyallmessage = REQUEST.TLS('email_replyallmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    reply_mail_id = msg_reply.get_id()

    mail_to = _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['from']))
    if _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['to'])):
        mail_to += ", " + _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['to']))
    if _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['cc'])):
        mail_to += ", " + _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['cc']))

    mail_subject = "Re: %s" % msg_reply.get('email_subject') # FIXME
    if isinstance(mail_subject, str):
        mail_subject = mail_subject.decode('UTF8')

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """ <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
#        mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        attach_output = u""
        mail_id = u""
        mail_cc = u""
        mail_bcc = u""


    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="read_mail_id" value="%(reply_mail_id)s">
<INPUT type="hidden" name="type_reply" value="1">""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, REQUEST.TLS('email_replyallmessage')))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def send(REQUEST):
    # Find out drafts id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DRAFTS))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodraftsfolder')
    DRAFT_ID = result['efolder_id']

    # Find out sent-items id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_SENT))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nosentfolder')
    SENT_ID = result['efolder_id']

    if REQUEST.form.has_key('_attach') or REQUEST.form.has_key('_attach.x'):
        filedata = None
        if not REQUEST.form.has_key('filepointer') or not REQUEST.form['filepointer'].file or not REQUEST.form['filepointer'].filename:
            if REQUEST.form.has_key('_attachid') and REQUEST.form['_attachid'].value.decode('UTF8').strip() and REQUEST.form.has_key('_attachname') and REQUEST.form['_attachname'].value.decode('UTF8').strip():
                try:
                    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['_attachid'].value))
                except:
                    raise RuntimeError, REQUEST.TLS('doc_file_notfound')
                filepath = doc.get_path()
                filefp = open(filepath.encode('UTF8'),'rb')
                filedata = filefp.read()
                filefp.close()
                del filepath
                del filefp
                filename = REQUEST.form['_attachname'].value.decode('UTF8').strip().encode('UTF8')
            else:
                raise RuntimeError, REQUEST.TLS('email_nofileattached')
        if filedata is None:
            filedata = REQUEST.form['filepointer'].file.read()
            filename = REQUEST.form['filepointer'].filename.split('\\')[-1].split('/')[-1]
        if not filedata:
            raise RuntimeError, REQUEST.TLS('email_emptyfileattached')

        if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
            message2 = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
            message = email.MIMEMultipart.MIMEMultipart()
            message.set_payload(message2.get_payload())
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 0
        else:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
            msg.set('index_this_item', 1)
            msg.set('parent_id', DRAFT_ID)
            message = email.MIMEMultipart.MIMEMultipart()
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 1
        del message['to']
        del message['cc']
        del message['bcc']
        del message['subject']
        if REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            msg.set('email_to', REQUEST.form['email_to'].value.decode('UTF8'))
            message['To'] = parse_obj_addresses(msg, msg.get('email_to'))
        else:
            msg.set('email_to', u'')
            message['To'] = ''
        if REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            message['Cc'] = parse_obj_addresses(msg, REQUEST.form['email_cc'].value.decode('UTF8'))
        else:
            message['Cc'] = ''
        if REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            message['bcc'] = parse_obj_addresses(msg, REQUEST.form['email_bcc'].value.decode('UTF8'))
        else:
            message['bcc'] = ''
        if REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            msg.set('email_subject', REQUEST.form['email_subject'].value.decode('UTF8'))
            message['Subject'] = email.Header.Header(REQUEST.form['email_subject'].value.decode('UTF8')).encode()
        else:
            msg.set('email_subject', u'')
            message['Subject'] = ''
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            submsg = email.MIMEText.MIMEText(REQUEST.form['email_contents'].value) # _charset = utf8
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"'
                submsgcontainer = email.MIMEMultipart.MIMEMultipart(_subtype='alternative')
                mail_contents2 = REQUEST.form['email_contents'].value.decode('UTF8').replace('\n',' ')
                mail_contents2 = mail_contents2.replace('\r', '')
                mail_contents2 = mail_contents2.replace('<br>','\n').replace('<BR>','\n')
                mail_contents2 = mail_contents2.replace('<p>','\n\n').replace('<P>','\n\n')
                mail_contents2 = mail_contents2.replace('</li>','\n').replace('</LI>','\n')
                mail_contents2 = _Utils.strip_html(mail_contents2, valid_tags=[])
                ndx = mail_contents2.find('\n\n\n')
                while ndx <> -1:
                    mail_contents2 = mail_contents2.replace('\n\n\n', '\n\n')
                    ndx = mail_contents2.find('\n\n\n')
                submsgalter = email.MIMEText.MIMEText(mail_contents2.encode('UTF8'))
                del submsgalter['content-type']
                submsgalter['Content-Type'] = 'text/plain; charset="utf-8"'
                submsgcontainer.set_payload([submsgalter, submsg])
                submsg = submsgcontainer
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        else:
            submsg = email.MIMEText.MIMEText('')
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        submsg = MIMEFile.MIMEFile(filedata, filename.decode('UTF8'))
        message.attach(submsg)
        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))

        con_ids = []
        for key in REQUEST.form.keys():
            try:
                if key[:4] == 'sel_':
                    con_ids.append(key[4:])
            except: raise RuntimeError, (key, REQUEST.form.keys())
        if con_ids:
            msg.set('email_contacts', ",".join(con_ids))
        else:
            msg.set('email_contacts', None)
        msg.set('email_flags', (msg.get('email_flags') or 0) | _Email.EMAIL_READ | _Email.EMAIL_ATTACH)
        msg.set('is_private', 1)
        msg.save()

        from_account = ""
        if REQUEST.form.has_key('from_account'):
            accid = int(REQUEST.form['from_account'].value)
            if accid <> -1:
                from_account = "&from_account=%d" % accid
        if REQUEST.form.has_key('type_reply'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/reply?read_mail_id=%d&mail_id=%d&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value, from_account)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_compose'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/compose?mail_id=%d&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), REQUEST.form['is_html'].value, from_account)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_forward'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/forward?read_mail_id=%d&mail_id=%d&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value, from_account)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_contact'):
            con_ids = []
            for key in REQUEST.form.keys():
                if key[:4] == 'sel_':
                    con_ids.append( u"sel_%d=1" % int(key[4:]))
            con_ids = "&".join(con_ids)
            if con_ids:
                con_ids = u"&%s" % con_ids
            loc = u"%scompose.py/contactmail?mail_id=%d%s&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), con_ids, REQUEST.form['is_html'].value,from_account)
            REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            raise RuntimeError, REQUEST.TLS('email_noreturnpath')
    elif REQUEST.form.has_key('_save') or REQUEST.form.has_key('_save.x'):
        if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
            message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 0
        else:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
            msg.set('index_this_item', 1)
            msg.set('parent_id', DRAFT_ID)
            message = email.MIMEMultipart.MIMEMultipart()
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 1
        del message['to']
        del message['cc']
        del message['bcc']
        del message['subject']
        if REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            msg.set('email_to', REQUEST.form['email_to'].value.decode('UTF8'))
            message['To'] = parse_obj_addresses(msg, msg.get('email_to'))
        else:
            msg.set('email_to', u'')
            message['To'] = ''
        if REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            message['Cc'] = parse_obj_addresses(msg, REQUEST.form['email_cc'].value.decode('UTF8'))
        else:
            message['Cc'] = ''
        if REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            message['bcc'] = parse_obj_addresses(msg, REQUEST.form['email_bcc'].value.decode('UTF8'))
        else:
            message['bcc'] = ''
        if REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            msg.set('email_subject', REQUEST.form['email_subject'].value.decode('UTF8'))
            message['Subject'] = email.Header.Header(REQUEST.form['email_subject'].value.decode('UTF8')).encode()
        else:
            msg.set('email_subject', u'')
            message['Subject'] = ''
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            submsg = email.MIMEText.MIMEText(REQUEST.form['email_contents'].value)
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
                submsgcontainer = email.MIMEMultipart.MIMEMultipart(_subtype='alternative')
                mail_contents2 = REQUEST.form['email_contents'].value.decode('UTF8').replace('\n',' ')
                mail_contents2 = mail_contents2.replace('\r', '')
                mail_contents2 = mail_contents2.replace('<br>','\n').replace('<BR>','\n')
                mail_contents2 = mail_contents2.replace('<p>','\n\n').replace('<P>','\n\n')
                mail_contents2 = mail_contents2.replace('</li>','\n').replace('</LI>','\n')
                mail_contents2 = _Utils.strip_html(mail_contents2, valid_tags=[])
                ndx = mail_contents2.find('\n\n\n')
                while ndx <> -1:
                    mail_contents2 = mail_contents2.replace('\n\n\n', '\n\n')
                    ndx = mail_contents2.find('\n\n\n')
                submsgalter = email.MIMEText.MIMEText(mail_contents2.encode('UTF8'))
                del submsgalter['content-type']
                submsgalter['Content-Type'] = 'text/plain; charset="utf-8"'
                submsgcontainer.set_payload([submsgalter, submsg])
                submsg = submsgcontainer
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        else:
            submsg = email.MIMEText.MIMEText('')
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append(key[4:])
        if con_ids:
            msg.set('email_contacts', ",".join(con_ids))
        else:
            msg.set('email_contacts', None)
        msg.set('email_flags', (msg.get('email_flags') or 0) | _Email.EMAIL_READ | _Email.EMAIL_DRAFT)
        msg.set('is_private', 1)
        msg.save()

        from_account = ""
        if REQUEST.form.has_key('from_account'):
            accid = int(REQUEST.form['from_account'].value)
            if accid <> -1:
                from_account = "&from_account=%d" % accid
        if REQUEST.form.has_key('type_compose'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/compose?mail_id=%d&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), REQUEST.form['is_html'].value, from_account)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_reply'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/reply?read_mail_id=%d&mail_id=%d&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value, from_account)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_forward'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/forward?read_mail_id=%d&mail_id=%d&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value, from_account)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_contact'):
            con_ids = []
            for key in REQUEST.form.keys():
                if key[:4] == 'sel_':
                    con_ids.append( u"sel_%d=1" % int(key[4:]))
            con_ids = "&".join(con_ids)
            if con_ids:
                con_ids = u"&%s" % con_ids
            loc = u"%scompose.py/contactmail?mail_id=%d%s&is_html=%s%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), con_ids, REQUEST.form['is_html'].value, from_account)
            REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            raise RuntimeError, REQUEST.TLS('email_noreturnpath')
    elif REQUEST.form.has_key('_send') or REQUEST.form.has_key('_send.x'):
        if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
            message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 0
        else:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
            msg.set('index_this_item', 1)
            message = email.MIMEMultipart.MIMEMultipart()
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 1

        if REQUEST.form.has_key('from_account'):
            accid = int(REQUEST.form['from_account'].value)
            if accid <> -1:
                eacc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, accid)
                if eacc.get('eaccount_sendername') is not None and eacc.get('eaccount_sendermail') is not None:
                    msg.set('email_from', u"%s <%s>" % (email.Header.Header(eacc.get('eaccount_sendername')), eacc.get('eaccount_sendermail')))
                    del message['from']
                    message['From'] = u"%s <%s>" % (email.Header.Header(eacc.get('eaccount_sendername')), eacc.get('eaccount_sendermail'))

        del message['to']
        del message['cc']
        del message['bcc']
        del message['subject']
        if REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            msg.set('email_to', REQUEST.form['email_to'].value.decode('UTF8'))
            message['To'] = parse_obj_addresses(msg, msg.get('email_to'))
        else:
            msg.set('email_to', u'')
            message['To'] = ''
        if REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            message['Cc'] = parse_obj_addresses(msg, REQUEST.form['email_cc'].value.decode('UTF8'))
        else:
            message['Cc'] = ''
        if REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            message['bcc'] = parse_obj_addresses(msg, REQUEST.form['email_bcc'].value.decode('UTF8'))
        else:
            message['bcc'] = ''
        if REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            msg.set('email_subject', REQUEST.form['email_subject'].value.decode('UTF8'))
            message['Subject'] = email.Header.Header(REQUEST.form['email_subject'].value.decode('UTF8')).encode()
        else:
            msg.set('email_subject', u'')
            message['Subject'] = ''
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            submsg = email.MIMEText.MIMEText(REQUEST.form['email_contents'].value)
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
                submsgcontainer = email.MIMEMultipart.MIMEMultipart(_subtype='alternative')
                mail_contents2 = REQUEST.form['email_contents'].value.decode('UTF8').replace('\n',' ')
                mail_contents2 = mail_contents2.replace('\r', '')
                mail_contents2 = mail_contents2.replace('<br>','\n').replace('<BR>','\n')
                mail_contents2 = mail_contents2.replace('<p>','\n\n').replace('<P>','\n\n')
                mail_contents2 = mail_contents2.replace('</li>','\n').replace('</LI>','\n')
                mail_contents2 = _Utils.strip_html(mail_contents2, valid_tags=[])
                ndx = mail_contents2.find('\n\n\n')
                while ndx <> -1:
                    mail_contents2 = mail_contents2.replace('\n\n\n', '\n\n')
                    ndx = mail_contents2.find('\n\n\n')
                submsgalter = email.MIMEText.MIMEText(mail_contents2.encode('UTF8'))
                del submsgalter['content-type']
                submsgalter['Content-Type'] = 'text/plain; charset="utf-8"'
                submsgcontainer.set_payload([submsgalter, submsg])
                submsg = submsgcontainer
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        else:
            submsg = email.MIMEText.MIMEText('')
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        del message['date']
        message['Date'] = str(email.Header.Header(email.Utils.formatdate(localtime=1)))
        bcc_to = message['bcc']
        del message['bcc']
        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append(key[4:])
        if con_ids:
            msg.set('email_contacts', ",".join(con_ids))
        else:
            msg.set('email_contacts', None)
        msg.set('email_flags', (msg.get('email_flags') or 0) | _Email.EMAIL_READ)
        if msg.get_id() is None: # Unsaved message:
            msg.set('parent_id', SENT_ID)
            msg.set('is_private', 1)
            msg.save()
        elif (msg.get('email_flags') & _Email.EMAIL_DRAFT): # Draft
            msg.copyto(SENT_ID)
            msg.set('is_private', 1)
            msg.save()
        else:
            msg.set('parent_id', SENT_ID)
            msg.set('is_private', 1)
            msg.save()

        to_1 = []
        to_2 = []
        to_3 = []
        if REQUEST.form.has_key('type_contact'):
            to = []
            con_ids = msg.get('email_contacts') or u''
            con_ids = map(int, con_ids.split(u','))
            for con_id in con_ids:
                con_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, con_id)
                if con_obj.get('e_mail'):
                    to.append(con_obj.get('e_mail').strip().encode('UTF8'))
        else:
            to1 = _mail.parse_quoted_string(message, message['to'] or u'')
            to2 = _mail.parse_quoted_string(message, message['cc'] or u'')
            to3 = _mail.parse_quoted_string(message, bcc_to or u'')
            groups1 = []
            groups2 = []
            groups3 = []
            for (tox, groupsx) in [(to1, groups1),(to2, groups2),(to3, groups3)]:
                while 1:
                    ndx1 = tox.find("{")
                    if ndx1<>-1:
                        ndx2 = tox.find("}", ndx1)
                        if ndx2<>-1:
                            toid = tox[ndx1+1:ndx2]
                            gid = re.search(':\d+:', toid)
                            if gid:
                                gid = gid.group()
                                if gid:
                                    groupsx.append(gid[1:-1])
                            tox = tox[ndx2:]
                        else:
                            break
                    else:
                        break
            for (to_x, groupsx) in [(to_1, groups1), (to_2, groups2), (to_3, groups3)]:
                if groupsx:
                    groups = map(int, groupsx)
                    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACTGROUP])
                    if right_param:
                        right_param = " AND " + right_param
                    SQL = """SELECT c.contacts from contact_groups c, items i where i.item_id=c.group_id and c.group_id in (%s) %s""" % (",".join(map(str, groups)), right_param)
                    REQUEST.db.execute(SQL.encode('UTF8'))
                    contacts = REQUEST.db.fetchall()
                    c = []
                    for row in contacts:
                        c = c + _Utils.sql_parse_array(REQUEST, row[0])
                    if c:
                        SQL = """SELECT c.first_name || ' ' || c.last_name, c.e_mail from contacts c, items i where i.item_id = c.contact_id and c.contact_id in (%s) and c.e_mail is not null""" % (",".join(map(str, c)))
                        REQUEST.db.execute(SQL)
                        contacts = REQUEST.db.fetchall()
                        for row in contacts:
                            if row[0] and row[0].strip() and row[1] and row[1].strip():
                                to_x.append((row[0].decode('UTF8'), row[1].decode('UTF8')))

            tmp1 = parse_obj_addresses(message, message['to'] or u'', include_groups=0)
            tmp2 = parse_obj_addresses(message, message['cc'] or u'', include_groups=0)
            del message['to']
            del message['cc']
            message['to'] = tmp1
            message['cc'] = tmp2
            to = filter(None, map(lambda x: x[1], email.Utils.getaddresses([message['to'], message['cc'] or '', bcc_to or ''])))
        server = smtplib.SMTP(_Conf.SMTPSERVER) # FIXME - error handling (raises)
        if to:
            errors = server.sendmail(message['from'], to, message.as_string())
        to_old = parse_obj_addresses(message, message['to'] or '')
        cc_old = parse_obj_addresses(message, message['cc'] or '')
        for (tolist, messfield, oldmessfield) in [(to_1,'to',to_old),(to_2,'cc',cc_old),(to_3,'','')]:
            if tolist:
                del message['to']
                del message['cc']
                message['to'] = to_old
                message['cc'] = cc_old
                for targets in tolist:
                    if messfield and oldmessfield:
                        del message[messfield]
                        message[messfield] = "%s, %s <%s>" % (oldmessfield, email.Header.Header(u'"%s"'%targets[0]).encode().strip(), targets[1].strip().encode('UTF8'))
                    elif messfield and not oldmessfield:
                        del message[messfield]
                        message[messfield] = "%s <%s>" % (email.Header.Header(u'"%s"'%targets[0]).encode().strip(), targets[1].strip().encode('UTF8'))
                    errors = server.sendmail(message['from'], [targets[1].strip().encode('UTF8')], message.as_string())
        server.quit()
        errors = {}

        if REQUEST.form.has_key('from_account'): # xxx
            accid = int(REQUEST.form['from_account'].value)
            if accid <> -1:
                try:
                    sentsetting = REQUEST.get_setting("sentsync_%s" % accid)
                except:
                    sentsetting = None
                if sentsetting and sentsetting <> "-1":
                    acc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, accid)
                    box = _mail.IMAP4Mailbox()
                    box.open(REQUEST, acc)
                    # box.foldername = sentsetting
                    folder = sentsetting
                    if folder.find('"') <> -1 and (len(folder) < 2 or (folder[0] <> '"' and folder[-1] <> '"')):
                        folder= folder.replace('"', r'\"') 
                    if folder.find(' ') <> -1 or folder.find("'") <> -1:
                        folder= '"%s"' % folder
                    box.foldername = folder
                    res = box._con.append(box.foldername, None, None, message.as_string())
                    if res[0] <> 'OK':
                         raise RuntimeError, str(res)
                    box.openfolder(box.foldername)
                    box.close()

        if REQUEST.form.has_key('type_reply'):
            try:
                reply_id = int(REQUEST.form['read_mail_id'].value)
                REQUEST.db.execute("""UPDATE emails set email_flags=(email_flags | %d) WHERE email_id=%d""" % (_Email.EMAIL_ANSWERED, reply_id))
            except:
                pass # FIXME

        output = []
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"efolder1.py"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_email_menu(REQUEST, MY_MENU_ID))
        output.append("""<BR>&nbsp;&nbsp;%s""" % REQUEST.TLS('email_messagesent'))
        for key, value in errors.items():
            output.append("""<BR>&nbsp;&nbsp;%s""" % (REQUEST.TLS('email_sendmailerror') % (key, value[0], value[1])))
        output.append(standard_html.html_footer(REQUEST))
        return '\n'.join(output)
    return "NOT IMPLEMENTED. FIXME"

def delpart(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

    part = int(REQUEST.form['part'].value.split('.')[1])

    payload = message.get_payload()
    del payload[part]
    message.set_payload(payload)

    msg.set('email_contents', base64.encodestring(message.as_string()))
    msg.set('is_private', 1)
    msg.save()

    if REQUEST.form.has_key('type_compose'):
        REQUEST.mod_req.headers_out["Location"] = "%scompose.py/compose?mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), REQUEST.form['is_html'].value)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('type_reply'):
        REQUEST.mod_req.headers_out["Location"] = "%scompose.py/reply?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('type_forward'):
        REQUEST.mod_req.headers_out["Location"] = "%scompose.py/forward?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('type_contact'):
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append( u"sel_%d=1" % int(key[4:]))
        con_ids = "&".join(con_ids)
        if con_ids:
            con_ids = u"&%s" % con_ids
        loc = u"%scompose.py/contactmail?mail_id=%d%s&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), con_ids, REQUEST.form['is_html'].value)
        REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
        return apache.HTTP_MOVED_TEMPORARILY
    else:
        raise RuntimeError, REQUEST.TLS('email_noreturnpath')


def form_html(REQUEST, mail_id, drafts, attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, title="", to_str=""):
    output = []
    spell_ok = 1
    top_px = 225
    is_drafts = 0
    if len(drafts)>5:
        is_drafts = 1
        top_px = top_px + 30
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    if REQUEST.form.has_key('act') and REQUEST.form['act'].value=="spellcheck":
        read_mail_id = ""
        if not mail_to and REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            mail_to = REQUEST.form['email_to'].value.decode('UTF8')
        if not mail_cc and REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            mail_cc = REQUEST.form['email_cc'].value.decode('UTF8')
        if not mail_bcc and REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            mail_bcc = REQUEST.form['email_bcc'].value.decode('UTF8')
        if not mail_subject and REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            mail_subject = REQUEST.form['email_subject'].value.decode('UTF8')
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            mail_contents = REQUEST.form['email_contents'].value.decode('UTF8')
        lang = "en_US"
        if REQUEST.form.has_key('lang') and REQUEST.form['lang']=="et_EE":
            lang="et_EE"
        elif REQUEST.form.has_key('lang') and REQUEST.form['lang']=="pt_PT":
            lang="pt_PT"
        elif REQUEST.form.has_key('lang') and REQUEST.form['lang']=="de_DE":
            lang="de_DE"      
        orig_contents = mail_contents
        plain_contents = _Utils.strip_all_html(orig_contents.replace("<br>", "\n").replace("<BR>", "\n").replace("<", " <")).replace("\r", "")
        plain_list = plain_contents.split(" ")
        plain_list = filter(None, plain_list)
        orig_words = base64.encodestring(str(plain_list))
        echo_out = " ".join(plain_list)
        echo_out = echo_out.replace("\r", " ").replace("\n", " ")
        aspell=popen2.popen4('echo "%s" | %s --encoding=UTF-8 -a --mode=email --lang=%s' % (echo_out.encode('UTF8'), _Conf.SPELL_CHECKER, lang))[0].read()
        try:
            aspell = aspell.decode('UTF8')
        except:
            while(aspell<>re.sub('\n\+ (\S+)\n', '\n', aspell)):
                aspell = re.sub('\n\+ (\S+)\n', '\n', aspell)
            aspell = aspell.decode('UTF8')
        aspell=dict(re.compile('^& (\S+) \d+ \d+: (.*)',re.M | re.UNICODE).findall(aspell))
        # FIXME suse bugi, tegelt peab \S asemel \w olema
        if aspell:
           QUERY = """SELECT word from dictionaries where language='%s' and person_id=%d""" % (lang, REQUEST.USER.get_id())
           REQUEST.db.execute(QUERY.encode('UTF8'))
           res = REQUEST.db.fetchall()
           if res:
               res = map(lambda x:x[0].decode('UTF8'), res)
           text = re.split('(<.*?>|&.*?;)',_Utils.strip_all_html(mail_contents.replace("<br>", "\n").replace("<BR>", "\n").replace("<", " <")).replace("\r", ""))
           ndx = 0
           for i in range(0,len(text),2):
             words=re.split(r'\b(\S+)\b',text[i])
             for j in range(0,len(words)):
               if words[j] in aspell and words[j].lower() not in res:
                 spell_ok = 0
                 w = words[j]
                 orig_contents = orig_contents.replace(w, "##%d##" % ndx, 1)
                 words[j]="""<input name="word_%s" id="input%s" onclick="showdiv('input%s', 'spell%s');" readonly class="spellcheckview" type="text" value="%s" style="width: %dpx">""" % (ndx, ndx, ndx, ndx, words[j], ((len(words[j])*7)+3))
                 output.append(u"""<div id="spell%(ndx)s" style="position: absolute; z-index: 7; top: 1px; left: 1px; visibility: hidden;">\n<table cellpadding="0" cellspacing="0" border="0" bgcolor="#FAFAFA" style="border: 1px solid #AAAAAA; cursor: pointer; cursor: hand;">""" % locals())
                 index = 0
                 for suggestion in aspell[w].split(","):
                     if index < 8:
                         output.append(u"""<tr onclick="change_val('input%s', 'spell%s', '%s');" onmouseover="this.style.backgroundColor='#AAAAAA';" onmouseout="this.style.backgroundColor='#FAFAFA';">\n  <td style="padding: 2px; padding-left: 5px; padding-right: 5px;">%s</td>\n</tr>""" % (ndx, ndx, suggestion.strip().replace("'", "\\'"), suggestion.strip()))
                     else:
                         break
                     index = index + 1
                 output.append(u"""<tr onclick="add_val('input%s', 'spell%s', '%s');" onmouseover="this.style.backgroundColor='#AAAAAA';" onmouseout="this.style.backgroundColor='#FAFAFA';">\n  <td style="padding: 2px; padding-left: 5px; padding-right: 5px;"><b>%s</b></td>\n</tr>""" % (ndx, ndx, w.replace("'", "\\'"), REQUEST.TLS('tls_add_to_dict')))
                 output.append(u"""<tr onclick="edit_val('input%s', 'spell%s');" onmouseover="this.style.backgroundColor='#AAAAAA';" onmouseout="this.style.backgroundColor='#FAFAFA';">\n  <td style="padding: 2px; padding-left: 5px; padding-right: 5px;"><b>%s</b></td>\n</tr>\n</table>\n</div>""" % (ndx, ndx, REQUEST.TLS('tls_edit')))
                 ndx = ndx + 1
             text[i]=''.join(words)
           text=''.join(text)
           text=text.replace("\n", "<BR>")
           orig_contents = base64.encodestring(orig_contents.encode('UTF8')).replace("\n", "")
           if not spell_ok:
               html_div = """\
<SCRIPT type="text/javascript">
function DL_GetElementLeft(eElement){ var nLeftPos = eElement.offsetLeft; var eParElement = eElement.offsetParent; while (eParElement != null) { nLeftPos += eParElement.offsetLeft; eParElement = eParElement.offsetParent; } return nLeftPos; }
function DL_GetElementTop(eElement){ var nTopPos = eElement.offsetTop; var eParElement = eElement.offsetParent; while (eParElement != null) { nTopPos += eParElement.offsetTop; eParElement = eParElement.offsetParent; } return nTopPos; }
function showdiv(inp_id, id) { el = document.getElementById(id); inp = document.getElementById(inp_id); pos_top = DL_GetElementTop(inp); pos_left = DL_GetElementLeft(inp); if(el.style.visibility == "visible") { el.style.visibility = "hidden"; } else { el.style.left = pos_left+'px'; el.style.top = pos_top+18+'px'; el.style.visibility = "visible"; } }
function change_val(inp_id, id, val) { el = document.getElementById(id); inp = document.getElementById(inp_id); inp.value=val; inp.className='spellcheckok'; inp.style.width = ((val.length)*7+3)+'px'; showdiv(inp_id, id); }
function edit_val(inp_id, id) { el = document.getElementById(id); inp = document.getElementById(inp_id); inp.readOnly=false; inp.className='spellcheckedit'; inp.onclick='return true;'; showdiv(inp_id, id); }
function add_val(inp_id, id, word) { 
  el = document.getElementById(id); 
  inp = document.getElementById(inp_id); 
  inp.className='spellcheckok'; 
  inp.onclick='return true;'; 
  showdiv(inp_id, id); 
  document.forms['spellcheckedit']['add_words'].value=document.forms['spellcheckedit']['add_words'].value+" "+ word;
}

</SCRIPT>
<div id="spellcheckdiv" style="cursor: default; position: absolute; z-index: 5; top: %(top_px)spx; left: 18px; width:750px; height:360px; padding: 2px;"><TABLE border="0" cellpadding="2" width="750" height="360" cellspacing="0" style="background-color: #FFFFFF; border: 1px solid #7F9DB9;"><TR valign="top"><TD valign="top"><form name="spellcheckedit" method="post" onsubmit="confirm_leave=function();" action = "%(BASE_EMAIL_URL)scompose.py"><input type="hidden" name="add_words" value=""><input type="hidden" name="orig_contents" value="%(orig_contents)s"><input type="hidden" name="type_compose" value="1"><input type="hidden" name="resume_edit" value="1"><input type="hidden" name="email_to" value=""><input type="hidden" name="email_cc" value=""><input type="hidden" name="email_bcc" value=""><input type="hidden" name="email_subject" value=""><input type="hidden" name="is_html" value=""><input type="hidden" name="lang" value="%(lang)s">%(mail_id)s%(hiddenstr)s%(read_mail_id)s""" % locals()
               html_div = html_div + text + "</form></TR></TD></table><BR><BR></div>"
               output.append(html_div)
    elif REQUEST.form.has_key('resume_edit') and REQUEST.form['resume_edit'].value=="1":
        if not mail_to and REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            mail_to = REQUEST.form['email_to'].value.decode('UTF8')
        if not mail_cc and REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            mail_cc = REQUEST.form['email_cc'].value.decode('UTF8')
        if not mail_bcc and REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            mail_bcc = REQUEST.form['email_bcc'].value.decode('UTF8')
        if not mail_subject and REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            mail_subject = REQUEST.form['email_subject'].value.decode('UTF8')
        changed_words = {}
        for key in REQUEST.form.keys():
            if key[:5] == 'word_':
                changed_words[int(key[5:])] = REQUEST.form[key].value
        orig_text = base64.decodestring(REQUEST.form['orig_contents'].value).decode('UTF8')
        keys = changed_words.keys()
        keys.sort()
        index = 0
        for key in keys:
            orig_text = orig_text.replace("##%s##" % index, changed_words[key].decode('UTF8'), 1)
            index = index + 1
        mail_contents = orig_text
        add_words = REQUEST.form['add_words'].value.decode('UTF8').strip()
        if add_words:
            add_words = add_words.split(" ")
            lang = REQUEST.form['lang'].value.decode('UTF8')
            for word in add_words:
                word = word.lower()
                REQUEST.db.execute(("""SELECT word from dictionaries where word=%s and language=%s and person_id=%d""" % (_Utils.sql_quote(word), _Utils.sql_quote(lang), REQUEST.USER.get_id())).encode('UTF8'))
                res = REQUEST.db.fetchall()
                if not res:
                    REQUEST.db.execute(("""INSERT into dictionaries (person_id, language, word) values (%d, %s, %s)""" % (REQUEST.USER.get_id(), _Utils.sql_quote(lang), _Utils.sql_quote(word))).encode('UTF8'))


    if not title:
        title = REQUEST.TLS('email_newmessage')
    if mail_to.find('&') == -1:
        mail_to = _Utils.html_quote(mail_to)
    if mail_cc.find('&') == -1:
        mail_cc = _Utils.html_quote(mail_cc)
    if mail_bcc.find('&') == -1:
        mail_bcc = _Utils.html_quote(mail_bcc)
    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_newmessage = REQUEST.TLS('email_newmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_format = REQUEST.TLS('tls_format')
    tls_signature = REQUEST.TLS('email_signature')
    timestamp = REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())
    tls_format_conf = REQUEST.TLS('email_format_confirm')
    tls_format1 = REQUEST.TLS('email_format_html')
    tls_format2 = REQUEST.TLS('email_format_plain')
    tls_missing_attachment = REQUEST.TLS('email_missingattachment')
    tls_spellcheck = REQUEST.TLS('email_spellcheck')
    tls_resumeedit = REQUEST.TLS('email_resumeedit')
    tls_spellok = REQUEST.TLS('email_spellingok')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_confirm_leave = REQUEST.TLS('email_confirm_leave')
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    
    access_str = _Utils.get_module_access(REQUEST)
    types_menus = {_InitTypes.ITEM_TYPE_DOCUMENT: _Conf.MODULES_DOCUMENTS}
    if access_str[types_menus[_InitTypes.ITEM_TYPE_DOCUMENT]]=="1":
        conflux_att = """\
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_selectdoc)s:</TD>
  <TD class="td_listing0"><INPUT size=26 class="input6" type="text" name="_attachname" readonly><INPUT type="hidden" name="_attachid" value="">&nbsp;<INPUT class="input6" type="button" name="_attachconflux" value="%(tls_choose)s" onClick="open_window('%(BASE_EMAIL_URL)setree.py/doctree');"></TD>
 </TR>""" % locals()
    else:
        conflux_att = ""
    
    signatures = []
    try:
        sig1 = REQUEST.get_setting('user_signature1')
        signatures.append(sig1)
    except:
        pass
    try:
        sig2 = REQUEST.get_setting('user_signature2')
        signatures.append(sig2)
    except:
        pass
    try:
        sig3 = REQUEST.get_setting('user_signature3')
        signatures.append(sig3)
    except:
        pass
    sign_out = ""
    script_out = ""
    if signatures:
        sign_out = u"""&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>%(tls_signature)s:</b>&nbsp;&nbsp;<SELECT id="sig_select" name="signature">""" % locals()
        n = 1
        for sig in signatures:
            sign_out = sign_out + u"""<option value="%s">%s</option>""" % (n, sig[0])
            n = n + 1
        sign_out = sign_out + u"""</SELECT>&nbsp;&nbsp;&nbsp;<input type="button" class="input6" value="OK" onclick="do_sig();">"""
        script_out = u"""function do_sig() { html = document.forms['composeform']['is_html'].value; elem = document.forms['composeform']['signature'].selectedIndex + 1;if(html=="2") { if(0){;}"""
        n = 1
        for sig in signatures:
            script_out = script_out + u"""\n    else if(elem==%s){ document.forms['0'].email_contents.value = document.forms['0'].email_contents.value + '%s';} """ % (n,"\\n"+sig[1].replace("\r","").replace("\n","\\n").replace("'", "\\'"))
            n = n + 1;
        script_out = script_out + u""" } else { if(0){;}"""
        n = 1
        for sig in signatures:
            script_out = script_out + u"""\n    else if(elem==%s){ SwitchViewMode(1);document.forms['0'].email_contents.value = document.forms['0'].email_contents.value + '%s';SwitchViewMode(0);} """ % (n,"<BR>\\n"+_Utils.newline2br(sig[1].replace("'", "\\'")))
            n = n + 1;
        script_out = script_out + u""" } }"""
        
    spell_tr = ""
    if REQUEST.form.has_key('act') and REQUEST.form['act'].value=="spellcheck" and spell_ok==1:
        spell_tr=u"""<TR>\n  <TD>&nbsp;</TD>\n  <TD colspan="2">\n  
<TABLE border="0" cellpadding="0" cellspacing="0" style="padding: 0px;">
<TR>
    <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="2" border="0" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sco_crn1.gif" width="3" height="3" border="0" alt=""></TD>
    <TD bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sco_crn3.gif" width="3" height="3" border="0" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
    <TD bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
    <TD bgcolor="#B5EDBC"><b>&nbsp;%(tls_spellok)s&nbsp;</b></TD>
    <TD bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sco_crn2.gif" width="3" height="3" border="0" alt=""></TD>
    <TD bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sco_crn4.gif" width="3" height="3" border="0" alt=""></TD>
</TR>
<TR>
    <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="2" border="0" alt=""></TD>
</TR>
</TABLE>\n  </TD>\n</TR>""" % locals()
    output.append(standard_html.window_script(height=500,width=550))
    output.append(u"""<SCRIPT LANGUAGE="JavaScript" type="text/javascript">function change_url(id){ self.location.href='%(BASE_EMAIL_URL)scompose.py/compose?mail_id=' + (id) + '&datetime=%(timestamp)s';} function change_editor(confi){ elem = document.forms['composeform']['is_html'].value; if(elem=="2") { if(confi&&confi=='1') { if(confirm('%(tls_format_conf)s')) { show_plain(); } else { document.forms['composeform']['is_html'].selectedIndex='0'; } } else { show_plain(); } } else { if(confi&&confi=='1') { if(confirm('%(tls_format_conf)s')) { show_html(); } else { document.forms['composeform']['is_html'].selectedIndex='1'; } } else { show_html(); } } } function parse_tags(){data = document.forms['composeform']['email_contents'].value;while(data.indexOf('<br>')!=-1){data = data.replace('<br>',"\\n");}while(data.indexOf('<BR>')!=-1){data = data.replace('<BR>',"\\n");}var tags= /<\S[^>]*>/g;data = data.replace(tags,"");while(data.indexOf('&nbsp;')!=-1){data = data.replace('&nbsp;'," ");}while(data.indexOf('&amp;')!=-1){data = data.replace('&amp;',"&");}while(data.indexOf('&gt;')!=-1){data = data.replace('&gt;',">");}while(data.indexOf('&lt;')!=-1){data = data.replace('&lt;',"<");}while(data.indexOf('\\t')!=-1){data = data.replace('\\t'," ");}while(data.indexOf('  ')!=-1){data = data.replace('  ',' ');}document.forms['composeform']['email_contents'].value=data;} function nl2br(){ data = document.forms['composeform']['email_contents'].value; while(data.indexOf('\\n')!=-1) { data = data.replace('\\n','<br>'); } document.forms['composeform']['email_contents'].value=data; } %(script_out)s </script>""" % locals())
    if not (REQUEST.form.has_key('act') and REQUEST.form['act'].value=="spellcheck" and spell_ok==0):
        output.append(u"""<SCRIPT LANGUAGE="JavaScript" type="text/javascript">function show_html() { document.getElementById('EpozViewMode').checked = false; document.forms['composeform']['is_html'].selectedIndex='0'; document.getElementById('HtmlDiv').style.display='block'; nl2br(); SwitchViewMode(0); } function show_plain() { document.getElementById('EpozViewMode').checked = true; document.forms['composeform']['is_html'].selectedIndex='1'; SwitchViewMode(1); document.getElementById('HtmlDiv').style.display='none'; parse_tags(); }</script>""" % locals())
    else:
        output.append(u"""<SCRIPT LANGUAGE="JavaScript" type="text/javascript">function show_plain() { return true; }</script>""")
    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    mail_contents = mail_contents.replace("\n", "<BR>")
    if REQUEST.form.has_key('act') and REQUEST.form['act'].value=="spellcheck" and spell_ok==0:
        text_area = """<iframe id="EpozIFrame" style="display: none"><textarea name="email_contents"></textarea></iframe>"""
    else:
        text_area = _Utils.get_epoz_field(REQUEST, 'email_contents', mail_contents)
    format_str = u"""
        <select id="html_select" name="is_html" onchange="change_editor('1');">
          <option value="1" SELECTED>%(tls_format1)s</option>
          <option value="2">%(tls_format2)s</option>
        </select>""" % locals()
    if REQUEST.form.has_key('lang'):
        lang = REQUEST.form['lang'].value.decode('UTF8')
    else:
        lang = REQUEST.get_setting('user_language')
    lang_sel = """<select name="lang">"""
    s_ok = 1;
    sel = ""
    if lang=="en_US":
        sel = "SELECTED"
        s_ok = 0;
    lang_sel = lang_sel + """<option value="en_US" %s>%s</option>""" % (sel, 'Eng')
    sel = ""
    if s_ok and (lang=="de_DE"):
        sel = "SELECTED"
    lang_sel = lang_sel + """<option value="de_DE" %s>%s</option>""" % (sel, 'Deu')
    sel = ""
    if s_ok and (lang=="et_EE" or lang=="estonian"):
        sel = "SELECTED"
    lang_sel = lang_sel + """<option value="et_EE" %s>%s</option>""" % (sel, 'Est')
    sel = ""
    if s_ok and (lang=="pt_PT"):
        sel = "SELECTED"
    lang_sel = lang_sel + """<option value="pt_PT" %s>%s</option>""" % (sel, 'Prt')
    lang_sel = lang_sel + "</select>"
    REQ_FIELD = _Conf.REQ_FIELD
    if REQUEST.form.has_key('act') and REQUEST.form['act'].value=="spellcheck" and spell_ok==0:
      format_sig_spellcheck = u"""\n <TR class="tr_listing1">\n  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>\n  <TD class="td_listing1ke" nowrap colspan="2"><input onclick="spell_check_done();" type="button" value="%(tls_resumeedit)s" class="input6"><input type="hidden" name="is_html" value=""></TD>\n </TR>""" % locals()
    else:
      format_sig_spellcheck = u"""\n <TR class="tr_listing1">\n  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>\n  <TD class="td_listing1ke">%(tls_format)s:</td>\n  <TD class="td_listing1" nowrap>%(format_str)s %(sign_out)s&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input onclick="spell_check();" type="button" value="%(tls_spellcheck)s" class="input6">&nbsp;%(lang_sel)s</TD>\n </TR>""" % locals()
    spell_html = 2
    if REQUEST.form.has_key('is_html'):
        spell_html = REQUEST.form['is_html'].value
    ### CONTACT JS
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT count(*) FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s """ % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    if count_all <=100:
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id AND (c.e_mail IS NOT NULL or c.e_mail2 IS NOT NULL or c.e_mail3 IS NOT NULL) and (c.e_mail <> '' OR c.e_mail2 <> '' OR c.e_mail3 <> '') %s""" % (right_param)
    else:
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id AND (c.e_mail IS NOT NULL or c.e_mail2 IS NOT NULL or c.e_mail3 IS NOT NULL) and (c.e_mail <> '' OR c.e_mail2 <> '' OR c.e_mail3 <> '') %s AND i.creator_id=%d""" % (right_param, REQUEST.USER.get_id())
    REQUEST.db.execute(SQL.encode('UTF8'))
    cres = REQUEST.db.dictfetchall()
    temp_res = []
    temp_em = []
    for row in cres:
         if row['e_mail'] not in temp_em:
           temp_res.append({'first_name':row['first_name'], 'last_name':row['last_name'], 'e_mail':row['e_mail']})
           temp_em.append(row['e_mail'])
         if row['e_mail2'] not in temp_em:
           temp_res.append({'first_name':row['first_name'], 'last_name':row['last_name'], 'e_mail':row['e_mail2']})
           temp_em.append(row['e_mail2'])
         if row['e_mail3'] not in temp_em:
           temp_res.append({'first_name':row['first_name'], 'last_name':row['last_name'], 'e_mail':row['e_mail3']})
           temp_em.append(row['e_mail3'])
    cres = temp_res

    if cres:
        output.append(u"""<SCRIPT type="text/javascript">
function check_contacts(field_name)
{
  basetop = 110;
  if(%(is_drafts)d) basetop = basetop + 30;
  if(field_name=='email_cc') basetop = basetop + 30;
  if(field_name=='email_bcc') basetop = basetop + 60;
  out = new Array();
  inputstr = document.forms['composeform'][field_name].value;
  inputstr? parts = inputstr.split(" "): parts=new Array();
  part = parts[parts.length-1];
  if(part && part.length>=2)
  {
      part = part.toLowerCase()
      n = 0;
      o = 0;
      while(n<contacts.length)
      {
          if(contacts[n].toLowerCase().indexOf(part)!=-1)
          {
              out[o]=contacts[n];
              o = o + 1;
          }
          n = n + 1;
      }
  }
  if(out && out !="" && out!=[])
  {
    c_div = document.getElementById('placeholder');
    c_div.innerHTML = "";
    c_div.style.position='absolute';
    c_div.style.top=basetop+'px';
    c_div.style.left='115px';
    out_html='<TABLE border="0" cellpadding="0" cellspacing="0" bgcolor="#F6F6F6" style="border-top: 1px solid #8A867A;border-right: 1px solid #8A867A;border-left: 1px solid #8A867A;">';
    n = 0;
    while(n<out.length && n<20)
    {
      out_html += '<TR><TD onmouseover="this.style.backgroundColor=\\'#C1D2EE\\';" onmouseout="this.style.backgroundColor=\\'#F6F6F6\\';" style="cursor: pointer; cursor: hand; padding: 3px;" onmousedown="subval(\\''+field_name+'\\',\\''+out[n]+'\\');">'+out[n].replace("<", "&lt;").replace(">", "&gt;")+'</TD></TR><TR><TD bgcolor="#8A867A"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD></TR>';
      n++;
    }
    out_html += '</TABLE>';
    el1 = document.getElementById('html_select');
    el2 = document.getElementById('sig_select');
    if (el1) el1.style.visibility = 'hidden';
    if (el2) el2.style.visibility = 'hidden';
    c_div.innerHTML = out_html;
  }
  else
  {
    c_div = document.getElementById('placeholder');
    el1 = document.getElementById('html_select');
    el2 = document.getElementById('sig_select');
    if (el1) el1.style.visibility = 'visible';
    if (el2) el2.style.visibility = 'visible';
    c_div.innerHTML = "";
  }
}
function subval(field_name, val)
{
  inputstr = document.forms['composeform'][field_name].value;
  inputstr? parts = inputstr.split(" "): parts=new Array();
  outstr = ""
  if(parts.length>1)
  {
    n = 0;
    while(n<parts.length-1)
    {
      outstr += parts[n] + ' ';
      n++;
    }
    outstr += val+', ';
  }
  else
  {
    outstr = val+', ';
  }
  document.forms['composeform'][field_name].value = outstr;
  c_div = document.getElementById('placeholder');
  c_div.innerHTML = "";
  el1 = document.getElementById('html_select');
  el2 = document.getElementById('sig_select');
  if (el1) el1.style.visibility = 'visible';
  if (el2) el2.style.visibility = 'visible';
  document.forms['composeform'][field_name].focus();
}
function destroy_div()
{
  c_div = document.getElementById('placeholder');
  c_div.innerHTML = "";
  el1 = document.getElementById('html_select');
  el2 = document.getElementById('sig_select');
  if (el1) el1.style.visibility = 'visible';
  if (el2) el2.style.visibility = 'visible';
}
var contacts = new Array();""" % locals())
        n = 0
        for c in cres:
            if c['e_mail']:
                output.append(u"""contacts[%d] = '&quot;%s %s&quot; %s';""" % (n, c['first_name'].decode('UTF8').replace("\n", "").replace("\r", "").replace('"', '').replace("<", "").replace(">", "").replace("'", ""), c['last_name'].decode('UTF8').replace("\n", "").replace("\r", "").replace('"', '').replace("<", "").replace(">", "").replace("'", ""), "<"+c['e_mail'].decode('UTF8').replace("\n", "").replace("\r", "").replace('"', '').replace("'", "").replace("<", "").replace(">", "")+">"))
                n = n + 1
        output.append(u"""</SCRIPT>""")

    ### CONTACT JS
    else:
        output.append(u"""<SCRIPT type="text/javascript">
function check_contacts(field_name) { return true; }
function destroy_div() { return true; }
</SCRIPT>""")

    REQUEST.db.execute("""SELECT e.* FROM items i, eaccounts e WHERE i.item_id=e.eaccount_id AND i.parent_id=%d AND e.eaccount_sendername is not null and eaccount_sendermail is not null""" % REQUEST.USER.get_id())
    account_res = REQUEST.db.dictfetchall()
    if account_res:
        tmp1 = REQUEST.get_setting('email_sender_name')
        tmp2 = REQUEST.get_setting('email_sender_email')
        account_html = []
        if len(account_res) > 1 or tmp1 not in map(lambda x: x['eaccount_sendername'].decode('UTF8'), account_res) or \
                                   tmp2 not in map(lambda x: x['eaccount_sendermail'].decode('UTF8'), account_res):
            account_html.append(u"""<OPTION value="-1">%s &lt;%s&gt;</OPTION>""" % (tmp1, tmp2))
            if REQUEST.form.has_key('from_account'):
                from_account = int(REQUEST.form['from_account'].value)
            else:
                from_account = -1
            for row in account_res:
                account_html.append(u"""<OPTION value="%d"%s>%s &lt;%s&gt; (%s@%s)</OPTION>""" % (row['eaccount_id'],(from_account==row['eaccount_id'] and " SELECTED") or '', row['eaccount_sendername'].decode('UTF8'),row['eaccount_sendermail'].decode('UTF8'), row['eaccount_user'].decode('UTF8'), row['eaccount_name'].decode('UTF8')))
            account_html = "\n".join(account_html)
            tls_sendername = REQUEST.TLS('email_sendername')
            account_html = u""" <TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="10%%" nowrap>%(REQ_FIELD)s%(tls_sendername)s:</TD>
  <TD class="td_listing1" width="90%%"><SELECT name="from_account">%(account_html)s</SELECT></TD>
 </TR>""" % locals()
        else:
            account_html = u""
    else:
        account_html = u""
    
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
function check_values(e){ if (!document.composeform.email_to.value) { alert("%(tls_missing_input)s"); return false; } return true; }
function spell_check(){  confirm_leave=function(){}; document.forms['composeform'].action = "%(BASE_EMAIL_URL)scompose.py";  document.forms['composeform']['act'].value = "spellcheck"; SyncEpoz();  document.forms['composeform'].submit();}
function spell_check_done(){  document.forms['spellcheckedit'].email_to.value = document.forms['composeform'].email_to.value;  document.forms['spellcheckedit'].email_cc.value = document.forms['composeform'].email_cc.value;  document.forms['spellcheckedit'].email_bcc.value = document.forms['composeform'].email_bcc.value;  document.forms['spellcheckedit'].email_subject.value = document.forms['composeform'].email_subject.value;  document.forms['spellcheckedit'].is_html.value = '%(spell_html)s';  document.forms['spellcheckedit'].submit();}
function confirm_leave()
{
 try{ SyncEpoz(); } catch(e) { ; }
 try{ a = document.forms['composeform']['email_contents'].value; } catch(e) { a=""; } 
 if(a && a.length>6)
 {
    return "%(tls_confirm_leave)s";
 }
}
// -->
</SCRIPT>
<FORM action="%(BASE_EMAIL_URL)scompose.py/send" method="POST" ENCTYPE="multipart/form-data" onsubmit="confirm_leave=function(){};" name="composeform">
<INPUT type="hidden" name="type_compose" value="1">
<INPUT type="hidden" name="act" value="">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_9.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(title)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
%(mail_id)s
%(hiddenstr)s
%(drafts)s
%(account_html)s
 <TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing1ke" width="10%%">%(REQ_FIELD)s%(tls_to)s:</TD>
  <TD class="td_listing1ve" width="90%%"><INPUT  onkeydown="try { if (window.event.keyCode == 13) { return false;}} catch(e){;}" AUTOCOMPLETE="OFF" onblur="setTimeout('destroy_div()', 10);" onkeyup="check_contacts('email_to');" tabindex=1 class=textfield2 type="text" name="email_to" size="90" value="%(mail_to)s"> <A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/contacts?field=email_to" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/mycontacts.gif" width="18" height="16" border="0" alt=""></A>&nbsp;<A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/groups?field=email_to" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/allcontacts.gif" width="20" height="16" border="0" alt=""></A><BR>%(to_str)s</TD>
 </TR>
 <TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing0ke">%(tls_cc)s:</TD>
  <TD class="td_listing0ve"><INPUT onkeydown="try { if (window.event.keyCode == 13) { return false;}} catch(e){;}" AUTOCOMPLETE="OFF" onblur="setTimeout('destroy_div()', 10);" onkeyup="check_contacts('email_cc');" tabindex=2 class=textfield2 type="text" name="email_cc" size="90" value="%(mail_cc)s"> <A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/contacts?field=email_cc" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/mycontacts.gif" width="18" height="16" border="0" alt=""></A>&nbsp;<A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/groups?field=email_cc" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/allcontacts.gif" width="20" height="16" border="0" alt=""></A></TD>
 </TR>
 <TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing1ke">%(tls_bcc)s:</TD>
  <TD class="td_listing1ve"><INPUT onkeydown="try { if (window.event.keyCode == 13) { return false;}} catch(e){;}" AUTOCOMPLETE="OFF" onblur="setTimeout('destroy_div()', 10);" onkeyup="check_contacts('email_bcc');" tabindex=3 class=textfield2 type="text" name="email_bcc" size="90" value="%(mail_bcc)s"> <A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/contacts?field=email_bcc" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/mycontacts.gif" width="18" height="16" border="0" alt=""></A>&nbsp;<A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/groups?field=email_bcc" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/allcontacts.gif" width="20" height="16" border="0" alt=""></A></TD>
 </TR>
 <TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing0ke">%(tls_subject)s:</TD>
  <TD class="td_listing0ve"><INPUT onkeydown="try { if (window.event.keyCode == 13) { return false;}} catch(e){;}" tabindex=4 class=textfield2 type="text" name="email_subject" size="90" value="%(mail_subject)s"></TD>
 </TR>
%(format_sig_spellcheck)s
%(spell_tr)s
 <TR class="tr_listing0">
  <TD class="td_listing0" colspan="3">%(text_area)s</TD>
 </TR>""" % locals())
    if spell_ok:
      output.append(u"""
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="2"><INPUT class="input6" type="submit" name="_send" value="%(tls_send)s" onclick="isclicked=true;confirm_leave=function(){;};return check_values();"> <INPUT class="input6" type="submit" onclick="confirm_leave=function(){};" name="_save" value="%(tls_save)s"></TD>
 </TR>
 </TABLE>
 <TABLE class="td_normal" cellpadding="0" cellspacing="0">
 <TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing_noborder" nowrap>%(tls_addattachment)s:</TD>
  <TD class="td_listing_noborder" width="100%%"><INPUT size=26 class="inputfile" type="file" name="filepointer">&nbsp;%(tls_or)s</TD>
 </TR>
%(conflux_att)s
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="2"><INPUT class="input6" type="submit" name="_attach" value="%(tls_addattachment)s" onclick="confirm_leave=function(){}; if(!this.form.filepointer.value&&(!this.form._attachid||!this.form._attachid.value)){ alert('%(tls_missing_attachment)s'); return false;};"></TD>
 </TR>
%(attach_output)s
</TABLE>""" % locals())
    else:
      output.append("</TABLE>")
    output.append("""
<DIV id="placeholder"></DIV>
<SCRIPT TYPE="text/javascript">
document.forms['composeform']['email_to'].focus();
</SCRIPT>
</FORM>
<BR>""")
    return "\n".join(output)
