
from mod_python import apache

import email

import _mail, _InitTypes, _Email, base64, _Conf, cStringIO, _Utils, os, _Document, _Eaccount
import Menus, _Efolder
import standard_html
import mx.DateTime

MY_MENU_ID=-1

def index(REQUEST): # Add folder management
    output = []
    output.append(standard_html.html_header(REQUEST))
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value:
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)

    if not REQUEST.form.has_key('headers'):
        output.append(Menus.get_email_menu(REQUEST, MY_MENU_ID))

    active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['folder_id'].value))
    if active_folder.get('eaccount_id'):
        acc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, active_folder.get('eaccount_id'))
    else:
        raise RuntimeError, "THIS IS NOT AN IMAP FOLDER FIXME!!!"

    REQUEST.db.execute("""SELECT conflux_id FROM imap_emails WHERE folder_id=%d AND imap_uid=%d""" % (active_folder.get_id(), int(REQUEST.form['mail_id'].value)))
    res = REQUEST.db.fetchone()
    if res:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, res[0])
        if (msg.get('email_flags') & _Email.EMAIL_READ) == 0:
            REQUEST.db.execute("""UPDATE emails set email_flags=(email_flags | %d) WHERE email_id=%d""" % (_Email.EMAIL_READ, msg.get_id()))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
        email_id = msg.get_id()
        del msg
    else:
        box = _mail.IMAP4Mailbox()
        import cStringIO
        fp = cStringIO.StringIO()
        try:
            box.open(REQUEST, acc, 0)
            box.foldername = active_folder.get('efolder_name')
            box.openfolder(box.foldername)
            message = box.get(REQUEST.form['mail_id'].value, fp, use_uid=1)
            box.markbit(int(REQUEST.form['mail_id'].value), "(\Seen)")
        finally:
            try: box.close()
            except: pass
            fp.close()

        email_id = _mail.mail_from_imap(REQUEST, message, active_folder, active_folder.get_id(), acc)

        REQUEST.db.execute("""INSERT INTO imap_emails ( folder_id, imap_uid, conflux_id ) VALUES ( %d, %d, %d )""" % (active_folder.get_id(), int(REQUEST.form['mail_id'].value), email_id))
    output.append(_mail.full_parse_message(REQUEST, message, message, email_id))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def getpart(REQUEST):
    return _mail.getpart(REQUEST)

def getpart_inline(REQUEST):
    return _mail.getpart_inline(REQUEST)

def save_file_form(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(standard_html.window_script(height=400,width=400, resizable='yes'))

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    mail_id = int(REQUEST.form['mail_id'].value)
    part = REQUEST.form['part'].decode('UTF8')
    email_filename = local_getpart_name(REQUEST, mail_id, part)
    try:
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.getCookie('activeFolder')))
        my_parent_id = obj.get_id()
        my_parent_name = obj.get_virtual_path()
    except:
        my_parent_id = REQUEST.USER.get_parent_id(REQUEST)
        my_parent_name = REQUEST.USER.get_parent(REQUEST).get_virtual_path()
    if REQUEST.form.has_key('headers'):
        headers = u"""<input type="hidden" name="headers" value="1">"""
    else:
        headers = u""
    add_file_tls = REQUEST.TLS("doc_addfile")
    file_tls = REQUEST.TLS("doc_file")
    save_tls = REQUEST.TLS("tls_save")
    title_tls = REQUEST.TLS("tls_title")
    author_tls = REQUEST.TLS("doc_author")
    folder_tls = REQUEST.TLS("doc_folder")
    desc_tls = REQUEST.TLS("tls_description")
    comments_tls = REQUEST.TLS("tls_comments")
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    REQ_FIELD = _Conf.REQ_FIELD
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    output.append("""\
<SCRIPT language="javascript">
<!--
  function check_values()
  {
    if (!document.addform.filename.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_4.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(add_file_tls)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_EMAIL_URL)sread.py/addfile" ENCTYPE="multipart/form-data" onSubmit="return check_values();">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
<INPUT type="hidden" name="mail_id" value="%(mail_id)d">
<INPUT type="hidden" name="part" value="%(part)s">
%(headers)s
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1">%(file_tls)s%(REQ_FIELD)s</TD>
  <TD class="td_listing1" width="100%%"><INPUT size=35 class="textfield1" type="text" name="filename" value="%(email_filename)s"></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0">%(title_tls)s</TD>
  <TD class="td_listing0"><INPUT  size=35 class="textfield1" type="text" name="title"></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1">%(author_tls)s</TD>
  <TD class="td_listing1"><INPUT  size=35 class="textfield1" type="text" name="author"></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0">%(folder_tls)s</TD>
  <TD class="td_listing0"><INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/frametree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" border="0"></A></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="2">%(desc_tls)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20"></TEXTAREA></TD>
</TR>
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
  <TD colspan="2"><INPUT type="submit" class="input2" name="_save" value="%(save_tls)s"></TD>
</TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def addfile(REQUEST):
    output = []
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if not REQUEST.form.has_key('filename'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if not REQUEST.form.has_key('title'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    mail_id = int(REQUEST.form['mail_id'].value)
    part = REQUEST.form['part'].decode('UTF8')

    if REQUEST.form['filename'].value.find('\\') <> -1:
        filename = REQUEST.form['filename'].value.decode('UTF8').split('\\')[-1]
    else:
        filename = REQUEST.form['filename'].value.decode('UTF8')
    filename = _Utils.make_path(os.path.split(filename)[-1])

    fp = cStringIO.StringIO(local_getpart(REQUEST, mail_id, part))
    fp.seek(0)

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_REQ)
    doc.set('filename', filename)
    doc.set('filepointer', fp)
    if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
        doc.set('title', filename)
    if os.path.exists(doc.get_path().encode('UTF8')):
        # Try adding a new unique number:
        origpath = doc.get_path()
        splitpath = os.path.splitext(origpath)
        newname = None
        for i in range(1,100):
            tmppath = splitpath[0] + ('-%d'%i) + splitpath[1]
            if not os.path.exists(tmppath.encode('UTF8')):
                newname = os.path.split(splitpath[0] + ('-%d'%i) + splitpath[1])[1]
                break
        if newname is None:
            raise RuntimeError, REQUEST.TLS('doc_rename_exists')
        else:
            if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
                doc.set('title', newname)
            doc.set('filename', newname)
    doc.save()

    if REQUEST.form.has_key('headers'):
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"read.py?mail_id=%d&headers=1" % mail_id
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    else:
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"read.py?mail_id=%d" % mail_id
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(REQUEST.TLS('doc_fileadded'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def local_getpart_name(REQUEST, mail_id, part):
    parts = map(int, part.split('.'))[1:]

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mail_id)
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
    del msg

    for part_ndx in parts:
        message = message.get_payload()[part_ndx]

    return _mail.parse_quoted_string(message, message.get_filename() or _mail.get_alt_name(message) or 'noname.bin')

def local_getpart(REQUEST, mail_id, part):
    parts = map(int, part.split('.'))[1:]

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mail_id)
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
    del msg

    for part_ndx in parts:
        message = message.get_payload()[part_ndx]

    return message.get_payload(decode=1)

def source(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
    return "<PRE>%s</PRE>" % _Utils.html_quote(base64.decodestring(msg.get('email_contents')))

def get_dict_from_ical(REQUEST, ical):
    ical_contents = filter(None, ical.split("\n"))
    event = {}
    in_event = 0
    for line in ical_contents:
        if in_event and len(line)>6 and line[0:6] == "BEGIN:":
            in_event = 0
        if line.strip() == "BEGIN:VEVENT":
            in_event = 1
        if in_event and len(line)>8 and line[0:8] == "SUMMARY:":
            event['title']=line[8:]
        if in_event and len(line)>10 and line[0:10] == "ORGANIZER:":
            event['creator'] = line[10:].replace("MAILTO:", "")
        if in_event and len(line)>12 and line[0:12] == "DESCRIPTION:":
            event['description'] = line[12:]
        if in_event and len(line)>8 and line[0:8] == "ATTENDEE":
            tmp = line.split(";")[1].replace("CN=", "").replace('"', "")
            event['attendees'] = event.get('attendees', '') + "###" + tmp
        if in_event and len(line)>8 and line[0:8] == "DTSTART:":
            date = line[8:16]
            time = line[17:21]
            event['start_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
        if in_event and len(line)>6 and line[0:6] == "DTEND:":
            date = line[6:14]
            time = line[15:19]
            event['end_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
    return event

def ical(REQUEST, contents):
    event = get_dict_from_ical(REQUEST, a)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    title = REQUEST.TLS('log_event_id') + ": " + event.get('title')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(u"""
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn221.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="color: #FFFFFF; font-weight: bold; padding: 4px;" bgcolor="#0068C6" nowrap><b>%(title)s</b></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn222.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>""" % locals())
    creator = event.get('creator')
    if creator:
        line = "<b>" + REQUEST.TLS('tls_creator') + ":</b> " + creator
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    start_stamp = event.get('start_stamp')
    if start_stamp:
        date, time = start_stamp.split(" ")
        year, month, day = map(int, date.split("-"))
        hour, minute = map(int, time.split(":"))
        start_stamp = mx.DateTime.DateTime(year, month, day, hour, minute)
        start_stamp = REQUEST.iso2userdatetime(REQUEST, start_stamp)
        line = "<b>" + REQUEST.TLS('cal_start') + ":</b> " + start_stamp
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    end_stamp = event.get('end_stamp')
    if end_stamp:
        date, time = end_stamp.split(" ")
        year, month, day = map(int, date.split("-"))
        hour, minute = map(int, time.split(":"))
        end_stamp = mx.DateTime.DateTime(year, month, day, hour, minute)
        end_stamp = REQUEST.iso2userdatetime(REQUEST, end_stamp)
        line = "<b>" + REQUEST.TLS('cal_end') + ":</b> " + end_stamp
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    description = event.get('description')
    if description:
        line = u"<b>" + REQUEST.TLS('tls_description') + u":</b> " + _Utils.newline2br(description)
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())

    output.append(u"""</TABLE>""")
    return "\n".join(output)
