"""
Popup related persons

"""


import _Conf, standard_html
import _Access, _InitTypes


def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    show_users = None
    userlist1=[]
    self_param = ""
    if not show_users:
        self_param = " and p.person_id<>%d " % REQUEST.USER.get_id()
        userlist1.append(u"""<OPTION value="%d" SELECTED>%s</OPTION>""" % (REQUEST.USER.get_id(), REQUEST.USER.get_name()))
    userlist2=[]
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    if REQUEST.form.has_key('ret'):
        retform = REQUEST.form['ret'].value
    else:
        raise RuntimeError, REQUEST.TLS('tls_noreturnform')
    if REQUEST.form.has_key('num'):
        divnr = REQUEST.form['num'].value
    else:
        raise RuntimeError, REQUEST.TLS('tls_noreturndiv')
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param

    REQUEST.db.execute((u"""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0 %s%s""" % (self_param, right_param)).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    related_persons = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, REQUEST.USER.get_parent_id(REQUEST), x['person_id']) > _Access.ACCESS_NONE and x) or None, related_persons))
    for person in related_persons:
        if show_users and person['person_id'] in show_users:
            userlist1.append(u"""<OPTION value="%d" SELECTED>%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
        else:
            userlist2.append(u"""<OPTION value="%d">%s""" % (person['person_id'], person['item_name'].decode('UTF8')))

    ulist1 = "\n".join(userlist1)
    ulist2 = "\n".join(userlist2)
    output.append(u"""\
<SCRIPT type="text/javascript">
function move_1()
{
	var the_select1 = window.document.vorm.show_users_set2;
	var the_select2 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_2()
{
	var the_select1 = window.document.vorm.show_users_set;
	var the_select2 = window.document.vorm.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function select_all()
{
	var the_select1 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		the_select1.options[loop].selected = true;
	}
}
function send_data()
{
var browser;
if (checkIt('msie')) browser = "IE";

    if(browser == "IE")
    {
      var the_select1=window.opener.document.addform.%(retform)s;
      var the_select2=window.document.vorm.show_users_set;
      var writeStr = '<SELECT size="3" multiple name="%(retform)s">';
      for (loop=0; loop < the_select2.options.length; loop++)// fill other select list with new values
      {
        writeStr += '<option SELECTED value="' + the_select2.options[loop].value + '">' + the_select2.options[loop].text.substr(0, 10) + '..' + '</option>';
      }
      writeStr +='</SELECT>&nbsp;<A href="javascript:void(0);" OnClick="rel_popup(\\'%(BASE_GENERAL_URL)spopuprel.py?ret=%(retform)s&num=%(divnr)s\\', \\'%(retform)s\\');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" align="top" style="position: relative; top: 2px;"></A>';
      writeObj = window.opener.document.getElementById('%(divnr)s');
      writeObj.innerHTML = writeStr;
      window.close();
    }
    else
    {

      var the_select1=window.opener.document.addform.%(retform)s;
      var the_select2=window.document.vorm.show_users_set;
      for (loop=0; loop < the_select1.options.length; loop++)// empty other select list first (just in case)
      {
        the_select1.options[loop] = null;
        loop--;
      }
      var the_select1=window.opener.document.addform.%(retform)s;
      var the_select2=window.document.vorm.show_users_set;
      for (loop=0; loop < the_select2.options.length; loop++)// fill the other select with new values
      {
        var opt = new Option(the_select2.options[loop].text.substr(0,10) + '..', the_select2.options[loop].value);
        opt.selected = true;
        the_select1.options[the_select1.options.length] = opt;
      }
      window.close();
    }
}

function checkIt(string)
{
	var detect;
	detect = navigator.userAgent.toLowerCase();
	place = detect.indexOf(string) + 1;
	thestring = string;
	return place;
}
</SCRIPT>""" %locals())
    
    tls_choose_related = REQUEST.TLS('tls_choose_related')
    tls_workflow_related = REQUEST.TLS('tls_workflow_related')
    tls_workflow_other = REQUEST.TLS('tls_workflow_other')
    tls_save = REQUEST.TLS('tls_save')
    
    output.append(u"""\
<FORM name="vorm" method="post" onsubmit="send_data(); return false;">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=30 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=30 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=10 border=0 alt=""></TD>
    <TD class="td_listing1" colspan=4>%(tls_choose_related)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=10 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_workflow_related)s</TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=30 border=0 alt=""></TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=30 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_workflow_other)s</TD>
    <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
  </TR>
     <TR class="tr_listing1">
       <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set" multiple size="5">
%(ulist1)s
         </SELECT>
       </TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_1();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_2();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set2" multiple size="5">
%(ulist2)s
         </SELECT>
       </TD>
       <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
     </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="4"><input type="submit" value="%(tls_save)s" class="input2"></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
