
import _Conf
import standard_html, _Access, _InitTypes, _Utils
import mx.DateTime

def index(REQUEST):
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_MESSENGER_URL = _Conf.BASE_MESSENGER_URL
    host_name = REQUEST.mod_req.server.server_hostname
    if REQUEST.is_https:
        protocol = "https://"
    else:
        protocol = "http://"
    output = []
    output.append(standard_html.html_header(REQUEST, "", "onload='get_b()'", 0))
    app_name = _Conf.APP_NAME
    output.append(u"""
<script type="text/javascript" src="%(BASE_WEB_URL)sreq.js"></script>
<script type="text/javascript">
function disabletext(e) { return false; }
function reEnable() { return true; }
document.onselectstart=new Function ("return false")
if (window.sidebar){ document.onmousedown=disabletext; document.onclick=reEnable; }
function chati(uid)
{
    im_win = window.open("","imwindow"+uid,"width=410,height=280,toolbar=0,directories=0,menubar=0,status=0,location=0,scrollbars=yes,resizable=no");
    if(im_win.location.href && im_win.location.href=="about:blank")
    {
      myhref = '%(protocol)s%(host_name)s%(BASE_MESSENGER_URL)smessenger.py?im_to='+uid;
      im_win.location.href=myhref;
      im_win.focus();
    }
    else
    {
      im_win.focus();
    }
}
</script>
<BR>
<TABLE border="0" cellpadding="0" cellspacing="0" width="180" align="center">
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn221.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD bgcolor="#0068C6">&nbsp;</TD>
  <TD width="100%%" bgcolor="#0068C6" style="color: #CBFFFF; padding:5px; cursor: default;" align="center"><b>%(app_name)s
 Messenger</b></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn222.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
<TR>
  <TD colspan="4" width="100%%"><DIV id="buddy_list">&nbsp;</DIV></TD>
</TR>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn23.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD bgcolor="#3F97E1" colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="2" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn24.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<script type="text/javascript">
function get_b()
{
  txt = SendRequest_RES("%(protocol)s%(host_name)s%(BASE_MESSENGER_URL)sbuddy_list.py/buddy_list?a=1");
  if(txt && txt!=" ")
  {
    el = document.getElementById('buddy_list');
    el.innerHTML = txt;
  }
  setTimeout("get_b()", 30000);
}
</script>
""" % locals())
    output.append(standard_html.html_footer3(REQUEST))
    return '\n'.join(output)


def buddy_list(REQUEST):
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    now = _Utils.utc_now_mx()
    now2 = now - mx.DateTime.DateTimeDelta(0, 0, 0, 50);
    if right_param:
        right_param = " AND " + right_param
    SQL = """SELECT distinct person_id, p.first_name || ' ' || p.last_name as name, case when s.update_stamp>'%s' then 1 else 0 end from persons p, sessions s, items i WHERE p.person_id=i.item_id and p.person_id=s.user_id AND p.is_deleted=0 %s order by p.person_id""" % (now2, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    res = REQUEST.db.fetchall()
    res1 = []
    res2 = []
    c = []
    for row in res:
        if row[2]==1 and row[0] not in c:
            c.append(row[0])
            res1.append(row)
    for row in res:
        if row[2]==0 and row[0] not in c:
            c.append(row[0])
            res2.append(row)
    out = "<TABLE width='100%' border='0' cellpadding='0' cellspacing='0' bgcolor='#3F97E1'><TR><TD style='padding: 4px; color: green;cursor: default;'><b>Online:</b></TD></TR>"
    if res1:
        for row in res1:
            out = out + """<TR><TD nowrap onclick="chati(%d);" onmouseover="this.style.backgroundColor='#0068C6'" onmouseout="this.style.backgroundColor='#3F97E1'" style="font-size: 11px; color: #CBFFFF; padding: 3px; cursor: pointer; cursor: hand">&nbsp;&nbsp;%s</TD></TR>""" % (row[0], _Utils.shorten_string(row[1].decode('UTF8'),30))
    out += "<TR><TD style='padding: 4px; color: red; cursor: default;'><b>Offline:</b></TD></TR>"
    if res2:
        for row in res2:
            out = out + """<TR><TD nowrap onclick="chati(%d);" onmouseover="this.style.backgroundColor='#0068C6'" onmouseout="this.style.backgroundColor='#3F97E1'" style="font-size: 11px; color: #CBFFFF; padding: 3px; cursor: pointer; cursor: hand">&nbsp;&nbsp;%s</TD></TR>""" % (row[0], _Utils.shorten_string(row[1].decode('UTF8'),30))
    out += "</TABLE>"
    return out
