MY_MENU_ID=1
MY_MENU_ID_OTHERS=2
MY_MENU_ID_ALL=3

import _Conf, standard_html
from Menus import get_opportunities_menu
import _Access, _InitTypes, _Utils

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('all') and int(REQUEST.form['all'].value)==1:
        output.append(get_opportunities_menu(REQUEST, MY_MENU_ID_ALL))
        only_mine = """ AND (o.opp_stage=100 or o.opp_stage=0)"""
        mine_str = """<input type="hidden" name="all" value="1">"""
    elif REQUEST.form.has_key('all') and int(REQUEST.form['all'].value)==2:
        output.append(get_opportunities_menu(REQUEST, MY_MENU_ID_OTHERS))
        only_mine = """ AND i.creator_id<>%d and o.opp_stage<100 and o.opp_stage>0""" % REQUEST.USER.get_id()
        mine_str = """<input type="hidden" name="all" value="2">"""
    else:
        output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
        only_mine = """ AND i.creator_id=%d and o.opp_stage<100 and o.opp_stage>0""" % REQUEST.USER.get_id()
        mine_str = ""

    filter = ""
    search_params = ""
    if REQUEST.form.has_key('filter') and REQUEST.form['filter'].value.decode('UTF8').strip():
        filter = REQUEST.form['filter'].value.decode('UTF8').strip()
        w = _Utils.sql_quote_simple(REQUEST.form['filter'].value.decode('UTF8').strip().lower())
        w2 = _Utils.sql_quote_simple(REQUEST.form['filter'].value.decode('UTF8').strip())
        if len(w)>=3:
            search_params = u""" AND i.item_id in (SELECT item_id FROM fti_search WHERE word = '%s' and fti_type=true)""" % w
        else:
            search_params = u""" AND (
lower(o.opp_name) like '%%%s%%' OR 
lower(o.opp_next_stage) like '%%%s%%' OR 
lower(o.description) like '%%%s%%' OR 
lower(o.req_descr) like '%%%s%%' OR 
lower(o.amount) like '%%%s%%' OR 
lower(o.opp_lost) like '%%%s%%' OR 
lower(o.lead_source) like '%%%s%%' OR 
lower(o.client_type) like '%%%s%%')""" % (w,w,w,w,w,w,w,w)

    tls_name = REQUEST.TLS('tls_name')
    tls_creator = REQUEST.TLS('client_owner')
    tls_client = REQUEST.TLS('opp_client')
    tls_stage = REQUEST.TLS('opp_stage')
    tls_prob = REQUEST.TLS('opp_probability')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_closedate = REQUEST.TLS('opp_date')
    tls_filter = REQUEST.TLS('tls_filter')
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    sortby = [
'opp_name ASC', 'opp_name DESC',
'creator_name ASC, opp_name ASC', 'creator_name DESC, opp_name ASC',
'client_name ASC, opp_name ASC', 'client_name DESC, opp_name ASC',
'opp_stage ASC, opp_name ASC', 'opp_stage DESC, opp_name ASC',
'amount ASC, opp_name ASC', 'amount DESC, opp_name ASC',
'close_date ASC, opp_name ASC', 'close_date DESC, opp_name ASC'
]
    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    sortby_name = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=0">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_name)
    sortby_creator = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=2">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_creator)
    sortby_client = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=4">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_client)
    sortby_stage = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=6">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_stage)
    sortby_amount = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=8">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_amount)
    sortby_date = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=10">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_closedate)
    if sortby_id == 0:
        sortby_name = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=1">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=0">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=3">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=2">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_client = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=5">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_client)
    elif sortby_id == 5:
        sortby_client = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=4">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_client)
    elif sortby_id == 6:
        sortby_stage = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=7">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_stage)
    elif sortby_id == 7:
        sortby_stage = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=6">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_stage)
    elif sortby_id == 8:
        sortby_amount = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=9">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_amount)
    elif sortby_id == 9:
        sortby_amount = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=8">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_amount)
    elif sortby_id == 10:
        sortby_date = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=11">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_closedate)
    elif sortby_id == 11:
        sortby_date = u"""<A class="blackboldlink" href="%sopportunities.py%ssort_by=10">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_closedate)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND " + right_param
    

    QUERY = """SELECT count(*) AS count_all FROM opportunities o, items i WHERE o.opp_id=i.item_id %s%s%s""" % (only_mine, right_param, search_params)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sopportunities.py%sqs=" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sopportunities.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sopportunities.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    SQL = """SELECT o.*, i.parent_id, i2.item_name as creator_name, c.client_name as client_name FROM opportunities o, items i, items i2, clients c WHERE o.opp_id=i.item_id and i.creator_id=i2.item_id and o.client_id=c.client_id%s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (only_mine, right_param, search_params, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()


    tls_opportunities = REQUEST.TLS('topmenu_opportunities')
    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_19.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap width="100%%"><span class="t3">%(tls_opportunities)s</span></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdnrk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="3" height="20" border=0 alt=""></TD>
  <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_filter)s:</b>&nbsp;</TD>
  <TD class="th_listing" align="center" nowrap><input type="text" name="filter" class="textfield_filter" value="%(filter)s">&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdnrk2.gif')"><input type="image" src="%(BASE_ICON_URL)sspacer.gif" width="3" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_OPPORTUNITIES_URL)sopportunities.py">
%(mine_str)s
<TR>
  <TD width="1%%"  class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="20%%" class="td_listing1b">%(sortby_name)s</TD>
  <TD width="20%%" class="td_listing1b">%(sortby_creator)s</TD>
  <TD width="20%%" class="td_listing1b">%(sortby_client)s</TD>
  <TD width="15%%" class="td_listing1b">%(sortby_stage)s</TD>
  <TD width="5%%"  class="td_listing1b">%(tls_prob)s</TD>
  <TD width="9%%"  class="td_listing1b">%(sortby_amount)s</TD>
  <TD width="10%%" class="td_listing1b">%(sortby_date)s</TD>
</TR>""" % locals())
    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_OPPORTUNITIES_URL'] = _Conf.BASE_OPPORTUNITIES_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['opp_name'] = (_Utils.html_quote(item['opp_name'] or "")).decode('UTF8')
        item['creator_name'] = (item['creator_name'] or "&nbsp;").decode('UTF8')
        item['client_name'] = _Utils.html_quote((item['client_name'] or "&nbsp;").decode('UTF8'))
        opp_stage = str(item['opp_stage'])
        item['stage_name'] = stages[opp_stage]
        item['opp_stage'] = str(item['opp_stage']) + "%"
        if item['amount']:
            item['amount'] = (c_pre + str(item['amount'] and "%.2f" % item['amount'])+c_suf) or ''
        else:
            item['amount'] = ''
        item['close_date'] = REQUEST.iso2userdate(item['close_date']) or "&nbsp;"

        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" nowrap><A class="td_listing" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)d">%(opp_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(creator_name)s</TD>
  <TD class="td_listing%(class_type)d">%(client_name)s</TD>
  <TD class="td_listing%(class_type)d">%(stage_name)s</TD>
  <TD class="td_listing%(class_type)d" nowrap align="center">%(opp_stage)s</TD>
  <TD class="td_listing%(class_type)d">%(amount)s</TD>
  <TD class="td_listing%(class_type)d">%(close_date)s</TD>
</TR>""" % item)
    output.append("""</TABLE>""")
    output.append(FULL_BAR)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
