MY_MENU_ID=6

import _Conf, standard_html
from Menus import get_opportunities_menu
import _Product, _InitTypes, _Utils, _Access
import mx.DateTime, calendar

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    extra_str = ""
    if REQUEST.form.has_key('cli'):
        report = "report2"
        hiddenstr = """<input type="hidden" name="cli" value="1">"""
        tls_salesstat = REQUEST.TLS('rep_title2')
    elif REQUEST.form.has_key('pro'):
        report = "report2"
        hiddenstr = """<input type="hidden" name="pro" value="1">"""
        tls_salesstat = REQUEST.TLS('rep_title3')
    elif REQUEST.form.has_key('per'):
        report = "report2"
        hiddenstr = """<input type="hidden" name="per" value="1">"""
        tls_salesstat = REQUEST.TLS('rep_title4')
    elif REQUEST.form.has_key('clipro'):
        report = "report3"
        hiddenstr = """<input type="hidden" name="clipro" value="1">"""
        tls_salesstat = REQUEST.TLS('rep_title5')
        tls_show = REQUEST.TLS('tls_show')
        tls_won = REQUEST.TLS('rep_won')
        tls_lost = REQUEST.TLS('rep_lost')
        tls_pending = REQUEST.TLS('rep_pending')
        extra_str = u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=40 border=0 alt=""></TD>
    <TD class="td_listing_noborder" style="text-align: right; font-weight: bold;">%(tls_show)s:</TD>
    <TD class="td_listing_noborder" align="left">
      <SELECT name="type">
        <OPTION value="1" selected>%(tls_won)s</OPTION>
        <OPTION value="2">%(tls_lost)s</OPTION>
        <OPTION value="3">%(tls_pending)s</OPTION>
      </SELECT>
    </TD>
  </TR>""" % locals()
    else:
        report = "report1"
        tls_salesstat = REQUEST.TLS('rep_title1')
        hiddenstr = ""


    menu = menu_output(REQUEST)

    today = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
    day = today.day
    month = today.month
    year = today.year
    
    tls_dt1 = REQUEST.TLS('rep_thismonth')
    tls_dt2 = REQUEST.TLS('rep_lastmonth')
    tls_dt3 = REQUEST.TLS('rep_fromlastmonth')
    tls_dt4 = REQUEST.TLS('rep_q1')
    tls_dt5 = REQUEST.TLS('rep_q2')
    tls_dt6 = REQUEST.TLS('rep_q3')
    tls_dt7 = REQUEST.TLS('rep_q4')
    tls_dt8 = REQUEST.TLS('rep_thisyear')
    tls_dt9 = REQUEST.TLS('rep_lastyear')
    tls_start = REQUEST.TLS('rep_periodstart')
    tls_end = REQUEST.TLS('rep_periodend')
    tls_short = REQUEST.TLS('rep_shortformat')
    tls_long = REQUEST.TLS('rep_longformat')
    tls_show = REQUEST.TLS('rep_showreport')
    tls_reports = REQUEST.TLS('rep_reports')
    
    day_cont = ""
    i=1
    while(i<32):
        if i==day:
            day_cont += u"""<option value="%s" selected>%s</option>""" % (i,i)
        else:
            day_cont += u"""<option value="%s">%s</option>""" % (i,i)
        i += 1
    begin_day = u"""<select name="start_day">%s</select>""" % day_cont
    end_day = u"""<select name="end_day">%s</select>""" % day_cont
    
    month_cont = u""
    i=1
    while(i<13):
        if i==month:
            month_cont += """<option value="%s" selected>%s</option>""" % (i,REQUEST.TLS('month_%d' % i))
        else:
            month_cont += """<option value="%s">%s</option>""" % (i,REQUEST.TLS('month_%d' % i))
        i += 1
    begin_month = """<select name="start_month">%s</select>""" % month_cont
    end_month = u"""<select name="end_month">%s</select>""" % month_cont
    
    year_cont = u""
    i=year-3
    while(i<=year+1):
        if i==year:
            year_cont += """<option value="%s" selected>%s</option>""" % (i,i)
        else:
            year_cont += """<option value="%s">%s</option>""" % (i,i)
        i += 1
    begin_year = """<select name="start_year">%s</select>""" % year_cont
    end_year = u"""<select name="end_year">%s</select>""" % year_cont

    dt1 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,month,year,day,month,year)
    if month==1:
        lastday = calendar.monthrange(year-1, 12)[1]
        dt2 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,12,year-1,lastday,12,year-1)
    else:
        lastday = calendar.monthrange(year, month-1)[1]
        dt2 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,month-1,year,lastday,month-1,year)
    if month==1:
        dt3 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,12,year-1,day,month,year)
    else:
        dt3 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,month-1,year,day,month,year)
    dt4 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,1,year,31,3,year)
    dt5 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,4,year,30,6,year)
    dt6 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,7,year,30,9,year)
    dt7 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,10,year,31,12,year)
    dt8 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,1,year,day,month,year)
    dt9 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,1,year-1,31,12,year-1)
    str1 = """<a class="blueboldlink" href="#" onclick="%(dt1)s;">%(tls_dt1)s</a>""" % locals()
    str2 = """<a class="blueboldlink" href="#" onclick="%(dt2)s;">%(tls_dt2)s</a>""" % locals()
    str3 = """<a class="blueboldlink" href="#" onclick="%(dt3)s;">%(tls_dt3)s</a>""" % locals()
    str4 = """<a class="blueboldlink" href="#" onclick="%(dt4)s;">%(tls_dt4)s</a> |""" % locals()
    if month>3:
        str5 = """<a class="blueboldlink" href="#" onclick="%(dt5)s;">%(tls_dt5)s</a> |""" % locals()
    else:
        str5 = ""
    if month>6:
        str6 = """<a class="blueboldlink" href="#" onclick="%(dt6)s;">%(tls_dt6)s</a> |""" % locals()
    else:
        str6 = ""
    if month>9:
        str7 = """<a class="blueboldlink" href="#" onclick="%(dt7)s;">%(tls_dt7)s</a> |""" % locals()
    else:
        str7 = ""
    str8 = """<a class="blueboldlink" href="#" onclick="%(dt8)s;">%(tls_dt8)s</a>""" % locals()
    str9 = """<a class="blueboldlink" href="#" onclick="%(dt9)s;">%(tls_dt9)s</a>""" % locals()
    output.append(u"""
<script type="text/javascript">
function show_r(sd, sm, sy, ed, em, ey)
{
  document.forms[0]['start_day'].value   = sd;
  document.forms[0]['start_month'].value = sm;
  document.forms[0]['start_year'].value  = sy;
  document.forms[0]['end_day'].value   = ed;
  document.forms[0]['end_month'].value = em;
  document.forms[0]['end_year'].value  = ey;
  document.forms[0].submit();
}
</script>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD>
        <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
        <TR>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
            <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
            <TD nowrap><span class="t3">%(tls_reports)s</span></TD>
            <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
        <TR>
            <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
        </TR>
        </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing0">
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="editform" method="POST" action="%(BASE_OPPORTUNITIES_URL)soppreports.py/%(report)s">
%(hiddenstr)s
  <TR class="tr_listing1">
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b" colspan="2" width="100%%">%(tls_salesstat)s:</TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" colspan="2" width="100%%" align="center">%(str1)s | %(str2)s | %(str3)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" colspan="2" width="100%%" align="center">%(str4)s %(str5)s %(str6)s %(str7)s %(str8)s | %(str9)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder"  style="text-align: right; font-weight: bold;" width="40%%">%(tls_start)s:</TD>
    <TD class="td_listing_noborder" align="left" width="60%%" nowrap>%(begin_day)s %(begin_month)s %(begin_year)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder"  style="text-align: right; font-weight: bold;" width="40%%">%(tls_end)s:</TD>
    <TD class="td_listing_noborder" align="left" width="60%%" nowrap>%(end_day)s %(end_month)s %(end_year)s</TD>
  </TR>
  %(extra_str)s
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=40 border=0 alt=""></TD>
    <TD class="td_listing_noborder" colspan="2" width="100%%" align="center"><input name="_report" type="submit" class="input6" value="%(tls_show)s"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST):
    output=[]
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    tls_rep1 = REQUEST.TLS('rep_totalsales')
    tls_rep2 = REQUEST.TLS('rep_clientsales')
    tls_rep3 = REQUEST.TLS('rep_productsales')
    tls_rep4 = REQUEST.TLS('rep_repsales')
    tls_rep5 = REQUEST.TLS('rep_clientproduct')
    active = 0
    if REQUEST.form.has_key('cli') and REQUEST.form['cli']=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?cli=1">%(tls_rep2)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?cli=1">%(tls_rep2)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('pro') and REQUEST.form['pro']=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?pro=1">%(tls_rep3)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?pro=1">%(tls_rep3)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('per') and REQUEST.form['per'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?per=1">%(tls_rep4)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?per=1">%(tls_rep4)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('clipro') and REQUEST.form['clipro'].value=='1':
      active = 1
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?clipro=1">%(tls_rep5)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py?clipro=1">%(tls_rep5)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py">%(tls_rep1)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppreports.py">%(tls_rep1)s</a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def report1(REQUEST):
    if not (REQUEST.form.has_key('start_day') and REQUEST.form.has_key('end_day') and REQUEST.form.has_key('start_month') and REQUEST.form.has_key('end_month') and REQUEST.form.has_key('start_year') and REQUEST.form.has_key('end_year') and REQUEST.form['start_day'].value and REQUEST.form['start_month'].value and REQUEST.form['start_year'].value and REQUEST.form['end_day'].value and REQUEST.form['end_month'].value and REQUEST.form['end_year'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    start_date = mx.DateTime.DateTime(int(REQUEST.form['start_year'].value), int(REQUEST.form['start_month'].value), int(REQUEST.form['start_day'].value))
    end_date = mx.DateTime.DateTime(int(REQUEST.form['end_year'].value), int(REQUEST.form['end_month'].value), int(REQUEST.form['end_day'].value))
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND " + right_param
    SQL = """
SELECT
 coalesce(sum(case when opp_stage=100 then o.amount else 0 end),0) as sold,
 coalesce(sum(case when opp_stage=0 then o.amount else 0 end),0) as lost,
 coalesce(sum(case when opp_stage>0 and opp_stage<100 then o.amount else 0 end),0) as pending
FROM
 opportunities o, items i
WHERE
 i.item_id=o.opp_id and o.close_date between '%s' and '%s' %s""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.fetchone()
    deals_sold = dbres[0]
    deals_lost = dbres[1]
    deals_pending = dbres[2]

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    datestr = "%s-%s" % (REQUEST.iso2userdate(start_date), REQUEST.iso2userdate(end_date))
    tls_stat_during = REQUEST.TLS('rep_stat_period') % datestr
    tls_won = REQUEST.TLS('rep_won')
    tls_lost = REQUEST.TLS('rep_lost')
    tls_pending = REQUEST.TLS('rep_pending')
    tls_rowheader = REQUEST.TLS('rep_title1')
    tls_reports = REQUEST.TLS('rep_reports')
    out_str = u"""
      <TABLE border=0 cellpadding=0 cellspacing=1 bgcolor="#FFFFFF" style="border: 1px solid #EBEBEB">
        <TR>
          <TD class="td_listing1b" nowrap align="right">%(tls_won)s</TD>
          <TD class="td_listing1b" nowrap align="right">%(tls_lost)s</TD>
          <TD class="td_listing1b" nowrap align="right">%(tls_pending)s</TD>
        </TR>
        <TR>
          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(deals_sold)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(deals_lost)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(deals_pending)d%(c_suf)s</TD>
        </TR>
      </TABLE>""" % locals()
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD>
        <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
        <TR>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
            <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
            <TD nowrap><span class="t3">%(tls_reports)s</span></TD>
            <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
        <TR>
            <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
        </TR>
        </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing0">
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b" colspan="4" width="100%%">%(tls_rowheader)s:</TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan="3" align="center" class="td_listing_noborder" style="font-weight: bold;">%(tls_stat_during)s</TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan="3">%(out_str)s</TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
  </TR>
</TABLE>
<BR>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def report2(REQUEST):
    if not (REQUEST.form.has_key('start_day') and REQUEST.form.has_key('end_day') and REQUEST.form.has_key('start_month') and REQUEST.form.has_key('end_month') and REQUEST.form.has_key('start_year') and REQUEST.form.has_key('end_year') and REQUEST.form['start_day'].value and REQUEST.form['start_month'].value and REQUEST.form['start_year'].value and REQUEST.form['end_day'].value and REQUEST.form['end_month'].value and REQUEST.form['end_year'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    start_date = mx.DateTime.DateTime(int(REQUEST.form['start_year'].value), int(REQUEST.form['start_month'].value), int(REQUEST.form['start_day'].value))
    end_date = mx.DateTime.DateTime(int(REQUEST.form['end_year'].value), int(REQUEST.form['end_month'].value), int(REQUEST.form['end_day'].value))
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND " + right_param
    SQL = """SELECT c.client_name, coalesce(sum(case when opp_stage=100 then amount else 0 end),0) as sold, coalesce(sum(case when opp_stage=0 then amount else 0 end),0) as lost, coalesce(sum(case when opp_stage>0 and opp_stage<100 then amount else 0 end),0) as pending FROM opportunities o, clients c, items i WHERE i.item_id=o.opp_id and o.close_date between '%s' and '%s' and o.client_id = c.client_id %s GROUP BY c.client_name order by client_name""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), right_param)
    tls_rowheader = REQUEST.TLS('opp_client')
    tls_title = REQUEST.TLS('rep_title2')
    if REQUEST.form.has_key('pro'):
       tls_rowheader = REQUEST.TLS('log_product_id')
       tls_title = REQUEST.TLS('rep_title3')
       SQL = """SELECT p.product_name, coalesce(sum(case when opp_stage=100 then op.amount*op.price else 0 end),0) as sold, coalesce(sum(case when opp_stage=0 then op.amount*op.price else 0 end),0) as lost, coalesce(sum(case when opp_stage>0 and opp_stage<100 then op.amount*op.price else 0 end),0) as pending FROM opportunities o, products p, opp_products op, items i WHERE i.item_id=o.opp_id and o.close_date between '%s' and '%s' and o.opp_id = op.opp_id and op.product_id = p.product_id %s GROUP BY p.product_name order by p.product_name""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), right_param)
    elif REQUEST.form.has_key('per'):
       tls_rowheader = REQUEST.TLS('log_person_id')
       tls_title = REQUEST.TLS('rep_title4')
       SQL = """SELECT i2.item_name, coalesce(sum(case when opp_stage=100 then amount else 0 end),0) as sold, coalesce(sum(case when opp_stage=0 then amount else 0 end),0) as lost, coalesce(sum(case when opp_stage>0 and opp_stage<100 then amount else 0 end),0) as pending FROM opportunities o, items i, items i2 WHERE o.close_date between '%s' and '%s' and o.opp_id = i.item_id and i.creator_id = i2.item_id %s GROUP BY i2.item_name order by i2.item_name""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), right_param)

    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.fetchall()

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    datestr = "%s-%s" % (REQUEST.iso2userdate(start_date), REQUEST.iso2userdate(end_date))
    tls_stat_during = REQUEST.TLS('rep_stat_period') % datestr
    tls_won = REQUEST.TLS('rep_won')
    tls_lost = REQUEST.TLS('rep_lost')
    tls_pending = REQUEST.TLS('rep_pending')
    tls_total = REQUEST.TLS('rep_total')
    tls_reports = REQUEST.TLS('rep_reports')
    out_str = u"""
      <TABLE border=0 cellpadding=0 cellspacing=1 bgcolor="#FFFFFF" style="border: 1px solid #EBEBEB">
        <TR>
          <TD class="td_listing1b" nowrap>%(tls_rowheader)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_won)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_lost)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_pending)s</TD>
        </TR>""" % locals()
    sum1 = sum2 = sum3 = 0
    for row in dbres:
        cli = _Utils.html_quote_show(row[0].decode('UTF8'))
        won = row[1]
        lost = row[2]
        pending = row[3]
        sum1 = sum1 + row[1]
        sum2 = sum2 + row[2]
        sum3 = sum3 + row[3]
        out_str += u"""
        <TR>
          <TD class="td_listing0b" nowrap>%(cli)s</TD>
          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(won)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(lost)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(pending)d%(c_suf)s</TD>
        </TR>""" % locals()
    out_str += u"""
        <TR>
          <TD class="td_listing1b" nowrap>%(tls_total)s</TD>
          <TD class="td_listing1b" nowrap align="right">%(c_pre)s%(sum1)d%(c_suf)s</TD>
          <TD class="td_listing1b" nowrap align="right">%(c_pre)s%(sum2)d%(c_suf)s</TD>
          <TD class="td_listing1b" nowrap align="right">%(c_pre)s%(sum3)d%(c_suf)s</TD>
        </TR>
      </TABLE>""" % locals()
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD>
        <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
        <TR>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
            <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
            <TD nowrap><span class="t3">%(tls_reports)s</span></TD>
            <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
        <TR>
            <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
        </TR>
        </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing0">
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b" colspan="4" width="100%%">%(tls_title)s:</TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan="3" align="center" class="td_listing_noborder" style="font-weight: bold;">%(tls_stat_during)s</TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan="3">%(out_str)s</TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
  </TR>
</TABLE>
<BR>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def report3(REQUEST):
    if not (REQUEST.form.has_key('start_day') and REQUEST.form.has_key('end_day') and REQUEST.form.has_key('start_month') and REQUEST.form.has_key('end_month') and REQUEST.form.has_key('start_year') and REQUEST.form.has_key('end_year') and REQUEST.form['start_day'].value and REQUEST.form['start_month'].value and REQUEST.form['start_year'].value and REQUEST.form['end_day'].value and REQUEST.form['end_month'].value and REQUEST.form['end_year'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    start_date = mx.DateTime.DateTime(int(REQUEST.form['start_year'].value), int(REQUEST.form['start_month'].value), int(REQUEST.form['start_day'].value))
    end_date = mx.DateTime.DateTime(int(REQUEST.form['end_year'].value), int(REQUEST.form['end_month'].value), int(REQUEST.form['end_day'].value))
    if REQUEST.form['type'].value=="1":
      cond = "opp_stage=100"
    elif REQUEST.form['type'].value=="2":
      cond = "opp_stage=0"
    else:
      cond = "opp_stage>0 and opp_stage<100"
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND " + right_param
    SQL = """
SELECT 
 DISTINCT
 p.product_id, 
 p.product_name
FROM 
 opportunities o,
 opp_products op,
 products p,
 items i
WHERE 
  i.item_id=o.opp_id and o.close_date between '%s' and '%s' and o.opp_id=op.opp_id and op.product_id=p.product_id and %s %s""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), cond, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.fetchall()
    products = []
    q_str=""
    if dbres:
      for row in dbres:
        products.append(_Utils.html_quote_show(row[1].decode('UTF8')))
        product_id = row[0]
        q_str +="""sum(case when %(cond)s and p.product_id = %(product_id)s then op.amount*op.price else 0 end),\n""" % locals()
      q_str = q_str[0:-2]
      QUERY = """
SELECT
c.client_name,
%s
FROM
opportunities o,
opp_products op,
clients c,
products p,
items i
WHERE
 i.item_id=o.opp_id and o.close_date between '%s' and '%s' and %s and o.opp_id=op.opp_id and op.product_id=p.product_id and o.client_id=c.client_id %s GROUP BY c.client_name order by c.client_name""" % (q_str, start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), cond, right_param)
      REQUEST.db.execute(QUERY.encode('UTF8'))
      dbres = REQUEST.db.fetchall()


    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_rowheader = REQUEST.TLS('opp_client')
    tls_title = REQUEST.TLS('rep_title5')
    tls_total = REQUEST.TLS('rep_total')
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    datestr = "%s-%s" % (REQUEST.iso2userdate(start_date), REQUEST.iso2userdate(end_date))
    tls_stat_during = REQUEST.TLS('rep_stat_period') % datestr
    tls_total = REQUEST.TLS('rep_total')
    tls_reports = REQUEST.TLS('rep_reports')

    if len(dbres):
      lenrow = dbres[0]
      cols = len(lenrow)
      rowsum = [0]*cols
      out_str = u"""\n      <TABLE border=0 cellpadding=0 cellspacing=1 bgcolor="#FFFFFF" style="border: 1px solid #EBEBEB">\n        <TR>\n          <TD class="td_listing1b" nowrap>%(tls_rowheader)s</TD>""" % locals()
      for i in range(0, cols-1):
          product_name = products[i]
          out_str+= u"""\n          <TD class="td_listing1b" nowrap>%(product_name)s</TD>""" % locals()
      out_str += u"""\n          <TD class="td_listing1b" nowrap>%(tls_total)s</TD>\n        </TR>"""  % locals()
      for row in dbres:
          client_name = _Utils.html_quote_show(row[0].decode('UTF8'))
          out_str += u"""\n        <TR>\n          <TD class="td_listing0b">%(client_name)s</TD>""" % locals()
          cols = row[1:]
          colsum = 0
          i = 0
          for col in cols:
              col = int(col)
              colsum+=col
              rowsum[i] += col
              i +=1
              out_str += u"""\n          <TD class="td_listing0" nowrap align="right">%(c_pre)s%(col)s%(c_suf)s</TD>""" % locals()
          rowsum[i] +=colsum
          out_str += u"""\n          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(colsum)s%(c_suf)s</TD>\n        </TR>""" % locals()
      out_str += u"""\n        <TR>\n          <TD class="td_listing0b" nowrap>%(tls_total)s</TD>""" % locals()
      for col in rowsum:
          out_str += u"""\n          <TD class="td_listing0b" nowrap align="right">%(c_pre)s%(col)s%(c_suf)s</TD>""" % locals()
      out_str += u"""\n        </TR>\n      </TABLE>"""
    else:
      out_str = u"""%s""" % REQUEST.TLS('opp_nofound')

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD>
        <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
        <TR>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
            <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
            <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
            <TD nowrap><span class="t3">%(tls_reports)s</span></TD>
            <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
        <TR>
            <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
        </TR>
        </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing0">
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b" colspan="4" width="100%%">%(tls_title)s:</TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan="3" align="center" class="td_listing_noborder" style="font-weight: bold;">%(tls_stat_during)s</TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan="3">%(out_str)s</TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  </TR>
</TABLE>
<BR>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)