MY_MENU_ID=4

import _Conf, standard_html
from Menus import get_opportunities_menu
import _Opportunity, _InitTypes, _Utils, _Access, custom_fields
import mx.DateTime

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    
    try:
      country_setting = REQUEST.get_setting('client_country')
    except:
      country_setting = ''
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addopp = REQUEST.TLS('opp_add')
    tls_name = REQUEST.TLS('tls_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_client = REQUEST.TLS('opp_client')
    tls_owner = REQUEST.TLS('client_owner')
    tls_nextstep = REQUEST.TLS('opp_nextstep')
    tls_stage = REQUEST.TLS('opp_stage')
    tls_probability = REQUEST.TLS('opp_probability')
    tls_closedate = REQUEST.TLS('opp_date_bw')
    tls_and = REQUEST.TLS('cal_and')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_lead = REQUEST.TLS('opp_source')
    tls_description = REQUEST.TLS('tls_description')
    tls_req = REQUEST.TLS('opp_req_desc')
    tls_lost_reason = REQUEST.TLS('opp_lost_reason')
    tls_save = REQUEST.TLS('tls_save')
    tls_choose = REQUEST.TLS('email_choose')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_search = REQUEST.TLS('tls_search')
    tls_asearch = REQUEST.TLS('tls_adv_search')
    tls_keyword = REQUEST.TLS('tls_keyword')



    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.* FROM persons p, items i WHERE p.person_id=i.item_id %s ORDER BY p.first_name, p.last_name""" % (right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    creator_name = u"""<SELECT name="creator_name">"""
    for row in dbres:
        if row['person_id'] == REQUEST.USER.get_id():
          sel = " SELECTED"
        else:
          sel = ""
        creator_name += """<option value="%s"%s>%s %s</option>""" % (row['person_id'], sel, row['first_name'].decode('UTF8'), row['last_name'].decode('UTF8'))
    creator_name += u"""</SELECT>"""

    client_type = _Utils.make_setting_selection(REQUEST, None, 'client_type', 'opportunity_client_type', is_multiple=0, selected="", style="textfield4")
    lead_source = _Utils.make_setting_selection(REQUEST, None, 'lead_source', 'opportunity_lead_source', is_multiple=0, selected="", style="textfield4")
    lost_reason = _Utils.make_setting_selection(REQUEST, None, 'opp_lost', 'opportunity_lost_reason', is_multiple=0, selected="", style="textfield4")


    def kala(a,b):
      if a=='':
        return -1
      elif b=='':
        return 1
      elif int(a)==0:
        return 1
      elif int(b)==0:
        return -1
      elif int(a)>int(b):
        return 1
      else:
        return -1

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    stage = u"""<select name="opp_stage" onchange="prob(this.value)" class="textfield4">"""
    keys = stages.keys()
    keys.sort(kala)
    for key in keys:
      stage = stage + u"""<option value="%s">%s</option>""" % (key, stages[key])
    stage = stage + u"""</select>"""


    datecheck_js = REQUEST.datecheck_js(REQUEST)

    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    c_fields = custom_fields.get_object_search_fields(REQUEST, REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id(), _InitTypes.ITEM_TYPE_OPPORTUNITY, 1)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(standard_html.window_script(height=500,width=500))
    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
function change(numb)
{
  el1 = document.getElementById('1');
  el2 = document.getElementById('2');
  if(numb=='1')
  {
    el1.style.visibility='visible';
    el2.style.visibility='hidden';
  }
  else if(numb=='2')
  {
    el1.style.visibility='hidden';
    el2.style.visibility='visible';
  }
}

function prob(val)
{
  document.forms['addform'].probability.value=val;
}
function cal_popup(url, fieldname)
{
    window.date_result = document.addform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
%(datecheck_js)s
// -->
</SCRIPT>
<DIV id="1" style="position: absolute; width: 95%%; margin-left: auto; margin-right: auto; left: 0px; top: 50px; visibility: visible;">
<FORM name="searchform" method="POST" action="%(BASE_OPPORTUNITIES_URL)soppsearch.py/search">
<TABLE class="td_normal_noborder" cellpadding=0 cellspacing=0>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding=0 cellspacing=0>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD nowrap class="td_listing1ke">%(tls_keyword)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="search_keyword"></TD>
  <TD nowrap class="td_listing1"><INPUT type="submit" name="_search" value="%(tls_search)s" class="input2"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
</DIV>
<DIV id="2" style="position: absolute; width: 95%%; margin-left: auto; margin-right: auto; left: 0px; top: 50px; visibility: hidden;">
<FORM name="addform" method="POST" action="%(BASE_OPPORTUNITIES_URL)soppsearch.py/search">
<TABLE class="td_normal_noborder" cellpadding=0 cellspacing=0>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding=0 cellspacing=0>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="opp_name" value=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_client)s:</TD>
  <TD class="td_listing1ve"><INPUT type="hidden" name="client_id" value=""><INPUT type="text" class="textfield1" size="15" readonly name="client_name" value=""> <input type="button" class="input6" value="%(tls_choose)s" onclick="open_window('%(BASE_OPPORTUNITIES_URL)sclient_pop.py')"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0b" nowrap colspan="4">&nbsp;
  %(tls_closedate)s: 
  <INPUT class="textfield1" size="6" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="close_date1" id="close_date1" value="">
  &nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('close_date1', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A>
  &nbsp;&nbsp;%(tls_and)s&nbsp;&nbsp;
  <INPUT class="textfield1" size="6" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="close_date2" id="close_date2" value="">
  &nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('close_date2', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_stage)s:</TD>
  <TD class="td_listing1ve">%(stage)s</TD>
  <TD class="td_listing1ke">%(tls_probability)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" readonly class="textfield4_readonly" size=2 name="probability" value="">%%</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing0ve">%(client_type)s</TD>
  <TD class="td_listing0ke">%(tls_lead)s:</TD>
  <TD class="td_listing0ve">%(lead_source)s</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_amount)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="amount" value=""></TD>
  <TD class="td_listing1ke">%(tls_nextstep)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="opp_next_stage" value=""></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0" valign="top">
  <TD class="td_listing0b" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="description" rows="8" cols="40"></TEXTAREA></TD>
  <TD class="td_listing0b" colspan="2">%(tls_req)s<BR><TEXTAREA class="textarea5" name="req_descr" rows="8" cols="40"></TEXTAREA></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_lost_reason)s:</TD>
  <TD class="td_listing1ve" colspan="3">%(lost_reason)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
%(c_fields)s
<TR class="tr_listing0">
  <TD class="td_listing_noborder" colspan="4"><INPUT type="submit" value="%(tls_search)s" class="input2"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
</DIV>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def search(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))

    tls_name = REQUEST.TLS('tls_name')
    tls_creator = REQUEST.TLS('client_owner')
    tls_client = REQUEST.TLS('opp_client')
    tls_stage = REQUEST.TLS('opp_stage')
    tls_prob = REQUEST.TLS('opp_probability')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_closedate = REQUEST.TLS('opp_date')

    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    sortby = [
'opp_name ASC', 'opp_name DESC',
'creator_name ASC, opp_name ASC', 'creator_name DESC, opp_name ASC',
'client_name ASC, opp_name ASC', 'client_name DESC, opp_name ASC',
'opp_stage ASC, opp_name ASC', 'opp_stage DESC, opp_name ASC',
'amount ASC, opp_name ASC', 'amount DESC, opp_name ASC',
'close_date ASC, opp_name ASC', 'close_date DESC, opp_name ASC'
]
    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    sortby_name = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=0">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_name)
    sortby_creator = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=2">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_creator)
    sortby_client = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=4">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_client)
    sortby_stage = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=6">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_stage)
    sortby_amount = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=8">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_amount)
    sortby_date = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=10">%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_closedate)
    if sortby_id == 0:
        sortby_name = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=1">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=0">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=3">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=2">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_client = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=5">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_client)
    elif sortby_id == 5:
        sortby_client = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=4">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_client)
    elif sortby_id == 6:
        sortby_stage = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=7">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_stage)
    elif sortby_id == 7:
        sortby_stage = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=6">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_stage)
    elif sortby_id == 8:
        sortby_amount = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=9">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_amount)
    elif sortby_id == 9:
        sortby_amount = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=8">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_amount)
    elif sortby_id == 10:
        sortby_date = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=11">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_closedate)
    elif sortby_id == 11:
        sortby_date = u"""<A class="blackboldlink" href="%soppsearch.py/search%ssort_by=10">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_OPPORTUNITIES_URL, formstring, tls_closedate)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND " + right_param
    search_params = []
    if REQUEST.form.has_key('search_keyword'):
        w = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8').lower())
        w2 = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8'))
        if len(w)>=3:
            search_params = u""" AND i.item_id in (SELECT item_id FROM fti_search WHERE word = '%s' and fti_type=true)""" % w
        else:
            search_params = u""" AND (
lower(o.opp_name) like '%%%s%%' OR 
lower(o.opp_next_stage) like '%%%s%%' OR 
lower(o.description) like '%%%s%%' OR 
lower(o.req_descr) like '%%%s%%' OR 
lower(o.amount) like '%%%s%%' OR 
lower(o.opp_lost) like '%%%s%%' OR 
lower(o.lead_source) like '%%%s%%' OR 
lower(o.client_type) like '%%%s%%')""" % (w,w,w,w,w,w,w,w)
    else:
        if REQUEST.form.has_key('opp_name') and REQUEST.form['opp_name'].value:
            search_params.append(u"lower(o.opp_name) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['opp_name'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('client_id') and REQUEST.form['client_id'].value:
            search_params.append(u"lower(o.client_id) = %s" % _Utils.sql_quote_simple(REQUEST.form['client_id'].value))
        if REQUEST.form.has_key('opp_stage') and REQUEST.form['opp_stage'].value:
            search_params.append(u"lower(o.opp_stage) >= %s" % _Utils.sql_quote_simple(REQUEST.form['opp_stage'].value))
        if REQUEST.form.has_key('opp_next_stage') and REQUEST.form['opp_next_stage'].value:
            search_params.append(u"lower(o.opp_next_stage) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['opp_next_stage'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('description') and REQUEST.form['description'].value:
            search_params.append(u"lower(o.description) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['description'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('req_descr') and REQUEST.form['req_descr'].value:
            search_params.append(u"lower(o.req_descr) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['req_descr'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('opp_lost') and REQUEST.form['opp_lost'].value:
            search_params.append(u"lower(o.opp_lost) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['opp_lost'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('lead_source') and REQUEST.form['lead_source'].value:
            search_params.append(u"lower(o.lead_source) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['lead_source'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('client_type') and REQUEST.form['client_type'].value:
            search_params.append(u"lower(o.client_type) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['client_type'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('amount') and REQUEST.form['amount'].value:
            search_params.append(u"lower(o.amount) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['amount'].value))
        if REQUEST.form.has_key('close_date1') and REQUEST.form['close_date1'].value:
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['close_date1'].value.decode('UTF8').strip()).split('-'))
            date = _Utils.local2utc_mx(REQUEST, mx.DateTime.DateTime(year, month, day))
            search_params.append(u"o.close_date>=%s" % _Utils.sql_quote(str(date)))
        if REQUEST.form.has_key('close_date2') and REQUEST.form['close_date2'].value:
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['close_date2'].value.decode('UTF8').strip()).split('-'))
            date = _Utils.local2utc_mx(REQUEST, mx.DateTime.DateTime(year, month, day))
            search_params.append(u"o.close_date<=%s" % _Utils.sql_quote(str(date)))

        if search_params:
            search_params = u" AND %s" % " AND ".join(search_params)
        else:
            search_params = u""

    custom_pars = custom_fields.get_custom_search_query(REQUEST, _InitTypes.ITEM_TYPE_OPPORTUNITY)

    QUERY = """SELECT count(*) AS count_all FROM opportunities o, items i, items i2, clients c WHERE o.opp_id=i.item_id and i.creator_id=i2.item_id and o.client_id=c.client_id %s%s%s""" % (right_param, search_params, custom_pars)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%soppsearch.py/search%sqs=" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%soppsearch.py/search%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%soppsearch.py/search%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    QUERY = """SELECT o.*, i.parent_id, i2.item_name as creator_name, c.client_name as client_name FROM opportunities o, items i, items i2, clients c WHERE o.opp_id=i.item_id and i.creator_id=i2.item_id and o.client_id=c.client_id %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, search_params, custom_pars, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_opportunities = REQUEST.TLS('topmenu_opportunities')
    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_search.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_opportunities)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">%(sortby_name)s</TD>
  <TD class="td_listing1b">%(sortby_creator)s</TD>
  <TD class="td_listing1b">%(sortby_client)s</TD>
  <TD class="td_listing1b">%(sortby_stage)s</TD>
  <TD class="td_listing1b">%(tls_prob)s</TD>
  <TD class="td_listing1b">%(sortby_amount)s</TD>
  <TD class="td_listing1b">%(sortby_date)s</TD>
</TR>""" % locals())
    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_OPPORTUNITIES_URL'] = _Conf.BASE_OPPORTUNITIES_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['opp_name'] = (_Utils.html_quote(item['opp_name'] or "")).decode('UTF8')
        item['creator_name'] = (item['creator_name'] or "&nbsp;").decode('UTF8')
        item['client_name'] = _Utils.html_quote((item['client_name'] or "&nbsp;").decode('UTF8'))
        opp_stage = str(item['opp_stage'])
        item['stage_name'] = stages[opp_stage]
        if item['opp_stage']:
          item['opp_stage'] = str(item['opp_stage']) + "%"
        if item['amount']:
            item['amount'] = (c_pre + str(item['amount'] and "%.2f" % item['amount']) + c_suf) or ''
        else:
            item['amount'] = ""
        if not item['amount']:
               item['amount'] = "&nbsp;"
        item['close_date'] = REQUEST.iso2userdate(item['close_date']) or "&nbsp;"

        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" nowrap><A class="td_listing" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)d">%(opp_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(creator_name)s</TD>
  <TD class="td_listing%(class_type)d">%(client_name)s</TD>
  <TD class="td_listing%(class_type)d">%(stage_name)s</TD>
  <TD class="td_listing%(class_type)d">%(opp_stage)s</TD>
  <TD class="td_listing%(class_type)d">%(amount)s</TD>
  <TD class="td_listing%(class_type)d">%(close_date)s</TD>
</TR>""" % item)
    output.append("""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
