
import _Conf
from Menus import get_products_menu
from mod_python import apache
import standard_html
import _Access, _InitTypes, _Product
import _Utils
import _Document
import urllib, cStringIO, csv, base64

MY_MENU_ID=2


def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))

    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_export = REQUEST.TLS('contact_export')
    tls_import = REQUEST.TLS('contact_import')
    tls_output_format = REQUEST.TLS('contact_format')
    tls_match = REQUEST.TLS('contact_matching')
    tls_ins_new = REQUEST.TLS('contact_insert_new')
    tls_upd_ex = REQUEST.TLS('contact_update_ex')
    tls_leave_out = REQUEST.TLS('contact_leave_out')
    tls_file = REQUEST.TLS('tls_file')

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_export)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_PRODUCTS_URL)sprodport.py/export_products">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_output_format)s</TD>
  <TD class="td_listing1b" nowrap><input type="radio" name="csv" value="1" checked>CSV</TD>
  <TD class="td_listing1b" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" colspan=4><input type="submit" name="_export" value="%(tls_export)s" class="input2"></TD>
</TR>
</TABLE>
</FORM>
<BR/>
<BR/>
<FORM method="POST" action="%(BASE_PRODUCTS_URL)sprodport.py/import_products" ENCTYPE="multipart/form-data">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_import)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_match)s:</TD>
  <TD class="td_listing1b" nowrap><input type="radio" name="new" value="1">%(tls_ins_new)s</TD>
  <TD class="td_listing1b" nowrap><input type="radio" name="new" value="2">%(tls_upd_ex)s</TD>
  <TD class="td_listing1b" nowrap><input type="radio" name="new" value="3" checked>%(tls_leave_out)s</TD>
  <TD class="td_listing1b" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" nowrap>%(tls_file)s:</TD>
  <TD class="td_listing0b" nowrap colspan=3><input type="file" name="import_file"></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan=5><input type="submit" name="_import" value="%(tls_import)s" class="input2"></TD>
</TR>
</TABLE>
""" % locals())


    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def export_products(REQUEST):
  if REQUEST.form.has_key('csv') and REQUEST.form['csv'].value=='1':
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PRODUCT])
    if right_param:
        right_param = " AND " + right_param
    SQL = """SELECT p.* FROM products p, items i WHERE p.product_id=i.item_id %s""" % (right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    temp_file = cStringIO.StringIO()
    count = 0
    writer = csv.writer(temp_file)
    for row in dbresult:
        del row['product_id']
        count = count + 1
        tmp = []
        map(lambda x: tmp.append(row[x.encode('utf8')]), row.keys())
        writer.writerow(tmp)
    temp_file.seek(0)
    filesize = len(temp_file.read())
    temp_file.seek(0)
    REQUEST.mod_req.headers_out["Content-Length"] = str(filesize)
    REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=products.csv"
    REQUEST.mod_req.content_type = "text/csv"

    if _Conf.IS_MP_27:
        REQUEST.mod_req.send_http_header()

    reqwrite = REQUEST.mod_req.write
    fpread = temp_file.read
    data = fpread(_Document.BLOCK_SIZE)
    while data:
        reqwrite(data)
        data = fpread(_Document.BLOCK_SIZE)
    temp_file.close()
    return apache.OK


def import_products(REQUEST):
  BLOCK_SIZE = 8192
  if not REQUEST.form.has_key('import_file'):
      raise RuntimeError, REQUEST.TLS('required_parameters_missing') 
  if not REQUEST.form.has_key('new'):
      raise RuntimeError, REQUEST.TLS('required_parameters_missing') 
  import_type = int(REQUEST.form['new'].value)
  output = []
  output.append(standard_html.html_header(REQUEST))
  output.append(get_products_menu(REQUEST, MY_MENU_ID))
  filepointer=REQUEST.form['import_file'].file
  fpread = filepointer.read
  # check
  ext = REQUEST.form['import_file'].filename.split(".")[-1:][0]
  if ext=="csv" or ext=="txt" or ext=="TXT" or ext=="CSV":
      return import_csv(REQUEST, import_type)
  else:
      raise RuntimeError, REQUEST.TLS('tls_invalid_file')

def import_csv(REQUEST, import_type=None):
    if import_type is None:
        import_type = int(REQUEST.form['import_type'].value)

    csv_formats = { 1: ('cp1252', 'Outlook Windows CSV'),
                    3: ('cp850', 'Outlook MS-DOS CSV'),
                    2: ('utf8', 'Unicode UTF-8'),
                    4: (_Conf.FALLBACK_ENCODING, _Conf.FALLBACK_ENCODING),
                  }
    if not REQUEST.form.has_key('csv_format'):
        csv_format = 2
    else:
        csv_format = int(REQUEST.form['csv_format'].value)
        if not csv_formats.has_key(csv_format):
            csv_format = 2

    if REQUEST.form.has_key('file_data') and REQUEST.form.has_key('columns_defined'):
        BLOCK_SIZE = 8192
        output = []
        data = base64.decodestring(REQUEST.form['file_data'].value).decode(csv_formats[csv_format][0])
        parsed_data = _Utils.parse_csv(data)
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_WRITE, [_InitTypes.ITEM_TYPE_PRODUCT])
        if right_param:
            right_param = " AND " + right_param
        found_count = 0
        add_count = 0
        update_count = 0
        ignore_count = 0
        field_values = {}
        for i in range(len(parsed_data[0])):
            if REQUEST.form['col_%d_field' % i].value:
                field_values[REQUEST.form['col_%d_field' % i].value] = i
        if ('name' not in field_values.keys()):
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')

        for row in parsed_data:
            found_count = found_count + 1
            product_name = row[field_values['name']].lower()
            QUERY = """SELECT product_id FROM products p, items i where i.item_id=p.product_id and lower(p.product_name)=%s %s""" % (_Utils.sql_quote(product_name), right_param)
            REQUEST.db.execute(QUERY.encode('UTF8'))
            dbres = REQUEST.db.fetchall()
            if len(dbres)==0 or import_type==1:
                product = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_REQ)
                add_count = add_count + 1
            elif len(dbres)==1 and import_type==2:
                product = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, dbres[0][0])
                update_count = update_count + 1
            else:
                ignore_count = ignore_count + 1
                continue
            if field_values.has_key('name'):
                product.set('product_name', row[field_values['name']])
            if field_values.has_key('group'):
                product.set('product_group', row[field_values['group']])
            if field_values.has_key('unit'):
                product.set('product_unit', row[field_values['unit']])
            if field_values.has_key('description'):
                product.set('description', row[field_values['description']])
            if field_values.has_key('price'):
                product.set('product_price', row[field_values['price']])

            product.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
            product.save()

        product_import_success = REQUEST.TLS('contact_import_success')
        product_import_fount = REQUEST.TLS('product_import_fount') % found_count
        product_import_added = REQUEST.TLS('product_import_added') % add_count
        product_import_updated = REQUEST.TLS('product_import_updated') % update_count
        product_import_left_out = REQUEST.TLS('product_import_left_out') % ignore_count

        output = []
        output.append(standard_html.html_header(REQUEST))
        output.append(get_products_menu(REQUEST, MY_MENU_ID))
        output.append(u"""
&nbsp;&nbsp;&nbsp;<b>%(product_import_success)s</b>.<br>
&nbsp;&nbsp;&nbsp;%(product_import_fount)s,<br>
&nbsp;&nbsp;&nbsp;%(product_import_added)s,<br>
&nbsp;&nbsp;&nbsp;%(product_import_updated)s,<br>
&nbsp;&nbsp;&nbsp;%(product_import_left_out)s.<br>""" % locals())
        output.append(standard_html.html_footer(REQUEST))
        return '\n'.join(output)


    csv_html = u"""<SELECT name="csv_format" onChange="document.forms.impform.submit();">"""
    for (key, item) in csv_formats.items():
        if key == csv_format:
            csv_html += u"""<OPTION SELECTED value="%s">%s\n""" % (key, item[1])
        else:
            csv_html += u"""<OPTION value="%s">%s\n""" % (key, item[1])
    csv_html += u"</SELECT>"

    if REQUEST.form.has_key('file_data'):
        data = base64.decodestring(REQUEST.form['file_data'].value)
        origdata = data
    else:
        BLOCK_SIZE = 8192
        fp = REQUEST.form['import_file'].file
        fp.seek(0)
        fpread = fp.read
        tmp=fpread(BLOCK_SIZE)
        data = ""
        while(tmp):
            data = data + tmp
            tmp=fpread(BLOCK_SIZE)
    origdata = data
    try:
        data = data.decode(csv_formats[csv_format][0])
        parsed_data = _Utils.parse_csv(data)
        errormsg = None
    except:
        errormsg = REQUEST.TLS('tls_charsetconversionfailed')
        parsed_data = []

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    c_fields = [
    ('name', REQUEST.TLS('prod_name')),
    ('group', REQUEST.TLS('prod_group')),
    ('unit', REQUEST.TLS('prod_unit')),
    ('description', REQUEST.TLS('tls_description')),
    ('price', REQUEST.TLS('prod_price')),]
        
    encodedfile = base64.encodestring(origdata).replace('\n','')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    tls_import = REQUEST.TLS('contact_import_csv')
    if parsed_data: datalen = len(parsed_data[0])
    else: datalen = len(c_fields)
    c_fields = u"""<SELECT name="col_%%d_field"><option value="">&nbsp;\n%s</SELECT>""" % "\n".join(map(lambda x: u"""<option value=%s>%s""" % x, c_fields))
    tls_explain = REQUEST.TLS('prodport_csv_explain')
    tls_selectcsvcharset = REQUEST.TLS('tls_selectcsvcharset')
    output.append(u"""\
<form method="post" action="%(BASE_PRODUCTS_URL)sprodport.py/import_csv" name=impform>
<input type="hidden" name="import_type" value="%(import_type)d"><input type="hidden" name="file_data" value="%(encodedfile)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_import)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="%(datalen)d">%(tls_selectcsvcharset)s: %(csv_html)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="%(datalen)d">%(tls_explain)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>""" % locals())
    if parsed_data and parsed_data[0]:
        for i in range(len(parsed_data[0])):
            c_fields_row = c_fields % i
            output.append(u"""<TD align="center" class="td_listing0">%s</TD>""" % c_fields_row)
        output.append(u"</TR>")
        ndx = 1
        for row in parsed_data:
            if ndx >= 10: break
            td_class = ndx%2
            output.append(u"<TR class='tr_listing%s'>\n  <TD class='td_listing%s'><img src='%ssspacer.gif' width=10 height=1 border=0 alt=''></TD>" % (td_class, td_class, _Conf.BASE_ICON_URL))
            for column in row:
                column = _Utils.html_quote_show(column)
                output.append(u"<TD class='td_listing%s'>%s</TD>" % (td_class, column))
            output.append(u"</TR>")
            ndx += 1
    if errormsg:
        output.append(u"""<TR>\n <TD class="td_listing0"><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD><TD class="td_listing0b" colspan="%d">%s</TD></TR>""" % (_Conf.BASE_ICON_URL, datalen, errormsg))
    output.append(u"""<TR>\n  <TD class="td_listing0"><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>\n  <TD class="td_listing0" colspan="%d" nowrap>&nbsp;&nbsp;<input class="input6" type="submit" name="columns_defined" value="%s"></TD>\n</TR>""" % (_Conf.BASE_ICON_URL, datalen, REQUEST.TLS('contact_import')))
    output.append(u"</TABLE></FORM><BR>")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

