import os

import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Access

import _Todo, _RootObject

MY_MENU_ID = 2

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param

    REQUEST.db.execute(("""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0 %s""" % (right_param)).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    persons_out = [u"""<SELECT class="textfield1"  name="related_persons" multiple size="5">"""]
    for person in related_persons:
        persons_out.append(u"""<OPTION value="%d">%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
    persons_out.append(u"""</SELECT>""")
    related_persons = "\n".join(persons_out)
    del persons_out


    priorities = _Utils.make_setting_selection(REQUEST, None, 'priority', 'todo_priorities')

    tls_searchtodo = REQUEST.TLS('todo_searchtodo')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_completedover = REQUEST.TLS('todo_completedover')
    tls_search = REQUEST.TLS('tls_search')
    tls_title = REQUEST.TLS('tls_title')
    tls_desc = REQUEST.TLS('tls_description')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_to = REQUEST.TLS('tls_fromto_to')
    tls_related = REQUEST.TLS('tls_responsible')
    tls_search = REQUEST.TLS('tls_search')
    tls_asearch = REQUEST.TLS('tls_adv_search')
    tls_keyword = REQUEST.TLS('tls_keyword')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_created = REQUEST.TLS('tls_createtimebetween')
    
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.searchform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
function change(numb)
{
  el1 = document.getElementById('1');
  el2 = document.getElementById('2');
  if(numb=='1')
  {
    el1.style.visibility='visible';
    el2.style.visibility='hidden';
  }
  else if(numb=='2')
  {
    el1.style.visibility='hidden';
    el2.style.visibility='visible';  }
}
%(datecheck_js)s
// -->
</SCRIPT>
<DIV id="1" style="position: absolute; width:95%%; left: 0px; top: 50px; visibility: visible;">
<FORM name="searchform1" method="POST" action="%(BASE_TODO_URL)stodosearch.py/search">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1ke" nowrap>%(tls_keyword)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="search_keyword"></TD>
    <TD class="td_listing1"><INPUT type="submit" name="_search" value="%(tls_search)s" class="input2"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
<DIV id="2" style="position: absolute; width: 95%%; left: 0px; top: 50px; visibility: hidden;">
<FORM name="searchform" method="POST" action="%(BASE_TODO_URL)stodosearch.py/search">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD colspan="3">
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1ke">%(tls_title)s:</TD>
    <TD class="td_listing1ve"><INPUT class="textfield3"  type="text" name="title"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke">%(tls_priority)s:</TD>
    <TD class="td_listing0ve">%(priorities)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_created)s:</TD>
    <TD class="td_listing1ve"><INPUT class="textfield1"  type="text" size="10" name="create_time_start" id="create_time_start" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('create_time_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A>&nbsp; %(tls_to)s <INPUT size="10" class="textfield1" type="text" name="create_time_end" id="create_time_end" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('create_time_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke">%(tls_start)s:</TD>
    <TD class="td_listing0ve"><INPUT class="textfield1"  type="text" size="10" name="start_time_start" id="start_time_start" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A>&nbsp; %(tls_to)s <INPUT size="10" class="textfield1" type="text" name="start_time_end" id="start_time_end" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_due)s:</TD>
    <TD class="td_listing1ve"><INPUT size="10" class="textfield1"  type="text" name="due_time_start" id="due_time_start" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A>&nbsp; %(tls_to)s <INPUT size="10" class="textfield1" type="text" name="due_time_end" id="due_time_end" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke">%(tls_related)s:</TD>
    <TD class="td_listing0ve">%(related_persons)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_desc)s:</TD>
    <TD class="td_listing1ve"><INPUT class="textfield3" name="description"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke">%(tls_completedover)s:</TD>
    <TD class="td_listing0ve">
<SELECT name="percent_complete">
<OPTION value="">
<OPTION value="0">0%%
<OPTION value="10">10%%
<OPTION value="20">20%%
<OPTION value="30">30%%
<OPTION value="40">40%%
<OPTION value="50">50%%
<OPTION value="60">60%%
<OPTION value="70">70%%
<OPTION value="80">80%%
<OPTION value="90">90%%
<OPTION value="100">100%%
</SELECT>
</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1" colspan="2"><INPUT type="submit" class="input2" name="_search" value="%(tls_search)s"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))

    if REQUEST.form.has_key('_delete'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            todo.delete()
        if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
            REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
            return apache.HTTP_MOVED_TEMPORARILY

    sortby = [
'title ASC', 'title DESC',
'creator_name ASC', 'creator_name DESC',
'priority ASC', 'priority DESC',
'category ASC', 'category DESC',
'status ASC', 'status DESC',
'due_time ASC', 'due_time DESC',
'percent_complete ASC', 'percent_complete DESC'
]

    REQUEST.db.execute("""SELECT person_id, first_name || ' ' || last_name as person_name from persons""")
    res = REQUEST.db.fetchall()
    persons_dict = {}
    for row in res:
        persons_dict[row[0]] = row[1].decode('UTF8')

    BASE_TODO_URL = _Conf.BASE_TODO_URL
    tls_tasks = REQUEST.TLS('tls_todos')
    tls_done = REQUEST.TLS('todo_done')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_responsible')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_category = REQUEST.TLS('tls_category')
    tls_status = REQUEST.TLS('tls_status')
    tls_due = REQUEST.TLS('todo_due')
    tls_delete = REQUEST.TLS('tls_deletesel')
    tls_confirm = REQUEST.TLS('email_confirm_del')

    DEFAULT_SORTBY = 10
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_title = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=0">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    sortby_creator = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=2">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    sortby_priority = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=4">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    sortby_due = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=10">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    sortby_complete = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=12">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    if sortby_id == 0:
        sortby_title = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    elif sortby_id == 1:
        sortby_title = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_priority = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    elif sortby_id == 5:
        sortby_priority = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    elif sortby_id == 6:
        sortby_category = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=7">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    elif sortby_id == 7:
        sortby_category = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=6">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    elif sortby_id == 8:
        sortby_status = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=9">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    elif sortby_id == 9:
        sortby_status = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=8">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    elif sortby_id == 10:
        sortby_due = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=11">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    elif sortby_id == 11:
        sortby_due = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=10">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    elif sortby_id == 12:
        sortby_complete = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=13">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    elif sortby_id == 13:
        sortby_complete = u"""<A class="blackboldlink" href="%stodosearch.py/search%ssort_by=12">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_TODO])
    if right_param:
        right_param = " AND " + right_param
    search_param = []
    if REQUEST.form.has_key('search_keyword'):
        w = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8').lower())
        w2 = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8'))
        search_param = u""" AND (
lower(t.title) like '%%%s%%' OR 
lower(t.status) = '%s' OR
lower(t.priority) = '%s' OR
lower(t.category) = '%s' OR
lower(t.description) like '%%%s%%')""" % (w,w,w,w,w)
    else:
        if REQUEST.form.has_key('related_persons') and isinstance(REQUEST.form['related_persons'], list) and REQUEST.form['related_persons']:
            if REQUEST.db.version < 740:
                for itemval in REQUEST.form['related_persons']:
                    search_param.append(u"t.related_persons @ '{%s}'::int[]" % (itemval.decode('UTF8')))
            else:
                for itemval in REQUEST.form['related_persons']:
                    search_param.append(u"%d=ANY(t.related_persons)" % (int(itemval.decode('UTF8'))))
        elif REQUEST.form.has_key('related_persons') and not isinstance(REQUEST.form['related_persons'], list) and REQUEST.form['related_persons'].value.decode('UTF8'):
            itemval = REQUEST.form['related_persons'].value.decode('UTF8')
            if REQUEST.db.version < 740:
                search_param.append(u"t.related_persons @ '{%s}'::int[]" % (itemval))
            else:
                search_param.append(u"%d=ANY(t.related_persons)" % (int(itemval)))
        if REQUEST.form.has_key('title') and REQUEST.form['title'].value:
            search_param.append("lower(t.title) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['title'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('status') and REQUEST.form['status'].value:
            search_param.append("t.status=%s" % _Utils.sql_cast_str(REQUEST, REQUEST.form['status'].value.decode('UTF8')))
        if REQUEST.form.has_key('priority') and REQUEST.form['priority'].value:
            search_param.append("t.priority=%s" % _Utils.sql_cast_str(REQUEST, REQUEST.form['priority'].value.decode('UTF8')))
        if REQUEST.form.has_key('category') and REQUEST.form['category'].value:
            search_param.append("t.category=%s" % _Utils.sql_cast_str(REQUEST, REQUEST.form['category'].value.decode('UTF8')))
        if REQUEST.form.has_key('create_time_start') and REQUEST.form['create_time_start'].value:
            search_param.append("i.create_time >= %s::timestamptz" % _Utils.sql_cast_str(REQUEST, REQUEST.user2isodate(REQUEST, REQUEST.form['create_time_start'].value.decode('UTF8'))))
        if REQUEST.form.has_key('create_time_end') and REQUEST.form['create_time_end'].value:
            search_param.append("i.create_time < (%s::timestamptz + '1 day'::interval)" % _Utils.sql_cast_str(REQUEST, REQUEST.user2isodate(REQUEST, REQUEST.form['create_time_end'].value.decode('UTF8'))))
        if REQUEST.form.has_key('start_time_start') and REQUEST.form['start_time_start'].value:
            search_param.append("start_time >= %s::timestamptz" % _Utils.sql_cast_str(REQUEST, REQUEST.user2isodate(REQUEST, REQUEST.form['start_time_start'].value.decode('UTF8'))))
        if REQUEST.form.has_key('start_time_end') and REQUEST.form['start_time_end'].value:
            search_param.append("start_time < (%s::timestamptz + '1 day'::interval)" % _Utils.sql_cast_str(REQUEST, REQUEST.user2isodate(REQUEST, REQUEST.form['start_time_end'].value.decode('UTF8'))))
        if REQUEST.form.has_key('due_time_start') and REQUEST.form['due_time_start'].value:
            search_param.append("due_time >= %s::timestamptz" % _Utils.sql_cast_str(REQUEST, REQUEST.user2isodate(REQUEST, REQUEST.form['due_time_start'].value.decode('UTF8'))))
        if REQUEST.form.has_key('due_time_end') and REQUEST.form['due_time_end'].value:
            search_param.append("due_time < (%s::timestamptz + '1 day'::interval)" % _Utils.sql_cast_str(REQUEST, REQUEST.user2isodate(REQUEST, REQUEST.form['due_time_end'].value.decode('UTF8'))))
        if REQUEST.form.has_key('description') and REQUEST.form['description'].value:
            search_param.append("lower(t.description) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['description'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('percent_complete') and REQUEST.form['percent_complete'].value:
            search_param.append("t.percent_complete >= %d" % int(REQUEST.form['percent_complete'].value.decode('UTF8').lower()))
        if search_param:
            search_param = " AND\n%s\n" % " AND \n".join(search_param)
        else:
            search_param = ""

    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None

    if show_users: # Show involved people
        users_limit = []
        for userid in show_users:
            users_limit.append("""i.creator_id = %d""" % userid)
            if REQUEST.db.version < 740:
                users_limit.append("""t.related_persons @ '{%d}'::int[]""" % userid)
            else:
                users_limit.append("""%d=ANY(t.related_persons)""" % userid)
        users_limit = "\n     (%s) " % " OR ".join(users_limit)
    else: # show only personal stuff
        if REQUEST.db.version < 740:
            users_limit = """\n     (i.creator_id = %d OR t.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n     (i.creator_id = %d OR %d=ANY(t.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
    QUERY = """SELECT
 count(*) AS count_all
FROM
 todos t, items i, items p
WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND
%s%s%s""" % (users_limit, search_param, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%stodosearch.py/search%sqs=" % (_Conf.BASE_TODO_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%stodosearch.py/search%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_TODO_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%stodosearch.py/search%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_TODO_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    QUERY = """SELECT
 t.*, i.creator_id, i.parent_id, p.item_name AS creator_name
FROM
 todos t, items i, items p
WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND
%s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (users_limit, search_param, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)

    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    retval = REQUEST.get_formstring(['qs'])

    output.append(u"""
<SCRIPT type="text/javascript">
<!--
function markAll(formvar)
{
    for(var x=0;x<formvar.elements.length;x++) {
       var y=formvar.elements[x];
       if(y.name != 'all')
          y.checked = formvar.all.checked;
    }
}
//-->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM method="post" action="%(BASE_TODO_URL)stodosearch.py/search%(retval)s">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_6.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_tasks)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal">
<TR>
  <TD width="1%%" class="td_listing1b"><INPUT type="checkbox" name="all" onClick="javascript:markAll(this.form);"></TD>
  <TD width="4%%" class="td_listing1b">%(sortby_complete)s</TD>
  <TD width="60%%" class="td_listing1b">%(sortby_title)s</TD>
  <TD width="15%%" class="td_listing1b" nowrap>%(tls_creator)s</TD>
  <TD width="10%%" class="td_listing1b" nowrap>%(sortby_priority)s</TD>
  <TD width="10%%" class="td_listing1b" nowrap>%(sortby_due)s</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        if item['category'] is None: item['category'] = "&nbsp;"
        if item['due_time'] is None: item['due_time'] = "&nbsp;"
        else: item['due_time'] = REQUEST.iso2userdate(item['due_time'])

        item['title'] = _Utils.html_quote(item['title'].decode('UTF8'))
        item['creator_name'] = _Utils.sql_parse_array(REQUEST, item['related_persons'])
        if item['creator_name'] == []:
            item['creator_name'] = "&nbsp;"
        else:
            p_out = ""
            for person in item['creator_name']:
                p_out = p_out + persons_dict.get(person, "N/A") + "<BR>"
            item['creator_name'] = p_out[0:-4]
        item['priority'] = item['priority'].decode('UTF8')
        if not item['priority']:
            item['priority'] = "&nbsp;"
        
        if(item['percent_complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['percent_complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']=(int) (item['percent_complete']/2)
            item['second_percent']=50 - item['first_percent']
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
        
        if item['creator_id'] == REQUEST.USER.get_id() or REQUEST.USER.get_id()== _Conf.SUPERUSER:
            item['checkbox_str'] = u"""<INPUT type="checkbox" name="sel_%(todo_id)d">""" % item
        else:
            item['checkbox_str'] = u""
        
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d" width="5%%">%(checkbox_str)s</TD>
  <TD class="td_listing%(class_type)d" style="text-align: center" nowrap>
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
  </TD>
  <TD class="td_listing%(class_type)d" width="30%%"><A class="td_listing" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)d">%(title)s</A></TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(creator_name)s</TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(priority)s</TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(due_time)s</TD>
</TR>""" % item)

    output.append(u"</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)

    output.append(u"""\
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="100%%" align="right"><INPUT TYPE="submit" class="input6" name="_delete" value="%(tls_delete)s" onClick="return confirm('%(tls_confirm)s');"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
