//
// Create HTML for Epoz-Editor
//
// Comment out the parts you don't want to be shown.
//

function CreateEpoz() {

    var widget = '';

    widget += '<div id="EpozToolbar">';

/*
    The select-box for formats
*/
    widget +='<table border=0 cellpadding=0 cellspacing=0><tr><td>'
    widget += '<select id="formatblock" onchange="SelectFormat(this);" style="margin-bottom: 2px;">';
    widget += '<option value="">'+EpozLangNormal+'</option>';
    widget += '<option value="<p>">'+EpozLangParagraph+'</option>';
    widget += '<option value="<h1>">'+EpozLangHeading1+'</option>';
    widget += '<option value="<h2>">'+EpozLangHeading2+'</option>';
    widget += '<option value="<h3>">'+EpozLangHeading3+'</option>';
    widget += '<option value="<h4>">'+EpozLangHeading4+'</option>';
    widget += '<option value="<h5>">'+EpozLangHeading5+'</option>';
    widget += '<option value="<h6>">'+EpozLangHeading6+'</option>';
    widget += '<option value="<pre>">'+EpozLangFormatted+'</option>';
    widget += '</select>';
    widget += '<br />';

/*
    The font-face-buttons (bold, italic, underline)
*/
    widget +='</td><td>&nbsp;</td><td width="100%">'
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_bold.gif" width="23" height="22" alt="'+EpozLangBold+'" title="'+EpozLangBold+'" onClick="FormatText(\'bold\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_italic.gif" width="23" height="22" alt="'+EpozLangItalic+'" title="'+EpozLangItalic+'" onClick="FormatText(\'italic\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_underline.gif" width="23" height="22" alt="'+EpozLangUnderline+'" title="'+EpozLangUnderline+'" onClick="FormatText(\'underline\', \'\');">';
    widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';

/*
    The sub-/superscript-buttons
*/

    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_subscript.gif" width="23" height="22" alt="'+EpozLangSubscript+'" title="'+EpozLangSubscript+'" onClick="FormatText(\'subscript\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_superscript.gif" width="23" height="22" alt="'+EpozLangSuperscript+'" title="'+EpozLangSuperscript+'" onClick="FormatText(\'superscript\', \'\');">';
    widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';

/*
    The color-selections (foreground, background)
*/
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_textcolor.gif" width="23" height="22" alt="'+EpozLangTextColor+'" title="'+EpozLangTextColor+'" onClick="SetTextColor();">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_bgcolor.gif" width="23" height="22" alt="'+EpozLangBackColor+'" title="'+EpozLangBackColor+'" onClick="SetBackColor();">';
    widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';

/*
    Alignment-controls
*/
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_left_just.gif" width="23" height="22" alt="'+EpozLangAlignLeft+'" title="'+EpozLangAlignLeft+'" onClick="FormatText(\'justifyleft\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_centre.gif" width="23" height="22" alt="'+EpozLangCenter+'" title="'+EpozLangCenter+'" onClick="FormatText(\'justifycenter\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_right_just.gif" width="23" height="22" alt="'+EpozLangAlignRight+'" title="'+EpozLangAlignRight+'" onClick="FormatText(\'justifyright\', \'\');">';
    widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';

/*
    Lists and In/Outdent
*/
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_numbered_list.gif" width="23" height="22" alt="'+EpozLangOrderedList+'" title="'+EpozLangOrderedList+'" onClick="FormatText(\'insertorderedlist\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_list.gif" width="23" height="22" alt="'+EpozLangUnorderedList+'" title="'+EpozLangUnorderedList+'" onClick="FormatText(\'insertunorderedlist\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_outdent.gif" width="23" height="22" alt="'+EpozLangOutdent+'" title="'+EpozLangOutdent+'" onClick="FormatText(\'outdent\', \'\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_indent.gif" width="23" height="22" alt="'+EpozLangIndent+'" title="'+EpozLangIndent+'" onClick="FormatText(\'indent\', \'\');">';
    widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';


/*  
    Insert Link, Image, Rule, Table
*/
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_hyperlink.gif" width="23" height="22" alt="'+EpozLangInsertLink+'" title="'+EpozLangInsertLink+'" onClick="CreateLink();">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_hr.gif" width="23" height="22" alt="'+EpozLangInsertRule+'" title="'+EpozLangInsertRule+'" onClick="FormatText(\'inserthorizontalrule\');">';

/*
    The optional toolbox

    if ((form_toolbox != null) && (form_toolbox != "")) {
        widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';
        widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_tools.gif" width="23" height="22" alt="'+EpozLangToolbox+'" title="'+EpozLangToolbox+'"" onClick="window.open(\''+form_toolbox+'\',\'EpozToolbox\',\'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=400,height=400\');">';
    }

    widget += '<img src="'+form_path+'epoz_button_space.gif" width="2" height="1">';
*/
/*
    Undo & Redo
*/

    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_undo.gif" width="23" height="22" alt="'+EpozLangUndo+'" title="'+EpozLangUndo+'" onClick="FormatText(\'undo\');">';
    widget += '<img style="'+form_button_style+'" src="'+form_path+'epoz_button_redo.gif" width="23" height="22" alt="'+EpozLangRedo+'" title="'+EpozLangRedo+'" onClick="FormatText(\'redo\');">';


/*
     Don't remove!!!
*/

    widget +='</td></tr></table>'
    widget += '\n';
    widget += '<iframe frameborder="0" id="' + Epoz + '" style="font-size: 6px; font-family: courier;' + form_area_style + '" onload="InitDocument();"></iframe>';
    widget += '</div>';
    
    widget += '<textarea style="display: none; ' + 'width: 760px; height: 323px; border: 1px solid #7F9DB9; padding: 3px;' + '"  id="' + form_name + '" name="' + form_name + '" value=""></textarea>';
    widget += '<div id="HtmlDiv" style="margin: 0px; padding:2px;"><input id="EpozViewMode" style="margin: 0px;" type="checkbox" onclick="SwitchViewMode(this.checked)"> HTML</div>'; 

    document.writeln(widget);
    setTimeout("EnableDesignMode();", EpozTimeOut);
}


// Create a default-textbox for browsers without Rich-Text-Features

function CreateTextarea() {
    document.writeln('<textarea name="' + form_name + '" id="' + Epoz + '" style="' + form_area_style + '">'+form_data+'</textarea>');
}

