import mx.DateTime

import _Conf
from Menus import get_workflows_menu
import standard_html, _Utils

import _Access, _InitTypes, _Workflow, _Todo


def index(REQUEST):
    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            QUERY = """SELECT * FROM todos WHERE workflow_id=%d""" % del_id
            REQUEST.db.execute(QUERY.encode('UTF8'))
            dbresult = REQUEST.db.dictfetchall()
            for item in dbresult:
                todo_obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, item['todo_id'])
                todo_obj.delete()
            workflow_obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            workflow_obj.delete()
    output = []
    MY_MENU_ID=0
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('others'):
        extra_pars = u" AND w.percent_complete<100"
        output.append(get_workflows_menu(REQUEST, MY_MENU_ID+1))
    elif REQUEST.form.has_key('all'):
        extra_pars = u""
        output.append(get_workflows_menu(REQUEST, MY_MENU_ID+2))
    else:
        extra_pars = u" AND w.percent_complete<100"
        output.append(get_workflows_menu(REQUEST, MY_MENU_ID))


    tls_complete = REQUEST.TLS('todo_complete')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_current_task = REQUEST.TLS('tls_current_task')
    tls_due = REQUEST.TLS('todo_due')
    sortby = [
'workflow_title ASC', 'workflow_title DESC',
'workflow_start_time  ASC', 'workflow_start_time  DESC',
'workflow_due_time ASC', 'workflow_due_time DESC',
]
    DEFAULT_SORTBY = 6
    sortby_id = 4

    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_title = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=0">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
    sortby_creator = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=2">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    sortby_due = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=4">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
    if sortby_id == 0:
        sortby_title = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
    elif sortby_id == 1:
        sortby_title = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_due = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
    elif sortby_id == 5:
        sortby_due = u"""<A class="blackboldlink" href="%sworkflowindex.py%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
    del formstring

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_workflows = REQUEST.TLS('topmenu_workflows')

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_WORKFLOW])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('others'):
        if REQUEST.db.version < 740:
            users_limit = """\n  AND (i.creator_id <> %d OR w.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n  AND (i.creator_id <> %d OR %d=ANY(w.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
    elif REQUEST.form.has_key('all'):
        users_limit = ""
    else:
        if REQUEST.db.version < 740:
            users_limit = """\n  AND (i.creator_id = %d OR w.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n  AND (i.creator_id = %d OR %d=ANY(w.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())

    SQL = u"""SELECT count(*) as count_all FROM workflows w, items i, items p WHERE w.workflow_id=i.item_id AND p.item_id=i.creator_id %s%s%s """ % (users_limit, right_param, extra_pars)
    REQUEST.db.execute(SQL.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sworkflowindex.py%sqs=" % (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sworkflowindex.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sworkflowindex.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    QUERY = u"""SELECT w.*, i.parent_id, p.item_name AS creator_name FROM workflows w, items i, items p WHERE w.workflow_id=i.item_id AND p.item_id=i.creator_id %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (users_limit, right_param, extra_pars, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()




    output.append(u"""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM method="POST" action="workflowindex.py">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_16.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_workflows)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_complete)s</TD>
  <TD class="td_listing1b">%(sortby_title)s</TD>
  <TD class="td_listing1b" nowrap>%(sortby_creator)s</TD>
  <TD class="td_listing1b" nowrap align="center">%(tls_current_task)s</TD>
  <TD class="td_listing1b" nowrap>%(sortby_due)s</TD>
  <TD class="td_listing1b">&nbsp;</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_WORKFLOWS_URL'] = _Conf.BASE_WORKFLOWS_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['markredstart'] = ""
        item['markredend'] = ""
        if item['workflow_due_time'] is None:
            item['workflow_due_time'] = ""
        else:
            item['workflow_due_time'] = REQUEST.iso2userdate(item['workflow_due_time'])
        REQUEST.db.execute("SELECT count(*), coalesce(sum(case when percent_complete=100 then 1 else 0 end), 0) FROM todos where workflow_id=%d" % int(item['workflow_id']))
        item['todocount'], item['tododone'] = REQUEST.db.fetchone()
        item['workflow_title']= _Utils.html_quote(item['workflow_title'].decode('UTF8'))
        item['creator_name']= item['creator_name'].decode('UTF8')
        if(item['percent_complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['percent_complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']= (int) (item['percent_complete']/2)
            item['second_percent']= 50 - item['percent_complete']/2
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
        output.append(u"""\
<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: left">
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
  </TD>
  <TD class="td_listing%(class_type)d" width="35%%"><A class="td_listing" href="%(BASE_WORKFLOWS_URL)sworkflowedit.py?workflow_id=%(workflow_id)d">%(markredstart)s%(workflow_title)s%(markredend)s</A></TD>
  <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="20%%" nowrap align="center">%(markredstart)s%(tododone)s/%(todocount)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(workflow_due_time)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="5%%" style="text-align: center">&nbsp;</TD>
</TR>""" % item)
    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""</FORM><BR>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
