import mx.DateTime

import _Conf
from Menus import get_workflows_menu
import standard_html

import _Access, _InitTypes, _Utils

MY_MENU_ID=4

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_workflows_menu(REQUEST, MY_MENU_ID))
    
    tls_searchevent = REQUEST.TLS('tls_search_workflow')
    tls_between = REQUEST.TLS('cal_between')
    tls_startdate = REQUEST.TLS('todo_starttime')
    tls_enddate = REQUEST.TLS('todo_duetime')
    tls_and = REQUEST.TLS('cal_and')
    tls_desc = REQUEST.TLS('tls_description')
    tls_search = REQUEST.TLS('tls_search')
    tls_subject = REQUEST.TLS('tls_title')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_search = REQUEST.TLS('tls_search')
    tls_asearch = REQUEST.TLS('tls_adv_search')
    tls_keyword = REQUEST.TLS('tls_keyword')
    
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""\
<SCRIPT type="text/JavaScript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.searchform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
%(datecheck_js)s
function change(numb)
{
  el1 = document.getElementById('1');
  el2 = document.getElementById('2');
  if(numb=='1')
  {
    el1.style.visibility='visible';
    el2.style.visibility='hidden';
  }
  else if(numb=='2')
  {
    el1.style.visibility='hidden';
    el2.style.visibility='visible';  }
}
// -->
</SCRIPT>
<DIV id="1" style="position: absolute; width:95%%; left: 0px; top: 50px; visibility: visible;">
<FORM name="vorm" method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowsearch.py/search">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD colspan=5>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap >%(tls_keyword)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="search_keyword"></TD>
    <TD class="td_listing1" nowrap><INPUT type="submit" name="_search" value="%(tls_search)s" class="input2"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
<DIV id="2" style="position: absolute; width:95%%; left: 0px; top: 50px; visibility: hidden;">
<FORM name="searchform" method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowsearch.py/search">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD colspan=7>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_subject)s</TD>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3"><INPUT type="text" size=30 class="textfield1" name="workflow_title"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_startdate)s %(tls_between)s</TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3">
    <INPUT type="text" size="10" class="textfield1" name="start_stamp_1" id="start_stamp_1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">
    &nbsp;
    <A href="javascript:void(0);" OnClick="return showCalendar('start_stamp_1', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A>
    &nbsp;&nbsp;%(tls_and)s&nbsp;&nbsp;
    <INPUT type="text" size="10" class="textfield1" name="start_stamp_2" id="start_stamp_2" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">
    &nbsp;
    <A href="javascript:void(0);" OnClick="return showCalendar('start_stamp_2', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A>
    </TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_enddate)s %(tls_between)s</TD>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3">
    <INPUT type="text" class="textfield1" size="10" name="end_stamp_1" id="end_stamp_1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">
    &nbsp;
    <A href="javascript:void(0);" OnClick="return showCalendar('end_stamp_1', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A>
    &nbsp;&nbsp;%(tls_and)s&nbsp;&nbsp;
    <INPUT type="text" class="textfield1" size="10" name="end_stamp_2" id="end_stamp_2" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">
    &nbsp;
    <A href="javascript:void(0);" OnClick="return showCalendar('end_stamp_2', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 2px;"></A>
    </TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_desc)s</TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3"><INPUT class="textfield3" name="description"></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="5"><INPUT type="submit" class="input2" name="_search" value="%(tls_search)s"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_WORKFLOW])
    if right_param:
        right_param = " AND %s" % right_param

    search_params = []
    if REQUEST.form.has_key('search_keyword'):
        w = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8').lower())
        search_params = u""" AND (lower(e.workflow_title) like '%%%s%%' OR lower(e.workflow_description) like '%%%s%%')""" % (w, w)
    else:
        if REQUEST.form.has_key('workflow_title') and REQUEST.form['workflow_title'].value.decode('UTF8').strip():
            search_params.append(u"lower(e.workflow_title) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['workflow_title'].value.decode('UTF8').strip().lower()))
        if REQUEST.form.has_key('description') and REQUEST.form['description'].value.decode('UTF8').strip():
            search_params.append(u"lower(e.workflow_description) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['description'].value.decode('UTF8').strip().lower()))
        if REQUEST.form.has_key('start_stamp_1') and REQUEST.form['start_stamp_1'].value.decode('UTF8'):
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['start_stamp_1'].value.decode('UTF8').strip()).split('-'))
            date = mx.DateTime.DateTime(year, month, day)
            search_params.append(u"e.workflow_start_time>=%s" % _Utils.sql_quote(str(date)))
        if REQUEST.form.has_key('start_stamp_2') and REQUEST.form['start_stamp_2'].value.decode('UTF8').strip():
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['start_stamp_2'].value.decode('UTF8').strip()).split('-'))
            date = mx.DateTime.DateTime(year, month, day, 23, 59)
            search_params.append(u"e.workflow_start_time<=%s" % _Utils.sql_quote(str(date)))
        if REQUEST.form.has_key('end_stamp_1') and REQUEST.form['end_stamp_1'].value.decode('UTF8').strip():
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['end_stamp_1'].value.decode('UTF8').strip()).split('-'))
            date = mx.DateTime.DateTime(year, month, day)
            search_params.append(u"e.workflow_due_time>=%s" % _Utils.sql_quote(str(date)))
        if REQUEST.form.has_key('end_stamp_2') and REQUEST.form['end_stamp_2'].value.decode('UTF8').strip():
            year, month, day = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['end_stamp_2'].value.decode('UTF8').strip()).split('-'))
            date = mx.DateTime.DateTime(year, month, day, 23, 59)
            search_params.append(u"e.workflow_due_time<=%s" % _Utils.sql_quote(str(date)))
        if search_params:
            search_params = " AND %s" % " AND ".join(search_params)
        else:
            search_params = u""

    sortby = [
'workflow_title ASC', 'workflow_title',
'creator_name ASC', 'creator_name DESC',
'workflow_start_time ASC', 'workflow_start_time DESC',
'workflow_due_time ASC', 'workflow_due_time DESC',
'percent_complete ASC', 'percent_complete DESC']

    DEFAULT_SORTBY = 9
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    tls_startdate = REQUEST.TLS('cal_startdate')
    tls_enddate = REQUEST.TLS('cal_enddate')
    tls_search = REQUEST.TLS('tls_search_results')
    tls_pri = REQUEST.TLS('tls_priority')
    tls_act = REQUEST.TLS('tls_activity')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_creator = REQUEST.TLS('tls_creator')

    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_subject = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=0">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_subject)
    sortby_creator = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=2">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    sortby_start = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=4">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_startdate)
    sortby_end = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=6">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_enddate)
    sortby_act = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=8">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_act)
    if sortby_id == 0:
        sortby_subject = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_subject)
    elif sortby_id == 1:
        sortby_subject = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_subject)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_start = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_startdate)
    elif sortby_id == 5:
        sortby_start = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_startdate)
    elif sortby_id == 6:
        sortby_end = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_enddate)
    elif sortby_id == 7:
        sortby_end = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_enddate)
    elif sortby_id == 8:
        sortby_act = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=9">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_act)
    elif sortby_id == 9:
        sortby_act = u"""<A class="blackboldlink" href="%sworkflowsearch.py/search%ssort_by=8">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_act)

    SQL = u"""\
SELECT
 count(*) AS count_all
FROM
 workflows e,
 items i,
 items p
WHERE 
 e.workflow_id=i.item_id AND
 i.creator_id=p.item_id
-- search-param
%s
-- right-param
%s
-- end q
""" % (search_params, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sworkflowsearch.py/search%sqs=" % (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sworkflowsearch.py/search%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sworkflowsearch.py/search%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    SQL = u"""\
SELECT
 e.*,
 i.*,
 p.item_name AS creator_name
FROM
 workflows e,
 items i,
 items p
WHERE 
 e.workflow_id=i.item_id AND
 i.creator_id=p.item_id
-- search-param
%s
-- right-param
%s
-- end q
ORDER BY %s
LIMIT %d OFFSET %d
""" % (search_params, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresults = REQUEST.db.dictfetchall()

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_workflows_menu(REQUEST, MY_MENU_ID))
    output.append(u"""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_16.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_search)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal">
 <TR>
  <TD class="td_listing1b">%(sortby_subject)s</TD>
  <TD class="td_listing1b">%(sortby_creator)s</TD>
  <TD class="td_listing1b">%(sortby_start)s</TD>
  <TD class="td_listing1b">%(sortby_end)s</TD>
  <TD class="td_listing1b">%(sortby_act)s</TD>
 </TR>""" % locals())
    index = 0
    for dbresult in dbresults:
        if(index % 2 == 0):
          dbresult['td_style']='td_listing0'
        else:
          dbresult['td_style']='td_listing1'
        index = index + 1
        dbresult['BASE_WORKFLOWS_URL'] = _Conf.BASE_WORKFLOWS_URL
        dbresult['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        if dbresult['workflow_start_time']:
            dbresult['workflow_start_time'] = REQUEST.iso2userdate(dbresult['workflow_start_time'])
        else:
            dbresult['start_stamp'] = ''
        
        if dbresult['workflow_due_time']:
            dbresult['workflow_due_time'] = REQUEST.iso2userdate(dbresult['workflow_due_time'])
        else:
            dbresult['workflow_due_time'] = ''
        
        dbresult['workflow_title'] = _Utils.html_quote(dbresult['workflow_title'].decode('UTF8'))
        dbresult['creator_name'] = dbresult['creator_name'].decode('UTF8')
        dbresult['workflow_description'] = (dbresult['workflow_description'] and _Utils.html_quote(dbresult['workflow_description'].decode('UTF8'))) or '&nbsp;'
        output.append(u"""\
 <TR>
  <TD class="%(td_style)s" width="25%%"><A class="blacklink" href="%(BASE_WORKFLOWS_URL)sworkflowedit.py?workflow_id=%(workflow_id)d">%(workflow_title)s</A></TD>
  <TD class="%(td_style)s" nowrap width="15%%">%(creator_name)s</TD>
  <TD class="%(td_style)s" nowrap width="15%%">%(workflow_start_time)s</TD>
  <TD class="%(td_style)s" nowrap width="15%%">%(workflow_due_time)s</TD>
  <TD class="%(td_style)s" nowrap width="35%%">%(workflow_description)s</TD>
 </TR>""" % dbresult)
    output.append(u"""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
