class MultiForm:
    def __init__(self, REQUEST):
        self.rows = {}

        for key in REQUEST.form.keys():
            if key[:4] == "form":
                first = key.find('_')
                second = key.find('_', first+1)
                try:
                    row_id, key_id = int(key[first+1:second]), key[second+1:]
                except ValueError: # Int and key are switched around
                    key_id, row_id = key[first+1:second], int(key[second+1:])
                if self.rows.has_key(row_id):
                    if isinstance(REQUEST.form[key], list):
                        self.rows[row_id][key_id] = map(lambda x: x.decode('UTF8'), REQUEST.form[key])
                    else:
                        self.rows[row_id][key_id] = REQUEST.form[key].value.decode('UTF8')
                else:
                    self.rows[row_id] = {}
                    if isinstance(REQUEST.form[key], list):
                        self.rows[row_id][key_id] = map(lambda x: x.decode('UTF8'), REQUEST.form[key])
                    else:
                        self.rows[row_id][key_id] = REQUEST.form[key].value.decode('UTF8')

    def get_rows(self):
        rows = []
        for (key, item) in self.rows.items():
            row = {}
            for (rowkey, rowitem) in item.items():
                row[rowkey] = rowitem
            rows.append(row)
        return rows
