import _Utils

def generate_search(REQUEST, item_class, form, tablename="o", banned_keys=[]):
    QUERY = ""
    objectkeys = item_class.object_fields.keys()
    itemkeys = item_class.item_fields.keys()
    for key in form.keys():
        value = form[key].value.decode('UTF8').lower()
        if key in banned_keys:
            continue
        if key in itemkeys and value:
            if item_class.item_fields[key]['type'] == _Utils.sql_cast_str:
                QUERY = QUERY + " AND lower(i.%s) like %s" % (key, item_class.item_fields[key]['type'](REQUEST, "%%%s%%" % value))
            else:
                QUERY = QUERY + " AND i.%s=%s" % (key, item_class.item_fields[key]['type'](REQUEST, value))
        if key in objectkeys and value:
            if item_class.object_fields[key]['type'] == _Utils.sql_cast_str:
                QUERY = QUERY + " AND lower(%s.%s) like %s" % (tablename, key, item_class.object_fields[key]['type'](REQUEST, "%%%s%%" % value))
            else:
                QUERY = QUERY + " AND %s.%s=%s" % (tablename, key, item_class.object_fields[key]['type'](REQUEST, value))
    return QUERY
