"""

Bookmark Object

$Id: _Bookmark.py,v 1.1 2003/09/14 10:19:41 incxcvs Exp $
"""

import _RootObject, _Utils
import _InitTypes


class Bookmark(_RootObject.RootObject):
    table_name = 'bookmarks'
    field_name = 'bookmark_id'
    item_type_id = _InitTypes.ITEM_TYPE_BOOKMARK
    is_container = 0
    object_fields = {
'bookmark_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'bookmark_url':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'bookmark_description':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'is_category':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 0,       'can_insert': 1 },
    }

    def get_name(self):
        if self.get('bookmark_url') is not None:
            return self.get('bookmark_url')
        else:
            raise RuntimeError
