
import _RootObject, _Utils
import _InitTypes

class ContactGroup(_RootObject.RootObject):
    table_name = 'contact_groups'
    field_name = 'group_id'
    item_type_id = _InitTypes.ITEM_TYPE_CONTACTGROUP
    is_container = 0
    object_fields = {
'group_id':	{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'group_name':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'group_description':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'contacts':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
    }

    fti_keys = ['group_name','group_description']

    def get_name(self):
        if self.get('group_name') is not None:
            return self.get('group_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('contactobj_notsaved')
        else:
            return self.REQUEST.TLS('contactobj_noname') % self.get_id()
