"""

_DiscCategory Object

$Id: _DiscCategory.py,v 1.2 2003/12/12 21:13:48 incxcvs Exp $
"""

import _RootObject, _Utils
import _InitTypes

import os

class DiscCategory(_RootObject.RootObject):
    table_name = 'disccategories'
    field_name = 'disccategory_id'
    item_type_id = _InitTypes.ITEM_TYPE_DISCCATEGORY
    is_container = 1
    object_fields = {
'disccategory_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	 'has_default': 1,       'can_insert': 0 },
'disccategory_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': str,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['disccategory_name']

    def get_name(self):
        if self.get('disccategory_name') is not None:
            return self.get('disccategory_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('disccatobj_notsaved')
        else:
            return self.REQUEST.TLS('disccatobj_noname') % self.get_id()
