"""

_Efilter Object

$Id$
"""

import _RootObject, _Utils
import _InitTypes, _Conf

import os

class Efilter(_RootObject.RootObject):
    table_name = 'email_filters'
    field_name = 'filter_id'
    item_type_id = _InitTypes.ITEM_TYPE_EFILTER
    is_container = 0
    object_fields = {
'filter_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'condition_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'keywords':	{ 'type': _Utils.sql_cast_str,	'simple_type': str,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'action_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'folder_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'use_case':	{ 'type': _Utils.sql_cast_bool,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'priority':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,	'can_insert':1	},
    }

    fti_keys = []

    def get_name(self):
        if self.get_id() is None:
            return 'Filter object' # self.REQUEST.TLS('resourceobj_notsaved')
        else:
            return 'Filter object %d' % self.get_id() # self.REQUEST.TLS('resourceobj_noname') % self.get_id()
