import _Conf, _Efolder, math, standard_html, _Email

def folder_output(REQUEST, active_folder, url="2", url_ext="/mail_list"):
    _Efolder.create_shared_folder(REQUEST)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    try:
        email_view = REQUEST.get_setting('email_view')
    except:
        email_view = "0"

    # Translation stuff
    tls_folders = REQUEST.TLS('tls_folders')
    tls_active = REQUEST.TLS('tls_active')
    tls_from = REQUEST.TLS('email_from')
    tls_to = REQUEST.TLS('email_to')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('email_sent')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')
    tls_short_newmail = REQUEST.TLS('email_short_newmail')
    tls_short_attach = REQUEST.TLS('email_short_attach')
    tls_localfolders = REQUEST.TLS('tls_localfolders')

    REQUEST.db.execute("""SELECT e.efolder_id, e.efolder_name, efolder_flags, eaccount_id, case when efolder_flags > 0 and (efolder_flags & %d)=0 then 1 else 0 end as system_folders FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d ORDER BY system_folders desc, efolder_id asc""" % (_Efolder.EFOLDER_IMAPF, REQUEST.USER.get_id()))
    result = REQUEST.db.dictfetchall()

    div_height = 120 + ((len(result) - 4)*21)

    efolder_output = []
    efolder_output.append(u"""\
<div id="efolders" style="position:absolute; width:100px; height: %(div_height)spx ;top:0px; left:215px; visibility: hidden; z-index: 1100">
<table border=0 width="100%%" cellpadding="3" cellspacing="0" style="background: #FAFAFA; border-left: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-bottom: 1px solid #AAAAAA; padding: 3px;">""" % locals())

    if active_folder:
        active_folder_id = active_folder.get_id()
    else:
        active_folder_id = -1

    if not result:
        raise RuntimeError, REQUEST.TLS('emails_nofolders')
    for item in result:
        if item['efolder_flags'] & _Efolder.EFOLDER_DRAFTS <> 0:
            continue
        if item['efolder_id'] <> active_folder_id:
            if item.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS:
                item['efolder_name'] = REQUEST.TLS('mail_Drafts')
            elif item.get('efolder_flags') & _Efolder.EFOLDER_SENT:
                item['efolder_name'] = REQUEST.TLS('mail_Sent Items')
            elif item.get('efolder_flags') & _Efolder.EFOLDER_INBOX:
                item['efolder_name'] = REQUEST.TLS('mail_Inbox')
            elif item.get('efolder_flags') & _Efolder.EFOLDER_DELETED:
                item['efolder_name'] = REQUEST.TLS('mail_Deleted Items')
            elif item.get('efolder_flags') & _Efolder.EFOLDER_SHARED:
                continue
            elif item.get('efolder_flags') & _Efolder.EFOLDER_IMAPF <> 0 and item.get('efolder_flags') & _Efolder.EFOLDER_IMAPF_ACTIVE ==0:
                continue
            else: 
                item['efolder_name'] = item['efolder_name'].decode('UTF8')
            eaccname = ""
            if item['eaccount_id']:
                try:
                    acc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, item['eaccount_id'])
                    eaccname = u" / %s@%s" % (acc.get('eaccount_user'), acc.get('eaccount_name'))
                except:
                    pass
            efolder_output.append(u"""\
  <tr onclick="move(%d);show_efolders();" style="cursor: pointer; cursor: hand; font-size: 11px;" onmouseover="this.style.backgroundColor='#CCCCCC';" onmouseout="this.style.backgroundColor='#FAFAFA';">
    <td><img src="%sspacer.gif" width=1 height=17 border=0 alt=""></td>
    <td width="100%%" nowrap>%s%s</td>
    <td><img src="%sspacer.gif" width=1 height=1 border=0 alt=""></td>
  </tr>""" % (item['efolder_id'], _Conf.BASE_ICON_URL, item['efolder_name'],eaccname, _Conf.BASE_ICON_URL))


    efolder_output.append(u"""</table>\n</div>""" % locals())

    REQUEST.db.execute("""SELECT  e.*, i.*, e2.eaccount_name, e2.eaccount_user, case when efolder_flags > 0 and (efolder_flags & %d)=0 then 1 else 0 end as system_folders FROM items i, efolders e left join eaccounts e2 on e.eaccount_id=e2.eaccount_id WHERE e.efolder_id=i.item_id AND i.parent_id=%d ORDER by system_folders DESC, (efolder_flags & %d) asc, eaccount_id, efolder_id""" % (_Efolder.EFOLDER_IMAPF, REQUEST.USER.get_id(),_Efolder.EFOLDER_IMAPF))
    result = REQUEST.db.dictfetchall()
    for i in range(len(result)):
        temp = result[i]
        if temp.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS:
            result[i]['efolder_name'] = REQUEST.TLS('mail_Drafts').encode('UTF8')
        elif temp.get('efolder_flags') & _Efolder.EFOLDER_SENT:
            result[i]['efolder_name'] = REQUEST.TLS('mail_Sent Items').encode('UTF8')
        elif temp.get('efolder_flags') & _Efolder.EFOLDER_INBOX:
            result[i]['efolder_name'] = REQUEST.TLS('mail_Inbox').encode('UTF8')
        elif temp.get('efolder_flags') & _Efolder.EFOLDER_DELETED:
            result[i]['efolder_name'] = REQUEST.TLS('mail_Deleted Items').encode('UTF8')
        elif temp.get('efolder_flags') & _Efolder.EFOLDER_SHARED:
            result[i]['efolder_name'] = REQUEST.TLS('mail_Shared Folder')
    div_height = 120 + ((len(result) - 4)*21)
    folder_output = []
    folders = []

    last_acc_id = -1
    # append account name
    folder_output.append(u"""
  <tr>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></td>
    <td width="100%%" nowrap style="text-align: center; font-weight: bold;">%(tls_localfolders)s</td>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></td>
  </tr>
    """ % locals())

    for efolder in result:
        if efolder['efolder_flags'] & _Efolder.EFOLDER_IMAPF <> 0 and efolder['efolder_flags'] & _Efolder.EFOLDER_IMAPF_ACTIVE ==0:
            continue
        if last_acc_id<>-1 and efolder['eaccount_id']<>last_acc_id:
            folders.append(folder_output)
            folder_output = []
            folder_output.append(u"""
          <tr>
            <td><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></td>
            <td width="100%%" nowrap style="text-align: center; font-weight: bold;">%s @ %s</td>
            <td><img src="%sspacer.gif" width=7 height=1 border=0 alt=""></td>
          </tr>
            """ % (_Conf.BASE_ICON_URL, efolder['eaccount_user'], efolder['eaccount_name'], _Conf.BASE_ICON_URL))
        last_acc_id = efolder['eaccount_id']
        i_str = ""
        count_out = u""
        if efolder['efolder_flags'] & _Efolder.EFOLDER_IMAPF <>0:
            i_str = "i"
        else:
            SQL = u"""SELECT
     (SELECT count(*) FROM emails e, items i WHERE e.email_id=i.item_id AND i.parent_id=%d) AS count_all,
     (SELECT count(*) FROM emails e, items i WHERE e.email_id=i.item_id AND i.parent_id=%d AND (e.email_flags & %d) = 0) AS count_unread
    """ % (efolder['efolder_id'], efolder['efolder_id'], _Email.EMAIL_READ)
            REQUEST.db.execute(SQL.encode('UTF8'))
            number_of_emails = REQUEST.db.dictfetchone()
            if efolder['efolder_flags'] & _Efolder.EFOLDER_SHARED <> 0:
                count_out = u""
            else:
                count_out = u"""<span class="efoldercount">(%s/%s)</span>""" % (number_of_emails['count_unread'] or 0, number_of_emails['count_all'] or 0)
        ef_id = efolder['efolder_id']
        ef_name = efolder['efolder_name'].decode('UTF8')
        if email_view == "0":
            folder_output.append(u"""
  <tr>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></td>
    <td width="100%%" nowrap><img src="%(BASE_ICON_URL)sfld%(i_str)s.gif" border=0 alt="">&nbsp;<a class="email_folder" onclick="try{ parent.mail.document.location='%(BASE_EMAIL_URL)sefolder%(url)s.py%(url_ext)s?folder_id=%(ef_id)s';} catch(e){;};" href="%(BASE_EMAIL_URL)sefolder%(url)s.py%(url_ext)s?folder_id=%(ef_id)d">%(ef_name)s</a> %(count_out)s</td>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></td>
  </tr>""" % locals())
        else:
            folder_output.append(u"""
  <tr>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></td>
    <td width="100%%" nowrap><img src="%(BASE_ICON_URL)sfld%(i_str)s.gif" border=0 alt="">&nbsp;<a class="email_folder" onclick="try{ parent.mail.document.location='%(BASE_EMAIL_URL)sefolder2.py?folder_id=%(ef_id)s';} catch(e){;};" href="%(BASE_EMAIL_URL)sefolder%(url)s.py%(url_ext)s?folder_id=%(ef_id)d">%(ef_name)s</a> %(count_out)s</td>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></td>
  </tr>""" % locals())
    # end efolder stuff
    if folder_output:
        folders.append(folder_output)

    folder_output = []
    folder_output.append(u"""\
<div id="folders" style="position:absolute; width:150px; height: %(div_height)spx ;top:0px; left:9px; visibility: hidden; z-index: 1100">
<table border=0 width="100%%" cellpadding=2 cellspacing=0 style="background: #FAFAFA; border-left: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-bottom: 1px solid #AAAAAA; padding: 3px;">
<tr>""" % locals())
    for foldertree in folders:
        fld = "\n".join(foldertree)
        folder_output.append(u"""\
    <td valign="top">
<table border="0" cellpadding="1" cellspacing="0">
%(fld)s
</table>
    </td>  """ % locals())
    folder_output.append(u"""<tr>""")
    colspan = len(folders)
    folder_output.append(u"""
<td colspan="%(colspan)s">
  <table border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td colspan=3><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></td>
  </tr>
  <tr>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></td>
    <td width="100%%" nowrap align="center">&nbsp;<a class="email_folder"  href="%(BASE_EMAIL_URL)sefolder%(url)s.py/createfolder">%(tls_createnew)s</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="email_folder"  href="%(BASE_EMAIL_URL)sefolder%(url)s.py/deletefolder">%(tls_deletefolder)s</a></td>
    <td><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></td>
  </tr>
  </table>
</td>
""" % locals())
    folder_output.append(u"""
  </tr>
  <tr>
    <td colspan=3><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></td>
  </tr>
</table>
</div>
""" % locals())
    return ("\n".join(folder_output), "\n".join(efolder_output))



def mkbatch(REQUEST, count_all, url="2", url_ext="/mail_list"):
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.email_batch_size:
        batch_url = "%sefolder%s.py%s%sqs=" % (_Conf.BASE_EMAIL_URL, url, url_ext, REQUEST.get_formstring(['qs']))
        batches = []
        i = 1
        try:
            current = int((REQUEST.qs)/REQUEST.email_batch_size) + 1
        except:
            current = 1
        batch_count = math.ceil(float(count_all)/REQUEST.email_batch_size)
        p1 = 0
        p2 = 0
        for n in range(1,batch_count+1):
            ok = 0
            if batch_count>15:
                    if n<=5:
                        ok = 1
                    elif n>5 and n<current-2 and not p1:
                        batches.append("&nbsp;...&nbsp;")
                        p1 = 1
                    elif (n>=current-2 and n<=current+2):
                        ok = 2
                    elif (n>=current-2 and n<batch_count - 5 and not p2):
                        batches.append("&nbsp;...&nbsp;")
                        p2 = 1
                    elif (n>batch_count - 5):
                        ok = 3
                    else:
                        ok = 0
                    if ok:
                        if (n==current):
                            batches.append(u"""<SPAN class="bb">%d</SPAN>&nbsp;&nbsp;""" % (i))
                        else:
                            batches.append(u"""<A class="bbl" href="%s%d">%d</A>&nbsp;&nbsp;""" % (batch_url, (n-1)*REQUEST.email_batch_size, i))
                    elif not ok and n>=batch_count:
                        raise RuntimeError, n
            else:
                if (n==current):
                    batches.append(u"""<SPAN class="bb">%d</SPAN>&nbsp;&nbsp;""" % (i))
                else:
                    batches.append(u"""<A class="bbl" href="%s%d">%d</A>&nbsp;&nbsp;""" % (batch_url, (n-1)*REQUEST.email_batch_size, i))
            i = i + 1
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="bbt" href="%sefolder%s.py%s%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_EMAIL_URL, url, url_ext, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.email_batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.email_batch_size))
        if count_all > REQUEST.qs + REQUEST.email_batch_size:
            END_BAR = u"""<A class="bbt" href="%sefolder%s.py%s%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_EMAIL_URL, url, url_ext, REQUEST.get_formstring(['qs']), REQUEST.email_batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.email_batch_size))
        FULL_BAR = standard_html.FULL_BAR3(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    return FULL_BAR
