import _Conf

class Translator:
    def __init__(self, REQUEST):
        try:
            self.language = REQUEST.get_setting("user_language")
        except AttributeError:
            self.language = _Conf.DEFAULT_LANG
        try:
            self.dateformat = REQUEST.get_setting("user_dateformat")
        except AttributeError:
            self.dateformat = _Conf.DEFAULT_DATE

        exec("from LANG import %s_lang" % self.language)
        exec("self._language = %s_lang.translation_dict" % self.language)
        exec("from LANG import %s_date" % self.dateformat)
        exec("self._dateformat = %s_date" % self.dateformat)

        REQUEST.iso2userdate = self._dateformat.iso2userdate
        REQUEST.iso2usertime = self._dateformat.iso2usertime
        REQUEST.iso2userdatetime = self._dateformat.iso2userdatetime
        REQUEST.date2usertext = self._dateformat.date2usertext

        REQUEST.user2isodate = self._dateformat.user2isodate
        REQUEST.user2isodatetime = self._dateformat.user2isodatetime

        REQUEST.datecheck_js = self._dateformat.datecheck_js
        REQUEST.timecheck_js = self._dateformat.timecheck_js

    def translate(self, word):
        return self._language[word]
