import standard_html

import SQLTree, _InitTypes, _Conf

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))

    a = SQLTree.SQLTree(REQUEST, "accesstree1")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION])
    a.set_param('tree_url', _Conf.BASE_ADMIN_URL + 'accesstree.py')
    a.set_param('target_url', _Conf.BASE_ADMIN_URL + 'accesslist.py')
    a.set_param('target', 'framecontents')
    a.set_param('urlparams', 'organization_id=%(item_id)d')
    a.maketree()

    output.append(a.getTree())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
