import _Conf, _Access, _InitTypes, _Utils
import standard_html

def index(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    
    persons = ""
    if REQUEST.form.has_key('persons') and REQUEST.form['persons'].value:
      persons = REQUEST.form['persons'].value
    
    if REQUEST.form.has_key('_add'):
      del_ids = {}
      for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
          del_ids[str(key[4:])] = 1
          persons = persons + "," + str(key[4:])
      # 2 remove dupes
      dic1 = {}
      p_list = persons.split(",")
      for p in p_list:
        if not dic1.has_key(p):
          dic1[p] = 1
      persons = ""
      for key in dic1.keys():
        persons = persons + "," + key
    
    if REQUEST.form.has_key('_delete'):
      del_ids = {}
      for key in REQUEST.form.keys():
        if key[:4] == 'del_':
          del_ids[str(key[4:])] = 1
      p_list = persons.split(",")
      dic1 = {}
      for p in p_list:
        if not(dic1.has_key(p) or del_ids.has_key(p)):
          dic1[p] = 1
      persons = ""
      for key in dic1.keys():
        persons = persons + "," + key
    persons = persons.replace(",,",",")
    if persons and persons[0]==",":
      if len(persons)>1:
        persons = persons[1:]
      else:
        persons=""



    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    tls_search = REQUEST.TLS('tls_search')
    tls_save = REQUEST.TLS('tls_save_close')
    tls_selected = REQUEST.TLS('tls_selected')
    tls_name = REQUEST.TLS('tls_name')
    tls_org = REQUEST.TLS('admin_organization')
    tls_remove = REQUEST.TLS('tls_remove_sel')
    tls_results = REQUEST.TLS('cal_choose_persons')
    tls_add = REQUEST.TLS('tls_add')

    output.append(u"""
<script type="text/javascript">
window.focus();
function save_p()
{
  var o = window.opener.document.getElementById('98');
  window.opener.document.forms['addform'].rel_persons.value=document.forms['searchform'].persons.value;
  if(document.forms['searchform'].person_out)
    o.innerHTML = document.forms['searchform'].person_out.value;
  else
    o.innerHTML = ""
  window.close();
}
</script>
<FORM method="POST" name="searchform" action="%(BASE_CALENDAR_URL)spopup_persons.py">
<input type="hidden" name="persons" value="%(persons)s">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD align="right"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="button" class="input6" name="save" value="%(tls_save)s" onclick="save_p();"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())


    if persons:
      output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="5">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_selected)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b" width="55%%">%(tls_name)s</TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b" width="45%%">%(tls_org)s</TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b">&nbsp;</TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
      if right_param:
        right_param = " AND " + right_param
      REQUEST.db.execute(("""SELECT i.item_name, p.person_id, o.organization_name FROM items i, persons p, organizations o WHERE p.person_id=i.item_id AND p.is_deleted=0 AND o.organization_id=i.parent_id AND p.person_id in (%s) %s order by p.last_name, p.first_name""" % (persons, right_param)).encode('UTF8'))
      res = REQUEST.db.dictfetchall()
      index = 0
      person_out = ""
      for row in res:
        if index%2==0:
          td_class = 0
        else:
          td_class = 1
        index = index + 1
        p_name = row['item_name'].decode('UTF8')
        p_org = row['organization_name'].decode('UTF8')
        p_id = row['person_id']
        person_out = person_out + p_name + "<br>"
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s">%(p_name)s</TD>
  <TD class="td_listing%(td_class)s">%(p_org)s</TD>
  <TD class="td_listing%(td_class)s"><input type="checkbox" name="del_%(p_id)s"></TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      output.append(u"""
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing_noborder" colspan="3"><input type="submit" name="_delete" class="input6" value="%(tls_remove)s"></TD>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<input type="hidden" name="person_out" value="%(person_out)s">""" % locals())
    
    
    words = ''
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      words = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND %s" % right_param
    
    no_list = ""
    if persons:
      no_list = " AND p.person_id not in (%s) " % persons
    search_params = u"""(lower(first_name) like '%%%s%%' or lower(middle_name) like '%%%s%%' or lower(last_name) like '%%%s%%' or lower(username) like '%%%s%%' or lower(e_mail) like '%%%s%%')""" % (words, words, words, words, words)
    
    QUERY = """SELECT count(*) FROM items i, persons p, organizations o WHERE p.person_id=i.item_id AND p.is_deleted=0 AND o.organization_id=i.parent_id %s AND %s %s""" % (no_list, search_params, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%spopup_persons.py%spersons=%s&qs=" % (_Conf.BASE_CALENDAR_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), persons)
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%spopup_persons.py%spersons=%s&qs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CALENDAR_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), persons, REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%spopup_persons.py%spersons=%s&qs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CALENDAR_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), persons, REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    SQL = ("""SELECT i.item_name, p.person_id, o.organization_name FROM items i, persons p, organizations o WHERE p.person_id=i.item_id AND p.is_deleted=0 AND o.organization_id=i.parent_id %s AND %s %s order by p.last_name, p.first_name LIMIT %d OFFSET %d""" % (no_list, search_params, right_param, REQUEST.batch_size, REQUEST.qs)).encode('UTF8')

    REQUEST.db.execute(SQL)
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="5">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_results)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b" width="55%%">%(tls_name)s</TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b" width="45%%">%(tls_org)s</TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b">&nbsp;</TD>
  <TD style="border-top: 1px solid #CCCCCC;" class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    res = REQUEST.db.dictfetchall()
    res = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, x['person_id'], REQUEST.USER.get_id()) > _Access.ACCESS_NONE and x) or None, res))
    index = 0
    for row in res:
      if index%2==0:
        td_class = 0
      else:
        td_class = 1
      index = index + 1
      p_name = row['item_name'].decode('UTF8')
      p_org = row['organization_name'].decode('UTF8')
      p_id = row['person_id']
      output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s">%(p_name)s</TD>
  <TD class="td_listing%(td_class)s">%(p_org)s</TD>
  <TD class="td_listing%(td_class)s"><input type="checkbox" name="sel_%(p_id)s"></TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing_noborder" style="padding: 7px" width="100%%"><input type="submit" name="_add" class="input6" value="%(tls_add)s"></TD>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
