import mx.DateTime
import standard_html
import _Event, _InitTypes, _Conf, _Utils, _Access, _RootObject, _Exceptions
import _calendar, calendar


def index(REQUEST):
    output = []
    try:
        date = _Utils.tuple2datetime(_Utils.isostr2tuple(REQUEST.user2isodatetime(REQUEST, REQUEST.form['date'].value+' 00:00')+':00'))
        date = _Utils.utc2local_mx(REQUEST, date)
        day = date.day
        month = date.month
        year = date.year
    except:
        raise
        date = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
        day = date.day
        month = date.month
        year = date.year
    output.append(standard_html.html_header(REQUEST))
    try:
        sel_users = REQUEST.form['users'].value
    except:
        sel_users = ""
    try:
        sel_groups = REQUEST.form['groups'].value
    except:
        sel_groups = ""
    show_users = sel_users.split(",")
    show_users = filter(None, show_users)
    show_users2 = sel_groups.split(",")
    show_users2 = filter(None, show_users2)
    
    for group in show_users2:
        REQUEST.db.execute("""select members from calendar_groups where group_id=%d""" % int(group))
        dbres = REQUEST.db.fetchone()
        if dbres:
          members = _Utils.sql_parse_array(REQUEST, dbres[0])
          show_users = show_users + members
    
    temp_dict = {}
    for user in show_users:
        if int(user)<>REQUEST.USER.get_id():
            temp_dict[int(user)] = 1
    show_users = temp_dict.keys()
    
    main_list = []
    data = _calendar.DayHandlerUTC(REQUEST, REQUEST.USER.get_id(), year, month, day, "", "")
    data.load(REQUEST)
    for i in range(0,16):
        events = data.active_week[0].events[i][2]
        for event in events:
            for j in range(i+1, 16):
                current = mx.DateTime.DateTime(year, month, day, j+7)
                if event['real_end_stamp'].day_of_year-event['real_start_stamp'].day_of_year == 1 and event['repeat_type'] not in [None, _Event.REPEAT_DAY]:
                    tmp = mx.DateTime.DateTimeDelta(1)
                else:
                    tmp = mx.DateTime.DateTimeDelta(0)
                if not event.has_key('is_clone') and event['end_stamp']+tmp>current:
                    new_event = {}
                    for key in event.keys():
                        new_event[key] = event[key]
                    new_event['is_clone'] = 1
                    data.active_week[0].events[j][2].append(new_event)
    temp_list=['%s' % REQUEST.USER.get_name(), data]
    main_list.append(temp_list)
    for user_id in show_users:
        try:
            REQUEST.su_by_id(int(user_id))
        except:
            continue
        username =  REQUEST.USER.get_name()
        REQUEST.unsu()
        data = _calendar.DayHandlerUTC(REQUEST, int(user_id), year, month, day, "", "")
        data.load(REQUEST)
        for i in range(0,16):
            events = data.active_week[0].events[i][2]
            for event in events:
                for j in range(i+1, 16):
                    current = mx.DateTime.DateTime(year, month, day, j+7)
                    if event['real_end_stamp'].day_of_year-event['real_start_stamp'].day_of_year == 1 and event['repeat_type'] not in [None, _Event.REPEAT_DAY]:
                        tmp = mx.DateTime.DateTimeDelta(1)
                    else:
                        tmp = mx.DateTime.DateTimeDelta(0)
                    if not event.has_key('is_clone') and event['end_stamp']+tmp>current:
                        new_event = {}
                        for key in event.keys():
                            new_event[key] = event[key]
                        new_event['is_clone'] = 1
                        data.active_week[0].events[j][2].append(new_event)
        temp_list=['%s' % username, data]
        main_list.append(temp_list)

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    cday = data.active_week[0]
    tls_dayname = REQUEST.TLS(_Conf.WEEK_DAYS[calendar.weekday(cday.year, cday.month, cday.day)])
    month_name = "%d %s %d" % (cday.day, REQUEST.TLS('month_%d' % cday.month), cday.year)
    prev = mx.DateTime.DateTime(cday.year, cday.month, cday.day)-1
    next = mx.DateTime.DateTime(cday.year, cday.month, cday.day)+1
    prevdate = REQUEST.iso2userdate(prev)
    nextdate = REQUEST.iso2userdate(next)
    tls_prev = REQUEST.TLS('cal_prevday')
    tls_next = REQUEST.TLS('cal_nextday')
    tls_time = REQUEST.TLS('tls_time2')
    tls_status_0 = REQUEST.TLS('cal_showas_0')
    tls_status_1 = REQUEST.TLS('cal_showas_1')
    tls_status_2 = REQUEST.TLS('cal_showas_2')
    tls_status_3 = REQUEST.TLS('cal_showas_3')

    if REQUEST._translator.dateformat == 'en_US_12': # FIXME
        convert_to_12 = 1
    else:
        convert_to_12 = 0

    output.append(u"""
<SCRIPT LANGUAGE = JAVASCRIPT>
window.focus();
if (document.images) 
{
   img1 = new Image();
   img2 = new Image();
   img3 = new Image();
   img4 = new Image();
   img5 = new Image();
   img6 = new Image();
   img7 = new Image();
   img8 = new Image();
   img1.src = "%(BASE_ICON_URL)sstatus_0.png"
   img2.src = "%(BASE_ICON_URL)sstatus_1.png"
   img3.src = "%(BASE_ICON_URL)sstatus_2.png"
   img4.src = "%(BASE_ICON_URL)sstatus_3.png"
   img5.src = "%(BASE_ICON_URL)sstatus_0a.png"
   img6.src = "%(BASE_ICON_URL)sstatus_1a.png"
   img7.src = "%(BASE_ICON_URL)sstatus_2a.png"
   img8.src = "%(BASE_ICON_URL)sstatus_3a.png"
}
function choose_date(date_string, hour)
{
window.opener.document.forms[0].start_stamp_d.value=date_string;
window.opener.document.forms[0].end_stamp_d.value=date_string;
window.opener.document.forms[0].start_stamp_t.selectedIndex=hour*4;
window.opener.document.forms[0].end_stamp_t.selectedIndex=(hour*4)+2;
window.close();
}
</SCRIPT>
<BR>
<TABLE border="0" cellpadding="0" cellspacing="0" width="100%%">
<TR>
  <TD width="50%%" align="right"><A href="%(BASE_CALENDAR_URL)sschedule.py?date=%(prevdate)s&users=%(sel_users)s&groups=%(sel_groups)s"><IMG title="%(tls_prev)s" src="%(BASE_ICON_URL)sarr1.gif" width="11" height="16" border="0" alt=""></A></TD>
  <TD nowrap align="center" style="font-weight: bold; font-size: 16px;">&nbsp;&nbsp;%(tls_dayname)s, %(month_name)s&nbsp;&nbsp;</TD>
  <TD width="50%%" align="left"><A href="%(BASE_CALENDAR_URL)sschedule.py?date=%(nextdate)s&users=%(sel_users)s&groups=%(sel_groups)s"><IMG title="%(tls_next)s" src="%(BASE_ICON_URL)sarr2.gif" width="11" height="16" border="0" alt=""></A></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE border="0" cellpadding="0" cellspacing="0" align="center" style="border-top: 1px solid #AAAAAA;">
<TR class="tr_listing1">
  <TD class="td_listing1b" style="text-align: center; border-left: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-bottom: 1px solid #CCCCCC;">%(tls_time)s</TD>""" % locals())
    for col in main_list:
        output.append(u"""  <TD class="td_listing1b" style="border-right: 1px solid #AAAAAA; border-bottom: 1px solid #CCCCCC;" align="center">%s</TD>"""%col[0])
    output.append(u"""</TR>""")
    for i in range(0, 16):
       tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.DateTime(2001,1,1, main_list[0][1].active_week[0].events[i][0], 0)) # Dummy date
       tmp = REQUEST.iso2userdatetime(REQUEST, tmp).split(' ')[-1]
       output.append(u"""<TR>
  <TD class="td_listing0" style="border-left: 1px solid #CCCCCC; border-right: 1px solid #CCCCCC; border-bottom: 1px solid #CCCCCC;text-align: center;">%s</TD>""" % (tmp))
       for j in range(0, len(main_list)):
           events = main_list[j][1].active_week[0].events[i][2]
           statuses = []
           for event in events:
               statuses.append(int((event['event_activity'] in ['0', '1', '2', '3'] and event['event_activity']) or 2))
           status = max(statuses or [0])
           date_string = REQUEST.iso2userdate(date)
           hour = i+7
           output.append("""  <TD align="center" onmouseover="this.style.backgroundImage='url(%(BASE_ICON_URL)sstatus_%(status)sa.png)';" onmouseout="this.style.backgroundImage='url(%(BASE_ICON_URL)sstatus_%(status)s.png)';" style="cursor: hand; cursor: pointer;background-image: url('%(BASE_ICON_URL)sstatus_%(status)s.png'); border-right: 1px solid #CCCCCC; border-bottom: 1px solid #CCCCCC;" onclick="choose_date('%(date_string)s', '%(hour)s');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="23" border="0" alt=""></TD>""" % locals())
       output.append(u"""</TR>""")
    output.append(u"""
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
</TR>
</TABLE>""")
    output.append(u"""
<TABLE border="0" cellpadding="0" cellspacing="0" align="center">
<TR>
  <TD colspan="11"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="5" border="0" alt=""></TD>
</TR>
<TR>
  <TD style="background-image: url('%(BASE_ICON_URL)sstatus_0.png'); border: 1px solid #AAAAAA"><img src="%(BASE_ICON_URL)sspacer.gif" width="15" height="15" border="0" alt=""></TD>
  <TD>&nbsp;- %(tls_status_0)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sstatus_1.png'); border: 1px solid #AAAAAA"><img src="%(BASE_ICON_URL)sspacer.gif" width="15" height="15" border="0" alt=""></TD>
  <TD>&nbsp;- %(tls_status_1)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sstatus_2.png'); border: 1px solid #AAAAAA"><img src="%(BASE_ICON_URL)sspacer.gif" width="15" height="15" border="0" alt=""></TD>
  <TD>&nbsp;- %(tls_status_2)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sstatus_3.png'); border: 1px solid #AAAAAA"><img src="%(BASE_ICON_URL)sspacer.gif" width="15" height="15" border="0" alt=""></TD>
  <TD>&nbsp;- %(tls_status_3)s</TD>
</TR>
</TABLE>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
