MY_MENU_ID=3
from mod_python import apache

import _Conf, standard_html
from Menus import get_clients_menu
import _Client, _InitTypes, _Utils, urllib, relations, custom_fields

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_clients_menu(REQUEST, MY_MENU_ID))
    
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""
    
    try:
      country_setting = REQUEST.get_setting('client_country')
    except:
      country_setting = ''
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addclient = REQUEST.TLS('clients_add')
    tls_name = REQUEST.TLS('clients_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_number = REQUEST.TLS('clients_number')
    tls_area = REQUEST.TLS('clients_area')
    tls_phone = REQUEST.TLS('clients_phone')
    tls_rating = REQUEST.TLS('clients_rating')
    tls_fax = REQUEST.TLS('clients_fax')
    tls_ownership = REQUEST.TLS('clients_ownership')
    tls_email = REQUEST.TLS('tls_email')
    tls_webpage = REQUEST.TLS('contact_homepage')
    tls_regcode = REQUEST.TLS('clients_regcode')
    tls_kmkr = REQUEST.TLS('clients_kmkr')
    tls_post_address = REQUEST.TLS('clients_post_address')
    tls_reg_address = REQUEST.TLS('clients_reg_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_bank = REQUEST.TLS('clients_bank_info')
    tls_country = REQUEST.TLS('admin_country')
    tls_save = REQUEST.TLS('tls_save')
    client_type = _Utils.make_setting_selection(REQUEST, None, 'client_type', 'client_type', is_multiple=0, selected="", style="textfield4")
    client_field = _Utils.make_setting_selection(REQUEST, None, 'client_field', 'client_field', is_multiple=0, selected="", style="textfield4")
    client_ownership = _Utils.make_setting_selection(REQUEST, None, 'client_ownership', 'client_ownership', is_multiple=0, selected="", style="textfield4")
    client_rating = """<SELECT name="client_rating" class="textfield4"><OPTION value="0"></OPTION><OPTION value="1">1</OPTION><OPTION value="2">2</OPTION><OPTION value="3">3</OPTION><OPTION value="4">4</OPTION><OPTION value="5">5</OPTION></SELECT>"""
    def kala(a,b):
      if countries[a]>countries[b]:
        return 1
      elif countries[a]<countries[b]:
        return -1
      else:
        return 0

    if _Conf.ENABLE_TRANSLATIONBUREAU:
        import _DusConf
        if REQUEST.USER.get_person(REQUEST).get_top_parent().get_id() == _DusConf.TRANSLATION_ORG:
            tls_discount_normal = 'Tavatellimus'
            tls_discount_fast = 'Kiirtellimus'
            tls_discount_spec = 'Spetsiifiline tekst'
            discount_html = u"""
<TR class="tr_listing0">
    <TD align="left" width="100%%" colspan=5>ALLAHINDLUSED</TD>
</TR>
<TR class="tr_listing1">
    <TD class="td_listing1" nowrap>%(tls_discount_normal)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="discount_normal" value="0">%%</TD>
    <TD class="td_listing1" nowrap>%(tls_discount_spec)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="discount_spec" value="0">%%</TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0" nowrap>%(tls_discount_fast)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="discount_fast" value="0">%%</TD>
    <TD class="td_listing0" colspan=2>&nbsp;</TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
""" % locals()
        else: discount_html = u""
    else: discount_html = u""

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.countries_" + user_lang
    countries = eval(clist)
    cout = u"""<select name="country"><option></option>"""
    keys = countries.keys()
    keys.sort(kala)
    for c in keys:
      if country_setting==c:
        sel = " selected"
      else:
        sel = ""
      cout = cout + """<option value="%s"%s>%s</option>""" % (c, sel, countries[c])
    cout = cout + """</select>"""

    c_fields = custom_fields.get_object_search_fields(REQUEST, REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id(), _InitTypes.ITEM_TYPE_CLIENT, 1)
    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if (!document.addform.client_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<FORM name="addform" method="POST" action="%(BASE_CLIENT_URL)sclientadd.py/add" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_18.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_addclient)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="client_name" value=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing1ve">%(client_type)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_number)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="client_nr" value=""></TD>
  <TD class="td_listing0ke">%(tls_area)s:</TD>
  <TD class="td_listing0ve">%(client_field)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_phone)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="telephone" value=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_rating)s:</TD>
  <TD class="td_listing1ve">%(client_rating)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_fax)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="fax"></TD>
  <TD class="td_listing0ke">%(tls_ownership)s:</TD>
  <TD class="td_listing0ve">%(client_ownership)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_email)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="e_mail"></TD>
  <TD class="td_listing1ke" nowrap>%(tls_webpage)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="homepage"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_regcode)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="registry_code" value=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_kmkr)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="vat_nr"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_country)s:</TD>
  <TD class="td_listing1ve" colspan="3">%(cout)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0" valign="top">
  <TD class="td_listing0b" colspan="2">%(tls_post_address)s<BR><TEXTAREA class="textarea6" name="mail_address" rows="4" cols="40"></TEXTAREA></TD>
  <TD class="td_listing0b" colspan="2">%(tls_reg_address)s<BR><TEXTAREA class="textarea6" name="legal_address" rows="4" cols="40"></TEXTAREA></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1" valign="top">
  <TD class="td_listing1b" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="description" rows="8" cols="40"></TEXTAREA></TD>
  <TD class="td_listing1b" colspan="2">%(tls_bank)s<BR><TEXTAREA class="textarea5" name="bank_reqs" rows="8" cols="40"></TEXTAREA></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
%(discount_html)s
%(c_fields)s
<TR class="tr_listing0">
  <TD class="td_listing0" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add(REQUEST):
    output = []
    if REQUEST.form.has_key('client_name') and REQUEST.form['client_name'].value.decode('UTF8').strip():
        client = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_REQ)
        client.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
        client.save()
        client_id = client.get_id()
        custom_fields.save_custom_vals(REQUEST, client_id)

        if _Conf.ENABLE_TRANSLATIONBUREAU:
            import _DusConf
            if REQUEST.USER.get_person(REQUEST).get_top_parent().get_id() == _DusConf.TRANSLATION_ORG:
                if REQUEST.form.has_key('discount_normal'):
                    try:
                        d = int(REQUEST.form['discount_normal'])
                        REQUEST._settings.set_setting_org(REQUEST, "discount_n:%d" % client_id, 100-d)
                    except:
                        raise
                if REQUEST.form.has_key('discount_spec'):
                    try:
                        d = int(REQUEST.form['discount_spec'])
                        REQUEST._settings.set_setting_org(REQUEST, "discount_s:%d" % client_id, 100-d)
                    except:
                        pass
                if REQUEST.form.has_key('discount_fast'):
                    try:
                        d = int(REQUEST.form['discount_fast'])
                        REQUEST._settings.set_setting_org(REQUEST, "discount_f:%d" % client_id, 100-d)
                    except:
                        pass

        if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
          rel_id = int(REQUEST.form['rel_id'].value)
          relations.add_relation(REQUEST, rel_id, client_id)
        if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
            REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
            return apache.HTTP_MOVED_TEMPORARILY
        output.append(standard_html.html_header(REQUEST))
        ref_url = _Conf.BASE_CLIENT_URL + 'clientedit.py?client_id=%s' % client_id
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_clients_menu(REQUEST, MY_MENU_ID))
        output.append(REQUEST.TLS('client_saved'))
        REQUEST.set_setting('client_country', REQUEST.form['country'].value.decode('UTF8'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
