import standard_html
import _InitTypes, _Conf, _Utils, Menus, _RootObject
import _Client, _RootObject, _Access, _Log, _Usernote, _Exceptions
import relations, custom_fields
import mx.DateTime
import urllib
import cStringIO
from mod_python import util
from mod_python import apache
import psycopg

MY_MENU_ID = -1

def index(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    client_id = REQUEST.form['client_id'].value
    if REQUEST.form.has_key('_edit'):
        return edit_contents(REQUEST)
    elif REQUEST.form.has_key('_delete'):
      client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))
      try:
          client_obj.delete()
      except _Exceptions.AccessError:
          raise
      except:
          raise RuntimeError, REQUEST.TLS('tls_clientdel_opp')
      REQUEST.mod_req.headers_out["Location"] = "%sclients.py?showmine=1" % (_Conf.BASE_CLIENT_URL)
      return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('contacts'):
        return contact_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['client_id'].value)
    elif REQUEST.form.has_key('reports'):
        return show_reports(REQUEST)
    
    
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))

    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD

    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))


    client_id = client_obj.get_id()
    client_name = _Utils.html_quote(client_obj.get('client_name'))
    client_type = _Utils.html_quote(client_obj.get('client_type')) or '&nbsp;'
    client_nr = _Utils.html_quote(client_obj.get('client_nr')) or '&nbsp;'
    client_field = _Utils.html_quote(client_obj.get('client_field')) or '&nbsp;'
    telephone = _Utils.html_quote(client_obj.get('telephone')) or '&nbsp;'
    client_rating = client_obj.get('client_rating')
    if client_rating:
        try:
            numb=int(client_rating)
        except:
            numb=0
        if numb:
            ratestr = """<img src="%(BASE_ICON_URL)sstar.gif" width="13" height="13" border="0" alt="">""" % locals()
            client_rating = ''
            for i in range(0, numb):
                client_rating += ratestr
        else:
            client_rating='&nbsp;'
    else:
        client_rating='&nbsp;'
    fax = _Utils.html_quote(client_obj.get('fax')) or '&nbsp;'
    client_ownership = _Utils.html_quote(client_obj.get('client_ownership') or '') or '&nbsp;'
    e_mail = _Utils.html_quote(client_obj.get('e_mail')) or ''
    if e_mail:
        e_mail = """<a href="%scompose.py?mail_to=%s%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, client_name, e_mail, e_mail)
    else:
        e_mail = "&nbsp;"
    homepage = _Utils.html_quote(client_obj.get('homepage'))
    if homepage[:4]=="http":
        homepage = """<a href="%s" target="_blank">%s</a>""" % (homepage, homepage)
    elif homepage[:3]=="www":
        homepage = """<a href="http://%s" target="_blank">%s</a>""" % (homepage, homepage)

    registry_code = _Utils.html_quote(client_obj.get('registry_code')) or '&nbsp;'
    vat_nr = _Utils.html_quote(client_obj.get('vat_nr')) or '&nbsp;'
    country = client_obj.get('country')
    if country:
        user_lang=REQUEST.get_setting("user_language")
        clist = "_Conf.countries_" + user_lang
        countries = eval(clist)
        country = countries[country]
    else:
        country = "&nbsp;"
    mail_address = _Utils.newline2br(_Utils.html_quote(client_obj.get('mail_address'))) or '&nbsp;'
    legal_address = _Utils.newline2br(_Utils.html_quote(client_obj.get('legal_address'))) or '&nbsp;'
    description = _Utils.newline2br(_Utils.html_quote(client_obj.get('description'))) or '&nbsp;'
    bank_reqs = _Utils.newline2br(_Utils.html_quote(client_obj.get('bank_reqs'))) or '&nbsp;'
    
    
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_viewclient = REQUEST.TLS('clients_view')
    tls_name = REQUEST.TLS('clients_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_number = REQUEST.TLS('clients_number')
    tls_area = REQUEST.TLS('clients_area')
    tls_phone = REQUEST.TLS('clients_phone')
    tls_rating = REQUEST.TLS('clients_rating')
    tls_fax = REQUEST.TLS('clients_fax')
    tls_ownership = REQUEST.TLS('clients_ownership')
    tls_email = REQUEST.TLS('tls_email')
    tls_webpage = REQUEST.TLS('contact_homepage')
    tls_regcode = REQUEST.TLS('clients_regcode')
    tls_kmkr = REQUEST.TLS('clients_kmkr')
    tls_post_address = REQUEST.TLS('clients_post_address')
    tls_reg_address = REQUEST.TLS('clients_reg_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_bank = REQUEST.TLS('clients_bank_info')
    tls_country = REQUEST.TLS('admin_country')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_delete = REQUEST.TLS('admin_delete')
    tls_confirm_del = REQUEST.TLS('tls_confirm_del')


    if _Conf.ENABLE_TRANSLATIONBUREAU:
        import _DusConf
        if REQUEST.USER.get_person(REQUEST).get_top_parent().get_id() == _DusConf.TRANSLATION_ORG:
            try:    discount_normal = -1 * (REQUEST.get_setting("discount_n:%d" % client_id) - 100)
            except: discount_normal = 0
            try:    discount_spec = -1 * (REQUEST.get_setting("discount_s:%d" % client_id) - 100)
            except: discount_spec = 0
            try:    discount_fast = -1 * (REQUEST.get_setting("discount_f:%d" % client_id) - 100)
            except: discount_fast = 0
            tls_discount_normal = 'Tavatellimus'
            tls_discount_fast = 'Kiirtellimus'
            tls_discount_spec = 'Spetsiifiline tekst'
            discount_html = u"""
<TR class="tr_listing0" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TH align="left" width="100%%" colspan=5>ALLAHINDLUSED</TD>
</TR>
<TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b">%(tls_discount_normal)s:</TD>
    <TD class="td_listing1">%(discount_normal)s&nbsp;%%</TD>
    <TD class="td_listing1b">%(tls_discount_spec)s:</TD>
    <TD class="td_listing1">%(discount_spec)s&nbsp;%%</TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0b">%(tls_discount_fast)s:</TD>
    <TD class="td_listing0">%(discount_fast)s&nbsp;%%</TD>
    <TD class="td_listing0b" colspan=2>&nbsp;</TD>
  </TR>""" % locals()
        else: discount_html = u""
    else: discount_html = u""


    if _Access.get_item_right(REQUEST, client_obj.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        save_html = u"""
  <TR class="tr_listing0">
    <TD class="td_listing0" colspan="2"><INPUT type="submit" name="_edit" value="%(tls_edit)s" class="input2"></TD>
    <TD class="td_listing0" colspan="2" align="right"><INPUT type="submit" name="_delete" value="%(tls_delete)s" class="input2" onClick="return confirm('%(tls_confirm_del)s');">&nbsp;&nbsp;</TD>
    <TD class="td_listing0"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>""" % locals()
    else:
        save_html = u""

    c_fields = custom_fields.get_object_show_fields(REQUEST, client_obj, 1)
    menu = menu_output(REQUEST, client_obj)
    output.append("""
<FORM name="editform" method="POST" action="%(BASE_CLIENT_URL)sclientedit.py">
<INPUT type="hidden" name="client_id" value="%(client_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
  %(menu)s
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=125 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=225 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=125 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=225 height=1 border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1kv" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1vv"  nowrap>%(client_name)s</TD>
  <TD class="td_listing1kv" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing1vv"  nowrap>%(client_type)s</TD>
  <TD class="td_listing1"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0kv" nowrap>%(tls_number)s:</TD>
  <TD class="td_listing0vv"  nowrap>%(client_nr)s&nbsp;</TD>
  <TD class="td_listing0kv" nowrap>%(tls_area)s:</TD>
  <TD class="td_listing0vv"  nowrap>%(client_field)s&nbsp;</TD>
  <TD class="td_listing0"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1kv" nowrap>%(tls_phone)s:</TD>
  <TD class="td_listing1vv"  nowrap>%(telephone)s&nbsp;</TD>
  <TD class="td_listing1kv" nowrap>%(tls_rating)s:</TD>
  <TD class="td_listing1vv"  nowrap>%(client_rating)s&nbsp;</TD>
  <TD class="td_listing1"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0kv" nowrap>%(tls_fax)s:</TD>
  <TD class="td_listing0vv"  nowrap>%(fax)s&nbsp;</TD>
  <TD class="td_listing0kv" nowrap>%(tls_ownership)s:</TD>
  <TD class="td_listing0vv"  nowrap>%(client_ownership)s&nbsp;</TD>
  <TD class="td_listing0"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1kv" nowrap>%(tls_email)s:</TD>
  <TD class="td_listing1vv"  nowrap>%(e_mail)s&nbsp;</TD>
  <TD class="td_listing1kv" nowrap>%(tls_webpage)s:</TD>
  <TD class="td_listing1vv"  nowrap>%(homepage)s&nbsp;</TD>
  <TD class="td_listing1"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0kv" nowrap>%(tls_regcode)s:</TD>
  <TD class="td_listing0vv"  nowrap>%(registry_code)s&nbsp;</TD>
  <TD class="td_listing0kv" nowrap>%(tls_kmkr)s:</TD>
  <TD class="td_listing0vv"  nowrap>%(vat_nr)s&nbsp;</TD>
  <TD class="td_listing0"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1kv" nowrap>%(tls_country)s:</TD>
  <TD class="td_listing1vv"  nowrap colspan="3">%(country)s&nbsp;</TD>
  <TD class="td_listing1"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0" valign="top">
  <TD class="td_listing0kv" nowrap>%(tls_post_address)s:</TD>
  <TD class="td_listing0">%(mail_address)s&nbsp;</TD>
  <TD class="td_listing0kv" nowrap>%(tls_reg_address)s:</TD>
  <TD class="td_listing0">%(legal_address)s&nbsp;</TD>
  <TD class="td_listing0"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1" valign="top">
  <TD class="td_listing1kv" nowrap>%(tls_description)s:</TD>
  <TD class="td_listing1">%(description)s&nbsp;</TD>
  <TD class="td_listing1kv" nowrap>%(tls_bank)s:</TD>
  <TD class="td_listing1">%(bank_reqs)s&nbsp;</TD>
  <TD class="td_listing1"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
</TR>
%(discount_html)s
%(c_fields)s
%(save_html)s
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_contents(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))
    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))
    menu = menu_output(REQUEST, client_obj)

    client_id = client_obj.get_id()
    client_name = _Utils.html_quote(client_obj.get('client_name'))
    client_type = _Utils.html_quote(client_obj.get('client_type') or '')
    client_nr = _Utils.html_quote(client_obj.get('client_nr') or '')
    client_field = _Utils.html_quote(client_obj.get('client_field') or '')
    telephone = _Utils.html_quote(client_obj.get('telephone') or '')
    client_rating = client_obj.get('client_rating') or ''
    fax = _Utils.html_quote(client_obj.get('fax') or '')
    client_ownership = _Utils.html_quote(client_obj.get('client_ownership') or '')
    e_mail = _Utils.html_quote(client_obj.get('e_mail') or '')
    homepage = _Utils.html_quote(client_obj.get('homepage') or '')
    registry_code = _Utils.html_quote(client_obj.get('registry_code') or '')
    vat_nr = _Utils.html_quote(client_obj.get('vat_nr') or '')
    country = _Utils.html_quote(client_obj.get('country') or '')
    mail_address = _Utils.html_quote(client_obj.get('mail_address') or '')
    legal_address = _Utils.html_quote(client_obj.get('legal_address') or '')
    description = _Utils.html_quote(client_obj.get('description') or '')
    bank_reqs = _Utils.html_quote(client_obj.get('bank_reqs') or '')

    client_type = _Utils.make_setting_selection(REQUEST, None, 'client_type', 'client_type', is_multiple=0, selected=client_type, style="textfield4")
    client_field = _Utils.make_setting_selection(REQUEST, None, 'client_field', 'client_field', is_multiple=0, selected=client_field, style="textfield4")
    client_ownership = _Utils.make_setting_selection(REQUEST, None, 'client_ownership', 'client_ownership', is_multiple=0, selected=client_ownership, style="textfield4")
    client_rt = u"""<SELECT name="client_rating" class="textfield4"><OPTION value="0"></OPTION>"""
    for i in range(1, 6):
      if i==client_rating:
        sel = " selected"
      else:
        sel = ""
      client_rt += """<OPTION value="%s"%s>%s</OPTION>""" % (i, sel, i)
    client_rating = client_rt + """</SELECT>"""

    def kala(a,b):
      if countries[a]>countries[b]:
        return 1
      elif countries[a]<countries[b]:
        return -1
      else:
        return 0

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.countries_" + user_lang
    countries = eval(clist)
    cout = u"""<select name="country"><option></option>"""
    keys = countries.keys()
    keys.sort(kala)
    for c in keys:
      if country==c:
        sel = " selected"
      else:
        sel = ""
      cout = cout + """<option value="%s"%s>%s</option>""" % (c, sel, countries[c])
    cout = cout + """</select>"""

    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addclient = REQUEST.TLS('clients_add')
    tls_name = REQUEST.TLS('clients_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_number = REQUEST.TLS('clients_number')
    tls_area = REQUEST.TLS('clients_area')
    tls_phone = REQUEST.TLS('clients_phone')
    tls_rating = REQUEST.TLS('clients_rating')
    tls_fax = REQUEST.TLS('clients_fax')
    tls_ownership = REQUEST.TLS('clients_ownership')
    tls_email = REQUEST.TLS('tls_email')
    tls_webpage = REQUEST.TLS('contact_homepage')
    tls_regcode = REQUEST.TLS('clients_regcode')
    tls_kmkr = REQUEST.TLS('clients_kmkr')
    tls_post_address = REQUEST.TLS('clients_post_address')
    tls_reg_address = REQUEST.TLS('clients_reg_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_bank = REQUEST.TLS('clients_bank_info')
    tls_country = REQUEST.TLS('admin_country')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_save = REQUEST.TLS('tls_save')

    if _Conf.ENABLE_TRANSLATIONBUREAU:
        import _DusConf
        if REQUEST.USER.get_person(REQUEST).get_top_parent().get_id() == _DusConf.TRANSLATION_ORG:
            try:    discount_normal = -1 * (REQUEST.get_setting("discount_n:%d" % client_id) - 100)
            except: discount_normal = 0
            try:    discount_spec = -1 * (REQUEST.get_setting("discount_s:%d" % client_id) - 100)
            except: discount_spec = 0
            try:    discount_fast = -1 * (REQUEST.get_setting("discount_f:%d" % client_id) - 100)
            except: discount_fast = 0
            tls_discount_normal = 'Tavatellimus'
            tls_discount_fast = 'Kiirtellimus'
            tls_discount_spec = 'Spetsiifiline tekst'
            discount_html = u"""  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TH align="left" width="100%%" colspan=5>ALLAHINDLUSED</TD>
</TR>
<TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_discount_normal)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="discount_normal" value="%(discount_normal)s">%%</TD>
    <TD class="td_listing1" nowrap>%(tls_discount_spec)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="discount_spec" value="%(discount_spec)s">%%</TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_discount_fast)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="discount_fast" value="%(discount_fast)s">%%</TD>
    <TD class="td_listing0" colspan=2>&nbsp;</TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
""" % locals()
        else: discount_html = u""
    else: discount_html = u""

    c_fields = custom_fields.get_object_edit_fields(REQUEST, client_obj, 1)

    output.append("""\
<script type="text/javascript">
<!--
  function check_values()
  {
    if (!document.editform.client_name.value || !document.editform.client_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->   
</SCRIPT>
<FORM name="editform" method="POST" action="%(BASE_CLIENT_URL)sclientedit.py/edit" onsubmit="return check_values();">
<INPUT type="hidden" name="client_id" value="%(client_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
  %(menu)s
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="client_name" value="%(client_name)s"></TD>
  <TD class="td_listing1ke" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing1ve">%(client_type)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_number)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="client_nr" value="%(client_nr)s"></TD>
  <TD class="td_listing0ke">%(tls_area)s:</TD>
  <TD class="td_listing0ve">%(client_field)s</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_phone)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="telephone" value="%(telephone)s"></TD>
  <TD class="td_listing1ke" nowrap>%(tls_rating)s:</TD>
  <TD class="td_listing1ve">%(client_rating)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_fax)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="fax" value="%(fax)s"></TD>
  <TD class="td_listing0ke">%(tls_ownership)s:</TD>
  <TD class="td_listing0ve">%(client_ownership)s</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_email)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="e_mail" value="%(e_mail)s"></TD>
  <TD class="td_listing1ke" nowrap>%(tls_webpage)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="homepage" value="%(homepage)s"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_regcode)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="registry_code" value="%(registry_code)s"></TD>
  <TD class="td_listing0ke" nowrap>%(tls_kmkr)s:</TD>
  <TD class="td_listing0ve"><INPUT type="text" class="textfield4" name="vat_nr" value="%(vat_nr)s"></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_country)s:</TD>
  <TD class="td_listing1ve" colspan="3">%(cout)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0" valign="top">
  <TD class="td_listing0b" colspan="2">%(tls_post_address)s<BR><TEXTAREA class="textarea6" name="mail_address" rows="4" cols="40">%(mail_address)s</TEXTAREA></TD>
  <TD class="td_listing0b" colspan="2">%(tls_reg_address)s<BR><TEXTAREA class="textarea6" name="legal_address" rows="4" cols="40">%(legal_address)s</TEXTAREA></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1" valign="top">
  <TD class="td_listing1b" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="description" rows="8" cols="40">%(description)s</TEXTAREA></TD>
  <TD class="td_listing1b" colspan="2">%(tls_bank)s<BR><TEXTAREA class="textarea5" name="bank_reqs" rows="8" cols="40">%(bank_reqs)s</TEXTAREA></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
%(discount_html)s
%(c_fields)s
<TR class="tr_listing0">
  <TD class="td_listing0" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
<BR>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = _Conf.BASE_CLIENT_URL + 'clientedit.py?client_id=%s' % REQUEST.form['client_id'].value
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))

    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))

    if not REQUEST.form.has_key('client_name') or not REQUEST.form['client_name'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    if _Conf.ENABLE_TRANSLATIONBUREAU:
        import _DusConf
        if REQUEST.USER.get_person(REQUEST).get_top_parent().get_id() == _DusConf.TRANSLATION_ORG:
            if REQUEST.form.has_key('discount_normal'):
                try:
                    d = int(REQUEST.form['discount_normal'])
                    REQUEST._settings.set_setting_org(REQUEST, "discount_n:%d" % client_obj.get_id(), 100-d)
                except:
                    pass
            if REQUEST.form.has_key('discount_spec'):
                try:
                    d = int(REQUEST.form['discount_spec'])
                    REQUEST._settings.set_setting_org(REQUEST, "discount_s:%d" % client_obj.get_id(), 100-d)
                except:
                    pass
            if REQUEST.form.has_key('discount_fast'):
                try:
                    d = int(REQUEST.form['discount_fast'])
                    REQUEST._settings.set_setting_org(REQUEST, "discount_f:%d" % client_obj.get_id(), 100-d)
                except:
                    pass

    client_obj.load_req()
    client_obj.save()
    custom_fields.save_custom_vals(REQUEST, client_obj.get_id())

    output.append(REQUEST.TLS('client_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def relations_contents(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    client_id = REQUEST.form['client_id'].value
    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, client_obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    relation_output = relations.show_relations(REQUEST, client_obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['client_id'].value)
    obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    menu = u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals()
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    returl = "%(BASE_CLIENT_URL)sclientedit.py?client_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "clients"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def contact_contents(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    client_id = REQUEST.form['client_id'].value
    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    tls_edit = REQUEST.TLS('tls_edit')
    tls_name = REQUEST.TLS('tls_name')
    tls_company = REQUEST.TLS('contact_company')
    tls_email = REQUEST.TLS('tls_email')
    tls_phone = REQUEST.TLS('tls_phone_work')
    tls_cell = REQUEST.TLS('tls_phone_cell')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, client_obj)
    SQL = """SELECT ir.*, c.* FROM item_rels ir, items i, items i2, contacts c WHERE ((i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d AND i2.item_type_id = %d) OR (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d AND i2.item_type_id = %d)) AND i2.item_id=c.contact_id order by c.last_name, c.first_name""" % (client_obj.get_id(), _InitTypes.ITEM_TYPE_CONTACT, client_obj.get_id(), _InitTypes.ITEM_TYPE_CONTACT)
    REQUEST.db.execute(SQL)
    dbres = REQUEST.db.dictfetchall()
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
  %(menu)s
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="post" action="%(BASE_CLIENT_URL)sclientedit.py/edit_contacts">
<INPUT type="hidden" name="client_id" value="%(client_id)s"
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">%(tls_name)s</TD>
  <TD class="td_listing1b">%(tls_company)s</TD>
  <TD class="td_listing1b">%(tls_email)s</TD>
  <TD class="td_listing1b">%(tls_phone)s</TD>
  <TD class="td_listing1b">%(tls_cell)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    index = 0
    for item in dbres:
        item['class_type'] = index % 2
        index += 1
        item['BASE_CONTACT_URL'] = _Conf.BASE_CONTACT_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        if item['company'] is None: item['company'] = ""
        else: item['company'] = item['company'].decode('UTF8')
        if item['e_mail'] is None: item['e_mail'] = ""
        else: item['e_mail'] = item['e_mail'].decode('UTF8')
        if item['phone_work'] is None: item['phone_work'] = ""
        else: item['phone_work'] = item['phone_work'].decode('UTF8')
        if item['phone_cell'] is None: item['phone_cell'] = ""
        else: item['phone_cell'] = item['phone_cell'].decode('UTF8')
        item['first_name'] = item['first_name'].decode('UTF8')
        item['last_name'] = item['last_name'].decode('UTF8')
        output.append(u"""
<TR>
  <TD width="1%%"  class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD width="29%%" class="td_listing%(class_type)d" nowrap><A class="td_listing" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)d">%(first_name)s&nbsp;%(last_name)s</A></TD>
  <TD width="29%%" class="td_listing%(class_type)d">%(company)s</TD>
  <TD width="15%%" class="td_listing%(class_type)d">%(e_mail)s</TD>
  <TD width="15%%" class="td_listing%(class_type)d">%(phone_work)s</TD>
  <TD width="15%%" class="td_listing%(class_type)d">%(phone_cell)s</TD>
  <TD width="1%%"  class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % item)
    class_type=index%2
    if _Access.get_item_right(REQUEST, client_obj.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" colspan="5"><INPUT type="submit" value="%(tls_edit)s" class="input2"></TD>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    output.append(u"""
</TABLE>
</FORM>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_contacts(REQUEST):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    output=[]
    fp = cStringIO.StringIO('1')
    asd = util.Field("contacts", fp, "", "", "", "")
    REQUEST.form.list.append(asd)
    client_id = int(REQUEST.form['client_id'].value)
    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, client_obj)

    SQL = """SELECT ir.*, c.* FROM item_rels ir, items i, items i2, contacts c WHERE ((i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d AND i2.item_type_id = %d) OR (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d AND i2.item_type_id = %d)) AND i2.item_id=c.contact_id order by c.last_name, c.first_name""" % (client_obj.get_id(), _InitTypes.ITEM_TYPE_CONTACT, client_obj.get_id(), _InitTypes.ITEM_TYPE_CONTACT)
    REQUEST.db.execute(SQL)
    dbres = REQUEST.db.dictfetchall()

    
    persons = ""
    if REQUEST.form.has_key('persons') and REQUEST.form['persons'].value:
      persons = REQUEST.form['persons'].value
    else:
      for item in dbres:
        persons = persons + "," + str(item['contact_id'])
      if persons:
        persons = persons[1:]

    if REQUEST.form.has_key('_save'):
        SQL = """SELECT ir.* FROM item_rels ir, items i, items i2 WHERE ((i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d AND i2.item_type_id = %d) OR (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d AND i2.item_type_id = %d))""" % (int(client_id), _InitTypes.ITEM_TYPE_CONTACT, int(client_id), _InitTypes.ITEM_TYPE_CONTACT)
        REQUEST.db.execute(SQL)
        dbres = REQUEST.db.dictfetchall()
        for item in dbres:
            REQUEST.db.execute("""DELETE from item_rels where left_item_id=%s and right_item_id=%s""" % (item['left_item_id'], item['right_item_id']))
        p_list = persons.split(",")
        for person_id in p_list:
            relations.add_relation(REQUEST, int(person_id), int(client_id))
            obj1 = _RootObject.dispatch_item(REQUEST, int(person_id))
            obj2 = _RootObject.dispatch_item(REQUEST, int(client_id))
            obj1.set('company', obj2.get('item_name'))
            obj1.save()
        REQUEST.mod_req.headers_out["Location"] = "%sclientedit.py?client_id=%s&contacts=1" % (_Conf.BASE_CLIENT_URL, client_id)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('_delete'):
        p_list = persons.split(",")
        for person_id in p_list:
            REQUEST.db.execute("""DELETE from item_rels where left_item_id=%s and right_item_id=%s""" % (client_id, int(person_id)))
            REQUEST.db.execute("""DELETE from item_rels where left_item_id=%s and right_item_id=%s""" % (int(person_id), client_id))

    if REQUEST.form.has_key('_add'):
      del_ids = {}
      for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
          del_ids[str(key[4:])] = 1
          persons = persons + "," + str(key[4:])
      # 2 remove dupes
      dic1 = {}
      p_list = persons.split(",")
      for p in p_list:
        if not dic1.has_key(p):
          dic1[p] = 1
      persons = ""
      for key in dic1.keys():
        persons = persons + "," + key
    
    if REQUEST.form.has_key('_delete'):
      del_ids = {}
      for key in REQUEST.form.keys():
        if key[:4] == 'del_':
          del_ids[str(key[4:])] = 1
      p_list = persons.split(",")
      dic1 = {}
      for p in p_list:
        if not(dic1.has_key(p) or del_ids.has_key(p)):
          dic1[p] = 1
      persons = ""
      for key in dic1.keys():
        persons = persons + "," + key
    persons = persons.replace(",,",",")
    if persons and persons[0]==",":
      if len(persons)>1:
        persons = persons[1:]
      else:
        persons=""

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    tls_search = REQUEST.TLS('tls_search')
    tls_save = REQUEST.TLS('tls_save_close')
    tls_selected = REQUEST.TLS('tls_selected')
    tls_name = REQUEST.TLS('tls_name')
    tls_org = REQUEST.TLS('contact_company')
    tls_remove = REQUEST.TLS('tls_remove_sel')
    tls_results = REQUEST.TLS('cal_choose_persons')
    tls_add = REQUEST.TLS('tls_add')
    tls_related = REQUEST.TLS('client_related_contacts') %  _Utils.html_quote_show(client_obj.get('item_name'))

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" name="searchform" action="%(BASE_CLIENT_URL)sclientedit.py/edit_contacts">
<input type="hidden" name="persons" value="%(persons)s">
<input type="hidden" name="client_id" value="%(client_id)s">
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="4">%(tls_related)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap align="center"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD class="td_listing0" nowrap><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="submit" class="input6" name="_save" value="%(tls_save)s"></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    if persons:
      output.append(u"""
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_selected)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b">&nbsp;</TD>
  <TD class="td_listing1b" nowrap>%(tls_name)s</TD>
  <TD class="td_listing1b" nowrap>%(tls_org)s</TD>
  <TD class="td_listing1b" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
      if right_param:
        right_param = " AND " + right_param
      REQUEST.db.execute(("""SELECT i.item_name, c.contact_id, c.company FROM items i, contacts c WHERE c.contact_id=i.item_id AND c.contact_id in (%s) %s order by c.last_name, c.first_name""" % (persons, right_param)).encode('UTF8'))
      res = REQUEST.db.dictfetchall()
      index = 0
      person_out = ""
      for row in res:
        if index%2==0:
          td_class = 0
        else:
          td_class = 1
        index = index + 1
        p_name = (row['item_name'] or "&nbsp").decode('UTF8')
        p_org = (row['company'] or "&nbsp").decode('UTF8')
        p_id = row['contact_id']
        person_out = person_out + p_name + "<br>"
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s" nowrap><input type="checkbox" name="del_%(p_id)s"></TD>
  <TD class="td_listing%(td_class)s" nowrap>%(p_name)s</TD>
  <TD class="td_listing%(td_class)s" nowrap>%(p_org)s</TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      output.append(u"""
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="3"><input type="submit" name="_delete" class="input2" value="%(tls_remove)s"></TD>
</TR>
</TABLE>
<input type="hidden" name="person_out" value="%(person_out)s">""" % locals())
    
    
    words = ''
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      words = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND %s" % right_param
    
    no_list = ""
    if persons:
      no_list = " AND c.contact_id not in (%s) " % persons
    search_params = u"""(lower(first_name) like '%%%s%%' or lower(middle_name) like '%%%s%%' or lower(last_name) like '%%%s%%' or lower(company) like '%%%s%%' or lower(e_mail) like '%%%s%%' or lower(description) like '%%%s%%')""" % (words, words, words, words, words, words)

    QUERY  = """SELECT count(*) AS count_all FROM items i, contacts c WHERE c.contact_id=i.item_id %s AND %s %s""" % (no_list, search_params, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sclientedit.py/edit_contacts%sqs=" % (_Conf.BASE_CLIENT_URL, REQUEST.get_formstring(['qs', 'contacts']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sclientedit.py/edit_contacts%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CLIENT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sclientedit.py/edit_contacts%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CLIENT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = None

    SQL = """SELECT i.item_name, c.contact_id, c.company FROM items i, contacts c WHERE c.contact_id=i.item_id %s AND %s %s order by c.last_name, c.first_name  LIMIT %d OFFSET %d""" % (no_list, search_params, right_param, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    output.append(u"""
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_results)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b">&nbsp;</TD>
  <TD class="td_listing1b" nowrap>%(tls_name)s</TD>
  <TD class="td_listing1b" nowrap>%(tls_org)s</TD>
  <TD class="td_listing1b" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
      if index%2==0:
        td_class = 0
      else:
        td_class = 1
      index = index + 1
      p_name = (row['item_name'] or "&nbsp").decode('UTF8')
      p_org = (row['company'] or "&nbsp").decode('UTF8')
      p_id = row['contact_id']
      output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><input type="checkbox" name="sel_%(p_id)s"></TD>
  <TD class="td_listing%(td_class)s" nowrap>%(p_name)s</TD>
  <TD class="td_listing%(td_class)s" nowrap>%(p_org)s</TD>
  <TD class="td_listing%(td_class)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    if FULL_BAR:
        output.append(u"""
<TR>
  <TD class="td_listing0" colspan="4">%(FULL_BAR)s</TD>
</TR>
        """ % locals())
    output.append(u"""
<TR>
  <TD class="td_listing0" colspan="3"><input type="submit" name="_add" class="input2" value="%(tls_add)s">&nbsp;<input type="submit" class="input6" name="_save" value="%(tls_save)s"></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
<BR>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, client_obj):
    if not REQUEST.form.has_key('client_id') or not REQUEST.form['client_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    client_id = int(REQUEST.form['client_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL

    tls_viewclient = REQUEST.TLS('clients_view')
    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_contacts = REQUEST.TLS('topmenu_contacts')
    tls_log = REQUEST.TLS('log_log')
    relations_count = relations.relations_count(REQUEST, client_obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (client_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]
    SQL = """SELECT count(*) FROM item_rels ir, items i, items i2, contacts c WHERE ((i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d AND i2.item_type_id = %d) OR (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d AND i2.item_type_id = %d)) AND i2.item_id=c.contact_id""" % (client_id, _InitTypes.ITEM_TYPE_CONTACT, client_id, _InitTypes.ITEM_TYPE_CONTACT)
    REQUEST.db.execute(SQL)
    contact_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('contacts'):
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&contacts=1">%(tls_contacts)s <span class="efoldercount">(%(contact_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&contacts=1">%(tls_contacts)s <span class="efoldercount">(%(contact_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()

    tls_object = REQUEST.TLS('log_client_id')
    object_name =  _Utils.html_quote_show(client_obj.get('item_name'))
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, client_obj.get('item_type_id')))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)


def show_log(REQUEST, obj_id):
    client_id = obj_id
    client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['client_id'].value))
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_clients_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, client_obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


