MY_MENU_ID_MY=0
MY_MENU_ID=1

import _Conf, standard_html
from Menus import get_clients_menu
import _Access, _InitTypes, _Utils

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('showmine'):
        output.append(get_clients_menu(REQUEST, MY_MENU_ID_MY))
    else:
        output.append(get_clients_menu(REQUEST, MY_MENU_ID))

    if REQUEST.form.has_key('let') and REQUEST.form['let'].decode('UTF8').strip():
        letter = REQUEST.form['let'].decode('UTF8').strip()
    else:
        letter = 0
    if REQUEST.form.has_key('client_type') and REQUEST.form['client_type'].decode('UTF8').strip():
        cl_string = " AND c.client_type='%s'" % REQUEST.form['client_type'].decode('UTF8').strip()
    else:
        cl_string = ""
    
    filter = ""
    search_params = ""
    if REQUEST.form.has_key('filter') and REQUEST.form['filter'].value.decode('UTF8').strip():
        filter = REQUEST.form['filter'].value.decode('UTF8').strip()
        w = _Utils.sql_quote_simple(REQUEST.form['filter'].value.decode('UTF8').strip().lower())
        w2 = _Utils.sql_quote_simple(REQUEST.form['filter'].value.decode('UTF8').strip())
        if len(w)>=3:
            search_params = u""" AND i.item_id in (SELECT item_id FROM fti_search WHERE word = '%s' and fti_type=true)""" % w
        else:
           search_params = u""" AND (
lower(c.client_name) like '%%%s%%' OR 
c.client_type = '%s' OR 
lower(c.client_nr) like '%%%s%%' OR 
c.client_field = '%s' OR 
lower(c.telephone) like '%%%s%%' OR 
lower(c.fax) like '%%%s%%' OR 
c.client_ownership = '%s' OR 
lower(c.e_mail) like '%%%s%%' OR 
lower(c.homepage) like '%%%s%%' OR 
lower(c.registry_code) like '%%%s%%' OR 
lower(c.vat_nr) like '%%%s%%' OR 
c.country = '%s' OR 
lower(c.mail_address) like '%%%s%%' OR 
lower(c.legal_address) like '%%%s%%' OR
lower(c.description) like '%%%s%%' OR 
lower(c.bank_reqs) like '%%%s%%')""" % (w, w2, w, w2, w, w, w2, w, w, w, w, w2, w, w, w, w)


    tls_name = REQUEST.TLS('clients_name')
    tls_field = REQUEST.TLS('clients_area')
    tls_rating = REQUEST.TLS('clients_rating')
    tls_telephone = REQUEST.TLS('clients_phone')
    tls_homepage = REQUEST.TLS('contact_homepage')
    tls_creator = REQUEST.TLS('client_owner')
    tls_email = REQUEST.TLS('tls_email')

    if REQUEST.form.has_key('showmine'):
        sortby = [
'client_name ASC', 'client_name DESC',
'client_field ASC, client_name ASC', 'client_field DESC, client_name ASC',
'client_rating ASC, client_name ASC', 'client_rating DESC, client_name ASC',
'telephone ASC, client_name ASC', 'telephone DESC, client_name ASC',
'homepage ASC, client_name ASC', 'homepage DESC, client_name ASC',
'e_mail ASC, client_name ASC', 'e_mail DESC, client_name ASC'
]
    else:
        sortby = [
'client_name ASC', 'client_name DESC',
'client_field ASC, client_name ASC', 'client_field DESC, client_name ASC',
'client_rating ASC, client_name ASC', 'client_rating DESC, client_name ASC',
'telephone ASC, client_name ASC', 'telephone DESC, client_name ASC',
'homepage ASC, client_name ASC', 'homepage DESC, client_name ASC',
'creator_name ASC, client_name ASC', 'creator_name DESC, client_name ASC'
]
    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    sortby_name = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=0">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_name)
    sortby_field = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=2">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_field)
    sortby_rating = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=4">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_rating)
    sortby_telephone = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=6">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_telephone)
    sortby_homepage = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=8">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_homepage)
    if REQUEST.form.has_key('showmine'):
        sortby_creator = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=10">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_email)
    else:
        sortby_creator = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=10">%s</A>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_creator)
    if sortby_id == 0:
        sortby_name = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=1">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=0">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_field = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=3">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_field)
    elif sortby_id == 3:
        sortby_field = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=2">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_field)
    elif sortby_id == 4:
        sortby_rating = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=5">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_rating)
    elif sortby_id == 5:
        sortby_rating = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=4">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_rating)
    elif sortby_id == 6:
        sortby_telephone = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=7">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_telephone)
    elif sortby_id == 7:
        sortby_telephone = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=6">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_telephone)
    elif sortby_id == 8:
        sortby_homepage = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=9">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_homepage)
    elif sortby_id == 9:
        sortby_homepage = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=8">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_homepage)
    elif sortby_id == 10:
        if REQUEST.form.has_key('showmine'):
            sortby_creator = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=11">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_email)
        else:
            sortby_creator = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=11">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_creator)
    elif sortby_id == 11:
        if REQUEST.form.has_key('showmine'):
            sortby_creator = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=10">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_email)
        else:
            sortby_creator = u"""<A class="blackboldlink" href="%sclients.py%ssort_by=10">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CLIENT_URL, formstring, tls_creator)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CLIENT])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('showmine'):
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()
    else:
        only_mine = ""

    if (letter=='num'):
        QUERY = """SELECT count(*) AS count_all FROM clients c, items i WHERE c.client_id=i.item_id AND lower(substr(c.client_name, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z') %s%s%s%s""" % (only_mine, right_param, cl_string, search_params)
    elif letter:
        QUERY = """SELECT count(*) AS count_all FROM clients c, items i WHERE c.client_id=i.item_id AND lower(substr(c.client_name, 1, 1))='%s' %s%s%s%s""" % (letter, only_mine, right_param, cl_string, search_params)
    else:
        QUERY = """SELECT count(*) AS count_all FROM clients c, items i WHERE c.client_id=i.item_id %s%s%s%s""" % (only_mine, right_param, cl_string, search_params)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sclients.py%sqs=" % (_Conf.BASE_CLIENT_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sclients.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CLIENT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sclients.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CLIENT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR (START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""


    if REQUEST.form.has_key('showmine'):
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()
        show_mine = """showmine=1"""
        mine_str = """<input type="hidden" name="showmine" value="1">"""
    else:
        only_mine = ""
        show_mine = ""
        mine_str = ""
    if (letter=='num'):
        SQL = """SELECT c.*, i.parent_id, i2.item_name as creator_name FROM clients c, items i, items i2 WHERE c.client_id=i.item_id AND i.creator_id=i2.item_id AND lower(substr(c.client_name, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z') %s%s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (only_mine, right_param, cl_string, search_params, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    elif letter:
        SQL = """SELECT c.*, i.parent_id, i2.item_name as creator_name FROM clients c, items i, items i2 WHERE c.client_id=i.item_id AND i.creator_id=i2.item_id  AND lower(substr(c.client_name, 1, 1))='%s' %s%s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (letter, only_mine, right_param, cl_string, search_params, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    else:
        SQL = """SELECT c.*, i.parent_id, i2.item_name as creator_name FROM clients c, items i, items i2 WHERE c.client_id=i.item_id AND i.creator_id=i2.item_id  %s%s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (only_mine, right_param, cl_string, search_params, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_all = REQUEST.TLS('tls_all').upper()
    tls_clients = REQUEST.TLS('topmenu_clients')
    tls_cltype = REQUEST.TLS('clients_type')
    tls_filter = REQUEST.TLS('tls_filter')

    if REQUEST.form.has_key('client_type') and REQUEST.form['client_type'].value:
        sel = REQUEST.form['client_type'].value.decode('UTF8')
    else:
        sel = ""
    values = REQUEST.get_setting('client_type')
    qs = REQUEST.get_formstring(['qs', 'client_type'])
    value_output = [u"""<SELECT class="todo_workflow" name="client_type" onchange="document.location.href='%(BASE_CLIENT_URL)sclients.py%(qs)sclient_type='+this.value"><option value="">&nbsp;</option>""" % locals()]
    for value in values:
        if value==sel:
            value_output.append(u"""<OPTION SELECTED value="%s">%s""" % (value, value))
        else:
            value_output.append(u"""<OPTION value="%s">%s""" % (value, value))
    value_output.append(u"""</SELECT>""")
    client_type = "\n".join(value_output)

    output.append(u"""
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing1" width="100%%">
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?%(show_mine)s">%(tls_all)s</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=num&%(show_mine)s">#</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=a&%(show_mine)s">A</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=b&%(show_mine)s">B</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=c&%(show_mine)s">C</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=d&%(show_mine)s">D</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=e&%(show_mine)s">E</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=f&%(show_mine)s">F</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=g&%(show_mine)s">G</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=h&%(show_mine)s">H</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=i&%(show_mine)s">I</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=j&%(show_mine)s">J</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=k&%(show_mine)s">K</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=l&%(show_mine)s">L</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=m&%(show_mine)s">M</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=n&%(show_mine)s">N</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=o&%(show_mine)s">O</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=p&%(show_mine)s">P</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=q&%(show_mine)s">Q</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=r&%(show_mine)s">R</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=s&%(show_mine)s">S</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=t&%(show_mine)s">T</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=u&%(show_mine)s">U</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=v&%(show_mine)s">V</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=w&%(show_mine)s">W</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=x&%(show_mine)s">X</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=y&%(show_mine)s">Y</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CLIENT_URL)sclients.py?let=z&%(show_mine)s">Z</A>&nbsp;
    </TD>
  </TR>
</TABLE>
<br>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan=7 width="100%%">
    <TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
    <FORM method="POST" action="%(BASE_CLIENT_URL)sclients.py">
    %(mine_str)s
      <TR>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)stitle_18.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
          <TD><span class="t3">%(tls_clients)s</span></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
          <TD nowrap><b>%(tls_cltype)s:</b>&nbsp;&nbsp;%(client_type)s</TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdnrk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="3" height="20" border=0 alt=""></TD>
          <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_filter)s:</b>&nbsp;</TD>
          <TD class="th_listing" align="center" nowrap><input type="text" name="filter" class="textfield_filter" value="%(filter)s">&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdnrk2.gif')"><input type="image" src="%(BASE_ICON_URL)sspacer.gif" width="3" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
      </TR>
    </FORM>
    </TABLE>
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="25%%">%(sortby_name)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_field)s</TD>
  <TD class="td_listing1b" width="5%%" nowrap>%(sortby_rating)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_telephone)s</TD>
  <TD class="td_listing1b" width="20%%">%(sortby_homepage)s</TD>
  <TD class="td_listing1b" width="20%%">%(sortby_creator)s</TD>
</TR>""" % locals())
    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_CLIENT_URL'] = _Conf.BASE_CLIENT_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['client_name'] = _Utils.html_quote((item['client_name'] or "").decode('UTF8'))
        item['client_field'] = _Utils.html_quote((item['client_field'] or "").decode('UTF8'))
        item['client_rating'] = (item['client_rating'] or "&nbsp;")
        if item['client_rating']:
          try:
            numb=int(item['client_rating'])
          except:
            numb=0
          if numb:
            ratestr = """<img src="%(BASE_ICON_URL)sstar.gif" width="13" height="13" border="0" alt="">""" % item
            item['client_rating'] = ''
            for i in range(0, numb):
              item['client_rating'] += ratestr
        item['telephone'] = _Utils.html_quote((item['telephone'] or "").decode('UTF8'))
        item['homepage'] = _Utils.html_quote((item['homepage'] or "").decode('UTF8'))
        if item['homepage'][:4]=="http":
          item['homepage'] = """<a href="%s" target="_blank">%s</a>""" % (item['homepage'], item['homepage'])
        elif item['homepage'][:3]=="www":
          item['homepage'] = """<a href="http://%s" target="_blank">%s</a>""" % (item['homepage'], item['homepage'])
        if REQUEST.form.has_key('showmine'):
            item['owner'] = (item['e_mail'] or "&nbsp;").decode('UTF8')
        else:
            item['owner'] = (item['creator_name'] or "&nbsp;").decode('UTF8')

        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" nowrap><A class="td_listing" href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)d">%(client_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(client_field)s</TD>
  <TD class="td_listing%(class_type)d" nowrap>%(client_rating)s</TD>
  <TD class="td_listing%(class_type)d">%(telephone)s</TD>
  <TD class="td_listing%(class_type)d">%(homepage)s</TD>
  <TD class="td_listing%(class_type)d">%(owner)s</TD>
</TR>""" % item)
    output.append("""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("""<BR>""")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
