
import _Conf
from Menus import get_contact_menu
from mod_python import apache
import standard_html
import _Access, _InitTypes, _Contact, _ContactGroup
import _Utils

MY_MENU_ID=5

def index(REQUEST):
    
    if REQUEST.form.has_key('add') and REQUEST.form['add'].value=="1":
        return add(REQUEST)
    
    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            group_obj = _ContactGroup.ContactGroup(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            group_obj.delete()


    
    tls_name = REQUEST.TLS('tls_name')
    tls_desc = REQUEST.TLS('tls_description')
    tls_owner = REQUEST.TLS('client_owner')
    tls_members = REQUEST.TLS('tls_members2')
    tls_contactgroups = REQUEST.TLS('tls_contactgroups')
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    menu = menu_output(REQUEST)

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_contactgroups)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="5" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    output.append(menu)
    
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACTGROUP])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('public'):
        only_mine = ""
    else:
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()
    QUERY = """SELECT count(*) AS count_all FROM contact_groups c, items i WHERE c.group_id=i.item_id %s%s""" % (only_mine, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%scontactgroups.py%sqs=" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%scontactgroups.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%scontactgroups.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    sortby = [
'group_name ASC, group_id ASC', 'group_name DESC, group_id DESC',
'creator_id ASC, group_id ASC', 'creator_id DESC, group_id ASC',
'group_description ASC, group_id ASC', 'group_description DESC, group_id DESC',
]
    DEFAULT_SORTBY = 0
    sortby_id = -1
    
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    sortby_name = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=0">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    sortby_creator = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=2">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_owner)
    sortby_desc = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=4">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_desc)
    if sortby_id == 0:
        sortby_name = u"""<A class="blackboldlink" href="%scontactgroups.py%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blackboldlink" href="%scontactgroups.py%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%scontactgroups.py%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_owner)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%scontactgroups.py%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_owner)
    elif sortby_id == 4:
        sortby_desc = u"""<A class="blackboldlink" href="%scontactgroups.py%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_desc)
    elif sortby_id == 5:
        sortby_desc = u"""<A class="blackboldlink" href="%scontactgroups.py%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_desc)
    del formstring
    
    SQL = """SELECT c.*, i2.item_name as creator_name FROM contact_groups c, items i, items i2 WHERE c.group_id=i.item_id and i.creator_id=i2.item_id %s%s ORDER BY %s LIMIT %d OFFSET %d""" % (only_mine, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    
    output.append(u"""
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_CONTACT_URL)scontactgroups.py">
<TR>
  <TD class="td_listing1b" width="1%%">&nbsp;</TD>
  <TD class="td_listing1b" width="30%%">%(sortby_name)s</TD>
  <TD class="td_listing1b" width="20%%">%(sortby_creator)s</TD>
  <TD class="td_listing1b" width="49%%">%(tls_desc)s</TD>
</TR>""" % locals())
    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_CONTACT_URL'] = _Conf.BASE_CONTACT_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        if item['group_name'] is None: item['company'] = ""
        if item['group_description'] is None: item['e_mail'] = ""
        if item['creator_name'] is None: item['creator_name'] = ""

        item['group_name'] = _Utils.html_quote(item['group_name'].decode('UTF8'))
        item['group_description'] = _Utils.newline2br(_Utils.html_quote(item['group_description'].decode('UTF8')))
        item['creator_name'] = _Utils.html_quote(item['creator_name'].decode('UTF8'))
        item['members'] = len(_Utils.sql_parse_array(REQUEST, item['contacts']))


        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d" style="text-align: center"><INPUT type="checkbox" name="sel_%(group_id)d"></TD>
  <TD nowrap class="td_listing%(class_type)d"><A href="%(BASE_CONTACT_URL)scontactgroups.py/edit?group_id=%(group_id)d&show=1">%(group_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(creator_name)s</TD>
  <TD class="td_listing%(class_type)d">%(group_description)s</TD>
</TR>""" % item)
    output.append(u"""</TABLE>""")

    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""\
  <BR>
  <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
      <TD width="100%%" align="right"><INPUT type="submit" class="input2" name="_delete" value="%s" onClick="return confirm('%s');"></TD>
      <TD><img src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
    </TR>
  </TABLE>
  </FORM>
  <BR>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('tls_deletesel'), REQUEST.TLS('email_confirm_del') ,_Conf.BASE_ICON_URL))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def add(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)

    
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_groupname = REQUEST.TLS('tls_groupname')
    tls_description = REQUEST.TLS('tls_description')
    tls_save = REQUEST.TLS('tls_save')
    tls_private = REQUEST.TLS('tls_private')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_contactgroups = REQUEST.TLS('tls_contactgroups')
    
    
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_contactgroups)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="5" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    output.append(menu)
    output.append(u"""
<script type="text/javascript">
function check_values()
{
  if (!document.addform.group_name.value)
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
</script>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_CONTACT_URL)scontactgroups.py/add_save" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
  <TR>
    <TD class="td_listing1kb" nowrap>%(REQ_FIELD)s%(tls_groupname)s:</TD>
    <TD class="td_listing1vb"><INPUT type="text" class="textfield4" name="group_name" value=""></TD>
    <TD class="td_listing1vb" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="group_description" rows="8" cols="40"></TEXTAREA></TD>
    <TD class="td_listing0vb" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1kb" nowrap>%(tls_private)s</TD>
    <TD class="td_listing1vb"><INPUT type="checkbox" name="group_is_private" value="%(tls_private)s"></TD>
    <TD class="td_listing1vb" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0vb" colspan="2"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
    <TD class="td_listing0vb" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def add_save(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        ref_url = urllib.unquote(REQUEST.form['returl'].value.strip())
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    else:
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_CONTACT_URL+"contactgroups.py"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('group_name') and REQUEST.form['group_name'].value.strip():
        contact_group = _ContactGroup.ContactGroup(REQUEST, _InitTypes.INIT_TYPE_REQ)
        contact_group.load_req()
        contact_group.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
        if REQUEST.form.has_key('group_is_private'):
            contact_group.set('is_private', 1)
        else:
            contact_group.set('is_private', 0)
        contact_group.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)




def menu_output(REQUEST):
    output=[]
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL

    tls_groups = REQUEST.TLS('email_mygroups')
    tls_pubgroups = REQUEST.TLS('email_pubgroups')
    tls_add = REQUEST.TLS('tls_add')

    active = 0
    if REQUEST.form.has_key('public') and REQUEST.form['public'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactgroups.py?public=1">%(tls_pubgroups)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactgroups.py?public=1">%(tls_pubgroups)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('add') and REQUEST.form['add'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactgroups.py?add=1">%(tls_add)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactgroups.py?add=1">%(tls_add)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactgroups.py">%(tls_groups)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactgroups.py">%(tls_groups)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()



    output.append(u"""
      <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('group_id') or not REQUEST.form['group_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['group_id'].value)
    group_id=obj_id
    obj = _ContactGroup.ContactGroup(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    
    persons = ""
    if REQUEST.form.has_key('persons') and REQUEST.form['persons'].value:
      persons = REQUEST.form['persons'].value
    if REQUEST.form.has_key('show') and REQUEST.form['show'].value=="1":
        persons = obj.get('contacts')[1:-1]

    if REQUEST.form.has_key('_add'):
      del_ids = {}
      for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
          del_ids[str(key[4:])] = 1
          persons = persons + "," + str(key[4:])
      # 2 remove dupes
      dic1 = {}
      p_list = persons.split(",")
      for p in p_list:
        if not dic1.has_key(p):
          dic1[p] = 1
      persons = ""
      for key in dic1.keys():
        persons = persons + "," + key
    
    if REQUEST.form.has_key('_delete'):
      del_ids = {}
      for key in REQUEST.form.keys():
        if key[:4] == 'del_':
          del_ids[str(key[4:])] = 1
      p_list = persons.split(",")
      dic1 = {}
      for p in p_list:
        if not(dic1.has_key(p) or del_ids.has_key(p)):
          dic1[p] = 1
      persons = ""
      for key in dic1.keys():
        persons = persons + "," + key
    persons = persons.replace(",,",",")
    if persons and persons[0]==",":
      if len(persons)>1:
        persons = persons[1:]
      else:
        persons=""



    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    tls_search = REQUEST.TLS('tls_search')
    tls_save = REQUEST.TLS('tls_save_close')
    tls_selected = REQUEST.TLS('tls_members')
    tls_name = REQUEST.TLS('tls_name')
    tls_email = REQUEST.TLS('tls_email')
    tls_org = REQUEST.TLS('contact_company')
    tls_remove = REQUEST.TLS('tls_remove_sel')
    tls_results = REQUEST.TLS('cal_choose_persons')
    tls_add = REQUEST.TLS('tls_add')
    tls_object = REQUEST.TLS('tls_group')
    object_name =  _Utils.html_quote_show(obj.get('item_name'))
    
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, 0))
    output.append(menu)
    output.append(u"""
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" name="searchform" action="%(BASE_CONTACT_URL)scontactgroups.py/edit">
<input type="hidden" name="group_id" value="%(group_id)s">
<input type="hidden" name="persons" value="%(persons)s">
<TR class="tr_listing1">
  <TD width="1%%"  class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="27%%" class="td_listing1" align="left"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD width="1%%"  class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD width="70%%" class="td_listing1" align="left" nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="button" class="input6" name="save" value="%(tls_save)s" onclick="document.forms['saveform'].submit()";"></TD>
  <TD width="1%%"  class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())


    if persons:
      output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="6"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="6">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
          <TD nowrap><span class="t3">%(tls_selected)s</span></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b" width="1%%">&nbsp;</TD>
  <TD class="td_listing1b" width="32%%">%(tls_name)s</TD>
  <TD class="td_listing1b" width="32%%">%(tls_email)s</TD>
  <TD class="td_listing1b" width="33%%">%(tls_org)s</TD>
  <TD class="td_listing1b" width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
      if right_param:
        right_param = " AND " + right_param
      REQUEST.db.execute(("""SELECT i.item_name, c.contact_id, c.company, c.e_mail FROM items i, contacts c WHERE c.contact_id=i.item_id AND c.contact_id in (%s) %s order by c.last_name, c.first_name""" % (persons, right_param)).encode('UTF8'))
      res = REQUEST.db.dictfetchall()
      index = 0
      person_out = ""
      for row in res:
        if index%2==0:
          td_class = 0
        else:
          td_class = 1
        index = index + 1
        p_name =  _Utils.html_quote_show((row['item_name']).decode('UTF8')) or "&nbsp;"
        p_org =  _Utils.html_quote_show((row['company']).decode('UTF8')) or "&nbsp;"
        p_mail =  _Utils.html_quote_show((row['e_mail']).decode('UTF8')) or "&nbsp;"
        p_id = row['contact_id']
        person_out = person_out + p_name + "<br>"
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><input type="checkbox" name="del_%(p_id)s"></TD>
  <TD class="td_listing%(td_class)s">%(p_name)s</TD>
  <TD class="td_listing%(td_class)s">%(p_mail)s</TD>
  <TD class="td_listing%(td_class)s">%(p_org)s</TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      output.append(u"""
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing_noborder" colspan="3"><input type="submit" name="_delete" class="input6" value="%(tls_remove)s"></TD>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<input type="hidden" name="person_out" value="%(person_out)s">""" % locals())
    
    
    words = ''
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      words = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND %s" % right_param
    
    no_list = ""
    if persons:
      no_list = " AND c.contact_id not in (%s) " % persons
    search_params = u"""(lower(first_name) like '%%%s%%' or lower(middle_name) like '%%%s%%' or lower(last_name) like '%%%s%%' or lower(company) like '%%%s%%' or lower(e_mail) like '%%%s%%' or lower(description) like '%%%s%%')""" % (words, words, words, words, words, words)
    QUERY = """SELECT count(*) FROM items i, contacts c WHERE c.contact_id=i.item_id %s AND %s %s""" % (no_list, search_params, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%scontactgroups.py/edit%spersons=%s&qs=" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), persons)
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%scontactgroups.py/edit%spersons=%s&qs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), persons, REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%scontactgroups.py/edit%spersons=%s&qs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), persons, REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    
    SQL = ("""SELECT i.item_name, c.contact_id, c.company, c.e_mail FROM items i, contacts c WHERE c.contact_id=i.item_id %s AND %s %s order by c.last_name, c.first_name LIMIT %s OFFSET %s""" % (no_list, search_params, right_param, REQUEST.batch_size, REQUEST.qs)).encode('UTF8')
    REQUEST.db.execute(SQL)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap><span class="t3">%(tls_results)s</span></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" width="1%%">&nbsp;</TD>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" width="32%%">%(tls_name)s</TD>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" width="33%%">%(tls_email)s</TD>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" width="33%%">%(tls_org)s</TD>
  <TD class="td_listing1b" style="border-top: 1px solid #CCCCCC" width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
      if index%2==0:
        td_class = 0
      else:
        td_class = 1
      index = index + 1
      p_name =  _Utils.html_quote_show((row['item_name']).decode('UTF8')) or "&nbsp;"
      p_org =  _Utils.html_quote_show((row['company']).decode('UTF8')) or "&nbsp;"
      p_mail =  _Utils.html_quote_show((row['e_mail']).decode('UTF8')) or "&nbsp;"
      p_id = row['contact_id']
      output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><input type="checkbox" name="sel_%(p_id)s"></TD>
  <TD class="td_listing%(td_class)s">%(p_name)s</TD>
  <TD class="td_listing%(td_class)s">%(p_mail)s</TD>
  <TD class="td_listing%(td_class)s">%(p_org)s</TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    output.append(u"""
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing_noborder" colspan="3" width="100%%"><input type="submit" name="_add" class="input6" value="%(tls_add)s"></TD>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""
</FORM>
<FORM name="saveform" method="post" action="%(BASE_CONTACT_URL)scontactgroups.py/edit_save">
<input type="hidden" name="group_id" value="%(group_id)s">
<input type="hidden" name="persons" value="%(persons)s">
</FORM>
""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def edit_save(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        ref_url = urllib.unquote(REQUEST.form['returl'].value.strip())
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    else:
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_CONTACT_URL+"contactgroups.py"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('group_id') and REQUEST.form['group_id'].value.strip():
        contact_group = _ContactGroup.ContactGroup(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['group_id'].value))
        if REQUEST.form.has_key('persons'):
            contact_group.set('contacts', [REQUEST.form['persons'].value])
        else:
            contact_group.set('contacts', [])
        contact_group.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)