"""

Default contact page.

$Id: contactindex.py,v 1.5 2004/02/15 13:10:56 incxcvs Exp $
"""

import _Conf
from Menus import get_contact_menu
from mod_python import apache
import standard_html
import _Access, _InitTypes, _Contact, custom_fields
import _Utils

MY_MENU_ID=-1

def index(REQUEST):
    if not (REQUEST.form.has_key('contact_id1') and REQUEST.form.has_key('contact_id2') and REQUEST.form['contact_id1'].value and REQUEST.form['contact_id2'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    
    c1 = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id1'].value))
    c2 = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id2'].value))
    
    if _Access.get_item_right(REQUEST, c1.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE and _Access.get_item_right(REQUEST, c2.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
      pass
    elif _Access.get_item_right(REQUEST, c1.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
      primary_id = c1.get_id()
      secondary_id = c2.get_id()
      REQUEST.mod_req.headers_out["Location"] = "%scontactmerge.py/merge_form?primary_id=%s&secondary_id=%s" % (_Conf.BASE_CONTACT_URL, primary_id, secondary_id)
      return apache.HTTP_MOVED_TEMPORARILY
    elif _Access.get_item_right(REQUEST, c2.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
      primary_id = c2.get_id()
      secondary_id = c1.get_id()
      REQUEST.mod_req.headers_out["Location"] = "%scontactmerge.py/merge_form?primary_id=%s&secondary_id=%s" % (_Conf.BASE_CONTACT_URL, primary_id, secondary_id)
      return apache.HTTP_MOVED_TEMPORARILY
    else:
      raise RuntimeError, REQUEST.TLS('contact_nomergeaccess')
    
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_name = REQUEST.TLS('tls_name')
    tls_company = REQUEST.TLS('contact_company')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_merge = REQUEST.TLS('contact_merge')
    tls_selprim = REQUEST.TLS('contact_selprim')
    tls_prim = REQUEST.TLS('contact_prim')
    tls_phone = REQUEST.TLS('admin_phone')
    tls_email = REQUEST.TLS('topmenu_email')
    tls_address = REQUEST.TLS('contact_address')
    tls_description = REQUEST.TLS('tls_description')
    
    
    name1 = "%s %s %s" % (_Utils.html_quote(c1.get('first_name')), _Utils.html_quote(c1.get('middle_names') or ''), _Utils.html_quote(c1.get('last_name')))
    name2 = "%s %s %s" % (_Utils.html_quote(c2.get('first_name')), _Utils.html_quote(c2.get('middle_names') or ''), _Utils.html_quote(c2.get('last_name')))
    com1 = "%s %s %s" % (_Utils.html_quote(c1.get('company') or ''),_Utils.html_quote(c1.get('department') or ''),_Utils.html_quote(c1.get('jobtitle') or ''))
    com2 = "%s %s %s" % (_Utils.html_quote(c2.get('company') or ''),_Utils.html_quote(c2.get('department') or ''),_Utils.html_quote(c2.get('jobtitle') or ''))
    tel1 = "%s %s %s %s" % (_Utils.html_quote(c1.get('phone_cell') or ''),_Utils.html_quote(c1.get('phone_work') or ''),_Utils.html_quote(c1.get('phone_home') or ''),_Utils.html_quote(c1.get('phone_fax') or ''))
    tel2 = "%s %s %s %s" % (_Utils.html_quote(c2.get('phone_cell') or ''),_Utils.html_quote(c2.get('phone_work') or ''),_Utils.html_quote(c2.get('phone_home') or ''),_Utils.html_quote(c2.get('phone_fax') or ''))
    em1 = _Utils.html_quote("%s %s" % (c1.get('e_mail'), (c1.get('homepage') or '')))
    em2 = _Utils.html_quote("%s %s" % (c2.get('e_mail'), (c2.get('homepage') or '')))
    ad1 = _Utils.html_quote("%s" % (_Utils.newline2br(c1.get('mailing_address') or '')))
    ad2 = _Utils.html_quote("%s" % (_Utils.newline2br(c2.get('mailing_address') or '')))
    d1 = _Utils.html_quote("%s" % (_Utils.newline2br(c1.get('description') or '')))
    d2 = _Utils.html_quote("%s" % (_Utils.newline2br(c2.get('description') or '')))
    c1_id = c1.get_id()
    c2_id = c2.get_id()
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    output.append(u"""
<br>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_merge)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b" colspan="5" width="100%%">%(tls_selprim)s:</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b">&nbsp;</TD>
  <TD class="td_listing0" width="50%%"><FORM method="POST" action="%(BASE_CONTACT_URL)scontactmerge.py/merge_form"><input type="hidden" name="primary_id" value="%(c1_id)s"><input type="hidden" name="secondary_id" value="%(c2_id)s"><input type="submit" value="%(tls_prim)s" class="input6"></FORM></TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="50%%"><FORM method="POST" action="%(BASE_CONTACT_URL)scontactmerge.py/merge_form"><input type="hidden" name="primary_id" value="%(c2_id)s"><input type="hidden" name="secondary_id" value="%(c1_id)s"><input type="submit" value="%(tls_prim)s" class="input6"></FORM></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b">%(tls_name)s:</TD>
  <TD class="td_listing1" width="50%%">%(name1)s</TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" width="50%%">%(name2)s</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b">%(tls_company)s:</TD>
  <TD class="td_listing0" width="50%%">%(com1)s</TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="50%%">%(com2)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b">%(tls_phone)s:</TD>
  <TD class="td_listing1" width="50%%">%(tel1)s</TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" width="50%%">%(tel2)s</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b">%(tls_email)s:</TD>
  <TD class="td_listing0" width="50%%">%(em1)s</TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="50%%">%(em2)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b">%(tls_address)s:</TD>
  <TD class="td_listing1" width="50%%">%(ad1)s</TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" width="50%%">%(ad2)s</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b">%(tls_description)s:</TD>
  <TD class="td_listing0" width="50%%">%(d1)s</TD>
  <TD bgcolor="#CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="50%%">%(d2)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def merge_form(REQUEST):
    if not (REQUEST.form.has_key('primary_id') and REQUEST.form.has_key('secondary_id') and REQUEST.form['primary_id'].value and REQUEST.form['secondary_id'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    
    c1 = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['primary_id'].value))
    contact_id = c1.get_id()
    c2 = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['secondary_id'].value))
    contact_id_2 = c2.get_id()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_first_name = REQUEST.TLS('tls_first_name')
    tls_last_name = REQUEST.TLS('tls_last_name')
    tls_middle_names = REQUEST.TLS('tls_middle_names')
    tls_company = REQUEST.TLS('contact_company')
    tls_department = REQUEST.TLS('contact_department')
    tls_job = REQUEST.TLS('contact_job')
    tls_phone_work = REQUEST.TLS('tls_phone_work')
    tls_phone_cell = REQUEST.TLS('tls_phone_cell')
    tls_phone_home = REQUEST.TLS('tls_phone_home')
    tls_phone_fax = REQUEST.TLS('tls_phone_fax')
    tls_email = REQUEST.TLS('tls_email')
    tls_email2 = REQUEST.TLS('tls_email') + " #2"
    tls_email3 = REQUEST.TLS('tls_email') + " #3"
    tls_category = REQUEST.TLS('tls_category')
    tls_dateofbirth = REQUEST.TLS('contact_dateofbirth')
    tls_sex = REQUEST.TLS('contact_sex')
    tls_private = REQUEST.TLS('tls_private')
    tls_address = REQUEST.TLS('contact_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_description = REQUEST.TLS('tls_description')
    tls_viewcontact = REQUEST.TLS('contact_viewcontact')
    tls_homepage = REQUEST.TLS('contact_homepage')
    tls_male = REQUEST.TLS('contact_male')
    tls_female = REQUEST.TLS('contact_female')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    REQ_FIELD = _Conf.REQ_FIELD
    tls_merge = REQUEST.TLS('contact_merge')
    tls_stay = REQUEST.TLS('contact_stay')
    tls_out = REQUEST.TLS('contact_out')
    tls_flip = REQUEST.TLS('contact_flip')
    tls_save = REQUEST.TLS('tls_save')
    
    first_name = _Utils.html_quote(c1.get('first_name'))
    first_name_2 = _Utils.html_quote(c2.get('first_name'))
    middle_names = _Utils.html_quote(c1.get('middle_names') or '')
    middle_names_2 = _Utils.html_quote(c2.get('middle_names') or '')
    last_name = _Utils.html_quote(c1.get('last_name'))
    last_name_2 = _Utils.html_quote(c2.get('last_name'))
    company = _Utils.html_quote(c1.get('company') or '')
    company_2 = _Utils.html_quote(c2.get('company') or '')
    department = _Utils.html_quote(c1.get('department') or '')
    department_2 = _Utils.html_quote(c2.get('department') or '')
    jobtitle = _Utils.html_quote(c1.get('jobtitle') or '')
    jobtitle_2 = _Utils.html_quote(c2.get('jobtitle') or '')
    phone_work = _Utils.html_quote(c1.get('phone_work') or '')
    phone_work_2 = _Utils.html_quote(c2.get('phone_work') or '')
    phone_home = _Utils.html_quote(c1.get('phone_home') or '')
    phone_home_2 = _Utils.html_quote(c2.get('phone_home') or '')
    phone_cell = _Utils.html_quote(c1.get('phone_cell') or '')
    phone_cell_2 = _Utils.html_quote(c2.get('phone_cell') or '')
    phone_fax = _Utils.html_quote(c1.get('phone_fax') or '')
    phone_fax_2 = _Utils.html_quote(c2.get('phone_fax') or '')
    e_mail = _Utils.html_quote(c1.get('e_mail') or '')
    e_mail2 = _Utils.html_quote(c1.get('e_mail2') or '')
    e_mail3 = _Utils.html_quote(c1.get('e_mail3') or '')
    e_mail_2 = _Utils.html_quote(c2.get('e_mail') or '')
    e_mail2_2 = _Utils.html_quote(c2.get('e_mail2') or '')
    e_mail3_2 = _Utils.html_quote(c2.get('e_mail3') or '')
    mailing_address = _Utils.html_quote(c1.get('mailing_address') or '')
    mailing_address_2 = _Utils.html_quote(c2.get('mailing_address') or '')
    description = _Utils.html_quote(c1.get('description') or '')
    description_2 = _Utils.html_quote(c2.get('description') or '')
    homepage = _Utils.html_quote(c1.get('homepage') or '')
    homepage_2 = _Utils.html_quote(c2.get('homepage') or '')
    contact_category = _Utils.make_setting_selection(REQUEST, c1, 'contact_category', 'contact_categories', is_multiple=1, read_only=0)
    contact_category_2 = _Utils.make_setting_selection(REQUEST, c2, 'contact_category', 'contact_categories', is_multiple=1, read_only=1)
    contact_sex = [u""""""]
    contact_sex = [u"""<SELECT name="contact_sex">"""]
    sexes = [u"&nbsp;&nbsp;", u"%(tls_male)s"%locals(), u"%(tls_female)s"%locals()]
    i = c1.get('contact_sex')
    for j in range(3):
        if i == j:
            contact_sex.append(u"""<OPTION value="%d" SELECTED>%s""" % (j, sexes[j]))
        else:
            contact_sex.append(u"""<OPTION value="%d">%s""" % (j, sexes[j]))
    contact_sex.append(u"</SELECT>")
    contact_sex = "\n".join(contact_sex)

    contact_sex_2 = [u""""""]
    sexes = [u"&nbsp;&nbsp;", u"%(tls_male)s"%locals(), u"%(tls_female)s"%locals()]
    i = c2.get('contact_sex')
    for j in range(3):
        if i == j:
            contact_sex_2.append(u"""%s""" % (sexes[j]))
    contact_sex_2 = "\n".join(contact_sex_2)

    birth_date = c1.get('birth_date')
    if birth_date:
        birth_date = REQUEST.iso2userdate(birth_date)
    else:
        birth_date = ''

    birth_date_2 = c2.get('birth_date')
    if birth_date_2:
        birth_date_2 = REQUEST.iso2userdate(birth_date_2)
    else:
        birth_date_2 = ''
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""
<script type="text/javascript">
function chan(val)
{
  v1 = document.forms[0][val].value;
  v2 = document.forms[0][val+"_2"].value;
  v3 = "";
  v3 = v1;
  v1 = v2;
  v2 = v3;
  document.forms[0][val].value=v1;
  document.forms[0][val+"_2"].value=v2;
}
function cal_popup(url, fieldname)
{
    window.date_result = document.merge_form[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.merge_form.first_name.value || !document.merge_form.last_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s

</script>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="merge_form" onsubmit="return check_values();" action="%(BASE_CONTACT_URL)scontactmerge.py/do_merge">
<INPUT type="hidden" name="contact_id" value="%(contact_id)s">
<INPUT type="hidden" name="contact_id_2" value="%(contact_id_2)s">
<TR>
  <TD colspan="6" width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap><span class="t3">%(tls_merge)s</span></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" style="border-top: 0px; border-bottom: 0px; border-right: 0px;" cellpadding="0" cellspacing="0">
<TR>
  <TD style="border-top: 1px solid #CCCCCC" class="td_listing1" nowrap>&nbsp;</TD>
  <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" align="center">%(tls_stay)s</TD>
  <TD style="border-top: 1px solid #CCCCCC" bgcolor="#EBEBEB"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  <TD style="border-top: 1px solid #CCCCCC; border-right: 1px solid #CCCCCC" class="td_listing1b" align="center">%(tls_out)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_first_name)s%(REQ_FIELD)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="first_name" value="%(first_name)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('first_name');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="first_name_2" value="%(first_name_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_middle_names)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="middle_names" value="%(middle_names)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('middle_names');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="middle_names_2" value="%(middle_names_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_last_name)s%(REQ_FIELD)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="last_name" value="%(last_name)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('last_name');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="last_name_2" value="%(last_name_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_company)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="company" value="%(company)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('company');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="company_2" value="%(company_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_department)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="department" value="%(department)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('department');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="department_2" value="%(department_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_job)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="jobtitle" value="%(jobtitle)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('jobtitle');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="jobtitle_2" value="%(jobtitle_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_phone_work)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="phone_work" value="%(phone_work)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('phone_work');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="phone_work_2" value="%(phone_work_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_phone_home)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="phone_home" value="%(phone_home)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('phone_home');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="phone_home_2" value="%(phone_home_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_phone_cell)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="phone_cell" value="%(phone_cell)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('phone_cell');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="phone_cell_2" value="%(phone_cell_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_phone_fax)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="phone_fax" value="%(phone_fax)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('phone_fax');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="phone_fax_2" value="%(phone_fax_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_email)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="e_mail" value="%(e_mail)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('e_mail');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="e_mail_2" value="%(e_mail_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_email2)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="e_mail2" value="%(e_mail2)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('e_mail2');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="e_mail2_2" value="%(e_mail2_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_email3)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="e_mail3" value="%(e_mail3)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('e_mail3');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="e_mail3_2" value="%(e_mail3_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_homepage)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="homepage" value="%(homepage)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('homepage');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="homepage_2" value="%(homepage_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_address)s</TD>
  <TD class="td_listing5"  nowrap><TEXTAREA name="mailing_address" class="textarea4" rows="4" cols="30">%(mailing_address)s</TEXTAREA></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('mailing_address');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><TEXTAREA name="mailing_address_2" class="textarea4" rows="4" cols="30">%(mailing_address_2)s</TEXTAREA></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_description)s</TD>
  <TD class="td_listing5"  nowrap><TEXTAREA name="description" class="textarea4" rows="4" cols="30">%(description)s</TEXTAREA></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('description');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><TEXTAREA name="description_2" class="textarea4" rows="4" cols="30">%(description_2)s</TEXTAREA></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_category)s</TD>
  <TD class="td_listing5"  nowrap>%(contact_category)s</TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap>%(contact_category_2)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_sex)s</TD>
  <TD class="td_listing5"  nowrap>%(contact_sex)s</TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap>%(contact_sex_2)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_dateofbirth)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" size="10" class="textfield1" name="birth_date" id="birth_date" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('birth_date', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap>%(birth_date_2)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    fields_1, fields_2 = get_custom_fields(REQUEST, c1, c2)
    n = 0
    while 1:
        try:
            row1 = fields_1[n]
            row2 = fields_2[n]
        except:
            break
        if not row1 and not row1:
            break
        tls_field = row1[1]
        field_name = "custom_"+str(row1[0])
        field_value_1 = row1[2]
        field_value_2 = row2[2]
        n = n + 1
        output.append(u"""
<TR>
  <TD class="td_listing0b" nowrap>%(tls_field)s</TD>
  <TD class="td_listing5"  nowrap><INPUT type="text" class="textfield4" name="%(field_name)s" value="%(field_value_1)s"></TD>
  <TD class="td_listing0"  nowrap align="center">&nbsp;&nbsp;<IMG onclick="chan('%(field_name)s');" src="%(BASE_ICON_URL)sflip2.gif" width="34" height="18" border="0" title="%(tls_flip)s" style="border:1px solid #565656; cursor: hand; cursor: pointer;">&nbsp;&nbsp;</TD>
  <TD class="td_listing6"  nowrap><INPUT type="text" class="textfield4" name="%(field_name)s_2" value="%(field_value_2)s"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>"""% locals())

    output.append(u"""
<TR>
  <TD class="td_listing0" style="border-right: 1px solid #CCCCCC; border-top: 1px solid #CCCCCC"" colspan="4"><input type="submit" value="%(tls_save)s" class="input2"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
<BR>
""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def do_merge(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_CONTACT_URL+"contactindex.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_contact_menu(REQUEST, -1))

    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))
    c1_id = contact_obj.get_id()

    if not REQUEST.form.has_key('first_name') or not REQUEST.form.has_key('last_name') or \
       not REQUEST.form['first_name'].value.decode('UTF8').strip() or not REQUEST.form['last_name'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    contact_obj.load_req()
    if REQUEST.form.has_key('contact_category') and isinstance(REQUEST.form['contact_category'], list) and REQUEST.form['contact_category']:
        contact_obj.set('contact_category', u"|%s|" % "|".join(map(lambda x:x.decode('UTF8'), REQUEST.form['contact_category'])))
    elif REQUEST.form.has_key('contact_category') and not isinstance(REQUEST.form['contact_category'], list) and REQUEST.form['contact_category'].value.decode('UTF8'):
        contact_obj.set('contact_category', u"|%s|" % REQUEST.form['contact_category'].value.decode('UTF8'))
    else:
        contact_obj.set('contact_category', u"")
    if REQUEST.form.has_key('birth_date') and REQUEST.form['birth_date'].value.decode('UTF8').strip():
        contact_obj.set('birth_date', REQUEST.user2isodate(REQUEST, REQUEST.form['birth_date'].value.decode('UTF8').strip()))
    else:
        contact_obj.set('birth_date', None)
    contact_obj.save()
    custom_fields.save_custom_vals(REQUEST, contact_obj.get_id())
    output.append(REQUEST.TLS('contact_saved'))
    output.append(standard_html.html_footer(REQUEST))
    if REQUEST.form.has_key('contact_id_2') and REQUEST.form['contact_id_2'].value:
      contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id_2'].value))
      c2_id = contact_obj.get_id()
      REQUEST.db.execute("""UPDATE items set parent_id=%d where parent_id=%s""" % (c1_id, c2_id))
      REQUEST.db.execute("""UPDATE item_rels set left_item_id=%d where left_item_id=%d""" % (c1_id, c2_id))
      REQUEST.db.execute("""UPDATE item_rels set right_item_id=%d where right_item_id=%d""" % (c1_id, c2_id))
      contact_obj.delete()
    return "\n".join(output)

def get_custom_fields(REQUEST, obj, obj2):
    obj_id = obj.get_id()
    obj2_id = obj2.get_id()
    toporg_id = obj.get_top_parent().get_id()
    type_id = obj.get('item_type_id')
    SQL = "SELECT f.field_id, f.field_name, r.contents from custom_fields f left join custom_rows r on f.field_id=r.field_id and r.item_id=%d where f.toporg_id=%d and f.item_type_id=%d order by priority asc""" % (obj_id, toporg_id, type_id)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.fetchall()
    SQL = "SELECT f.field_id, f.field_name, r.contents from custom_fields f left join custom_rows r on f.field_id=r.field_id and r.item_id=%d where f.toporg_id=%d and f.item_type_id=%d order by priority asc""" % (obj2_id, toporg_id, type_id)
    REQUEST.db.execute(SQL)
    res2 = REQUEST.db.fetchall()
    return (res, res2)