"""

Default contact page.

$Id: contactindex.py,v 1.5 2004/02/15 13:10:56 incxcvs Exp $
"""

import _Conf
from Menus import get_contact_menu
from mod_python import apache
import standard_html
import _Access, _InitTypes, _Contact
import _Utils
import _Document
import urllib, cStringIO, csv, base64, _Indexer

MY_MENU_ID=4


def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))

    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_export = REQUEST.TLS('contact_export')
    tls_import = REQUEST.TLS('contact_import')
    tls_allcontacts = REQUEST.TLS('compmenu_contact_all')
    tls_mycontacts = REQUEST.TLS('compmenu_contact_listmy')
    tls_output_format = REQUEST.TLS('contact_format')
    tls_match = REQUEST.TLS('contact_matching')
    tls_ins_new = REQUEST.TLS('contact_insert_new')
    tls_upd_ex = REQUEST.TLS('contact_update_ex')
    tls_leave_out = REQUEST.TLS('contact_leave_out')
    tls_file = REQUEST.TLS('tls_file')

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD><span class="t3">%(tls_export)s</span></TD>
  <TD width="100%%">&nbsp;</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_CONTACT_URL)scontactport.py/export_contacts">
<TR>
  <TD class="td_listing1" nowrap>%(tls_export)s:</TD>
  <TD class="td_listing1" nowrap><input type="radio" name="allcontacts" value="0" checked>%(tls_mycontacts)s</TD>
  <TD class="td_listing1" nowrap><input type="radio" name="allcontacts" value="1">%(tls_allcontacts)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0" nowrap>%(tls_output_format)s</TD>
  <TD class="td_listing0" nowrap><input type="radio" name="xml" value="0" checked>CSV</TD>
  <TD class="td_listing0" nowrap><input type="radio" name="xml" value="1">XML</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b" colspan=3><input type="submit" name="_export" value="%(tls_export)s" class="input2"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
<BR/>
<BR/>
<FORM method="POST" action="%(BASE_CONTACT_URL)scontactport.py/import_contacts" ENCTYPE="multipart/form-data">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD><span class="t3">%(tls_import)s</span></TD>
    <TD width="100%%">&nbsp;</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1" nowrap>%(tls_match)s:</TD>
  <TD class="td_listing1" nowrap><input type="radio" name="new" value="1">%(tls_ins_new)s</TD>
  <TD class="td_listing1" nowrap><input type="radio" name="new" value="2">%(tls_upd_ex)s</TD>
  <TD class="td_listing1" nowrap><input type="radio" name="new" value="3" checked>%(tls_leave_out)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0" nowrap>%(tls_file)s:</TD>
  <TD class="td_listing0" nowrap colspan="3"><input type="file" class="textfield1" name="import_file"></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b" colspan="4"><input type="submit" name="_import" value="%(tls_import)s" class="input2"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
""" % locals())


    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def export_contacts(REQUEST):
  if REQUEST.form.has_key('xml') and REQUEST.form['xml'].value=='1':
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param

    only_mine = ""
    if REQUEST.form.has_key('allcontacts') and REQUEST.form['allcontacts'].value=='0':
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()

    SQL = """SELECT c.*, i.parent_id, i.is_private FROM contacts c, items i WHERE c.contact_id=i.item_id %s%s""" % (only_mine, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()

    REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=contacts.xml"
    REQUEST.mod_req.content_type = "text/xml"
    if _Conf.IS_MP_27:
        REQUEST.mod_req.send_http_header()
    reqwrite = REQUEST.mod_req.write
    reqwrite("""<?xml version="1.0" encoding="UTF-8"?>\n\r""")
    reqwrite("""<contacts>\n\r""")
    for item in dbres:
      reqwrite("<contact>\n\r")
      reqwrite("    <first_name>%s</first_name>\n\r" % _Utils.html_quote_show(item.get("first_name") or ""))
      reqwrite("    <middle_name>%s</middle_name>\n\r" % _Utils.html_quote_show(item.get("middle_name") or ""))
      reqwrite("    <last_name>%s</last_name>\n\r" % _Utils.html_quote_show(item.get("last_name") or ""))
      reqwrite("    <company>%s</company>\n\r" % _Utils.html_quote_show(item.get("company") or ""))
      reqwrite("    <department>%s</department>\n\r" % _Utils.html_quote_show(item.get("department") or ""))
      reqwrite("    <jobtitle>%s</jobtitle>\n\r" % _Utils.html_quote_show(item.get("jobtitle") or ""))
      reqwrite("    <phone_work>%s</phone_work>\n\r" % _Utils.html_quote_show(item.get("phone_work") or ""))
      reqwrite("    <phone_home>%s</phone_home>\n\r" % _Utils.html_quote_show(item.get("phone_home") or ""))
      reqwrite("    <phone_cell>%s</phone_cell>\n\r" % _Utils.html_quote_show(item.get("phone_cell") or ""))
      reqwrite("    <phone_fax>%s</phone_fax>\n\r" % _Utils.html_quote_show(item.get("phone_fax") or ""))
      reqwrite("    <e_mail>%s</e_mail>\n\r" % _Utils.html_quote_show(item.get("e_mail") or ""))
      reqwrite("    <mailing_address>%s</mailing_address>\n\r" % _Utils.html_quote_show(item.get("mailing_address") or ""))
      reqwrite("    <description>%s</description>\n\r" % _Utils.html_quote_show(item.get("description") or ""))
      reqwrite("    <homepage>%s</homepage>\n\r" % _Utils.html_quote_show(item.get("homepage") or ""))
      reqwrite("    <contact_category>%s</contact_category>\n\r" % _Utils.html_quote_show(item.get("contact_category") or ""))
      reqwrite("    <birth_date>%s</birth_date>\n\r" % (item.get("birth_date") or ""))
      reqwrite("    <contact_sex>%s</contact_sex>\n\r" % _Utils.html_quote_show(item.get("contact_sex") or 0))
      reqwrite("    <private_contact>%s</private_contact>\n\r" % _Utils.html_quote_show(item.get("is_private") or 0))
      reqwrite("  </contact>\n\r")
    reqwrite("</contacts>\n\r")
    return apache.OK
  else:
    only_mine = ""
    if REQUEST.form.has_key('allcontacts') and REQUEST.form['allcontacts'].value=='0':
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param
    SQL = """SELECT c.* FROM contacts c, items i WHERE c.contact_id=i.item_id %s%s""" % (only_mine, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    temp_file = cStringIO.StringIO()
    count = 0
    writer = csv.writer(temp_file)
    for row in dbresult:
        del row['contact_id']
        count = count + 1
        tmp = []
        map(lambda x: tmp.append(row[x.encode('utf8')]), row.keys())
        writer.writerow(tmp)
    temp_file.seek(0)
    filesize = len(temp_file.read())
    temp_file.seek(0)
    REQUEST.mod_req.headers_out["Content-Length"] = str(filesize)
    REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=contacts.csv"
    REQUEST.mod_req.content_type = "text/csv"

    if _Conf.IS_MP_27:
        REQUEST.mod_req.send_http_header()

    reqwrite = REQUEST.mod_req.write
    fpread = temp_file.read
    data = fpread(_Document.BLOCK_SIZE)
    while data:
        reqwrite(data)
        data = fpread(_Document.BLOCK_SIZE)
    temp_file.close()
    return apache.OK


def import_contacts(REQUEST):
  BLOCK_SIZE = 8192
  if not REQUEST.form.has_key('import_file'):
      raise RuntimeError, REQUEST.TLS('required_parameters_missing') 
  if not REQUEST.form.has_key('new'):
      raise RuntimeError, REQUEST.TLS('required_parameters_missing') 
  import_type = int(REQUEST.form['new'].value)
  output = []
  output.append(standard_html.html_header(REQUEST))
  output.append(get_contact_menu(REQUEST, MY_MENU_ID))
  filepointer=REQUEST.form['import_file'].file
  fpread = filepointer.read
  # check
  ext = REQUEST.form['import_file'].filename.split(".")[-1:][0]
  if ext=="csv" or ext=="txt" or ext=="TXT" or ext=="CSV":
      return import_csv(REQUEST, import_type)
  
  # check
  data = ""
  tmp=fpread(BLOCK_SIZE)
  while(tmp):
    data = data + tmp
    tmp=fpread(BLOCK_SIZE)
  try:
      xml_dict=_Utils.xml2dict(data)
  except:
      raise RuntimeError, REQUEST.TLS('tls_invalid_file')
  xml_dict=xml_dict['contacts'][0]

  found_count = 0
  add_count = 0
  update_count = 0
  ignore_count = 0

  for key in xml_dict.keys():
    if key=='text':
      continue
    else:
      for contact in xml_dict[key]:
        found_count+=1
        contact_dict={}
        for contact_key in contact.keys():
          try:
            contact_dict[contact_key]=contact[contact_key][0]['text'][0]
          except:
            contact_dict[contact_key]=None
        # lets do some stuff
        if not contact_dict.has_key('first_name') or not contact_dict.has_key('last_name') or not contact_dict['first_name'] or not contact_dict['last_name']:
            raise RuntimeError, REQUEST.TLS('contact_import_req')
        if contact_dict.has_key('birth_date'):
            pass # FIXME
        if contact_dict.has_key('private_contact') and contact_dict['private_contact']=='1':
            is_private = 1
        else:
            is_private = 0
        if import_type==1:
            contact = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_REQ)
            contact.set('is_private', is_private)
            for key in contact_dict.keys():
              contact.set(key, urllib.unquote(contact_dict[key] or "" ))
              if key == 'birth_date' and contact_dict[key] is None:
                  contact.set(key, None)
            contact.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
            contact.save()
            add_count+=1
        elif import_type==2:
            if is_private:
                REQUEST.db.execute(("""select item_id from contacts, items where item_id=contact_id and parent_id=%d and first_name=%s and last_name=%s and creator_id=%d""" % (REQUEST.USER.get_parent_id(REQUEST), _Utils.sql_quote(contact_dict['first_name']), _Utils.sql_quote(contact_dict['last_name']))).encode('UTF8'), REQUEST.USER.get_id())
            else:
                REQUEST.db.execute(("""select item_id from contacts, items where item_id=contact_id and parent_id=%d and first_name=%s and last_name=%s""" % (REQUEST.USER.get_parent_id(REQUEST), _Utils.sql_quote(contact_dict['first_name']), _Utils.sql_quote(contact_dict['last_name']))).encode('UTF8'))
            dbres = REQUEST.db.fetchall()
            if len(dbres)>1:
                raise RuntimeError, REQUEST.TLS('contact_duplicate') % (contact_dict['first_name'], contact_dict['last_name'])
            elif len(dbres)==1:
                contact = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, dbres[0][0])
                contact.set('is_private', is_private)
                for key in contact_dict.keys():
                    contact.set(key, urllib.unquote(contact_dict[key] or ""))
                    if key == 'birth_date' and contact_dict[key] is None:
                        contact.set(key, None)
                contact.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
                contact.save()
                update_count+=1
            else:
                contact = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_REQ)
                contact.set('is_private', is_private)
                for key in contact_dict.keys():
                  contact.set(key, contact_dict[key] or "")
                  if key == 'birth_date' and contact_dict[key] is None:
                      contact.set(key, None)
                contact.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
                contact.save()
                add_count+=1
        elif import_type==3:
            if is_private:
                REQUEST.db.execute(("""select item_id, first_name, last_name from contacts, items where item_id=contact_id and parent_id=%d and first_name=%s and last_name=%s and creator_id=%d""" % (REQUEST.USER.get_parent_id(REQUEST), _Utils.sql_quote(contact_dict['first_name']), _Utils.sql_quote(contact_dict['last_name']))).encode('UTF8'), REQUEST.USER.get_id())
            else:
                REQUEST.db.execute(("""select item_id, first_name, last_name from contacts, items where item_id=contact_id and parent_id=%d and first_name=%s and last_name=%s""" % (REQUEST.USER.get_parent_id(REQUEST), _Utils.sql_quote(contact_dict['first_name']), _Utils.sql_quote(contact_dict['last_name']))).encode('UTF8'))
            dbres = REQUEST.db.fetchall()
            if len(dbres)>0:
                ignore_count+=1
                continue
            else:
                contact = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_REQ)
                contact.set('is_private', is_private)
                for key in contact_dict.keys():
                    contact.set(key, urllib.unquote(contact_dict[key] or "" or ""))
                    if key == 'birth_date' and contact_dict[key] is None:
                        contact.set(key, None)
                contact.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
                contact.save()
                add_count+=1
        else:
            pass


  contact_import_success = REQUEST.TLS('contact_import_success')
  contact_import_fount = REQUEST.TLS('contact_import_fount') % found_count
  contact_import_added = REQUEST.TLS('contact_import_added') % add_count
  contact_import_updated = REQUEST.TLS('contact_import_updated') % update_count
  contact_import_left_out = REQUEST.TLS('contact_import_left_out') % ignore_count
  output.append(u"""
&nbsp;&nbsp;&nbsp;<b>%(contact_import_success)s</b>.<br>
&nbsp;&nbsp;&nbsp;%(contact_import_fount)s,<br>
&nbsp;&nbsp;&nbsp;%(contact_import_added)s,<br>
&nbsp;&nbsp;&nbsp;%(contact_import_updated)s,<br>
&nbsp;&nbsp;&nbsp;%(contact_import_left_out)s.<br>""" % locals())
  output.append(standard_html.html_footer(REQUEST))
  return "\n".join(output)

def import_csv(REQUEST, import_type=None):
    if import_type is None:
        import_type = int(REQUEST.form['import_type'].value)

    csv_formats = { 1: ('cp1252', 'Outlook Windows CSV'),
                    3: ('cp850', 'Outlook MS-DOS CSV'),
                    2: ('utf8', 'Unicode UTF-8'),
                    4: (_Conf.FALLBACK_ENCODING, _Conf.FALLBACK_ENCODING),
                  }
    if not REQUEST.form.has_key('csv_format'):
        csv_format = 2
    else:
        csv_format = int(REQUEST.form['csv_format'].value)
        if not csv_formats.has_key(csv_format):
            csv_format = 2

    if REQUEST.form.has_key('file_data') and REQUEST.form.has_key('columns_defined'):
        BLOCK_SIZE = 8192
        output = []
        data = base64.decodestring(REQUEST.form['file_data'].value).decode(csv_formats[csv_format][0])
        parsed_data = _Utils.parse_csv(data)
        if parsed_data and parsed_data[0] and "First Name" in parsed_data[0] and "Last Name" in parsed_data[0]:
            parsed_data = parsed_data[1:]
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_WRITE, [_InitTypes.ITEM_TYPE_CONTACT])
        if right_param:
            right_param = " AND " + right_param
        found_count = 0
        add_count = 0
        update_count = 0
        ignore_count = 0
        field_values = {}
        for i in range(len(parsed_data[0])):
            if REQUEST.form['col_%d_field' % i].value:
                field_values[REQUEST.form['col_%d_field' % i].value] = i
        if ('first_name' not in field_values.keys() or \
           'last_name' not in field_values.keys()) and \
           'full_name' not in field_values.keys():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')

        if REQUEST.form.has_key('import_as_private') and REQUEST.form['import_as_private'].value=="1":
            priv_value = 1
        else:
            priv_value = 0

        for row in parsed_data:
            found_count = found_count + 1
            if field_values.has_key('full_name'):
                first_name, last_name = row[field_values['full_name']].lower().split(' ')[0], " ".join(row[field_values['full_name']].lower().split(' ')[1:])
                if not first_name or not last_name:
                    if field_values.has_key('first_name') and field_values.has_key('last_name'):
                        first_name = row[field_values['first_name']].lower()
                        last_name = row[field_values['last_name']].lower()
            else:
                first_name = row[field_values['first_name']].lower()
                last_name = row[field_values['last_name']].lower()
            if not first_name and not last_name:
                continue
            QUERY = """SELECT contact_id FROM contacts c, items i where i.item_id=c.contact_id and lower(c.first_name)=%s and lower(c.last_name)=%s %s""" % (_Utils.sql_quote(first_name), _Utils.sql_quote(last_name), right_param)
            REQUEST.db.execute(QUERY.encode('UTF8'))
            dbres = REQUEST.db.fetchall()
            if len(dbres)==0 or import_type==1:
                contact = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_REQ)
                add_count = add_count + 1
            elif len(dbres)==1 and import_type==2:
                contact = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, dbres[0][0])
                update_count = update_count + 1
            else:
                ignore_count = ignore_count + 1
                continue
            if field_values.has_key('full_name'):
                first_name, last_name = row[field_values['full_name']].split(' ')[0], " ".join(row[field_values['full_name']].split(' ')[1:])
                contact.set('first_name', first_name)
                contact.set('last_name', last_name)
            else:
                contact.set('first_name', row[field_values['first_name']])
                contact.set('last_name', row[field_values['last_name']])
            if field_values.has_key('middle_name'):
                contact.set('middle_name', row[field_values['middle_name']])
            if field_values.has_key('description'):
                contact.set('description', row[field_values['description']])
            if field_values.has_key('phone_work'):
                contact.set('phone_work', row[field_values['phone_work']])
            if field_values.has_key('contact_category'):
                contact.set('contact_category', row[field_values['contact_category']])
            if field_values.has_key('jobtitle'):
                contact.set('jobtitle', row[field_values['jobtitle']])
            if field_values.has_key('company'):
                contact.set('company', row[field_values['company']])
            if field_values.has_key('e_mail'):
                contact.set('e_mail', row[field_values['e_mail']])
            if field_values.has_key('e_mail2'):
                contact.set('e_mail2', row[field_values['e_mail2']])
            if field_values.has_key('e_mail3'):
                contact.set('e_mail3', row[field_values['e_mail3']])
            if field_values.has_key('phone_cell'):
                contact.set('phone_cell', row[field_values['phone_cell']])
            if field_values.has_key('phone_home'):
                contact.set('phone_home', row[field_values['phone_home']])
            if field_values.has_key('phone_fax'):
                contact.set('phone_fax', row[field_values['phone_fax']])
            if field_values.has_key('mailing_address'):
                contact.set('mailing_address', row[field_values['mailing_address']])
            if field_values.has_key('department'):
                contact.set('department', row[field_values['department']])
            if field_values.has_key('homepage'):
                contact.set('homepage', row[field_values['homepage']])
            if field_values.has_key('birth_date'):
                try:
                    bdate = row[field_values['birth_date']][0:10] or None
                    if bdate and len(bdate)==10:
                        if bdate[2]=="." and bdate[5]==".":
                            bdate = map(int, bdate.split("."))
                            bdate = "%04d-%02d-%02d" % (bdate[2], bdate[1], bdate[0])
                            contact.set('birth_date', bdate)
                        elif bdate[2]=="/" and bdate[5]=="/":
                            bdate = map(int, bdate.split("/"))
                            bdate = "%04d-%02d-%02d" % (bdate[2], bdate[0], bdate[1])
                            contact.set('birth_date', bdate)
                        elif bdate[4]=="-" and bdate[7]=="-":
                            contact.set('birth_date', bdate)
                        else:
                            contact.set('birth_date', None)
                except:
                    contact.set('birth_date', None)
            else:
                contact.set('birth_date', None)
            if field_values.has_key('contact_sex'):
                try:
                    contact.set('contact_sex', int(row[field_values['contact_sex']]))
                except:
                    try:
                        if row[field_values['contact_sex']][0].upper()=="M":
                            sex = 1
                        elif row[field_values['contact_sex']][0].upper()=="F":
                            sex = 2
                        else:
                            sex = 0
                        contact.set('contact_sex', sex)
                    except:
                        pass
            contact.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
            contact.set('is_private', priv_value)
            contact.save()
            save_custom_vals(REQUEST, contact.get_id(), row, field_values)

        contact_import_success = REQUEST.TLS('contact_import_success')
        contact_import_fount = REQUEST.TLS('contact_import_fount') % found_count
        contact_import_added = REQUEST.TLS('contact_import_added') % add_count
        contact_import_updated = REQUEST.TLS('contact_import_updated') % update_count
        contact_import_left_out = REQUEST.TLS('contact_import_left_out') % ignore_count

        output = []
        output.append(standard_html.html_header(REQUEST))
        output.append(get_contact_menu(REQUEST, MY_MENU_ID))
        output.append(u"""
&nbsp;&nbsp;&nbsp;<b>%(contact_import_success)s</b>.<br>
&nbsp;&nbsp;&nbsp;%(contact_import_fount)s,<br>
&nbsp;&nbsp;&nbsp;%(contact_import_added)s,<br>
&nbsp;&nbsp;&nbsp;%(contact_import_updated)s,<br>
&nbsp;&nbsp;&nbsp;%(contact_import_left_out)s.<br>""" % locals())
        output.append(standard_html.html_footer(REQUEST))
        return '\n'.join(output)

    csv_html = u"""<SELECT name="csv_format" onChange="document.forms.impform.submit();">"""
    for (key, item) in csv_formats.items():
        if key == csv_format:
            csv_html += u"""<OPTION SELECTED value="%s">%s\n""" % (key, item[1])
        else:
            csv_html += u"""<OPTION value="%s">%s\n""" % (key, item[1])
    csv_html += u"</SELECT>"
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('file_data'):
        data = base64.decodestring(REQUEST.form['file_data'].value)
        origdata = data
    else:
        BLOCK_SIZE = 8192
        fp = REQUEST.form['import_file'].file
        fp.seek(0)
        fpread = fp.read
        tmp=fpread(BLOCK_SIZE)
        data = ""
        while(tmp):
            data = data + tmp
            tmp=fpread(BLOCK_SIZE)
    origdata = data
    try:
        data = data.decode(csv_formats[csv_format][0])
        parsed_data = _Utils.parse_csv(data)
        errormsg = None
    except:
        errormsg = REQUEST.TLS('tls_charsetconversionfailed')
        parsed_data = []

    c_fields = [
    ('first_name', REQUEST.TLS('tls_first_name')),
    ('last_name', REQUEST.TLS('tls_last_name')),
    ('middle_name', REQUEST.TLS('tls_middle_names')),
    ('full_name', REQUEST.TLS('tls_name')),    
    ('company', REQUEST.TLS('contact_company')),
    ('department', REQUEST.TLS('contact_department')),
    ('jobtitle', REQUEST.TLS('contact_job')),
    ('phone_work', REQUEST.TLS('tls_phone_work')),
    ('phone_cell', REQUEST.TLS('tls_phone_cell')),
    ('phone_home', REQUEST.TLS('tls_phone_home')),
    ('phone_fax', REQUEST.TLS('tls_phone_fax')),
    ('e_mail', REQUEST.TLS('tls_email')),
    ('e_mail2', REQUEST.TLS('tls_email')+ " #2"),
    ('e_mail3', REQUEST.TLS('tls_email')+ " #3"),
    ('contact_category', REQUEST.TLS('tls_category')),
    ('birth_date', REQUEST.TLS('contact_dateofbirth')),
    ('contact_sex', REQUEST.TLS('contact_sex')),
    ('mailing_address', REQUEST.TLS('contact_address')),
    ('description', REQUEST.TLS('tls_description')),
    ('homepage', REQUEST.TLS('contact_homepage')),]


    encodedfile = base64.encodestring(origdata).replace('\n','')
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_import = REQUEST.TLS('contact_import_csv')
    if parsed_data:
        datalen = len(parsed_data[0])
    else:
        datalen = len(c_fields)



    toporg_id = REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id()
    type_id = _InitTypes.ITEM_TYPE_CONTACT
    SQL = "SELECT f.field_id, f.field_name from custom_fields f where f.toporg_id=%d and f.item_type_id=%d order by priority asc""" % (toporg_id, type_id)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchall()
    
    c_fields = u"""<option value="">&nbsp;</option>\n%s""" % "\n".join(map(lambda x: u"""<option value="%s">%s</option>""" % x, c_fields))
    for row in res:
        c_fields = c_fields + u"""<option value="custom_%s">%s</option>""" % (row['field_id'], row['field_name'])
    c_fields = """<SELECT name="col_%d_field">""" + c_fields + u"""</select>"""



    if REQUEST.form.has_key('import_as_private') and REQUEST.form['import_as_private'].value=="1":
        priv_html = u"""&nbsp;&nbsp;%s: <INPUT TYPE="checkbox" value="1" name="import_as_private" CHECKED>""" % REQUEST.TLS('tls_private')
    else:
        priv_html = u"""&nbsp;&nbsp;%s: <INPUT TYPE="checkbox" value="1" name="import_as_private">""" % REQUEST.TLS('tls_private')
    tls_explain = REQUEST.TLS('contactport_csv_explain')
    tls_selectcsvcharset = REQUEST.TLS('tls_selectcsvcharset')
    output.append(u"""\
<form method="post" action="%(BASE_CONTACT_URL)scontactport.py/import_csv" name='impform'>
<input type="hidden" name="import_type" value="%(import_type)d"><input type="hidden" name="file_data" value="%(encodedfile)s">
<TABLE border=0 cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="%(datalen)d" width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap><span class="t3">%(tls_import)s</span></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR class="tr_listing1">
  <TD style="border-top: 1px solid #CCCCCC" ><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD style="border-top: 1px solid #CCCCCC" class="td_listing1bb" colspan="%(datalen)d">%(tls_selectcsvcharset)s: %(csv_html)s %(priv_html)s</TD>
</TR>
<TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1bb" colspan="%(datalen)d">%(tls_explain)s</TD>
</TR>
<TR>
  <TD class="td_listing0bb"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>""" % locals())
    if parsed_data and parsed_data[0]:
        for i in range(len(parsed_data[0])):
            c_fields_row = c_fields % i
            output.append(u"""<TD  class="td_listing0bb" align="center">%s</TD>""" % c_fields_row)
        output.append(u"</TR>")
        ndx = 1
        for row in parsed_data:
            if ndx >= 16: break
            td_class = ndx%2
            output.append(u"<TR class='tr_listing%s'>\n  <TD class='td_listing%s'><img src='%ssspacer.gif' width=10 height=1 border=0 alt=''></TD>" % (td_class, td_class, _Conf.BASE_ICON_URL))
            for column in row:
                if not column:
                    column = "&nbsp;"
                output.append(u"<TD class='td_listing%s'>%s</TD>" % (td_class, column))
            output.append(u"</TR>")
            ndx += 1
    if errormsg:
        output.append(u"""<TR>\n  <TD><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD><TD colspan="%d"><B>%s</B></TD></TR>""" % (_Conf.BASE_ICON_URL, datalen, errormsg))
    output.append(u"""<TR>\n  <TD><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD><TD class="td_listing0bb" colspan="%d"><input class="input6" type=submit name="columns_defined" value="%s"></TD></TR>""" % (_Conf.BASE_ICON_URL, datalen, REQUEST.TLS('contact_import')))
    output.append(u"</TABLE></FORM>")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save_custom_vals(REQUEST, item_id, row, field_values):
    save_ids = []
    ftifp = None
    for key in field_values.keys():
        if key[:7] == 'custom_':
            try:
                save_ids.append([int(key[7:]), row[field_values[key]]])
            except:
                pass
    DEL_SQL = "DELETE FROM custom_rows where item_id=%d" % item_id
    REQUEST.db.execute(DEL_SQL)
    for row in save_ids:
        INSERT_SQL = "INSERT INTO custom_rows (item_id, field_id, contents) values (%d, %d, %s)" % (item_id, row[0], _Utils.sql_quote(row[1]).encode('UTF8'))
        REQUEST.db.execute(INSERT_SQL)
        # Update metadata indexes
        ftifp = cStringIO.StringIO()
    for row in save_ids:
        val = row[1]
        if val and isinstance(val, unicode):
            ftifp.write(val.encode('UTF8') + ' ')
        elif val and isinstance(val, int):
            ftifp.write(str(val) + ' ')
        elif val and isinstance(val, float):
            ftifp.write(str(val) + ' ')
    if ftifp:
        ftifp.seek(0)
        _Indexer.index_file(REQUEST, ftifp, 'a.txt', item_id, ftitype='true')
        ftifp.close()
        del ftifp

