import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Access

import _Discussion, _RootObject, _Person
import string
import cgi

MY_MENU_ID = -1

def index(REQUEST):
    if not REQUEST.form.has_key('discussion_id') or not REQUEST.form['discussion_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    
    if REQUEST.form.has_key('sel') and int(REQUEST.form['sel'].value):
        del_id = int(REQUEST.form['sel'].value)
        disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
        disc_obj.delete()

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))

    tls_author = REQUEST.TLS('tls_author')
    tls_message = REQUEST.TLS('note_message')
    tls_delete = REQUEST.TLS('tls_delete')
    tls_reply = REQUEST.TLS('email_reply')
    tls_edit = REQUEST.TLS('tls_edit')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL

    disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['discussion_id'].value))
    REQUEST.su_by_id(_Conf.SUPERUSER)
    if not disc_obj.get_parent().get('item_type_id') == _InitTypes.ITEM_TYPE_DISCCATEGORY:
        disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, disc_obj.get('parent_id'))

    parent_id = disc_obj.get('parent_id')
    disc_id = disc_obj.get_id()
    disc_subject = cgi.escape(disc_obj.get('disc_subject'))
    REQUEST.unsu()

    reply_row = u"""
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=23 height=30 border=0 alt=""></TD>
    <TD width="100%%"><INPUT type="submit" name="_reply" value="%(tls_reply)s" class="input2"></TD>
  </TR>
</TABLE>""" % locals()

    REQUEST.batch_size = 10
    REQUEST.db.execute("select count(*) from items where (item_id=%d or parent_id=%d) and item_type_id=%d" % (disc_id, disc_id, _InitTypes.ITEM_TYPE_DISCUSSION))
    count_all = REQUEST.db.fetchone()[0]
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sdiscread.py%sqs=" % (_Conf.BASE_DISCUSSION_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sdiscread.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_DISCUSSION_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sdiscread.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_DISCUSSION_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = u"""
<TR valign="top">
  <TD width="15%%" nowrap align=left>&nbsp;%s</TD>
  <TD width="70%%" align="left">%s</TD>
  <TD width="15%%" nowrap align=right>&nbsp;%s</TD>
</TR>""" % (START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

# Batch bar


    tree_bar = _Discussion.tree_bar(REQUEST)
    output.append(u"""\
%(tree_bar)s
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=23 height=1 border=0 alt=""></TD>
    <TD width="100%%" class="disc_title">%(disc_subject)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=23 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE width="100%%" cellpadding=0 cellspacing=0 border=0 style="border: 2px solid #9BB1DA">
      <TR>
        <TD align="center" width="150" class="td_listingdh">%(tls_author)s</TD>
        <TD width="1" bgcolor="#7BA5BD"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=26 border=0 alt=""></TD>
        <TD align="center" width="100%%" class="td_listingdh">%(tls_message)s</TD>
      </TR>
      <TR>
        <TD colspan=3 bgcolor="#7BA5BD"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
""" % locals())

    ndx = 1
    SQL = "SELECT i.item_id, i.creator_id FROM items i WHERE (i.item_id=%d or i.parent_id=%d) ORDER by i.item_id ASC limit %d offset %d" % (disc_obj.get_id(), disc_obj.get_id(), REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL)
    for item in REQUEST.db.dictfetchall():
        disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, item['item_id'])
        REQUEST.su_by_id(_Conf.SUPERUSER)
        try:
            disc_author = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, disc_obj.get('creator_id')).get_name()
        except:
            disc_author = "N/A"
        REQUEST.unsu()
        sub_disc_id = disc_obj.get_id()
        disc_message = parse_icons(REQUEST, _Utils.newline2br(cgi.escape(disc_obj.get('disc_message'))))
        disc_time = REQUEST.iso2userdatetime(REQUEST, disc_obj.get('create_time'))
        if disc_obj.get('creator_id') == REQUEST.USER.get_id():
            disc_edit = """<br><a class="disc_edit" href="%(BASE_DISCUSSION_URL)sdiscadd.py/edit?disc_id=%(sub_disc_id)d">%(tls_edit)s</a>""" % locals()
        else:
            disc_edit = """"""
        

        ndx = ndx%2
        output.append(u"""\
      <TR>
        <TD colspan=3 bgcolor="#7BA5BD"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
      <TR valign="top">
        <TD nowrap width="150" valign="top" class="td_listingd0">
          <span class="disc_author">%(disc_author)s</span>
          <br>
          <span class="disc_date">%(disc_time)s</span>%(disc_edit)s
        </TD>
        <TD width="1" bgcolor="#7BA5BD"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=80 border=0 alt=""></TD>
        <TD width="100%%" valign="top" class="disc_message">%(disc_message)s</TD>
      </TR>""" % locals())
        ndx += 1
    if FULL_BAR:
        output.append(u"""
      <TR>
        <TD colspan=3 bgcolor="#7BA5BD"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
      </TR>
      <TR>
        <TD colspan=3>
          <TABLE border=0 width="100%%" cellpadding=10 cellspacing=0>
          %(FULL_BAR)s
          </TABLE>
        </TD>
      </TR>""" % locals())
    output.append(u"""
    </TABLE>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
""" % locals())
    output.append("""<FORM name="editform" method="POST" action="%(BASE_DISCUSSION_URL)sdiscadd.py/reply"><INPUT type="hidden" name="discussion_id" value="%(disc_id)s"><INPUT type="hidden" name="parent_id" value="%(parent_id)s">%(reply_row)s</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))

    return "\n".join(output)

def parse_icons(REQUEST, text):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    em_smile = REQUEST.TLS('em_smile')
    em_wink = REQUEST.TLS('em_wink')
    em_confused = REQUEST.TLS('em_confused')
    em_eek = REQUEST.TLS('em_eek')
    em_biggrin = REQUEST.TLS('em_biggrin')
    em_cool = REQUEST.TLS('em_cool')
    em_mad = REQUEST.TLS('em_mad')
    em_rolleyes = REQUEST.TLS('em_rolleyes')
    em_embarrassed = REQUEST.TLS('em_embarrassed')
    em_frown = REQUEST.TLS('em_frown')
    em_sarcastic = REQUEST.TLS('em_sarcastic')
    em_silly = REQUEST.TLS('em_silly')
    text = string.replace(text, ":oops:", """<IMG src="%(BASE_ICON_URL)ssmileys/embarrassed.gif" width="15" height="15" border=0 alt="%(em_embarrassed)s" title="%(em_embarrassed)s">""" % locals())
    text = string.replace(text, ":)", """<IMG src="%(BASE_ICON_URL)ssmileys/smile.gif" width="15" height="15" border=0 alt="%(em_smile)s" title="%(em_smile)s">""" % locals())
    text = string.replace(text, ";)", """<IMG src="%(BASE_ICON_URL)ssmileys/wink.gif" width="15" height="15" border=0 alt="%(em_wink)s" title="%(em_wink)s">""" % locals())
    text = string.replace(text, ":?", """<IMG src="%(BASE_ICON_URL)ssmileys/confused.gif" width="15" height="22" border=0 alt="%(em_confused)s" title="%(em_confused)s">""" % locals())
    text = string.replace(text, ":o", """<IMG src="%(BASE_ICON_URL)ssmileys/eek.gif" width="15" height="15" border=0 alt="%(em_eek)s" title="%(em_eek)s">""" % locals())
    text = string.replace(text, ":D", """<IMG src="%(BASE_ICON_URL)ssmileys/biggrin.gif" width="15" height="15" border=0 alt="%(em_biggrin)s" title="%(em_biggrin)s">""" % locals())
    text = string.replace(text, "8)", """<IMG src="%(BASE_ICON_URL)ssmileys/cool.gif" width="15" height="15" border=0 alt="%(em_cool)s" title="%(em_cool)s">""" % locals())
    text = string.replace(text, ":x", """<IMG src="%(BASE_ICON_URL)ssmileys/mad.gif" width="15" height="15" border=0 alt="%(em_mad)s" title="%(em_mad)s">""" % locals())
    text = string.replace(text, ":roll:", """<IMG src="%(BASE_ICON_URL)ssmileys/rolleyes.gif" width="15" height="15" border=0 alt="%(em_rolleyes)s" title="%(em_rolleyes)s">""" % locals())
    text = string.replace(text, ":-/", """<IMG src="%(BASE_ICON_URL)ssmileys/sarcastic.gif" width="15" height="15" border=0 alt="%(em_sarcastic)s" title="%(em_sarcastic)s">""" % locals())
    text = string.replace(text, ":(", """<IMG src="%(BASE_ICON_URL)ssmileys/frown.gif" width="15" height="15" border=0 alt="%(em_frown)s" title="%(em_frown)s">""" % locals())
    text = string.replace(text, ":P", """<IMG src="%(BASE_ICON_URL)ssmileys/silly.gif" width="15" height="15" border=0 alt="%(em_silly)s" title="%(em_silly)s">""" % locals())
    return text
