"""

Default email page.

$Id: efolder2.py,v 1.13 2004/02/15 13:10:57 incxcvs Exp $
"""

from mod_python import apache
import sys
from cStringIO import StringIO
import email, base64, math, _emaillib
import email.Utils
import mx.DateTime, time
import cStringIO
import imaplib

import _Conf, _Utils, _mail, _Efolder, _Email, _InitTypes, _Eaccount, _Access
from Menus import get_email_menu
import standard_html
from _mail import sync

MY_MENU_ID=0

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID, 1))

    BASE_ICON_URL = _Conf.BASE_ICON_URL



    if REQUEST.form.has_key('folder_id') and REQUEST.form['folder_id'].value.decode('UTF8').strip():
        INBOX_ID = int(REQUEST.form['folder_id'].value)
        REQUEST.set_setting('user_inbox_id', INBOX_ID)
        active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    else:
        try:
            INBOX_ID = REQUEST.get_setting('user_inbox_id')
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
        except:
            REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
            result = REQUEST.db.dictfetchone()
            if not result:
                raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
            else:
                INBOX_ID = result['efolder_id']
                REQUEST.set_setting('user_inbox_id', INBOX_ID)
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)

    # Start efolder stuff here 
    REQUEST.db.execute("""SELECT  e.*, i.* FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_SYSTEM))
    result = REQUEST.db.dictfetchall()
    if not result: # The user does not have folders yet, tell the system to make them
        _Efolder.create_default_folders(REQUEST)



    # Find out inbox id
    if REQUEST.form.has_key('folder_id') and REQUEST.form['folder_id'].value.decode('UTF8').strip():
        INBOX_ID = int(REQUEST.form['folder_id'].value)
        REQUEST.set_setting('user_inbox_id', INBOX_ID)
        active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    else:
        try:
            INBOX_ID = REQUEST.get_setting('user_inbox_id')
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
        except:
            REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
            result = REQUEST.db.dictfetchone()
            if not result:
                raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
            else:
                INBOX_ID = result['efolder_id']
                REQUEST.set_setting('user_inbox_id', INBOX_ID)
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)


    if active_folder.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS:
        active_folder_name = REQUEST.TLS('mail_Drafts')
    elif active_folder.get('efolder_flags') & _Efolder.EFOLDER_SENT:
        active_folder_name = REQUEST.TLS('mail_Sent Items')
    elif active_folder.get('efolder_flags') & _Efolder.EFOLDER_INBOX:
        active_folder_name = REQUEST.TLS('mail_Inbox')
    elif active_folder.get('efolder_flags') & _Efolder.EFOLDER_DELETED:
        active_folder_name = REQUEST.TLS('mail_Deleted Items')
    elif active_folder.get('efolder_flags') & _Efolder.EFOLDER_SHARED:
        active_folder_name = REQUEST.TLS('mail_Shared Folder')
    else:
        active_folder_name =  active_folder.get_name()

    # Translation stuff
    tls_folder = REQUEST.TLS('log_folder_id')
    tls_active = REQUEST.TLS('tls_active')
    tls_from = REQUEST.TLS('email_from')
    tls_to = REQUEST.TLS('email_to')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('tls_date')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')
    tls_short_newmail = REQUEST.TLS('email_short_newmail')
    tls_short_attach = REQUEST.TLS('email_short_attach')
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_delete = REQUEST.TLS('tls_delete')
    email_confirm_del = REQUEST.TLS('email_confirm_del')
    email_moveselto = REQUEST.TLS('email_moveselto')
    tls_advanced = REQUEST.TLS('email_advanced_options')
    tls_mark_read = REQUEST.TLS('email_mark_read')
    tls_mark_unread = REQUEST.TLS('email_mark_unread')
    tls_high_priority = REQUEST.TLS('email_high_priority')
    tls_normal_priority = REQUEST.TLS('email_normal_priority')



    
    try:
        email_frame_size = REQUEST.get_setting('email_frame_size')
    except:
        email_frame_size = "0"
    
    if email_frame_size == "0":
      em_size = 300
    elif email_frame_size == "1":
      em_size = 325
    elif email_frame_size == "2":
      em_size = 350
    elif email_frame_size == "3":
      em_size = 375
    elif email_frame_size == "4":
      em_size = 400
    elif email_frame_size == "5":
      em_size = 425
    else:
      em_size = 450
    em_size = em_size - 50
    output.append(u"""\
<DIV style="position: absolute; top: 23px; z-index: 1;">
<FORM method="POST" action="%(BASE_EMAIL_URL)sefolder2.py" name="email">
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#7BC300" class="email_buttons">
<TR>
  <TD colspan="15" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="14" border="0" alt=""></TD>
  <TD nowrap onclick="show_folders();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_folder.gif" width="16" height="14" border="0" alt="">&nbsp;%(tls_folder)s: <b>%(active_folder_name)s</b></TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="confidel();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_del.gif" width="14" height="14" border="0" alt="">&nbsp;%(tls_delete)s</TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="show_efolders();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_moveto.gif" width="15" height="14" border="0" alt="">&nbsp;%(email_moveselto)s&nbsp;<img src="%(BASE_ICON_URL)semail_moveto2.gif" width="7" height="14" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="markread();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_markread.gif" width="14" height="14" border="0" alt="">&nbsp;%(tls_mark_read)s</TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="markunread();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_markunread.gif" width="14" height="14" border="0" alt="">&nbsp;%(tls_mark_unread)s</TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="markpri();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_markpri.gif" width="14" height="14" border="0" alt="">&nbsp;%(tls_high_priority)s</TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="markunpri();" onmouseover="on_over(this);" onmouseout="on_out(this);" class="email_btns"><img src="%(BASE_ICON_URL)semail_markunpri.gif" width="14" height="14" border="0" alt="">&nbsp;%(tls_normal_priority)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
</TR>
<TR>
  <TD colspan="15" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
</TR>
</TABLE>
</FORM>
<SCRIPT type="text/javascript">
function disabletext(e) { return false; }
function reEnable() { return true; }
document.onselectstart=new Function ("return false")
if (window.sidebar){ document.onmousedown=disabletext; document.onclick=reEnable; }
function chan() { b = document.getElementById('111'); if(b.style.display == "none") { b.style.display = "block"; } else { b.style.display = "none";}}
function confidel(){ if(confirm('%(email_confirm_del)s')){ parent.mail_listing.document.forms[0].noname.name = "deleteselected"; parent.mail_listing.document.forms[0].submit();}}
function markread(){ parent.mail_listing.document.forms[0].noname.name = "_markread"; parent.mail_listing.document.forms[0].submit(); } 
function markunread(){ parent.mail_listing.document.forms[0].noname.name = "_markunread"; parent.mail_listing.document.forms[0].submit();}
function markpri(){ parent.mail_listing.document.forms[0].noname.name = "_markpriority"; parent.mail_listing.document.forms[0].submit();}
function markunpri(){ parent.mail_listing.document.forms[0].noname.name = "_markunpriority"; parent.mail_listing.document.forms[0].submit();}
function move(id){ parent.mail_listing.document.forms[0].noname.name = "moveselected"; parent.mail_listing.document.forms[0].noid.name = "moveto_efolder_id"; parent.mail_listing.document.forms[0].noid.value = id; parent.mail_listing.document.forms[0].submit();}
function on_over(kala){ kala.style.backgroundColor = "#91E600";}
function on_out(kala){ kala.style.backgroundColor = "#7BC300";}
function show_folders(){ var fld = parent.mail_listing.document.getElementById('folders'); if(fld.style.visibility=='visible') fld.style.visibility='hidden'; else fld.style.visibility='visible';}
function show_efolders(){ var fld = parent.mail_listing.document.getElementById('efolders'); if(fld.style.visibility=='visible') fld.style.visibility='hidden'; else fld.style.visibility='visible';}
</SCRIPT>
</DIV>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def createfolder(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    tls_newfolder = REQUEST.TLS('email_newfolder')
    tls_foldername = REQUEST.TLS("doc_foldername")
    tls_save = REQUEST.TLS('tls_save')
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')

    if REQUEST.form.has_key('folder_id') and REQUEST.form['folder_id'].value.decode('UTF8').strip():
        INBOX_ID = int(REQUEST.form['folder_id'].value)
        REQUEST.set_setting('user_inbox_id', INBOX_ID)
        active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    else:
        try:
            INBOX_ID = REQUEST.get_setting('user_inbox_id')
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
        except:
            REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
            result = REQUEST.db.dictfetchone()
            if not result:
                raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
            else:
                INBOX_ID = result['efolder_id']
                REQUEST.set_setting('user_inbox_id', INBOX_ID)
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    f_output, e_output = _emaillib.folder_output(REQUEST, active_folder)
    output.append(u"""
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_9.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_newfolder)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_EMAIL_URL)sefolder2.py/newfolder">
 <TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1">%(tls_foldername)s</TD>
  <TD class="td_listing1" width="100%%"><INPUT type="text" class="textfield1" maxlength="25" name="efolder_name"></TD>
 </TR>
 <TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="2"><INPUT type="submit" class="input2" name="add" value="%(tls_save)s"></TD>
 </TR>
</TABLE>
</FORM>
""" % locals())
    output.append(f_output)
    output.append(e_output)
    output.append(standard_html.html_footer3(REQUEST))
    return '\n'.join(output)

def newfolder(REQUEST):
    if not REQUEST.form.has_key('efolder_name') or not REQUEST.form['efolder_name'].value or not REQUEST.form['efolder_name'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    efolder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_NEW)
    efolder.set('efolder_name', REQUEST.form['efolder_name'].value.decode('UTF8').strip())
    efolder.set('parent_id', REQUEST.USER.get_id())
    efolder.set('efolder_flags', 0)
    efolder.save()
    REQUEST.mod_req.headers_out["Location"] = "%sefolder2.py/mail_list" % _Conf.BASE_EMAIL_URL
    return apache.HTTP_MOVED_TEMPORARILY

def deletefolder(REQUEST):
    REQUEST.db.execute("""SELECT e.efolder_id, e.efolder_name FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND e.efolder_flags = 0""" % (REQUEST.USER.get_id()))
    result = REQUEST.db.dictfetchall()
    if result:
        select = u"""<SELECT name="efolder_id">\n%s\n</SELECT>""" % "\n".join(map(lambda x: u"""<OPTION value="%s">%s""" % (x['efolder_id'], x['efolder_name'].decode('UTF8')), result))
    else:
        raise RuntimeError, "No user-created folders."
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    tls_delfolder = REQUEST.TLS('email_delfolder')
    tls_foldername = REQUEST.TLS("doc_foldername")
    tls_delete = REQUEST.TLS('tls_delete')
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')

    if REQUEST.form.has_key('folder_id') and REQUEST.form['folder_id'].value.decode('UTF8').strip():
        INBOX_ID = int(REQUEST.form['folder_id'].value)
        REQUEST.set_setting('user_inbox_id', INBOX_ID)
        active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    else:
        try:
            INBOX_ID = REQUEST.get_setting('user_inbox_id')
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
        except:
            REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
            result = REQUEST.db.dictfetchone()
            if not result:
                raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
            else:
                INBOX_ID = result['efolder_id']
                REQUEST.set_setting('user_inbox_id', INBOX_ID)
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)

    f_output, e_output = _emaillib.folder_output(REQUEST, active_folder)

    output.append(u"""
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_9.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_delfolder)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_EMAIL_URL)sefolder2.py/delfolder">
 <TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1">%(tls_foldername)s</TD>
  <TD class="td_listing1" width="100%%">%(select)s</TD>
 </TR>
 <TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing_noborder" colspan="2"><INPUT type="submit" class="input2" name="del" value="%(tls_delete)s"></TD>
 </TR>
</FORM>
</TABLE>
""" % locals())
    output.append(f_output)
    output.append(e_output)
    output.append(standard_html.html_footer3(REQUEST))
    return '\n'.join(output)

def delfolder(REQUEST):
    if not REQUEST.form.has_key('efolder_id') or not REQUEST.form['efolder_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
    INBOX_ID = result['efolder_id']

    efolder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['efolder_id'].value))
    if efolder.get('efolder_flags')==0:
        efolder.delete()
    REQUEST.mod_req.headers_out["Location"] = "%sefolder2.py/mail_list?folder_id=%d" % (_Conf.BASE_EMAIL_URL, INBOX_ID)
    return apache.HTTP_MOVED_TEMPORARILY


def mail_list(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))

    if REQUEST.form.has_key('folder_id') and REQUEST.form['folder_id'].value.decode('UTF8').strip():
        INBOX_ID = int(REQUEST.form['folder_id'].value)
        REQUEST.set_setting('user_inbox_id', INBOX_ID)
        active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    else:
        try:
            INBOX_ID = REQUEST.get_setting('user_inbox_id')
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
        except:
            REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
            result = REQUEST.db.dictfetchone()
            if not result:
                raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
            else:
                INBOX_ID = result['efolder_id']
                REQUEST.set_setting('user_inbox_id', INBOX_ID)
            active_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, INBOX_ID)
    if active_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF <> 0 and active_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF_ACTIVE <> 0:
        return imap_mail_list(REQUEST, active_folder, INBOX_ID)


    if REQUEST.form.has_key('deleteselected') or REQUEST.form.has_key('deleteselected.x'):
        # Find out delete-items id
        REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DELETED))
        result = REQUEST.db.dictfetchone()
        if not result:
            raise RuntimeError, REQUEST.TLS('email_nodeletedfolder')
        DELBOX_ID = result['efolder_id']

        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
    
        for del_id in del_ids:
            email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            if email_obj.get_parent_id() == DELBOX_ID:
                email_obj.delete()
            else:
                email_obj.set('parent_id', DELBOX_ID)
                email_obj.save()
    elif REQUEST.form.has_key('moveselected') or REQUEST.form.has_key('moveselected.x'):
        if REQUEST.form.has_key('moveto_efolder_id') and REQUEST.form['moveto_efolder_id'].value.decode('UTF8').strip():
            MOVETO_ID = int(REQUEST.form['moveto_efolder_id'].value.decode('UTF8').strip())
        else:
            raise RuntimeError, REQUEST.TLS('email_nofolderdef')

        mov_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                mov_ids.append(int(key[4:]))

        target_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, MOVETO_ID)
        if target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF <>0 and target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF_ACTIVE ==0:
            raise RuntimeError, "FIXME THIS IMAP EFOLDER IS NOT ACTIVE!"
        elif target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF <>0 and target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF_ACTIVE<>0:
            if target_folder.get('eaccount_id'):
                acc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, target_folder.get('eaccount_id'))
            else:
                raise RuntimeError, "THIS IS NOT AN IMAP FOLDER FIXME!!!"
            box = _mail.IMAP4Mailbox()
            box.open(REQUEST, acc)
            folder = target_folder.get('efolder_name')
            if folder.find('"') <> -1 and (len(folder) < 2 or (folder[0] <> '"' and folder[-1] <> '"')):
                folder= folder.replace('"', r'\"')
            if folder.find(' ') <> -1 or folder.find("'") <> -1:
                folder= '"%s"' % folder
            box.foldername = folder

            for mov_id in mov_ids:
                email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mov_id)
                res = box._con.append(box.foldername, None, None, base64.decodestring(email_obj.get('email_contents')))
                if res[0] <> 'OK':
                    raise RuntimeError, str(res)
                email_obj.delete()
                del email_obj
                REQUEST.db.commit()
            box.openfolder(box.foldername)
            box.close()
        else:
            for mov_id in mov_ids:
                email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mov_id)
                email_obj.set('parent_id', MOVETO_ID)
                email_obj.save()
    elif REQUEST.form.has_key('_markread'):
        mov_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                mov_ids.append(int(key[4:]))
    
        for mov_id in mov_ids:
            email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mov_id)
            email_obj.set('email_flags', (email_obj.get('email_flags') or 0) | _Email.EMAIL_READ)
            email_obj.save()
    elif REQUEST.form.has_key('_markunread'):
        mov_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                mov_ids.append(int(key[4:]))
    
        for mov_id in mov_ids:
            email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mov_id)
            email_obj.set('email_flags', (email_obj.get('email_flags') or 0) & (~_Email.EMAIL_READ))
            email_obj.save()
    elif REQUEST.form.has_key('_markpriority'):
        mov_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                mov_ids.append(int(key[4:]))
    
        for mov_id in mov_ids:
            email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mov_id)
            email_obj.set('email_flags', (email_obj.get('email_flags') or 0) | _Email.EMAIL_PRIORITY)
            email_obj.save()
    elif REQUEST.form.has_key('_markunpriority'):
        mov_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                mov_ids.append(int(key[4:]))
    
        for mov_id in mov_ids:
            email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mov_id)
            email_obj.set('email_flags', (email_obj.get('email_flags') or 0) & (~_Email.EMAIL_PRIORITY))
            email_obj.save()

    # Translation stuff
    tls_folders = REQUEST.TLS('tls_folders')
    tls_active = REQUEST.TLS('tls_active')
    tls_from = REQUEST.TLS('email_from')
    tls_to = REQUEST.TLS('email_to')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('email_sent')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')
    tls_short_newmail = REQUEST.TLS('email_short_newmail')
    tls_short_attach = REQUEST.TLS('email_short_attach')
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    if (active_folder.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS) or (active_folder.get('efolder_flags') & _Efolder.EFOLDER_SENT):
        from_or_to = "To"
        tls_from = tls_to
        sortby = [
'email_to ASC, email_id ASC', 'email_to DESC, email_id ASC',
'email_subject ASC, email_id ASC', 'email_subject DESC, email_id ASC',
'email_date ASC, email_id ASC', 'email_date DESC, email_id ASC',
'email_size ASC, email_id ASC', 'email_size DESC, email_id ASC',
'(case when (email_flags & %d)<>0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_READ, '(case when (email_flags & %d)=0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_READ,
'(case when (email_flags & %d)=0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_ATTACH, '(case when (email_flags & %d)<>0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_ATTACH]
    else:
        from_or_to = "From"
        sortby = [
'email_from ASC, email_date DESC', 'email_from DESC, email_date DESC',
'email_subject ASC, email_date DESC', 'email_subject DESC, email_date DESC',
'email_date ASC, email_id ASC', 'email_date DESC, email_id ASC',
'email_size ASC, email_id ASC', 'email_size DESC, email_id ASC',
'(case when (email_flags & %d)<>0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_READ, '(case when (email_flags & %d)=0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_READ,
'(case when (email_flags & %d)=0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_ATTACH, '(case when (email_flags & %d)<>0 then 1 else 0 end), email_date DESC' % _Email.EMAIL_ATTACH]

    DEFAULT_SORTBY = 5
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    formstring = REQUEST.get_formstring(['qs','sort_by','moveselected','deleteselected'])
    sortby_from = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=0">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_from)
    sortby_subject = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=2">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_subject)
    sortby_date = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=4">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_date)
    sortby_size = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=6">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_size)
    sortby_flags = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=8">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_short_newmail)
    sortby_attach = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=10">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_short_attach)
    if sortby_id == 0:
        sortby_from = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_from)
    elif sortby_id == 1:
        sortby_from = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_from)
    elif sortby_id == 2:
        sortby_subject = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_subject)
    elif sortby_id == 3:
        sortby_subject = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_subject)
    elif sortby_id == 4:
        sortby_date = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_date)
    elif sortby_id == 5:
        sortby_date = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_date)
    elif sortby_id == 6:
        sortby_size = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_size)
    elif sortby_id == 7:
        sortby_size = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_size)
    elif sortby_id == 8:
        sortby_flags = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=9">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_short_newmail)
    elif sortby_id == 9:
        sortby_flags = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=8">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_short_newmail)
    elif sortby_id == 10:
        sortby_attach = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=11">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_short_attach)
    elif sortby_id == 11:
        sortby_attach = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=10">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_short_attach)
    del formstring

    output.append(u"""
<SCRIPT type="text/javascript">
function disabletext(e) { return false; }
function reEnable() { return true; }
document.onselectstart=new Function ("return false");
if (window.sidebar){ document.onmousedown=disabletext; document.onclick=reEnable; }
function markAll(){formvar = document.forms['email'];for(var x=0;x<formvar.elements.length;x++) {var y=formvar.elements[x];if(y.name != 'all')y.checked = formvar.all.checked;}CAC();}
function CAC(){ie = document.all?1:0;for (var i=0;i<document.forms['email'].elements.length;i++){var e = document.forms['email'].elements[i];if ((e.name != 'all') && (e.type=='checkbox')){CB=getParent(e);if (e.checked){ei = CB.getElementsByTagName("td");for (var j = 0; j < ei.length; j++){a = ei.item(j);a.style.textDecoration='line-through';}}else{ei = CB.getElementsByTagName("td");for (var j = 0; j < ei.length; j++){a = ei.item(j);a.style.textDecoration='none';}}}}}
function sp(kala, ndx){kala = getParent(kala);el1 = document.getElementById("a555");if(el1){el1.id = "1";el1.style.backgroundColor='#FFFFFF';}if(1){kala.style.backgroundColor='lightblue';kala.id = "a555";kala.className='email_listclass';kamm = document.getElementById("b"+ndx.substring(1));if(kamm.src.indexOf("newmail")!=-1)kamm.src='%(BASE_ICON_URL)smail.gif';}}
function getParent(el) {if (document.all){while (el.parentElement != null){if (el.tagName == 'TR') return el;else el = el.parentElement;}}else if (document.getElementById) {if (el.nodeType == 1 && el.tagName.toLowerCase() == 'tr') return el;else return getParent(el.parentNode);}}
function chk(ndx){e = document.getElementById('c'+ndx);e_td = document.getElementById('a'+ndx);e_tr = getParent(e_td);if(e.checked){ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='line-through';}}else{ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='none';}}}
function chk2(ndx){e = document.getElementById('c'+ndx);e_td = document.getElementById('a'+ndx);e_tr = getParent(e_td);if(!e.checked){e.checked=true;ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='line-through';}}else{e.checked=false;ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='none';}}}
function move(id){document.forms[0].noname.name = "moveselected";document.forms[0].noid.name = "moveto_efolder_id";document.forms[0].noid.value = id;document.forms[0].submit();}
</SCRIPT>
<FORM method="POST" action="%(BASE_EMAIL_URL)sefolder2.py/mail_list" name="email">
<input type="hidden" name="noname" value="1">
<input type="hidden" name="noid" value="1">
<TABLE style="position: relative; left: 1px;" border=0 width="99%%" cellpadding=1 cellspacing=0 bgcolor="#FAFAFA">
 <TR bgcolor="#EEEEEE">
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA; border-left: 1px solid #AAAAAA; padding: 0px; margin: 0px;" width="1" onClick="markAll();"><INPUT type="checkbox" name="all"></TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt="">%(sortby_attach)s</TH>
  <TH nowrap class="email_th2">%(sortby_flags)s</TH>
  <TH nowrap class="email_th1" width="40%%">%(sortby_from)s</TH>
  <TH nowrap class="email_th2" width="60%%">%(sortby_subject)s</TH>
  <TH nowrap class="email_th2">&nbsp;%(sortby_date)s</TH>
  <TH nowrap class="email_th2">%(sortby_size)s</TH>
 </TR>""" % locals())

    if active_folder.get('efolder_flags') & _Efolder.EFOLDER_SHARED <> 0:
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_EMAIL])
        if right_param:
            right_param = " AND " + right_param
        SQL = u"""SELECT count(email_id) AS count_all FROM items i, emails e WHERE e.email_id=i.item_id AND i.is_private=false%s""" % (right_param)
    else:
        SQL = u"""SELECT count(*) AS count_all FROM items i, emails e WHERE e.email_id=i.item_id AND i.parent_id=%d""" % (INBOX_ID)
    REQUEST.db.execute(SQL.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    FULL_BAR = _emaillib.mkbatch(REQUEST, count_all)


    if active_folder.get('efolder_flags') & _Efolder.EFOLDER_SHARED <> 0:
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_EMAIL])
        if right_param:
            right_param = " AND " + right_param
        SQL = """SELECT  e.email_id,
 e.email_from,
 e.email_subject,
 e.email_to,
 e.email_date,
 e.email_savedate,
 e.email_size,
 e.email_flags,
 e.email_from_addr, i.* FROM items i, emails e WHERE e.email_id=i.item_id AND i.is_private=false%s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, sortby[sortby_id], REQUEST.email_batch_size, REQUEST.qs)
    else:
        SQL = """SELECT  e.email_id,
 e.email_from,
 e.email_subject,
 e.email_to,
 e.email_date,
 e.email_savedate,
 e.email_size,
 e.email_flags,
 e.email_from_addr, i.* FROM items i, emails e WHERE e.email_id=i.item_id AND i.parent_id=%d ORDER BY %s LIMIT %d OFFSET %d""" % (INBOX_ID, sortby[sortby_id], REQUEST.email_batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    result = REQUEST.db.dictfetchall()

    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL}
    ndx = 0
    for email_str in result:
        if (active_folder.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS) or (active_folder.get('efolder_flags') & _Efolder.EFOLDER_SENT):
            ns['from'] = _Utils.html_quote(email.Utils.parseaddr(email_str['email_to'])[0] or email_str['email_to'])
        else:
            ns['from'] = email_str['email_from']
        if (active_folder.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS):
            ns['read_or_compose'] = 'compose'
            ns['target'] = 'top.topcontents.document.location'
        else:
            ns['read_or_compose'] = 'read'
            ns['target'] = 'top.topcontents.mail_contents.document.location'
        ns['subject'] = _Utils.html_quote(email_str['email_subject'])
        ns['date'] = _Utils.date2text(REQUEST, email_str['email_date'])
        ns['size'] = _Utils.str_size(email_str['email_size'])
        ns['ndx'] = email_str['email_id']
        ns['ecl'] = 'email_listclass'
        if not email_str['is_private']:
            if email_str['email_flags'] & _Email.EMAIL_ANSWERED:
                ns['is_new'] = '<img id="b%s" src="%spansmail.gif" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
                ns['start_bold'] = ''
                ns['end_bold'] = ''
            else:
                ns['is_new'] = '<img id="b%s" src="%spmail.gif" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
                ns['start_bold'] = ''
                ns['end_bold'] = ''
        elif email_str['email_flags'] & _Email.EMAIL_ANSWERED:
            ns['is_new'] = '<img id="b%s" src="%sansmail.gif" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
            ns['start_bold'] = ''
            ns['end_bold'] = ''
        else:
            if email_str['email_flags'] & _Email.EMAIL_READ:
                ns['is_new'] = '<img id="b%s" src="%smail.gif" width="18" height="14" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
            else:
                ns['is_new'] = '<img id="b%s" src="%snewmail.gif" width="18" height="12" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
                ns['ecl'] = 'email_listclassb'
        if email_str['email_flags'] & _Email.EMAIL_ATTACH:
            ns['has_attachment'] = '<img src="%sattatch.gif" width=14 height=12 border=0 alt="">' % _Conf.BASE_ICON_URL
        else:
            ns['has_attachment'] = '<img src="%sspacer.gif" width=1 height=1 border=0 alt="">' % _Conf.BASE_ICON_URL
        if isinstance(ns['from'], str):
            ns['from'] = ns['from'].decode('UTF8') or '-- no to --'
        if isinstance(ns['subject'], str):
            ns['subject'] = _Utils.shorten_string(ns['subject'].decode('UTF8'), 70)
        if email_str['email_flags'] & _Email.EMAIL_PRIORITY:
            ns['ispriority'] = 'style="color: red"'
        else:
            ns['ispriority'] = ''

        result = u"""\
 <TR class="%(ecl)s" valign="top">
  <TD id="a%(ndx)d" class="email_contents1" %(ispriority)s><center><INPUT id="c%(ndx)d" type="checkbox" onclick="chk('%(ndx)d');" name="sel_%(ndx)d"></center></TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&headers=1';" class="email_contents2" %(ispriority)s>%(has_attachment)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&headers=1';" class="email_contents2">%(is_new)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&headers=1';" class="email_contents3" %(ispriority)s width="40%%">%(from)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&headers=1';" class="email_contents3" %(ispriority)s width="60%%">%(subject)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&headers=1';" class="email_contents3" %(ispriority)s nowrap align="center">%(date)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&headers=1';" class="email_contents4" %(ispriority)s>%(size)s</TD>
 </TR>""" % ns
        output.append(result)
        ndx += 1

    output.append(u"""</FORM>\n</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)
    folder_outputs = _emaillib.folder_output(REQUEST, active_folder)
    output.append(folder_outputs[0])
    output.append(folder_outputs[1])
    output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)


def imap_mail_list(REQUEST, active_folder, inbox_id):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    if active_folder.get('eaccount_id'):
        acc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, active_folder.get('eaccount_id'))
    else:
        raise RuntimeError, "THIS IS NOT AN IMAP FOLDER FIXME!!!"
    if REQUEST.form.has_key('deleteselected') or REQUEST.form.has_key('deleteselected.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
    
        box = _mail.IMAP4Mailbox()
        fp = StringIO()
        count_all = 0
        try:
            box.open(REQUEST, acc, 0)
            box.foldername = active_folder.get('efolder_name')
            box.openfolder(box.foldername)
            for del_id in del_ids:
                # delete local if exists, delete imap always
                REQUEST.db.execute("""SELECT conflux_id FROM imap_emails WHERE folder_id=%d AND imap_uid=%d""" % (active_folder.get_id(), del_id))
                res = REQUEST.db.fetchone()
                if res:
                    email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, res[0])
                    email_obj.delete()
                box.markbit(del_id, "(\Deleted)")
                REQUEST.db.commit()
        finally:
            try: box._con.expunge()
            except: pass
            try: box.close()
            except: pass
            fp.close()

    elif REQUEST.form.has_key('moveselected') or REQUEST.form.has_key('moveselected.x'):
        if REQUEST.form.has_key('moveto_efolder_id') and REQUEST.form['moveto_efolder_id'].value.decode('UTF8').strip():
            MOVETO_ID = int(REQUEST.form['moveto_efolder_id'].value.decode('UTF8').strip())
        else:
            raise RuntimeError, REQUEST.TLS('email_nofolderdef')

        mov_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                mov_ids.append(int(key[4:]))

        target_folder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_ID, MOVETO_ID)
        if target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF <>0 and target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF_ACTIVE ==0:
            raise RuntimeError, "FIXME THIS IMAP EFOLDER IS NOT ACTIVE!"
        elif target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF <>0 and target_folder.get('efolder_flags') & _Efolder.EFOLDER_IMAPF_ACTIVE<>0:
            if target_folder.get('eaccount_id'):
                targetacc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, target_folder.get('eaccount_id'))
            else:
                raise RuntimeError, "THIS IS NOT AN IMAP FOLDER FIXME!!!"
            if active_folder.get('eaccount_id'):
                activeacc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, active_folder.get('eaccount_id'))
            else:
                raise RuntimeError, "THIS IS NOT AN IMAP FOLDER FIXME!!!"
            fp = cStringIO.StringIO()
            tbox = _mail.IMAP4Mailbox()
            tbox.open(REQUEST, targetacc)
            folder = target_folder.get('efolder_name')
            if folder.find('"') <> -1 and (len(folder) < 2 or (folder[0] <> '"' and folder[-1] <> '"')):
                folder= folder.replace('"', r'\"')
            if folder.find(' ') <> -1 or folder.find("'") <> -1:
                folder= '"%s"' % folder
            tbox.foldername = folder
            # tbox.foldername = target_folder.get('efolder_name')
            abox = _mail.IMAP4Mailbox()
            abox.open(REQUEST, activeacc, 0)
            abox.foldername = active_folder.get('efolder_name')
            res = abox.openfolder(abox.foldername)
            if res[0] <> 'OK':
                try: tbox.close()
                except: pass
                try: abox.close()
                except: pass
                raise RuntimeError, res[1][0]

            try:
                for mov_id in mov_ids:
                    email_obj = abox.get(mov_id, fp, 1)
                    res = tbox._con.append(tbox.foldername, None, None, email_obj.as_string())
                    if res[0] <> 'OK':
                        raise RuntimeError, str(res)
                    del email_obj

                    # delete local if exists, delete imap always
                    REQUEST.db.execute("""SELECT conflux_id FROM imap_emails WHERE folder_id=%d AND imap_uid=%d""" % (active_folder.get_id(), mov_id))
                    res = REQUEST.db.fetchone()
                    if res:
                        email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, res[0])
                        email_obj.delete()
                        del email_obj
                    abox.markbit(mov_id, "(\Deleted)")
                    REQUEST.db.commit()
                abox._con.expunge()
            finally:
                try: tbox.openfolder(tbox.foldername)
                except: pass
                try: tbox.close()
                except: pass
                try: abox.openfolder(abox.foldername)
                except: pass
                try: abox.close()
                except: pass
                fp.close()
        else:
            box = _mail.IMAP4Mailbox()
            fp = cStringIO.StringIO()
            box.foldername = active_folder.get('efolder_name')
            box.open(REQUEST, acc, 0)
            try:
                box.openfolder(box.foldername)
                for mov_id in mov_ids:
                    message = box.get(mov_id, fp, use_uid=1)
                    email_id = _mail.mail_from_imap(REQUEST, message, active_folder, MOVETO_ID)

                    # delete local if exists, delete imap always
                    REQUEST.db.execute("""SELECT conflux_id FROM imap_emails WHERE folder_id=%d AND imap_uid=%d""" % (active_folder.get_id(), mov_id))
                    res = REQUEST.db.fetchone()
                    if res:
                        email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, res[0])
                        email_obj.delete()
                    box.markbit(mov_id, "(\Deleted)")
                    REQUEST.db.commit()
            finally:
                try: box._con.expunge()
                except: pass
                try: box.close()
                except: pass
                fp.close()
    elif REQUEST.form.has_key('_markread'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
    
        box = _mail.IMAP4Mailbox()
        fp = StringIO()
        count_all = 0
        try:
            box.open(REQUEST, acc, 0)
            box.foldername = active_folder.get('efolder_name')
            box.openfolder(box.foldername)
            for del_id in del_ids:
                box.markbit(del_id, "(\Seen)")
        finally:
            try: box.close()
            except: pass
            fp.close()
    elif REQUEST.form.has_key('_markunread'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
    
        box = _mail.IMAP4Mailbox()
        fp = StringIO()
        count_all = 0
        try:
            box.open(REQUEST, acc, 0)
            box.foldername = active_folder.get('efolder_name')
            box.openfolder(box.foldername)
            for del_id in del_ids:
                box.unmarkbit(del_id, "(\Seen)")
        finally:
            try: box.close()
            except: pass
            fp.close()

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL

    # Translation stuff
    tls_folders = REQUEST.TLS('tls_folders')
    tls_active = REQUEST.TLS('tls_active')
    tls_from = REQUEST.TLS('email_from')
    tls_to = REQUEST.TLS('email_to')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('email_sent')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')
    tls_short_newmail = REQUEST.TLS('email_short_newmail')
    tls_short_attach = REQUEST.TLS('email_short_attach')

    sortby = [
'(FROM REVERSE ARRIVAL)', '(REVERSE FROM REVERSE ARRIVAL)',
'(SUBJECT REVERSE ARRIVAL)', '(REVERSE SUBJECT REVERSE ARRIVAL)',
'(ARRIVAL)', '(REVERSE ARRIVAL)',
'(SIZE REVERSE ARRIVAL)', '(REVERSE SIZE REVERSE ARRIVAL)',]

    DEFAULT_SORTBY = 5
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    formstring = REQUEST.get_formstring(['qs','sort_by','moveselected','deleteselected'])
    sortby_from = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=0">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_from)
    sortby_subject = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=2">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_subject)
    sortby_date = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=4">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_date)
    sortby_size = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=6">%s</A>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_size)
    sortby_flags = tls_short_newmail
    sortby_attach = tls_short_attach
    if sortby_id == 0:
        sortby_from = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_from)
    elif sortby_id == 1:
        sortby_from = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_from)
    elif sortby_id == 2:
        sortby_subject = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_subject)
    elif sortby_id == 3:
        sortby_subject = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_subject)
    elif sortby_id == 4:
        sortby_date = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_date)
    elif sortby_id == 5:
        sortby_date = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_date)
    elif sortby_id == 6:
        sortby_size = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_size)
    elif sortby_id == 7:
        sortby_size = u"""<A class="email_contentsb" href="%sefolder2.py/mail_list%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_EMAIL_URL, formstring, tls_size)

    output.append(u"""
<SCRIPT type="text/javascript">
function disabletext(e) { return false; }
function reEnable() { return true; }
document.onselectstart=new Function ("return false");
if (window.sidebar){ document.onmousedown=disabletext; document.onclick=reEnable; }
function markAll(){formvar = document.forms['email'];for(var x=0;x<formvar.elements.length;x++) {var y=formvar.elements[x];if(y.name != 'all')y.checked = formvar.all.checked;}CAC();}
function CAC(){ie = document.all?1:0;for (var i=0;i<document.forms['email'].elements.length;i++){var e = document.forms['email'].elements[i];if ((e.name != 'all') && (e.type=='checkbox')){CB=getParent(e);if (e.checked){ei = CB.getElementsByTagName("td");for (var j = 0; j < ei.length; j++){a = ei.item(j);a.style.textDecoration='line-through';}}else{ei = CB.getElementsByTagName("td");for (var j = 0; j < ei.length; j++){a = ei.item(j);a.style.textDecoration='none';}}}}}
function sp(kala, ndx){kala = getParent(kala);el1 = document.getElementById("a555");if(el1){el1.id = "1";el1.style.backgroundColor='#FFFFFF';}if(1){kala.style.backgroundColor='lightblue';kala.id = "a555";kala.className='email_listclass';kamm = document.getElementById("b"+ndx.substring(1));if(kamm.src.indexOf("newmail")!=-1)kamm.src='%(BASE_ICON_URL)smail.gif';}}
function getParent(el) {if (document.all){while (el.parentElement != null){if (el.tagName == 'TR') return el;else el = el.parentElement;}}else if (document.getElementById) {if (el.nodeType == 1 && el.tagName.toLowerCase() == 'tr') return el;else return getParent(el.parentNode);}}
function chk(ndx){e = document.getElementById('c'+ndx);e_td = document.getElementById('a'+ndx);e_tr = getParent(e_td);if(e.checked){ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='line-through';}}else{ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='none';}}}
function chk2(ndx){e = document.getElementById('c'+ndx);e_td = document.getElementById('a'+ndx);e_tr = getParent(e_td);if(!e.checked){e.checked=true;ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='line-through';}}else{e.checked=false;ei = e_tr.getElementsByTagName("td");for (var i = 0; i < ei.length; i++){a = ei.item(i);a.style.textDecoration='none';}}}
function move(id){document.forms[0].noname.name = "moveselected";document.forms[0].noid.name = "moveto_efolder_id";document.forms[0].noid.value = id;document.forms[0].submit();}
</SCRIPT>
<FORM method="POST" action="%(BASE_EMAIL_URL)sefolder2.py/mail_list" name="email">
<input type="hidden" name="noname" value="1">
<input type="hidden" name="noid" value="1">
<TABLE style="position: relative; left: 1px;" border=0 width="99%%" cellpadding=1 cellspacing=0 bgcolor="#FAFAFA">
 <TR bgcolor="#EEEEEE">
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA; border-left: 1px solid #AAAAAA; padding: 0px; margin: 0px;" width="1" onClick="markAll();"><INPUT type="checkbox" name="all"></TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt="">%(sortby_attach)s</TH>
  <TH nowrap class="email_th2">%(sortby_flags)s</TH>
  <TH nowrap class="email_th1" width="40%%">%(sortby_from)s</TH>
  <TH nowrap class="email_th2" width="60%%">%(sortby_subject)s</TH>
  <TH nowrap class="email_th2">&nbsp;%(sortby_date)s</TH>
  <TH nowrap class="email_th2">%(sortby_size)s</TH>
 </TR>""" % locals())

    box = _mail.IMAP4Mailbox()
    fp = StringIO()
    count_all = 0
    try:
        box.open(REQUEST, acc)
        box.foldername = active_folder.get('efolder_name')
        res = box.openfolder(box.foldername)
        if res[0] <> 'OK':
            try: box.close()
            except: pass
            raise RuntimeError, res[1][0]
        hascap_sort = box.hascap("SORT")
        if hascap_sort:
            uidlist = box.uidsort(sortby[sortby_id]).split(' ')
        else:
            uidlist = range(len(box))
        count_all = len(uidlist)

        ns = {}
        ns['BASE_EMAIL_URL'] = BASE_EMAIL_URL
        count = 0
        ns['fldid'] = active_folder.get_id()
        if uidlist == ['']:
            uidlist = []
        for ndx in uidlist[REQUEST.qs:REQUEST.qs+REQUEST.email_batch_size]:
            if count > 10: break
            if hascap_sort:
                email_str, sizedata, flags = box.getfast(ndx, fp, use_uid=1)
            else:
                email_str, sizedata, flags = box.getfast(ndx+1, fp)
            flags = imaplib.ParseFlags(flags[0])
            sizedata2 = sizedata
            try:
                tmp1 = sizedata.find('(') + 1
                tmp2 = sizedata.find(')')
                sizedata = sizedata[tmp1:tmp2].strip().replace(')','').split()
                tmp = {}
                for i in range(0, len(sizedata), 2):
                    tmp[sizedata[i]] = sizedata[i+1]
                sizedata = tmp
                y_orig = email.Utils.parseaddr(_mail.parse_quoted_string(email_str, email_str['from'] or ''))
                y = y_orig[0] or y_orig[1] or '-- no from --'
                ns['from'] = _Utils.html_quote(y)
                ns['subject'] = _mail.parse_quoted_string(email_str, email_str['subject'] or '-- no subject --')
                try:
                    dt = mx.DateTime.DateTimeFrom(email_str['date'])
                except:
                    dt = _Utils.utc_now_mx()
                ns['date'] = REQUEST.iso2userdatetime(REQUEST, dt)
                                       
                flags2 = 0                                                                                                                      
                if 'ANSWERED' in flags:
                    flags2 |= _Email.EMAIL_ANSWERED
                if r'\Seen' in flags:
                    flags2 |= _Email.EMAIL_READ

                ns['read_or_compose'] = 'readimap'
                ns['target'] = 'top.topcontents.mail_contents.document.location'
                ns['size'] = _Utils.str_size(int(sizedata['RFC822.SIZE']))
                if hascap_sort:
                    ns['ndx'] = int(ndx)
                else:
                    ns['ndx'] = int(sizedata['UID'])
                ns['ecl'] = 'email_listclass'

                if flags2 & _Email.EMAIL_ANSWERED:
                    ns['is_new'] = '<img id="b%s" src="%sansmail.gif" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
                else:
                    if flags2 & _Email.EMAIL_READ <> 0:
                        ns['is_new'] = '<img id="b%s" src="%smail.gif" width="18" height="14" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
                    else:
                        ns['is_new'] = '<img id="b%s" src="%snewmail.gif" width="18" height="12" border=0 alt="">' % (ns['ndx'], _Conf.BASE_ICON_URL)
                        ns['ecl'] = 'email_listclassb'
#                if email_str['email_flags'] & _Email.EMAIL_ATTACH:
#                    ns['has_attachment'] = '<img src="%sattatch.gif" width=14 height=12 border=0 alt="">' % _Conf.BASE_ICON_URL
#                else:
#                    ns['has_attachment'] = '<img src="%sspacer.gif" width=1 height=1 border=0 alt="">' % _Conf.BASE_ICON_URL

                ns['has_attachment'] = '<img src="%sspacer.gif" width=1 height=1 border=0 alt="">' % _Conf.BASE_ICON_URL
                ns['ispriority'] = ''
                result = u"""\
 <TR class="%(ecl)s" valign="top">
  <TD id="a%(ndx)d" class="email_contents1" %(ispriority)s><center><INPUT id="c%(ndx)d" type="checkbox" onclick="chk('%(ndx)d');" name="sel_%(ndx)d"></center></TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&folder_id=%(fldid)d&headers=1';" class="email_contents2" %(ispriority)s>%(has_attachment)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&folder_id=%(fldid)d&headers=1';" class="email_contents2">%(is_new)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&folder_id=%(fldid)d&headers=1';" class="email_contents3" %(ispriority)s width="40%%">%(from)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&folder_id=%(fldid)d&headers=1';" class="email_contents3" %(ispriority)s width="60%%">%(subject)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&folder_id=%(fldid)d&headers=1';" class="email_contents3" %(ispriority)s nowrap align="center">%(date)s</TD>
  <TD ondblclick="chk2('%(ndx)d');" onclick="sp(this, 'a%(ndx)d');%(target)s='%(BASE_EMAIL_URL)s%(read_or_compose)s.py?mail_id=%(ndx)d&folder_id=%(fldid)d&headers=1';" class="email_contents4" %(ispriority)s>%(size)s</TD>
 </TR>""" % ns
                output.append(result)
            except:
                raise
            count = count + 1
        box.close()
    except:
        error = str(sys.exc_value)
        try: box.close()
        except: pass
        output.append(u"<TR><TD colspan=7>%s</TD></TR>""" % error)

    fp.close()

    output.append(u"""</FORM>\n</TABLE>""")
    FULL_BAR = _emaillib.mkbatch(REQUEST, count_all)
    if FULL_BAR:
        output.append(FULL_BAR)
    folder_outputs = _emaillib.folder_output(REQUEST, active_folder)
    output.append(folder_outputs[0])
    output.append(folder_outputs[1])
    output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)
