"""

$Id: esettings.py,v 1.3 2003/12/30 00:15:52 incxcvs Exp $
"""

from mod_python import apache
import _Conf, _Utils, _mail, _Eaccount, _InitTypes, _Efolder
from Menus import get_email_menu
import standard_html

MY_MENU_ID=3

def index(REQUEST):
    
    if REQUEST.form.has_key('add'):
        return add_account(REQUEST)
    elif REQUEST.form.has_key('show'):
        return show_userinfo(REQUEST)
    elif REQUEST.form.has_key('sig'):
        return signatures(REQUEST)
    elif REQUEST.form.has_key('dic'):
        return dicts(REQUEST)
    elif REQUEST.form.has_key('imapf'):
        return imapf(REQUEST)

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    REQUEST.db.execute("""SELECT e.* FROM eaccounts e, items i WHERE e.eaccount_id=i.item_id AND i.parent_id=%d ORDER BY eaccount_id""" % REQUEST.USER.get_id())
    accounts = REQUEST.db.dictfetchall()

    accounts_string = []
    index = 0
    for account in accounts:
        if (index%2 == 0):
            account['tdstyle'] = "td_listing0"
        else:
            account['tdstyle'] = "td_listing1"
        index = index + 1
        if account['eaccount_flags'] & _Eaccount.EACCOUNT_IMAP4:
            account['eaccount_type'] = "IMAP4"
        elif account['eaccount_flags'] & _Eaccount.EACCOUNT_POP3:
            account['eaccount_type'] = "POP3"
        elif account['eaccount_flags'] & _Eaccount.EACCOUNT_IMAP4_REMOTE:
            account['eaccount_type'] = "Remote IMAP4"
        else:
            account['eaccount_type'] = '<DIV style="color: red;">Unknown</DIV>'
        if account['eaccount_flags'] & _Eaccount.EACCOUNT_IMAP4_REMOTE:
            account['active_check'] = '&nbsp;'
        elif account['eaccount_flags'] & _Eaccount.EACCOUNT_ACTIVE:
            account['active_check'] = '<DIV style="color: green;">YES</DIV>'
        else:
            account['active_check'] = '<DIV style="color: red;">NO</DIV>'
        if account['eaccount_flags'] & _Eaccount.EACCOUNT_IMAP4_REMOTE:
            account['delete_check'] = '&nbsp;'
        elif (account['eaccount_flags'] & _Eaccount.EACCOUNT_DELETE_MESSAGES) <> 0:
            account['delete_check'] = '<DIV style="color: red;">NO</DIV>'
        else:
            account['delete_check'] = '<DIV style="color: green;">YES</DIV>'

        account['BASE_ICON_URL'] = BASE_ICON_URL
        account['BASE_EMAIL_URL'] = _Conf.BASE_EMAIL_URL
        accounts_string.append(u"""
<TR>
  <TD class="%(tdstyle)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="%(tdstyle)s"><INPUT type="checkbox" name="sel_%(eaccount_id)d"></TD>
  <TD class="%(tdstyle)s" nowrap><A href="%(BASE_EMAIL_URL)sesettings.py/edit_account?eaccount_id=%(eaccount_id)d">%(eaccount_name)s</A></TD>
  <TD class="%(tdstyle)s">%(eaccount_user)s</TD>
  <TD class="%(tdstyle)s">%(eaccount_type)s</TD>
  <TD class="%(tdstyle)s" align="center">%(active_check)s</TD>
  <TD class="%(tdstyle)s" align="center">%(delete_check)s</TD>
</TR>""" % account)
    accounts_string = "\n".join(accounts_string)

    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL,'accounts_string':accounts_string}
    
    if (index%2 == 0):
        ns['tdstyle'] = "td_listing0"
    else:
        ns['tdstyle'] = "td_listing1"
    ns['REQ_FIELD'] = _Conf.REQ_FIELD
    ns['tls_missing_input'] = REQUEST.TLS('tls_missing_input')
    ns['tls_accounts'] = REQUEST.TLS('email_accounts')
    ns['tls_save'] = REQUEST.TLS('tls_save')
    ns['tls_delete'] = REQUEST.TLS('tls_delete')
    ns['tls_server'] = REQUEST.TLS('email_server')
    ns['tls_user'] = REQUEST.TLS('email_user')
    ns['tls_type'] = REQUEST.TLS('email_type')
    ns['tls_active'] = REQUEST.TLS('email_active')
    ns['tls_deletemessages'] = REQUEST.TLS('email_deletemessages')
    ns['tls_deletemessagesbutton'] = REQUEST.TLS('email_deletemessagesbutton')
    ns['tls_activate'] = REQUEST.TLS('email_activate')
    ns['tls_deactivate'] = REQUEST.TLS('email_deactivate')
    ns['tls_addaccount'] = REQUEST.TLS('email_addaccount')
    ns['BASE_ICON_URL'] = BASE_ICON_URL
    ns['menu'] = menu_output(REQUEST)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_EMAIL_URL)sesettings.py/managesettings" method="POST">
<TR>
  <TD class="td_listing1"  width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="4%%">&nbsp;</TD>
  <TD class="td_listing1b" nowrap width="25%%">%(tls_server)s</TD>
  <TD class="td_listing1b" nowrap width="20%%">%(tls_user)s</TD>
  <TD class="td_listing1b" nowrap width="20%%">%(tls_type)s</TD>
  <TD class="td_listing1b" align="center" nowrap width="15%%">%(tls_active)s</TD>
  <TD class="td_listing1b" align="center" nowrap width="15%%">%(tls_deletemessages)s</TD>
</TR>
%(accounts_string)s
<TR>
  <TD class="%(tdstyle)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="%(tdstyle)sb" colspan="6"><INPUT class="input6" type="submit" name="listingdelete" value="%(tls_delete)s">&nbsp;&nbsp;<INPUT class="input6" type="submit" name="listingactivate" value="%(tls_activate)s">&nbsp;&nbsp;<INPUT class="input6" type="submit" name="listingdeactivate" value="%(tls_deactivate)s">&nbsp;&nbsp;<INPUT class="input6" type="submit" name="listingtoggle" value="%(tls_deletemessagesbutton)s"></TD>
</TR>
</TABLE>
</FORM>""" % ns)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add_account(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL}
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['tls_sendermail'] = REQUEST.TLS('email_sendermail')
    ns['tls_sendername'] = REQUEST.TLS('email_sendername')
    ns['tls_delete'] = REQUEST.TLS('tls_delete')
    ns['tls_server'] = REQUEST.TLS('email_server')
    ns['tls_user'] = REQUEST.TLS('email_user')
    ns['tls_type'] = REQUEST.TLS('email_type')
    ns['tls_password'] = REQUEST.TLS('tls_password')
    ns['tls_passwordagain'] = REQUEST.TLS('tls_passwordagain')
    ns['tls_missing_input'] = REQUEST.TLS('tls_missing_input')
    ns['tls_addaccount'] = REQUEST.TLS('email_addaccount')
    ns['REQ_FIELD'] = _Conf.REQ_FIELD
    ns['tls_deletemessages'] = REQUEST.TLS('email_deletemessages')
    ns['tls_save'] = REQUEST.TLS('tls_save')
    ns['menu'] = menu_output(REQUEST)

    output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addaccountform.eaccount_name.value || !document.addaccountform.eaccount_user.value || !document.addaccountform.eaccount_password1.value || !document.addaccountform.eaccount_password2.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_EMAIL_URL)sesettings.py/managesettings" method="POST" name="addaccountform" onsubmit="return check_values();">
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_server)s:</TD>
  <TD class="td_listing1ve" width="100%%"><INPUT class="textfield1" type="text" name="eaccount_name"></TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_user)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="text" name="eaccount_user"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_password)s:</TD>
  <TD class="td_listing1ve"><INPUT class="textfield1" type="password" name="eaccount_password1"></TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_passwordagain)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="password" name="eaccount_password2"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing1ve"><INPUT type="radio" name="eaccount_type" value="POP3" CHECKED>Pop3<INPUT type="radio" name="eaccount_type" value="IMAP4">IMAP4<INPUT type="radio" name="eaccount_type" value="rIMAP4">Remote-IMAP4</TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_deletemessages)s:</TD>
  <TD class="td_listing0ve"><INPUT type="checkbox" name="eaccount_messages"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_sendername)s:</TD>
  <TD class="td_listing1ve"><INPUT class="textfield1" type="text" name="eaccount_sendername"></TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_sendermail)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="text" name="eaccount_sendermail"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="2"><INPUT class="input2" type="submit" name="newsubmit" value="%(tls_save)s"></TD>
 </TR>
</TABLE>
</FORM>""" % ns)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def show_userinfo(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL}
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['menu'] = menu_output(REQUEST)
    ns['tls_userinfo'] = REQUEST.TLS('email_userinfo')
    ns['tls_sendermail'] = REQUEST.TLS('email_sendermail')
    ns['tls_sendername'] = REQUEST.TLS('email_sendername')
    ns['tls_delchk'] = REQUEST.TLS('email_delchk')
    ns['tls_deldays'] = REQUEST.TLS('email_deldays')
    ns['tls_days'] = REQUEST.TLS('tls_timelimit_arg')
    ns['tls_save'] = REQUEST.TLS('tls_save')
    ns['email_imapcleanups'] = REQUEST.TLS('email_imapcleanup')
    try:
        ns['sender_name'] = REQUEST.get_setting('email_sender_name')
    except:
        ns['sender_name'] = REQUEST.USER.get_name()
    try:
        ns['sender_email'] = REQUEST.get_setting('email_sender_email')
    except:
        ns['sender_email'] = ""
    try:
        ns['reply_to'] = REQUEST.get_setting('email_reply_to')
    except:
        ns['reply_to'] = ""
    try:
        setting = REQUEST.get_setting('email_deleteold')
        if setting:
           ns['email_deleteold'] = " checked"
        else:
           ns['email_deleteold'] = ""
    except:
        ns['email_deleteold'] = ""
    try:
        ns['email_deletedays'] = int(REQUEST.get_setting('email_deletedays'))
    except:
        ns['email_deletedays'] = 5
    try:
        ns['email_imapcleanup'] = int(REQUEST.get_setting('email_imapcleanup'))
    except:
        ns['email_imapcleanup'] = 0
    if ns['email_imapcleanup']: ns['email_imapcleanup'] = ' CHECKED'
    else: ns['email_imapcleanup'] = ''
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_EMAIL_URL)sesettings.py/managesettings" method="POST">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_sendername)s:</TD>
  <TD class="td_listing1ve" width="100%%"><INPUT class="textfield1" type="text" name="email_sender_name" value="%(sender_name)s"></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_sendermail)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="text" name="email_sender_email" value="%(sender_email)s"></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(email_imapcleanups)s:</TD>
  <TD class="td_listing1ve"><INPUT type="checkbox" name="imap_cleanup" %(email_imapcleanup)s></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_delchk)s:</TD>
  <TD class="td_listing0ve"><INPUT type="checkbox" name="delete_old" %(email_deleteold)s></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_deldays)s:</TD>
  <TD class="td_listing1ve"><INPUT class="textfield1" type="text" name="delete_days" value="%(email_deletedays)d" size=2>&nbsp;%(tls_days)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="2"><INPUT type="submit" class="input2" name="setsubmit" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % ns)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def signatures(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL}
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['menu'] = menu_output(REQUEST)
    ns['tls_signature'] = REQUEST.TLS('email_signature')
    ns['tls_name'] = REQUEST.TLS('tls_name')
    ns['tls_save'] = REQUEST.TLS('tls_save')
    try:
        sig1 = REQUEST.get_setting('user_signature1')
        ns['name1'] = sig1[0]
        ns['sig1'] = sig1[1]
    except:
        ns['name1'] = ''
        ns['sig1'] = ''
    try:
        sig1 = REQUEST.get_setting('user_signature2')
        ns['name2'] = sig1[0]
        ns['sig2'] = sig1[1]
    except:
        ns['name2'] = ''
        ns['sig2'] = ''
    try:
        sig1 = REQUEST.get_setting('user_signature3')
        ns['name3'] = sig1[0]
        ns['sig3'] = sig1[1]
    except:
        ns['name3'] = ''
        ns['sig3'] = ''
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_EMAIL_URL)sesettings.py/managesettings" method="POST">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_signature)s 1&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD class="td_listing1" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1" width="100%%"><input type="text" value="%(name1)s" class="textfield1" maxlenth="20" name="name1"></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="100%%" colspan="3"><TEXTAREA class="textarea4" wrap="virtual" cols=50 rows=6 name="sig1">%(sig1)s</TEXTAREA></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_signature)s 2&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD class="td_listing1" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1" width="100%%"><input type="text" value="%(name2)s" class="textfield1" maxlenth="20" name="name2"></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="100%%" colspan="3"><TEXTAREA class="textarea4" wrap="virtual" cols=50 rows=6 name="sig2">%(sig2)s</TEXTAREA></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_signature)s 3&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD class="td_listing1" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1" width="100%%"><input type="text" value="%(name3)s" class="textfield1" maxlenth="20" name="name3"></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="100%%" colspan="3"><TEXTAREA class="textarea4" wrap="virtual" cols=50 rows=6 name="sig3">%(sig3)s</TEXTAREA></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="3"><INPUT type="submit" class="input2" name="sigsubmit" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>
""" % ns)

    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def managesettings(REQUEST):
    if REQUEST.form.has_key('setsubmit') or REQUEST.form.has_key('setsubmit.x'):
        if REQUEST.form.has_key('email_sender_name') and REQUEST.form['email_sender_name'].value.decode('UTF8').strip():
            REQUEST.set_setting('email_sender_name', REQUEST.form['email_sender_name'].value.decode('UTF8').strip())
        else:
            REQUEST.del_setting('email_sender_name')
        if REQUEST.form.has_key('email_sender_email') and REQUEST.form['email_sender_email'].value.decode('UTF8').strip():
            REQUEST.set_setting('email_sender_email', REQUEST.form['email_sender_email'].value.decode('UTF8').strip())
        else:
            REQUEST.del_setting('email_sender_email')
        if REQUEST.form.has_key('sender_reply_to') and REQUEST.form['sender_reply_to'].value.decode('UTF8').strip():
            REQUEST.set_setting('email_reply_to', REQUEST.form['sender_reply_to'].value.decode('UTF8').strip())
        else:
            REQUEST.del_setting('email_reply_to')
        if REQUEST.form.has_key('delete_old'):
            REQUEST.set_setting('email_deleteold', 1)
        else:
            REQUEST.del_setting('email_deleteold')
        if REQUEST.form.has_key('imap_cleanup'):
            REQUEST.set_setting('email_imapcleanup', 1)
        else:
            REQUEST.del_setting('email_imapcleanup')
        if REQUEST.form.has_key('delete_days') and REQUEST.form['delete_days'].value.decode('UTF8').strip():
            days = int(REQUEST.form['delete_days'].value.decode('UTF8').strip())
            if days > 0 and days < 367:
                REQUEST.set_setting('email_deletedays', days)
        else:
            REQUEST.del_setting('email_deletedays')

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py?show=1" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

    elif REQUEST.form.has_key('sigsubmit') or REQUEST.form.has_key('sigsubmit.x'):
        if REQUEST.form.has_key('name1') and REQUEST.form['name1'].value.decode('UTF8').strip():
            sig1 = ""
            if REQUEST.form.has_key('sig1') and REQUEST.form['sig1'].value.decode('UTF8').strip():
                sig1 = REQUEST.form['sig1'].value.decode('UTF8').strip()
            sign1 = [REQUEST.form['name1'].value.decode('UTF8').strip(), sig1]
            REQUEST.set_setting('user_signature1', sign1)
        else:
            REQUEST.del_setting('user_signature1')
        if REQUEST.form.has_key('name2') and REQUEST.form['name2'].value.decode('UTF8').strip():
            sig2 = ""
            if REQUEST.form.has_key('sig2') and REQUEST.form['sig2'].value.decode('UTF8').strip():
                sig2 = REQUEST.form['sig2'].value.decode('UTF8').strip()
            sign2 = [REQUEST.form['name2'].value.decode('UTF8').strip(), sig2]
            REQUEST.set_setting('user_signature2', sign2)
        else:
            REQUEST.del_setting('user_signature2')
        if REQUEST.form.has_key('name3') and REQUEST.form['name3'].value.decode('UTF8').strip():
            sig3 = ""
            if REQUEST.form.has_key('sig3') and REQUEST.form['sig3'].value.decode('UTF8').strip():
                sig3 = REQUEST.form['sig3'].value.decode('UTF8').strip()
            sign3 = [REQUEST.form['name3'].value.decode('UTF8').strip(), sig3]
            REQUEST.set_setting('user_signature3', sign3)
        else:
            REQUEST.del_setting('user_signature3')

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py?sig=1" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

    elif REQUEST.form.has_key('listingdelete') or REQUEST.form.has_key('listingdelete.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            account = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            account.delete()

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

    elif REQUEST.form.has_key('listingtoggle') or REQUEST.form.has_key('listingtoggle.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            account = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            if (account.get('eaccount_flags') & _Eaccount.EACCOUNT_DELETE_MESSAGES) <> 0:
                account.set('eaccount_flags', account.get('eaccount_flags') & ~(_Eaccount.EACCOUNT_DELETE_MESSAGES))
            else:
                account.set('eaccount_flags', account.get('eaccount_flags') | _Eaccount.EACCOUNT_DELETE_MESSAGES)
            account.save()

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

    elif REQUEST.form.has_key('listingactivate') or REQUEST.form.has_key('listingactivate.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            account = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            account.set('eaccount_flags', account.get('eaccount_flags') | _Eaccount.EACCOUNT_ACTIVE)
            account.save()

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

    elif REQUEST.form.has_key('listingdeactivate') or REQUEST.form.has_key('listingdeactivate.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            account = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            account.set('eaccount_flags', account.get('eaccount_flags') & ~(_Eaccount.EACCOUNT_ACTIVE))
            account.save()

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

    elif REQUEST.form.has_key('newsubmit') or REQUEST.form.has_key('newsubmit.x'):
        if not REQUEST.form.has_key('eaccount_name') or not REQUEST.form['eaccount_name'].value.decode('UTF8').strip() or \
           not REQUEST.form.has_key('eaccount_user') or not REQUEST.form['eaccount_user'].value.decode('UTF8').strip() or \
           not REQUEST.form.has_key('eaccount_password1') or not REQUEST.form['eaccount_password1'].value.decode('UTF8').strip() or \
           not REQUEST.form.has_key('eaccount_password2') or not REQUEST.form['eaccount_password2'].value.decode('UTF8').strip() or \
           not REQUEST.form.has_key('eaccount_type') or not REQUEST.form['eaccount_type'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('tls_missinginfo')
        if REQUEST.form['eaccount_password1'].value.decode('UTF8').strip() <> REQUEST.form['eaccount_password2'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('admin_users_nomatch')
        if REQUEST.form['eaccount_type'].value.decode('UTF8').strip() not in ['IMAP4','POP3','rIMAP4']:
            raise RuntimeError, REQUEST.TLS('email_invalidserver')

        account = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_NEW)
        if REQUEST.form.has_key('eaccount_messages'):
            account.set('eaccount_flags', 0)
        else:
            account.set('eaccount_flags', _Eaccount.EACCOUNT_DELETE_MESSAGES)
        account.set('parent_id', REQUEST.USER.get_id())
        account.set('is_private', 1)

        account.set('eaccount_name', REQUEST.form['eaccount_name'].value.decode('UTF8').strip())
        account.set('eaccount_user', REQUEST.form['eaccount_user'].value.decode('UTF8').strip())
        account.set('eaccount_password', REQUEST.form['eaccount_password1'].value.decode('UTF8').strip())
        if REQUEST.form['eaccount_type'].value.decode('UTF8').strip() == 'IMAP4':
            account.set('eaccount_flags', account.get('eaccount_flags') | _Eaccount.EACCOUNT_IMAP4)
        elif REQUEST.form['eaccount_type'].value.decode('UTF8').strip() == 'rIMAP4':
            account.set('eaccount_flags', account.get('eaccount_flags') | _Eaccount.EACCOUNT_IMAP4_REMOTE)
        else:
            account.set('eaccount_flags', account.get('eaccount_flags') | _Eaccount.EACCOUNT_POP3)
        account.set('eaccount_flags', account.get('eaccount_flags') | _Eaccount.EACCOUNT_ACTIVE)
        account.set('eaccount_sendername', REQUEST.form['eaccount_sendername'].value.decode('UTF8').strip() or None)
        account.set('eaccount_sendermail', REQUEST.form['eaccount_sendermail'].value.decode('UTF8').strip() or None)
        account.save()

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY


def menu_output(REQUEST):
    output=[]
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_addaccount = REQUEST.TLS('email_addaccount')
    tls_accounts = REQUEST.TLS('email_accounts')
    tls_userinfo = REQUEST.TLS('email_userinfo')
    tls_signatures = REQUEST.TLS('email_sig')
    tls_dictionaries = REQUEST.TLS('tls_dictionaries')
    tls_imapfolders = REQUEST.TLS('tls_imapfolders')
    tls_settings = REQUEST.TLS('compmenu_email_settings')


    active = 0
    if REQUEST.form.has_key('add') and REQUEST.form['add'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_EMAIL_URL)sesettings.py?add=1">%(tls_addaccount)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_EMAIL_URL)sesettings.py?add=1">%(tls_addaccount)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('show') and REQUEST.form['show'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_EMAIL_URL)sesettings.py?show=1">%(tls_userinfo)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_EMAIL_URL)sesettings.py?show=1">%(tls_userinfo)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('sig') and REQUEST.form['sig'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_EMAIL_URL)sesettings.py?sig=1">%(tls_signatures)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_EMAIL_URL)sesettings.py?sig=1">%(tls_signatures)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('dic') and REQUEST.form['dic'].value=='1':
      active = 1
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_EMAIL_URL)sesettings.py?dic=1">%(tls_dictionaries)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_EMAIL_URL)sesettings.py?dic=1">%(tls_dictionaries)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('imapf') and REQUEST.form['imapf'].value=='1':
      active = 1
      el6 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_EMAIL_URL)sesettings.py?imapf=1">%(tls_imapfolders)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el6 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_EMAIL_URL)sesettings.py?imapf=1">%(tls_imapfolders)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_EMAIL_URL)sesettings.py">%(tls_accounts)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_EMAIL_URL)sesettings.py">%(tls_accounts)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    output.append(u"""
      <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap width="100%%"><span class="t3">%(tls_settings)s</span></TD>
      </TR>
      <TR>
        <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
      </TR>
      </TABLE>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el6)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)


def dicts(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_language = REQUEST.TLS('setting_language')
    tls_add = REQUEST.TLS('tls_add')
    tls_delete = REQUEST.TLS('tls_delete')
    tls_confi_del = REQUEST.TLS('tls_confirm_del')
    try:
        langs = REQUEST.get_setting('dictionary_languages')
    except:
        langs = []
    lang_out = ""
    for lang in langs:
        lang_out = lang_out + """&nbsp;&nbsp;&nbsp;<a href="%sesettings.py?dic=1&lang=%s">%s</A>""" % (_Conf.BASE_EMAIL_URL, lang, lang)

    if REQUEST.form.has_key('lang') and REQUEST.form['lang'].value.decode('UTF8').strip():
        style_str = """ style="border-bottom: 0px;" """
    else:
        style_str = ""

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" %(style_str)s  cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD width="1%%"  style="padding: 4px;"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="99%%" style="padding: 4px;">%(tls_language)s:&nbsp;%(lang_out)s</TD>
</TR>
</TABLE>
""" % locals())
    if REQUEST.form.has_key('lang') and REQUEST.form['lang'].value.decode('UTF8').strip():
        lang = REQUEST.form['lang'].value.strip()
        SQL = """SELECT word from dictionaries where language=%s and person_id=%d order by word""" % (_Utils.sql_quote(lang), REQUEST.USER.get_id())
        REQUEST.db.execute(SQL)
        res = REQUEST.db.fetchall()
        output.append(u"""
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="post" action="%(BASE_EMAIL_URL)sesettings.py/add_word">
<input type="hidden" name="dic" value="1">
<input type="hidden" name="lang" value="%(lang)s">
<TR>
  <TD width="1%%"  class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="9%%"  class="td_listing0" nowrap><input type="text" name="word" class="textfield1"></TD>
  <TD width="90%%" class="td_listing0" nowrap><input type="submit" value="%(tls_add)s" class="input2"></TD>
</TR>
</FORM>
""" % locals())
        if res:
            output.append(u"""
            <FORM method="post" action="%(BASE_EMAIL_URL)sesettings.py/del_words">
            <input type="hidden" name="dic" value="1"><input type="hidden" name="lang" value="%(lang)s">""" % locals())
            for row in res:
                word = row[0].decode('UTF8')
                output.append(u"""
<TR>
  <TD class="td_listing0" nowrap><input type="checkbox" name="sel_%(word)s"></TD>
  <TD class="td_listing0" nowrap colspan="2">%(word)s</TD>
</TR>""" % locals())
            output.append(u"""\
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" nowrap colspan="2"><INPUT TYPE="submit" class="input6" name="_delete" value="%(tls_delete)s" onClick="return confirm('%(tls_confi_del)s');"></TD>
</TR>
</FORM>
</TABLE>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add_word(REQUEST):
    if REQUEST.form.has_key('word') and REQUEST.form['word'].value.strip() and REQUEST.form.has_key('lang') and REQUEST.form['lang'].value:
        word = _Utils.sql_quote(REQUEST.form['word'].value.decode('UTF8').strip().lower())
        lang = REQUEST.form['lang'].value.decode('UTF8').strip()
        REQUEST.db.execute(("""SELECT word from dictionaries where word=%s and language=%s and person_id=%d""" % (word, _Utils.sql_quote(lang), REQUEST.USER.get_id())).encode('UTF8'))
        res = REQUEST.db.fetchall()
        if not res:
            REQUEST.db.execute(("""INSERT into dictionaries (person_id, language, word) values (%d, %s, %s)""" % (REQUEST.USER.get_id(), _Utils.sql_quote(lang), word)).encode('UTF8'))
        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py?dic=1&lang=%s" % (_Conf.BASE_EMAIL_URL, str(lang))
        return apache.HTTP_MOVED_TEMPORARILY

def del_words(REQUEST):
    lang = REQUEST.form['lang'].value.decode('UTF8').strip()
    del_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            del_ids.append(key[4:])
    for del_id in del_ids:
        del_id = _Utils.sql_quote(del_id.decode('UTF8').strip().lower())
        REQUEST.db.execute(("""DELETE from dictionaries where person_id=%d and language=%s and word=%s""" % (REQUEST.USER.get_id(), _Utils.sql_quote(lang), del_id)).encode('UTF8'))
        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py?dic=1&lang=%s" % (_Conf.BASE_EMAIL_URL, str(lang))
        return apache.HTTP_MOVED_TEMPORARILY

def imapf(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_server = REQUEST.TLS('email_server')
    tls_user = REQUEST.TLS('email_user')
    tls_save = REQUEST.TLS('tls_save')
    tls_sync = REQUEST.TLS('tls_show')
    tls_connfailed = REQUEST.TLS('tls_connfailed')
    tls_syncfailed = REQUEST.TLS('tls_syncfailed')
    tls_sent = REQUEST.TLS('mail_Sent Items')

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
""" % locals())

    output.append(u"""<TABLE class="td_normal" cellpadding="0" cellspacing="0"><FORM method="POST" action="%(BASE_EMAIL_URL)sesettings.py/save_imapf">""" % locals())


    REQUEST.db.execute("""SELECT e.* FROM eaccounts e, items i WHERE e.eaccount_id=i.item_id AND i.parent_id=%d AND eaccount_flags & %d <> 0 ORDER BY eaccount_id""" % (REQUEST.USER.get_id(), _Eaccount.EACCOUNT_IMAP4_REMOTE))
    accounts = REQUEST.db.dictfetchall()

    for row in accounts:
        output.append(u"""
        <TR>
            <TD width="10%%"  class="td_listing1b" style="text-align: center">%s</TD>
            <TD width="10%%"  class="td_listing1b" style="text-align: center">%s</TD>
            <TD width="90%%" class="td_listing1b">%s: %s, %s: %s</TD>
        </TR>""" % (tls_sync, tls_sent, tls_server, row['eaccount_name'].decode('UTF8'),tls_user,row['eaccount_user'].decode('UTF8')))
        eacc = None
        try:
            eacc_obj = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, row['eaccount_id'])
            eacc = _mail.IMAP4Mailbox()
            eacc.open(REQUEST, eacc_obj)
            eacc_folders = eacc.get_folders()
            try:
                setting = REQUEST.get_setting("sync_%s" % row['eaccount_id'])
            except:
                setting = []
            try:
                sentsetting = REQUEST.get_setting("sentsync_%s" % row['eaccount_id'])
            except:
                sentsetting = None
            output.append(u"""<input type="hidden" name="has_%s" value="1">""" % row['eaccount_id'])
            if eacc_folders[0] == 'OK':
                eacc_folderlist = filter(None, eacc_folders[1])
                eacc_folderlist = map(lambda x: (isinstance(x, tuple) and "() NIL %s" % x[1]) or x, eacc_folderlist)
                if not "INBOX" in map(lambda x: " ".join(x.split(' ')[2:]).decode('UTF8').upper(), eacc_folderlist):
                    eacc_folderlist.append("() NIL INBOX")
                found_sent_match = 0
                for row2 in eacc_folderlist:
                     efolder_name = " ".join(row2.split(' ')[2:]).decode('UTF8')
                     if len(efolder_name) >= 2 and efolder_name[0] == '"' and efolder_name[-1] == '"':
                         efolder_name = efolder_name[1:-1]
                     if efolder_name in setting:
                         chk_str = " CHECKED "
                     else:
                         chk_str = ""
                     if efolder_name == sentsetting:
                         chk_str2 = " CHECKED"
                         found_sent_match = 1
                     else: chk_str2 = ""
                     efolder_name = _Utils.html_quote(efolder_name)
                     if efolder_name.upper() == 'INBOX':
                         output.append(u"""
                     <TR>
                         <TD style="text-align: center"><input type="CHECKBOX" name="sync_%s" value="%s" %s></TD>
                         <TD style="text-align: center">&nbsp;</TD>
                         <TD nowrap style="padding-left: 20px;">%s</TD>
                     </TR>""" % (row['eaccount_id'], efolder_name, chk_str, efolder_name))
                     else:
                         output.append(u"""
                     <TR>
                         <TD style="text-align: center"><input type="CHECKBOX" name="sync_%s" value="%s" %s></TD>
                         <TD style="text-align: center"><input type="radio" name="sentsync_%s" value="%s" %s></TD>
                         <TD nowrap style="padding-left: 20px;">%s</TD>
                     </TR>""" % (row['eaccount_id'], efolder_name, chk_str, row['eaccount_id'], efolder_name, chk_str2, efolder_name))
                output.append(u"""
                     <TR>
                         <TD style="text-align: center">&nbsp;</TD>
                         <TD style="text-align: center"><input type="radio" name="sentsync_%s" value="-1" %s></TD>
                         <TD nowrap style="padding-left: 20px;">%s</TD>
                     </TR>""" % (row['eaccount_id'], (found_sent_match and " ") or " CHECKED", REQUEST.TLS('tls_localfolders')))
            else:
                output.append(u"""
                <TR>
                    <TD colspan="3" style="padding-left: 20px;">%(tls_syncfailed)s</TD>
                </TR>""" % locals())
            len(eacc) # dummy select folder to quit without error
            eacc.close()
        except:
            try: eacc.close()
            except: pass
            output.append(u"""
            <TR>
                <TD colspan="3" class="td_listing0">%(tls_connfailed)s</TD>
            </TR>""" % locals())

    output.append(u"""
    <TR><TD colspan=3  class="td_listing1"><INPUT name="SAVE" type="submit" value="%(tls_save)s" class="input2"></TD></TR>""" % locals())
    output.append(u"""</FORM></TABLE>""")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save_imapf(REQUEST):
    values = {}
    has_list = []
    for key in REQUEST.form.keys():
        if key[:5] == 'sync_':
            try:
                values[key] = [REQUEST.form[key].value.decode('UTF8')]
            except:
                values[key] = map(lambda x: x.decode('UTF8'), REQUEST.form[key])
        elif key[:4] == 'has_':
            has_list.append(key[4:])

    SQL = u"""UPDATE efolders SET efolder_flags=efolder_flags&(~%d) WHERE efolder_id in (SELECT item_id FROM items WHERE parent_id=%d AND item_type_id=%d)""" % (_Efolder.EFOLDER_IMAPF_ACTIVE, REQUEST.USER.get_id(), _InitTypes.ITEM_TYPE_EFOLDER)
    REQUEST.db.execute(SQL.encode('UTF8'))
    for key in values.keys():
        REQUEST.set_setting(key, values[key])
        for row in values[key]:
            SQL = u"""SELECT efolder_id FROM efolders WHERE eaccount_id=%d AND efolder_name=%s""" % (int(key[5:]), _Utils.sql_quote(row))
            REQUEST.db.execute(SQL.encode('UTF8'))
            res = REQUEST.db.fetchone()
            if not res:
                efolder = _Efolder.Efolder(REQUEST, _InitTypes.INIT_TYPE_NEW)
                efolder.set('is_private', 1)
                efolder.set('efolder_name', row)
                efolder.set('efolder_flags', _Efolder.EFOLDER_IMAPF|_Efolder.EFOLDER_IMAPF_ACTIVE)
                efolder.set('parent_id', REQUEST.USER.get_id())
                efolder.set('eaccount_id', int(key[5:]))
                efolder.save()
            else:
                SQL = u"""UPDATE efolders SET efolder_flags=efolder_flags|%d WHERE efolder_id=%s""" % (_Efolder.EFOLDER_IMAPF_ACTIVE, res[0])
                REQUEST.db.execute(SQL.encode('UTF8'))
    for row in has_list:
       if ("sync_%s" % row) not in values.keys():
           REQUEST.set_setting(("sync_%s" % row), [])

    values = {}
    for key in REQUEST.form.keys():
        if key[:9] == 'sentsync_':
            try:
                values[key] = [REQUEST.form[key].value.decode('UTF8')]
            except:
                values[key] = map(lambda x: x.decode('UTF8'), REQUEST.form[key])
    for key in values.keys():
        REQUEST.set_setting(key, values[key][0])

    REQUEST.mod_req.headers_out["Location"] = "%sesettings.py?imapf=1" % _Conf.BASE_EMAIL_URL
    return apache.HTTP_MOVED_TEMPORARILY

def edit_account(REQUEST):
    eacc = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['eaccount_id'].value))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL}
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['tls_delete'] = REQUEST.TLS('tls_delete')
    ns['tls_server'] = REQUEST.TLS('email_server')
    ns['tls_user'] = REQUEST.TLS('email_user')
    ns['tls_type'] = REQUEST.TLS('email_type')
    ns['tls_password'] = REQUEST.TLS('tls_password')
    ns['tls_passwordagain'] = REQUEST.TLS('tls_passwordagain')
    ns['tls_missing_input'] = REQUEST.TLS('tls_missing_input')
    ns['tls_addaccount'] = REQUEST.TLS('email_addaccount')
    ns['REQ_FIELD'] = _Conf.REQ_FIELD
    ns['tls_deletemessages'] = REQUEST.TLS('email_deletemessages')
    ns['tls_save'] = REQUEST.TLS('tls_save')
    ns['menu'] = menu_output(REQUEST)
    ns['eaccount_name'] = eacc.get('eaccount_name') or ''
    ns['eaccount_user'] = eacc.get('eaccount_user') or ''
    ns['eaccount_sendername'] = eacc.get('eaccount_sendername') or ''
    ns['eaccount_sendermail'] = eacc.get('eaccount_sendermail') or ''
    ns['eaccount_id'] = eacc.get_id()
    ns['tls_sendermail'] = REQUEST.TLS('email_sendermail')
    ns['tls_sendername'] = REQUEST.TLS('email_sendername')

    if eacc.get('eaccount_flags') & _Eaccount.EACCOUNT_IMAP4:
        ns['account_type'] = 'IMAP4'
    elif eacc.get('eaccount_flags') & _Eaccount.EACCOUNT_POP3:
        ns['account_type'] = 'POP3'
    elif eacc.get('eaccount_flags') & _Eaccount.EACCOUNT_IMAP4_REMOTE:
        ns['account_type'] = 'Remote IMAP4'
    if eacc.get('eaccount_flags')&_Eaccount.EACCOUNT_DELETE_MESSAGES==0:
        ns['delmessages'] = " CHECKED"
    else:
        ns['delmessages'] = ""

    output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addaccountform.eaccount_name.value || !document.addaccountform.eaccount_user.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<FORM action="%(BASE_EMAIL_URL)sesettings.py/saveaccount" method="POST" name="addaccountform" onsubmit="return check_values();">
<input type="hidden" name="eaccount_id" value="%(eaccount_id)d">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_server)s:</TD>
  <TD class="td_listing1ve" width="100%%"><INPUT class="textfield1" type="text" name="eaccount_name" value=%(eaccount_name)s></TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_user)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="text" name="eaccount_user" value="%(eaccount_user)s"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_password)s:</TD>
  <TD class="td_listing1ve"><INPUT class="textfield1" type="password" name="eaccount_password1" value=""></TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_passwordagain)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="password" name="eaccount_password2"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing1ve">%(account_type)s</TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_deletemessages)s:</TD>
  <TD class="td_listing0ve"><INPUT type="checkbox" name="eaccount_messages" %(delmessages)s></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_sendername)s:</TD>
  <TD class="td_listing1ve"><INPUT class="textfield1" type="text" name="eaccount_sendername" value="%(eaccount_sendername)s"></TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_sendermail)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" type="text" name="eaccount_sendermail" value="%(eaccount_sendermail)s"></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="2"><INPUT class="input2" type="submit" name="newsubmit" value="%(tls_save)s"></TD>
 </TR>
</TABLE>
</FORM>""" % ns)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def saveaccount(REQUEST):
    if 1:
        if not REQUEST.form.has_key('eaccount_name') or not REQUEST.form['eaccount_name'].value.decode('UTF8').strip() or \
           not REQUEST.form.has_key('eaccount_user') or not REQUEST.form['eaccount_user'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('tls_missinginfo')
        set_password = 0
        if REQUEST.form.has_key('eaccount_password1') and REQUEST.form.has_key('eaccount_password2') and \
           REQUEST.form['eaccount_password1'].value.decode('UTF8').strip() <> REQUEST.form['eaccount_password2'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('admin_users_nomatch')
        if REQUEST.form.has_key('eaccount_password1') and REQUEST.form.has_key('eaccount_password2') and \
           REQUEST.form['eaccount_password1'].value.decode('UTF8').strip() == REQUEST.form['eaccount_password2'].value.decode('UTF8').strip() and \
           REQUEST.form['eaccount_password2'].value.decode('UTF8').strip():
           set_password = 1

        account = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['eaccount_id'].value))
        if REQUEST.form.has_key('eaccount_messages'):
            account.set('eaccount_flags', account.get('eaccount_flags')&(~_Eaccount.EACCOUNT_DELETE_MESSAGES))
        else:
            account.set('eaccount_flags', account.get('eaccount_flags')|_Eaccount.EACCOUNT_DELETE_MESSAGES)
        account.set('is_private', 1)

        account.set('eaccount_name', REQUEST.form['eaccount_name'].value.decode('UTF8').strip())
        account.set('eaccount_user', REQUEST.form['eaccount_user'].value.decode('UTF8').strip())
        if set_password:
            account.set('eaccount_password', REQUEST.form['eaccount_password1'].value.decode('UTF8').strip())
        account.set('eaccount_sendername', REQUEST.form['eaccount_sendername'].value.decode('UTF8').strip() or None)
        account.set('eaccount_sendermail', REQUEST.form['eaccount_sendermail'].value.decode('UTF8').strip() or None)
        account.save()

        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sesettings.py" % _Conf.BASE_EMAIL_URL
        return apache.HTTP_MOVED_TEMPORARILY

