"""
The front page.
$Id: frontmanage.py,v 1.4 2003/12/30 00:20:00 incxcvs Exp $
"""

import standard_html, _Conf, Menus, _Utils
from mod_python import apache

MY_MENU_ID=3

def index(REQUEST):

    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        edit_root = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            edit_root = 0
        else:
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_URL = _Conf.BASE_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_save = REQUEST.TLS('tls_save')
    tls_frontmanage = REQUEST.TLS('tls_frontmanage')
    tls_help_name = REQUEST.TLS('frontpage_help_name')
    tls_help_text = REQUEST.TLS('frontpage_help_contents')
    try:
         body = REQUEST.get_setting('frontpage_contents')
    except:
         body = ""
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))
    output.append(u"""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_front.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_frontmanage)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="post" action="%(BASE_URL)sfrontmanage.py/save_frontpage">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
    <TD class="td_listing1" width="100%%">%(tls_help_name)s</TD>
    <TD class="td_listing1" ><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="10" border="0" alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
    <TD class="td_listing0" width="100%%">%(tls_help_text)s</TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="10" border="0" alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
    <TD class="td_listing0" width="100%%">
""" % locals())
    output.append(_Utils.get_epoz_field(REQUEST, 'body', body))
    output.append(u"""\
        </TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="10" border="0" alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
    <TD class="td_listing1" width="100%%"><input type="submit" value="%(tls_save)s" class="input2"></TD>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="10" border="0" alt=""></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save_frontpage(REQUEST):
    if REQUEST.form.has_key('body'):
        REQUEST._settings.set_setting_org(REQUEST, 'frontpage_contents', REQUEST.form['body'].value.decode('UTF8'))
    REQUEST.mod_req.headers_out["Location"] = "%sfrontmanage.py" % _Conf.BASE_URL
    return apache.HTTP_MOVED_TEMPORARILY
