"""
The front page - links
$Id: links.py,v 1.3 2003/12/30 00:20:00 incxcvs Exp $
"""

from mod_python import apache
import standard_html, _Conf, Menus, _Access, _InitTypes, _Bookmark, _Utils

MY_MENU_ID=1

def index(REQUEST):
    if REQUEST.form.has_key('add'):
        return addform(REQUEST)
    elif REQUEST.form.has_key('_save'):
        return save(REQUEST)
    elif REQUEST.form.has_key('sync'):
        return sync(REQUEST)
    elif REQUEST.form.has_key('_deletesel'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
        for del_id in del_ids:
            book_obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            book_obj.delete()
    elif REQUEST.form.has_key('del'):
        book_obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['cat'].value))
        book_obj.delete()
    elif REQUEST.form.has_key('edit'):
        return editform(REQUEST)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))

    tls_url = REQUEST.TLS('tls_url')
    tls_bookmarks = REQUEST.TLS('tls_links')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_desc = REQUEST.TLS('tls_description')
    tls_add = REQUEST.TLS('tls_add')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    tls_showmine = REQUEST.TLS('tls_onlymine')
    tls_delete = REQUEST.TLS('tls_deletesel')
    tls_confirm_del = REQUEST.TLS('tls_confirm_del')



    if REQUEST.form.has_key('all') and int(REQUEST.form['all'].value)==1:
        extra_param = """ AND i.is_private=false """
        all = "1"
    else:
        all = "0"
        extra_param = """ AND i.is_private=true """
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_BOOKMARK])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('parent_cat'):
        parent_id = int(REQUEST.form['parent_cat'].value)
    else:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)
    SQL = u"""SELECT b.*, i.* FROM bookmarks b, items i WHERE i.parent_id=%d and  b.bookmark_id=i.item_id %s%s and b.is_category=1 order by b.bookmark_url""" % (parent_id, extra_param, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_URL = _Conf.BASE_URL
    menu = menu_output(REQUEST)

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_bookmarks.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_bookmarks)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD width="100%%">%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_100" cellpadding="0" cellspacing="0" style="border: 1px solid #CCCCCC;">
<TR class="tr_listing1">
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
</TR>
</TABLE>
<BR>""" % locals())

    
    output.append(u"""
<FORM method="post" action="%(BASE_URL)slinks.py">
<input type="hidden" name="all" value="%(all)s">
<TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    count = 0
    count1 = 0
    count2 = 0
    temp = ""
    out1 = ""
    out2 = ""
    for row in dbresult:
        count, temp = draw_table(REQUEST, row['bookmark_id'])
        if count2<count1:
            count2 = count2 + count
            out2 = out2 + temp
        else:
            count1 = count1 + count
            out1 = out1 + temp

    output.append(u"""
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="50%%">%(out1)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="50%%">%(out2)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
""" % locals())
    output.append(u"""
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
  <TD colspan="3"><input type="submit" name="_deletesel" value="%(tls_delete)s" class="input6" onClick="return confirm('%(tls_confirm_del)s');"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def addform(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))


    BASE_URL = _Conf.BASE_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_add = REQUEST.TLS('tls_add')
    tls_url = REQUEST.TLS('tls_url')
    tls_save = REQUEST.TLS('tls_save')
    tls_desc = REQUEST.TLS('tls_description')
    tls_private = REQUEST.TLS('tls_private')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addbookmark = REQUEST.TLS('tls_addbookmark')
    tls_addcat = REQUEST.TLS('disc_addcat')
    tls_category = REQUEST.TLS('tls_category')
    tls_private = REQUEST.TLS('tls_private')
    tls_catname = REQUEST.TLS('tls_cat_name')
    tls_catparent = REQUEST.TLS('tls_book_parent')
    tls_bookmarks = REQUEST.TLS('tls_links')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    menu = menu_output(REQUEST)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_BOOKMARK])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT b.*, i.treepos from bookmarks b, items i where b.bookmark_id=i.item_id and b.is_category = 1 and i.is_private=true %s order by i.treepos""" % right_param).encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    
    sel_1 = u"""<SELECT name="category1"><OPTION></OPTION>"""
    for row in dbres:
        posi = (len(row['treepos'])/32 - 3) * 2
        indent = "&nbsp;"*posi
        sel_1 += u"""<OPTION value="%s">%s%s</OPTION>""" % (row['bookmark_id'], indent, row['bookmark_url'].decode('UTF8'))
    sel_1 += u"""</SELECT>"""
    
    REQUEST.db.execute(("""SELECT b.*, i.treepos from bookmarks b, items i where b.bookmark_id=i.item_id and b.is_category = 1 and i.is_private=false %s order by i.treepos""" % right_param).encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    sel_2 = u"""<SELECT name="category2"><OPTION></OPTION>"""
    for row in dbres:
        posi = (len(row['treepos'])/32 - 3) * 2
        indent = "&nbsp;"*posi
        sel_2 += u"""<OPTION value="%s">%s%s</OPTION>""" % (row['bookmark_id'], indent, row['bookmark_url'].decode('UTF8'))
    sel_2 += u"""</SELECT>"""

    REQUEST.db.execute(("""SELECT b.*, i.treepos from bookmarks b, items i where b.bookmark_id=i.item_id and b.is_category = 1 %s order by treepos""" % right_param).encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    sel_3 = u"""<SELECT name="category">"""
    for row in dbres:
        posi = (len(row['treepos'])/32 - 3) * 2
        indent = "&nbsp;"*posi
        sel_3 += u"""<OPTION value="%s">%s%s</OPTION>""" % (row['bookmark_id'], indent, row['bookmark_url'].decode('UTF8'))
    sel_3 += u"""</SELECT>"""
    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
function check_values()
{
  if (!document.addform.bookmark_url.value)
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
function check_values2()
{
  if (!document.addform2.bookmark_url.value)
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
  function change_div(kala)
{
    div1 = document.getElementById('123');
    div2 = document.getElementById('124');
    if(kala.form.is_private.checked==true)
    {
        div1.style.display="none";
        div2.style.display="block";
    }
    else
    {
        div1.style.display="block";
        div2.style.display="none";
    }
}
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_bookmarks.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_bookmarks)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD width="100%%">%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_URL)slinks.py/save" onsubmit="return check_values();">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_url)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="text" size=30 class="textfield1" name="bookmark_url"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_desc)s</TD>
    <TD class="td_listing0"><INPUT size=50 type="text"  class="textfield1" name="bookmark_description"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_category)s</TD>
    <TD class="td_listing1" width="100%%">%(sel_3)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" name="_save1" value="%(tls_save)s" class="input2"></TD>
  </TR>
</FORM>
<FORM name="addform2" method="POST" action="%(BASE_URL)slinks.py/save" onsubmit="return check_values2();">
</TABLE>
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_bookmarks.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_addcat)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_catname)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="text" size=30 class="textfield1" name="bookmark_url"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_desc)s</TD>
    <TD class="td_listing0"><INPUT size=50 type="text"  class="textfield1" name="bookmark_description"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_private)s</TD>
    <TD class="td_listing1"><input type="checkbox" name="is_private" value="1" onclick="change_div(this);"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_catparent)s</TD>
    <TD class="td_listing0"><div id='123'>%(sel_2)s</div><div id='124' style="display: none">%(sel_1)s</div></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="2"><INPUT type="submit" name="_save2" value="%(tls_save)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save(REQUEST):
    if not REQUEST.form.has_key('bookmark_url') or not REQUEST.form['bookmark_url'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    bookmark = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_REQ)
    if REQUEST.form.has_key('_save2'):
        bookmark.set('is_category', 1)
    else:
        bookmark.set('is_category', 0)
    if REQUEST.form.has_key('_save2') and not (REQUEST.form.has_key('category1') and REQUEST.form['category1'].value or REQUEST.form.has_key('category2') and REQUEST.form['category2'].value):
       bookmark.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
    else:
       if REQUEST.form.has_key('_save2'):
           if REQUEST.form.has_key('is_private'):
               bookmark.set('parent_id', int(REQUEST.form['category1'].value))
           else:
               bookmark.set('parent_id', int(REQUEST.form['category2'].value))
       else:
         if REQUEST.form.has_key('category'):
             bookmark.set('parent_id', int(REQUEST.form['category'].value))
         else:
              tls_links = REQUEST.TLS('tls_links')
              obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_REQ)
              obj.set('bookmark_url', tls_links)
              obj.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
              obj.set('is_category', 1)
              obj.set('is_private', 1)
              obj.save()
              parent = obj.get_id()
              bookmark.set('parent_id', parent)
    bookmark.save()

    REQUEST.mod_req.headers_out["Location"] = "%slinks.py" % _Conf.BASE_URL
    return apache.HTTP_MOVED_TEMPORARILY

def menu_output(REQUEST):
    output=[]
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_URL = _Conf.BASE_URL


    tls_my = REQUEST.TLS('tls_mybookmarks')
    tls_all = REQUEST.TLS('tls_othersbookmarks')
    tls_add = REQUEST.TLS('tls_addbookmark')
    tls_expimp = REQUEST.TLS('compmenu_export_import')

    active = 0
    if REQUEST.form.has_key('all') and REQUEST.form['all'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_URL)slinks.py?all=1">%(tls_all)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_URL)slinks.py?all=1">%(tls_all)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('add') and REQUEST.form['add'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_URL)slinks.py?add=1">%(tls_add)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_URL)slinks.py?add=1">%(tls_add)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('sync') and REQUEST.form['sync'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_URL)slinks.py?sync=1">%(tls_expimp)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_URL)slinks.py?sync=1">%(tls_expimp)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_URL)slinks.py">%(tls_my)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_URL)slinks.py">%(tls_my)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def draw_table(REQUEST, cat_id):
    category = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_ID, cat_id)
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_BOOKMARK])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT b.*, i.*, p.item_name as person_name FROM bookmarks b, items i, items p WHERE i.parent_id=%d and b.bookmark_id=i.item_id AND i.creator_id=p.item_id%s order by is_category desc, bookmark_url asc""" % (category.get_id(), right_param)).encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    cat_name = _Utils.html_quote_show(category.get_name())
    cat_id = category.get_id();
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_URL = _Conf.BASE_URL
    tls_edit = REQUEST.TLS('tls_edit')
    output = []
    output.append(u"""
<TABLE border="0" cellpadding="0" cellspacing="0" style="border: 1px solid #596E33;" width="100%%">
<TR bgcolor="#596E33">
  <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
  <TD class="td_hdr" width="100%%" nowrap align="left"><b>%(cat_name)s</B></TD>
  <TD nowrap align="right" style="color: #FFFFFF;"><a href="%(BASE_URL)slinks.py?edit=1&cat=%(cat_id)s" style="color: #FFFFFF;">%(tls_edit)s</a></TD>
  <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
</TR>
</TABLE>
<TABLE border="0" cellpadding="0" cellspacing="0" style="border: 1px solid #596E33;" width="100%%">
""" % locals())
    count = 2
    for row in dbres:
        count = count + 1
        if row['bookmark_description']:
            desc = _Utils.html_quote_show(row['bookmark_description'].decode('UTF8').strip())
        else:
            desc = _Utils.html_quote_show(row['bookmark_url'].decode('UTF8').strip())
        if row['bookmark_url'].decode('UTF8')[0:4]=="http":
          bookmark_name = _Utils.html_quote_show(row['bookmark_url'].decode('UTF8'))
        else:
          bookmark_name = _Utils.html_quote_show("http://" + row['bookmark_url'].decode('UTF8'))
        selbox = ""
        if row['is_category']==1:
            if REQUEST.form.has_key('all') and REQUEST.form['all']=="1":
                extra_par = "&all=1"
            else:
                extra_par = ""
            book_img = """<img src="%(BASE_ICON_URL)sbook_cat.gif" width="16" height="16" border="0" alt="">""" % locals()
            bookmark_name = """<a href="%slinks.py?parent_cat=%s%s" class="blacklink">%s</a>""" % (_Conf.BASE_URL, cat_id, extra_par, row['bookmark_url'].decode('UTF8'))
        else:
            book_img = """<img src="%(BASE_ICON_URL)sbook_link.gif" width="16" height="16" border="0" alt="">""" % locals()
            bookmark_name = """<a href="%s" class="blacklink" target="blank">%s</a>""" % (bookmark_name, desc)
            selbox = u"""<input type="checkbox" name="sel_%s">""" % row['bookmark_id']
        output.append(u"""
<TR>
  <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
  <TD class="td_listingd0">%(book_img)s</b></TD>
  <TD class="td_listingd0" width="100%%" align="left">%(bookmark_name)s</b></TD>
  <TD class="td_listingd0">%(selbox)s</TD>
</TR>""" % locals())
    output.append("""</TABLE><BR><BR>""")
    return [count, "\n".join(output)]

def sync(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))


    BASE_URL = _Conf.BASE_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_add = REQUEST.TLS('tls_add')
    tls_url = REQUEST.TLS('tls_url')
    tls_save = REQUEST.TLS('tls_save')
    tls_desc = REQUEST.TLS('tls_description')
    tls_private = REQUEST.TLS('tls_private')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addbookmark = REQUEST.TLS('tls_addbookmark')
    tls_addcat = REQUEST.TLS('disc_addcat')
    tls_category = REQUEST.TLS('tls_category')
    tls_private = REQUEST.TLS('tls_private')
    tls_catname = REQUEST.TLS('tls_cat_name')
    tls_catparent = REQUEST.TLS('tls_book_parent')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_export = REQUEST.TLS('contact_export')
    tls_import = REQUEST.TLS('contact_import')
    tls_format = REQUEST.TLS('tls_format')
    tls_file = REQUEST.TLS('tls_file')
    tls_all = REQUEST.TLS('tls_all')
    tls_othersbookmarks = REQUEST.TLS('tls_othersbookmarks')
    tls_mybookmarks = REQUEST.TLS('tls_mybookmarks')
    tls_format_html = REQUEST.TLS('tls_format_html')
    tls_format_opera = REQUEST.TLS('tls_format_opera')
    tls_book_expimp = REQUEST.TLS('tls_book_expimp')
    tls_bookmarks = REQUEST.TLS('tls_links')
    menu = menu_output(REQUEST)
    
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_bookmarks.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_bookmarks)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD width="100%%">%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="export" method="POST" action="%(BASE_URL)slinks.py/export_bookmarks">
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="100%%" nowrap>%(tls_book_expimp)s</TD>
</TR>
</TABLE>
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_export)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_export)s:</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="radio" name="all_bookmarks" value="0" checked>&nbsp;%(tls_mybookmarks)s&nbsp;<INPUT type="radio" name="all_bookmarks" value="1">&nbsp;%(tls_othersbookmarks)s&nbsp;<INPUT type="radio" name="all_bookmarks" value="2">&nbsp;%(tls_all)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_format)s:</TD>
    <TD class="td_listing0"><INPUT type="radio" name="format" value="0" checked>&nbsp;%(tls_format_html)s&nbsp;<INPUT type="radio" name="format" value="1">&nbsp;%(tls_format_opera)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="2"><INPUT type="submit" name="_save1" value="%(tls_export)s" class="input2"></TD>
  </TR>
</FORM>
</TABLE>
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_import)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="import" method="POST" action="%(BASE_URL)slinks.py/import_bookmarks" ENCTYPE="multipart/form-data">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_file)s:</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="file" size=30 class="textfield1" name="filepointer"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" name="_save2" value="%(tls_import)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def import_bookmarks(REQUEST):
  BLOCK_SIZE = 8192
  if not REQUEST.form.has_key('filepointer'):
      raise RuntimeError, REQUEST.TLS('required_parameters_missing') 
  output = []
  output.append(standard_html.html_header(REQUEST))
  output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))
  filepointer=REQUEST.form['filepointer'].file
  fpread = filepointer.read
  data = ""
  tmp=fpread(BLOCK_SIZE)
  while(tmp):
    data = data + tmp
    tmp=fpread(BLOCK_SIZE)
  lifo_list = []
  depth = 0
  parent = 0
  parents = []
  cats = []
  links = []
  cat_parents={}
  if REQUEST.form['filepointer'].filename.split(".")[-1]=="html":
      while(data.find('<')<>-1):
          data = data[data.find('<')+1:]
          if data[0:2].upper()=="DL":
              depth = depth + 1
          elif data[0:3].upper()=="/DL":
              depth = depth - 1
              try:
                  parents.pop()
              except:
                  pass
          elif data[0:2].upper()=="H3":
              tempdata = data[data.find(">")+1:data.find("</H3>")].decode('UTF8').replace("\n","").replace("  "," ").replace("&amp;","&").strip()
              try:
                  parent = parents[len(parents)-1]
              except:
                  parent = 0
              parents.append(tempdata)
              cat = [tempdata, parent, depth]
              cats.append(cat)
          elif data[0:6].upper()=="A HREF":
              data = data[data.find('"')+1:]
              tempdata1 = data[0:data.find('"')].decode('UTF8').replace("\n","").replace("  "," ").replace("&amp;","&").strip()
              data = data[data.find('>')+1:]
              tempdata2 = data[0:data.find('>')-3].decode('UTF8').replace("\n","").replace("  "," ").replace("&amp;","&").strip()
              data = data[data.find('>')+1:]
              try:
                  parent = parents[len(parents)-1]
              except:
                  parent = 0
              thislink = [tempdata1, tempdata2, parent]
              links.append(thislink)
          else:
              pass
  elif REQUEST.form['filepointer'].filename.split(".")[-1]=="adr":
      data = data.split("\n")
      i = 0
      while(i in range(0, len(data))):
          if data[i][0:7]=="#FOLDER":
              i = i + 2
              depth = depth + 1
              tempdata = data[i][6:].strip()
              try:
                  parent = parents[len(parents)-1]
              except:
                  parent = 0
              cat = [tempdata, parent, depth]
              parents.append(tempdata)
              cats.append(cat)
          elif data[i] and data[i][0]=="-":
              depth = depth - 1
              try:
                  parents.pop()
              except:
                  pass
          elif data[i][0:4]=="#URL":
              i = i+2
              tempdata2 = data[i][6:].strip()
              i = i + 1
              tempdata1 = data[i][5:].strip()
              try:
                  parent = parents[len(parents)-1]
              except:
                  parent = 0
              thislink = [tempdata1, tempdata2, parent]
              links.append(thislink)
          i = i + 1

  def comp1(a, b):
      if a[2] > b[2]: return 1
      elif a[2] < b[2]: return -1
      else: return 0
  cats.sort(comp1)
  
## creating categories
  right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_WRITE, [_InitTypes.ITEM_TYPE_BOOKMARK])
  if right_param:
      right_param = " AND " + right_param

  for cat in cats:
      try:
          cat[0] = cat[0].decode('UTF8')
      except:
          pass
      REQUEST.db.execute(("""SELECT bookmark_id from bookmarks b, items i where b.bookmark_id=i.item_id and b.bookmark_url=%s and b.is_category=1 and i.is_private=true%s""" % (_Utils.sql_quote(cat[0]), right_param)).encode('UTF8'))
      dbres = REQUEST.db.fetchone()
      if dbres and dbres[0]:
         cat_parents[cat[0]] = dbres[0]
      else:
         obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_REQ)
         obj.set('bookmark_url', cat[0])
         if cat[1]<>0 and cat_parents[cat[1]]:
             obj.set('parent_id', cat_parents[cat[1]])
         else:
             obj.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
         obj.set('is_category', 1)
         obj.set('is_private', 1)
         obj.save()
         cat_parents[cat[0]] = obj.get_id()
  tls_links = REQUEST.TLS('tls_links')
  for link in links:
      try:
          parent = cat_parents[link[2]]
      except:
          REQUEST.db.execute((u"""SELECT bookmark_id from bookmarks b, items i where b.bookmark_id=i.item_id and b.bookmark_url='%s' and i.parent_id=%d and b.is_category=1 and i.is_private=true%s""" % (tls_links, REQUEST.USER.get_parent_id(REQUEST), right_param)).encode('UTF8'))
          dbres = REQUEST.db.fetchone()
          if dbres and dbres[0]:
              parent = dbres[0]
          else:
              obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_REQ)
              obj.set('bookmark_url', tls_links)
              obj.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
              obj.set('is_category', 1)
              obj.set('is_private', 1)
              obj.save()
              parent = obj.get_id()
      if isinstance(link[0], str):
          link[0] = link[0].decode('UTF8')
      if isinstance(link[1], str):
          link[1] = link[1].decode('UTF8')
      REQUEST.db.execute((u"""SELECT bookmark_id from bookmarks b, items i where b.bookmark_id=i.item_id and b.bookmark_url=%s and b.bookmark_description=%s and i.parent_id=%d and b.is_category=0 and i.is_private=true%s""" % (_Utils.sql_quote(link[0]), _Utils.sql_quote(link[1]), parent, right_param)).encode('UTF8'))
      dbres = REQUEST.db.fetchone()
      if dbres and dbres[0]:
         continue
      else:
         obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_REQ)
         obj.set('bookmark_url', link[0])
         obj.set('bookmark_description', link[1])
         obj.set('parent_id', parent)
         obj.set('is_category', 0)
         obj.set('is_private', 1)
         obj.save()
  menu = menu_output(REQUEST)
  BASE_ICON_URL = _Conf.BASE_ICON_URL
  tls_success = REQUEST.TLS('tls_import_success')
  output.append(u"""
<BR>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<TR>
  <TD colspan=2 width="100%%">%(menu)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="100%%" nowrap>%(tls_success)s</TD>
</TR>
</TABLE>
<BR>""" % locals())
  output.append(standard_html.html_footer(REQUEST))
  return "\n".join(output)

def export_bookmarks(REQUEST):
    if REQUEST.form.has_key('all_bookmarks') and REQUEST.form['all_bookmarks'].value=="2":
      extra_pars = " "
    elif REQUEST.form.has_key('all_bookmarks') and REQUEST.form['all_bookmarks'].value=="1":
      extra_pars = " and i.is_private=false "
    else:
      extra_pars = " and i.creator_id=%d and i.is_private=true " % REQUEST.USER.get_id()
    if REQUEST.form.has_key('format') and REQUEST.form['format'].value=="1":
      format = 1
    else:
      format = 0
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_BOOKMARK])
    if right_param:
        right_param = " AND " + right_param
    SQL = u"""SELECT b.*, i.* FROM bookmarks b, items i WHERE  b.bookmark_id=i.item_id %s%s order by i.treepos""" % (extra_pars, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    if _Conf.IS_MP_27:
        REQUEST.mod_req.send_http_header()
    if format:
      REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=opera6.adr"
      REQUEST.mod_req.content_type = "text/plain"
      reqwrite = REQUEST.mod_req.write
      reqwrite("""\
Opera Hotlist version 2.0
Options: encoding = utf8, version=3
""")
      oldlevel = -1
      for row in dbres:
          if row['is_category']==1:
              newlevel = len(row['treepos'])/32 - 1
              if oldlevel == -1:
                  base_depth = newlevel
              if oldlevel<>-1 and (oldlevel>=newlevel or newlevel==base_depth):
                  count = oldlevel - newlevel + 1
                  if newlevel==base_depth and newlevel==oldlevel:
                      str = "\n-\n"
                  else:
                      str = "\n-\n"*count
                  reqwrite(str)
              oldlevel = len(row['treepos'])/32 - 1
          if row['is_category']==1:
              reqwrite("""
#FOLDER
\tID=%d
\tNAME=%s
""" % (row['bookmark_id'], row['bookmark_url']))
          else:
              reqwrite("""
#URL
\tID=%d
\tNAME=%s
\tURL=%s
""" % (row['bookmark_id'], row['bookmark_description'].replace("\n", ""), row['bookmark_url']))
      reqwrite("\n-\n"*oldlevel)
    else:
      REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=bookmarks.html"
      REQUEST.mod_req.content_type = "text/plain"
      reqwrite = REQUEST.mod_req.write
      reqwrite("""\
<!DOCTYPE NETSCAPE-Bookmark-file-1>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
<TITLE>Bookmarks</TITLE>
<H1>Bookmarks</H1>\n\n
""")
      oldlevel = -1
      for row in dbres:
          newlevel = len(row['treepos'])/32 - 1
          if oldlevel == -1:
              tabstr = (newlevel-1)*"\t"
              reqwrite("\n%s<DL>" % tabstr)
          if newlevel>oldlevel and oldlevel<>-1:
              tabstr = (newlevel-1)*"\t"
              reqwrite("\n%s<DL>" % tabstr)
          if newlevel<oldlevel:
              count = oldlevel-newlevel
              tabstr = (oldlevel-1)*"\t"
              str = count*"</DL>"
              reqwrite("\n%s%s" % (tabstr,str))
          oldlevel = len(row['treepos'])/32 - 1
          tabstr = newlevel*"\t"
          if row['is_category']==1:
              reqwrite("""\n%s<DT><H3>%s</H3></DT>""" % (tabstr, row['bookmark_url']))
          else:
              reqwrite("""\n%s<DT><A HREF="%s">%s</A></DT>""" % (tabstr, row['bookmark_url'], row['bookmark_description'].replace("\n", "")))
      reqwrite("\n"+(oldlevel-1)*"</DL>")
    return apache.OK

def editform(REQUEST):
    if not (REQUEST.form.has_key('cat') and REQUEST.form['cat'].value):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    cat = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['cat'].value))
    cat_id = cat.get_id()
    cat_name = _Utils.html_quote_edit(cat.get('bookmark_url'))
    cat_desc = _Utils.html_quote_edit(cat.get('bookmark_description') or '')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST)
    tls_catname = REQUEST.TLS('tls_cat_name')
    tls_desc = REQUEST.TLS('tls_description')
    tls_save = REQUEST.TLS('tls_save')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_del = REQUEST.TLS('tls_delete')
    tls_confirm_del = REQUEST.TLS('tls_confirm_del')
    tls_bookmarks = REQUEST.TLS('tls_links')
    BASE_URL = _Conf.BASE_URL
    REQ_FIELD = _Conf.REQ_FIELD
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""
<script type="text/javascript">
function check_values()
{
  if (!document.addform.bookmark_url.value)
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
</script>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
      <TD><img src="%(BASE_ICON_URL)stitle_bookmarks.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
      <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
      <TD nowrap><span class="t3">%(tls_bookmarks)s</span></TD>
      <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD><img src="/web/icons/spacer.gif" width="10" height="5" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD width="100%%">%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_URL)slinks.py/editsave" onsubmit="return check_values();">
<INPUT TYPE="hidden" name="cat" value="%(cat_id)s">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_catname)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="text" size=30 class="textfield1" value="%(cat_name)s" name="bookmark_url"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_desc)s</TD>
    <TD class="td_listing0"><INPUT size=50 type="text" value="%(cat_desc)s" class="textfield1" name="bookmark_description"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="2"><input type="submit" value="%(tls_save)s" class="input6">&nbsp;<input type="submit" value="%(tls_del)s" class="input6" name="_del" onClick="return confirm('%(tls_confirm_del)s');"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    return "\n".join(output)

def editsave(REQUEST):
    if REQUEST.form.has_key('_del'):
        book_obj = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['cat'].value))
        book_obj.delete()
        REQUEST.mod_req.headers_out["Location"] = "%slinks.py" % _Conf.BASE_URL
        return apache.HTTP_MOVED_TEMPORARILY
    if not REQUEST.form.has_key('cat') or not REQUEST.form['cat'].value.strip() or  not REQUEST.form.has_key('bookmark_url') or not REQUEST.form['bookmark_url'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    cat = _Bookmark.Bookmark(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['cat'].value))
    cat.set('bookmark_url', REQUEST.form['bookmark_url'].value.strip())
    if REQUEST.form.has_key('bookmark_description') and REQUEST.form['bookmark_description'].value.strip():
      cat.set('bookmark_description', REQUEST.form['bookmark_description'].value.strip())
    cat.save()
    REQUEST.mod_req.headers_out["Location"] = "%slinks.py" % _Conf.BASE_URL
    return apache.HTTP_MOVED_TEMPORARILY
