
import _Conf, _Utils, _RootObject
import standard_html

def index(REQUEST):
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_MESSENGER_URL = _Conf.BASE_MESSENGER_URL
    if not REQUEST.form.has_key('im_to') or not REQUEST.form['im_to'].value:
        raise RuntimeError, "No user ID"
    user_id = int(REQUEST.form['im_to'].value)
    if user_id == -1:
        return reminder_contents(REQUEST)
    tls_send = REQUEST.TLS('tls_send').lower()
    SQL = "SELECT p.first_name || ' ' || p.last_name as name from persons p where p.person_id=%d" % REQUEST.USER.get_id()
    REQUEST.db.execute(SQL)
    user_name = REQUEST.db.fetchone()[0].decode('UTF8')
    host_name = REQUEST.mod_req.server.server_hostname
    if REQUEST.is_https:
        protocol = "https://"
    else:
        protocol = "http://"
    output = []
    output.append(standard_html.html_header(REQUEST, "", "onload='window.focus();document.f.q.focus();'", 0))
    output.append(u"""\
<script type="text/javascript" src="%(BASE_WEB_URL)sreq.js"></script>
<form name="f">
<table border="0" cellpadding="0" cellspacing="0"><tr><td align="center">
<iframe frameborder="0" border="0" width="385" height="200" name="im_iframe" src="%(BASE_MESSENGER_URL)smessenger.py/iframesrc" style="border: 1px solid #AAAAAA;"></iframe>
</td></tr></table>
<table border="0" width="385" cellpadding="0" cellspacing="0"><tr valign="top"><td>
<textarea tabindex=1 id="im_message" name="q" style="width:320px; height: 50px; border: 2px dashed #CCCCCC; overflow: auto;"></textarea><BR>
</td>
<td align="center" style="padding-top: 5px;">
<input tabindex=2 type="button" onclick="send_m()" value="%(tls_send)s" style="border: 1px solid #444444;">
</td></tr></table>
<script type="text/javascript">
function send_m()
{
  ta = document.getElementById('im_message');
  sndtxt = ta.value;
  if(!sndtxt) { document.f.q.focus(); return true; }
  sndtxt = replaceSubstring(sndtxt, '\\n', '<BR>');
  sndtxt = replaceSubstring(sndtxt, "'", "\\\\'");
  sndtxt = replaceSubstring(sndtxt, ";", " ");
  url = "%(protocol)s%(host_name)s%(BASE_MESSENGER_URL)smessenger.py/send_im?m="+sndtxt+"&d=%(user_id)d";
  SendRequest(url);
  txt = ta.value;
  while(txt.indexOf('\\n')!=-1){ txt = txt.replace('\\n', '<BR>'); }
  txt = '<b><font color="#FF0000">%(user_name)s:</font></b> ' +txt+ '<BR>';
  el = im_iframe.document.getElementById('im_div');
  el.innerHTML = el.innerHTML + txt;
  im_iframe.scrollTo(0,100000);
  ta.value = "";
  document.f.q.focus();
}
function get_m()
{
  txt = SendRequest_RES("%(protocol)s%(host_name)s%(BASE_MESSENGER_URL)smessenger.py/get_im?source_id=%(user_id)d");
  if(txt && txt!=" ")
  {
    el = im_iframe.document.getElementById('im_div');
    el.innerHTML = el.innerHTML + txt;
    im_iframe.scrollTo(0,100000);
    window.focus();
    document.f.q.focus()
  }
  setTimeout("get_m()", 1000);
}
function replaceSubstring(inputString, fromString, toString) {var temp = inputString;if (fromString == "") {return inputString;}if (toString.indexOf(fromString) == -1) { while (temp.indexOf(fromString) != -1) {var toTheLeft = temp.substring(0, temp.indexOf(fromString));var toTheRight = temp.substring(temp.indexOf(fromString)+fromString.length, temp.length);temp = toTheLeft + toString + toTheRight;}} else { var midStrings = new Array("~", "`", "_", "^", "#");var midStringLen = 1;var midString = "";while (midString == "") {for (var i=0; i < midStrings.length; i++) {var tempMidString = "";for (var j=0; j < midStringLen; j++) { tempMidString += midStrings[i]; }if (fromString.indexOf(tempMidString) == -1) { midString = tempMidString; i = midStrings.length + 1;}}} while (temp.indexOf(fromString) != -1) {var toTheLeft = temp.substring(0, temp.indexOf(fromString));var toTheRight = temp.substring(temp.indexOf(fromString)+fromString.length, temp.length);temp = toTheLeft + midString + toTheRight;}while (temp.indexOf(midString) != -1) {var toTheLeft = temp.substring(0, temp.indexOf(midString));var toTheRight = temp.substring(temp.indexOf(midString)+midString.length, temp.length);temp = toTheLeft + toString + toTheRight;}}return temp;}
function initf(){  setTimeout("get_m()", 1000); }
if (window.addEventListener)        window.addEventListener("load", initf, false); else if (window.attachEvent)        window.attachEvent("onload", initf); else if (document.getElementById)   window.onload=initf;
</script>
</form>
""" % locals())
    output.append(standard_html.html_footer3(REQUEST))
    return '\n'.join(output)


def iframesrc(REQUEST):
    return """<HTML><HEAD><TITLE>IM</TITLE></HEAD><BODY style="margin-top: 0px;margin-left: 0px;margin-right: 0px;"><div id='im_div'></div></BODY></HTML>"""

def send_im(REQUEST):
    if REQUEST.form.has_key('m') and REQUEST.form['m'].value.strip() and REQUEST.form.has_key('d') and REQUEST.form['d'].value.strip():
        source = REQUEST.USER.get_id()
        dest = int(REQUEST.form['d'].value.strip())
        msg = REQUEST.form['m'].value.strip()
        try:
            msg = msg.decode('UTF8').encode('UTF8')
        except:
            msg = msg.decode('LATIN1').encode('UTF8')
        SQL = """INSERT INTO im ( source_id, dest_id, message, date ) VALUES (%s, %s, '%s', now())""" % (source, dest, msg)
        REQUEST.db.execute(SQL)
        return " "

def get_im(REQUEST):
    source_id = int(REQUEST.form['source_id'].value)
    SQL = """SELECT i.msg_id, i.message, p.first_name || ' ' || p.last_name as sender, date from im i, persons p where i.dest_id=%d and i.source_id=%d and i.source_id=p.person_id order by date desc""" % (REQUEST.USER.get_id(), source_id)
    REQUEST.db.execute(SQL)
    dbres = REQUEST.db.fetchall()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output = []
    for row in dbres:
        txt = row[1].decode('UTF8').replace("\n", "<BR>")
        txt = txt.replace(":)", "<img src='%(BASE_ICON_URL)ssmileys/smile.gif' width='15' height='15' border='0' alt=''>" % locals())
        date = str(_Utils.utc2local_mx(REQUEST, row[3])).split(" ")[1].split(".")[0]
        output.append(u"""<b><font color="#0000FF">%s (%s):</font></b> %s<BR>""" % (row[2].decode('UTF8'), date, txt))
        try:
            REQUEST.db.execute("DELETE from im where msg_id=%d" % row[0])
        except:
            pass
    if not output:
        return " "
    return "\n".join(output)

def reminder_contents(REQUEST):
    event_id = int(REQUEST.form['event_id'].value)
    event = _RootObject.dispatch_item(REQUEST, event_id)

    tls_reminder = REQUEST.TLS('cal_reminder')
    tls_start = REQUEST.TLS('cal_starttime')
    tls_end = REQUEST.TLS('cal_endtime')
    tls_close = REQUEST.TLS('tls_closewin')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL

    now = _Utils.utc_now_mx()
    event.set('last_reminder', now)
    event.save()
    event_name = event.get('event_name')
    event_desc = event.get('description')
    start_time = REQUEST.iso2usertime(REQUEST, event.get('start_stamp'))
    end_time = REQUEST.iso2usertime(REQUEST, event.get('end_stamp'))
    output = []
    output.append(standard_html.html_header_popup(REQUEST, "", "onload='window.focus();'"))
    output.append(u"""\
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_reminder)s</span></TD>
</TR>
</TABLE>
<BR>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD colspan="4" class="td_listing0b">%(event_name)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing0">%(tls_start)s</TD>
  <TD class="td_listing0b">%(start_time)s</TD>
  <TD class="td_listing0">%(tls_end)s</TD>
  <TD class="td_listing0b">%(end_time)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD colspan="4" class="td_listing0b">%(event_desc)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD align="center" width="100%%"><input type="button" value="%(tls_close)s" class="input2" onclick="window.close()"></TD>
</TR>
</TABLE>
<BGSOUND id="BGSOUND_ID" LOOP=1 SRC="%(BASE_WEB_URL)sevent_notify.wav">
<script type="text/javascript">
if (navigator.mimeTypes["audio/x-wav"].enabledPlugin.name)               
{
    document.write('<EMBED NAME="notify" SRC="%(BASE_WEB_URL)sevent_notify.wav" LOOP=FALSE AUTOSTART=TRUE HIDDEN=TRUE MASTERSOUND>');
}
</script>
""" % locals())
    output.append(standard_html.html_footer3(REQUEST))
    return '\n'.join(output)