MY_MENU_ID=5

from mod_python import apache

import _Conf, standard_html
from Menus import get_opportunities_menu
import _Opportunity, _InitTypes, _Utils, _Access, urllib, relations, custom_fields, _RootObject, _Client

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""
    
    try:
      country_setting = REQUEST.get_setting('client_country')
    except:
      country_setting = ''
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addopp = REQUEST.TLS('opp_add')
    tls_name = REQUEST.TLS('tls_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_client = REQUEST.TLS('opp_client')
    tls_owner = REQUEST.TLS('client_owner')
    tls_nextstep = REQUEST.TLS('opp_nextstep')
    tls_stage = REQUEST.TLS('opp_stage')
    tls_probability = REQUEST.TLS('opp_probability')
    tls_closedate = REQUEST.TLS('opp_date')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_lead = REQUEST.TLS('opp_source')
    tls_description = REQUEST.TLS('tls_description')
    tls_req = REQUEST.TLS('opp_req_desc')
    tls_lost_reason = REQUEST.TLS('opp_lost_reason')
    tls_save = REQUEST.TLS('tls_save')
    tls_choose = REQUEST.TLS('email_choose')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_new = REQUEST.TLS('tls_new')

    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.* FROM persons p, items i WHERE p.person_id=i.item_id %s ORDER BY p.first_name, p.last_name""" % (right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    creator_name = u"""<SELECT name="creator_name">"""
    for row in dbres:
        if row['person_id'] == REQUEST.USER.get_id():
          sel = " SELECTED"
        else:
          sel = ""
        creator_name += """<option value="%s"%s>%s %s</option>""" % (row['person_id'], sel, row['first_name'].decode('UTF8'), row['last_name'].decode('UTF8'))
    creator_name += u"""</SELECT>"""

    client_type = _Utils.make_setting_selection(REQUEST, None, 'client_type', 'opportunity_client_type', is_multiple=0, selected="", style="textfield4")
    lead_source = _Utils.make_setting_selection(REQUEST, None, 'lead_source', 'opportunity_lead_source', is_multiple=0, selected="", style="textfield4")
    lost_reason = _Utils.make_setting_selection(REQUEST, None, 'opp_lost', 'opportunity_lost_reason', is_multiple=0, selected="", style="textfield4")


    def kala(a,b):
      if a=='':
        return -1
      elif b=='':
        return 1
      elif int(a)==0:
        return 1
      elif int(b)==0:
        return -1
      elif int(a)>int(b):
        return 1
      else:
        return -1

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    stage = u"""<select name="opp_stage" onchange="prob(this.value)" class="textfield4">"""
    keys = stages.keys()
    keys.sort(kala)
    for key in keys:
      stage = stage + u"""<option value="%s">%s</option>""" % (key, stages[key])
    stage = stage + u"""</select>"""


    datecheck_js = REQUEST.datecheck_js(REQUEST)

    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(standard_html.window_script(height=500,width=500))
    c_fields = custom_fields.get_object_search_fields(REQUEST, REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id(), _InitTypes.ITEM_TYPE_OPPORTUNITY, 0)

    client_id = ""
    client_name = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
        try:
            rel_item = int(REQUEST.form['rel_id'].value)
            rel_obj = _RootObject.dispatch_item(REQUEST, rel_item)
            if rel_obj.get('item_type_id') == _InitTypes.ITEM_TYPE_CLIENT:
                client_id = rel_obj.get_id()
                client_name = rel_obj.get('item_name')
        except:
            raise
            pass
    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
function check_values()
{
  if (!document.addform.opp_name.value||!document.addform.creator_name.value||(!(document.addform.client_id.value||document.addform.client_name.value))||!document.addform.close_date.value||document.addform.opp_stage.value=="")
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
function prob(val)
{
  el1 = document.getElementById('91');
  if(val=="0")
  {
    el1.style.display='block';
  }
  else
  {
    el1.style.display='none';
  }
  document.forms['addform'].probability.value=val;
}
function add_new()
{
  t = document.forms['addform']['client_name'];
  h = document.forms['addform']['client_id'];
  b1 = document.forms['addform']['b_choose'];
  b2 = document.forms['addform']['b_new'];
  t.value = "";
  t.readOnly = false;
  h.value = "";
  b1.style.display='none';
  b2.style.display='none';
  t.focus();
  dd = document.getElementById('cc');
  dd.style.display="inline";
}
function clear_new()
{
  t = document.forms['addform']['client_name'];
  h = document.forms['addform']['client_id'];
  b1 = document.forms['addform']['b_choose'];
  b2 = document.forms['addform']['b_new'];
  t.value = "";
  t.readOnly = true;
  h.value = "";
  b1.style.display='inline';
  b2.style.display='inline';
  dd = document.getElementById('cc');
  dd.style.display="none";
}
%(datecheck_js)s
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_19.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_addopp)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_OPPORTUNITIES_URL)soppadd.py/add" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
    <TD class="td_listing1ve" nowrap><INPUT type="text" class="textfield4" name="opp_name" value=""></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_owner)s:</TD>
    <TD class="td_listing1ve" nowrap>%(creator_name)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_client)s:</TD>
    <TD class="td_listing0ve" nowrap><INPUT type="hidden" name="client_id" value="%(client_id)s"><INPUT type="text" class="textfield1" size="15" readonly name="client_name" value="%(client_name)s"> <input type="button" class="input6" name="b_choose" value="%(tls_choose)s" onclick="open_window('%(BASE_OPPORTUNITIES_URL)sclient_pop.py')">&nbsp;<input type="button" name="b_new" class="input6" value="%(tls_new)s" onclick="add_new();"><div id="cc" style="display: none;"><input type="button" class="input6" name="bb_choose" value="%(tls_choose)s" onclick="clear_new();open_window('%(BASE_OPPORTUNITIES_URL)sclient_pop.py')"></div></TD>
    <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_closedate)s:</TD>
    <TD class="td_listing0ve" nowrap><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="close_date" id="close_date" value="">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('close_date', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_stage)s:</TD>
    <TD class="td_listing1ve" nowrap>%(stage)s</TD>
    <TD class="td_listing1ke" nowrap>%(tls_probability)s:</TD>
    <TD class="td_listing1ve" nowrap><INPUT type="text" readonly class="textfield4_readonly" size=2 name="probability" value="">%%</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0ke" nowrap>%(tls_type)s:</TD>
    <TD class="td_listing0ve" nowrap>%(client_type)s</TD>
    <TD class="td_listing0ke" nowrap>%(tls_lead)s:</TD>
    <TD class="td_listing0ve" nowrap>%(lead_source)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1ke" nowrap>%(tls_amount)s:</TD>
    <TD class="td_listing1ve" nowrap>%(c_pre)s <INPUT type="text" class="textfield4" name="amount" value=""> %(c_suf)s</TD>
    <TD class="td_listing1ke" nowrap>%(tls_nextstep)s:</TD>
    <TD class="td_listing1ve" nowrap><INPUT type="text" class="textfield4" name="opp_next_stage" value=""></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD class="td_listing0b" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="description" rows="8" cols="40"></TEXTAREA></TD>
    <TD class="td_listing0b" colspan="2">%(tls_req)s<BR><TEXTAREA class="textarea5" name="req_descr" rows="8" cols="40"></TEXTAREA></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="5">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0" style="display:none" id="91">
      <TR class="tr_listing1">
        <TD class="td_listing1ke" nowrap>%(tls_lost_reason)s</TD>
        <TD class="td_listing1ve">%(lost_reason)s</TD>
        <TD  class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
    </TD>
  </TR>
%(c_fields)s
  <TR class="tr_listing0">
    <TD class="td_listing_noborder" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
    <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('opp_name') and REQUEST.form['opp_name'].value.decode('UTF8').strip() and REQUEST.form.has_key('creator_name') and REQUEST.form['creator_name'].value.decode('UTF8').strip() and (REQUEST.form.has_key('client_id') and REQUEST.form['client_id'].value.decode('UTF8').strip() or REQUEST.form.has_key('client_name') and REQUEST.form['client_name'].value.decode('UTF8').strip()) and REQUEST.form.has_key('close_date') and REQUEST.form['close_date'].value.decode('UTF8').strip():
        if not (REQUEST.form.has_key('client_id') and REQUEST.form['client_id'].value.decode('UTF8').strip()):
            client = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_NEW)
            client.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
            client.set('client_name', REQUEST.form['client_name'].value.decode('UTF8').strip())
            client.save()
            client_id = client.get_id()
        else:
            client_id = REQUEST.form['client_id'].value.decode('UTF8').strip()
        opp = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_REQ)
        opp.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
        opp.set('close_date', REQUEST.user2isodate(REQUEST, REQUEST.form['close_date'].value))
        opp.__itemdata__['creator_id'] =  int(REQUEST.form['creator_name'].value)
        opp.set('client_id', client_id)
        opp.save()
        custom_fields.save_custom_vals(REQUEST, opp.get_id())
        output.append(REQUEST.TLS('opp_saved'))
        if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
          rel_id = int(REQUEST.form['rel_id'].value)
          relations.add_relation(REQUEST, rel_id, opp.get_id())
        # check whether the opportunity has the related client as a relation, if not, we will add
        rels = relations.get_relations_by_id(REQUEST, opp.get_id())
        if REQUEST.form['client_id'].value not in rels:
            relations.add_relation(REQUEST, int(client_id), opp.get_id())
        if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
            REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
            return apache.HTTP_MOVED_TEMPORARILY
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    ref_url = _Conf.BASE_OPPORTUNITIES_URL + 'oppedit.py?opp_id=%s' % opp.get_id()
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
