import standard_html

import _Access, _InitTypes, _Conf, _Utils, _Opportunity

def index(REQUEST):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    opp_id = REQUEST.form['opp_id'].value
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_name = REQUEST.TLS('prod_name')
    tls_group = REQUEST.TLS('prod_group')
    tls_unit = REQUEST.TLS('prod_unit')
    tls_price = REQUEST.TLS('prod_price')

    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,250);
// -->
</SCRIPT>
""" % locals())

    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    word = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PRODUCT])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = REQUEST.form['_word'].value.decode('UTF8').strip().lower()
    QUERY = """SELECT count(*) FROM products c, items i WHERE c.product_id=i.item_id %s AND (lower(c.product_name) like '%%%s%%' or lower(c.product_group) like '%%%s%%' or c.product_price like '%%%s%%')""" % (right_param, word, word, word)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sprod_pop.py%sqs=" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sprod_pop.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sprod_pop.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = _Utils.sql_quote_simple(REQUEST.form['_word'].value.decode('UTF8').strip().lower())
    SQL = """SELECT c.*, i.* FROM products c, items i WHERE c.product_id=i.item_id %s AND (lower(c.product_name) like '%%%s%%' or lower(c.product_group) like '%%%s%%' or c.product_price like '%%%s%%') ORDER BY product_name LIMIT %d OFFSET %d""" % (right_param, word, word, word, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    output.append(u"""
<TABLE border="0" width="100%%" cellpadding=0 cellspacing=0>
  <TR>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing0" colspan="4" align="center"><form method="POST" action="%(BASE_OPPORTUNITIES_URL)sprod_pop.py"><input type="hidden" name="opp_id" value="%(opp_id)s"><input name="_word" type="text" class="textfield1" value="%(word)s"> <input name="_search" class="input6" type="submit" value="%(tls_search)s"></FORM></TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
    <TD class="td_listing1b" width="35%%">%(tls_name)s</TD>
    <TD class="td_listing1b" width="35%%">%(tls_group)s</TD>
    <TD class="td_listing1b" width="15%%">%(tls_unit)s</TD>
    <TD class="td_listing1b" width="15%%">%(tls_price)s</TD>
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
""" %locals())
    index = 0
    for result in dbresult:
        if(index % 2 == 0):
            td_class='td_listing0'
        else:
            td_class='td_listing1'
        index = index + 1
        ns = {}
        ns['product_name'] = _Utils.html_quote_show(result['product_name'].decode('UTF8'))
        ns['product_group'] = _Utils.html_quote_show(result['product_group'].decode('UTF8'))
        ns['product_unit'] = _Utils.html_quote_show(result['product_unit'].decode('UTF8'))
        if result['product_price']:
            ns['product_price'] = (c_pre + str(result['product_price'] and "%.2f" % result['product_price']) + c_suf) or '&nbsp;'
        else:
            ns['product_price'] = ""
        ns['product_id'] = result['product_id']
        ns['td_class'] = td_class
        ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        ns['BASE_OPPORTUNITIES_URL'] = _Conf.BASE_OPPORTUNITIES_URL
        ns['opp_id'] = opp_id

        output.append(u"""
  <TR>
    <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
    <TD class="%(td_class)s"><A class="blacklink" href="%(BASE_OPPORTUNITIES_URL)sprod_pop.py/add?opp_id=%(opp_id)s&prod_id=%(product_id)s">%(product_name)s</A></TD>
    <TD class="%(td_class)s"><A class="blacklink" href="%(BASE_OPPORTUNITIES_URL)sprod_pop.py/add?opp_id=%(opp_id)s&prod_id=%(product_id)s">%(product_group)s</A></TD>
    <TD class="%(td_class)s">%(product_unit)s</TD>
    <TD class="%(td_class)s">%(product_price)s</TD>
    <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>""" % ns)
    output.append(u"""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add(REQUEST):
    if not REQUEST.form.has_key('prod_id') or not REQUEST.form['prod_id'].value or not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    opp_obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))
    opp_id = opp_obj.get_id()
    prod_id = int(REQUEST.form['prod_id'].value)
    REQUEST.db.execute("""SELECT * FROM products WHERE product_id=%(prod_id)d""" % locals())
    res = REQUEST.db.dictfetchone()
    success = opp_obj.add_product(res['product_id'], 1, (res['product_price'] or 0), "")
    if success == -1:
        raise RuntimeError, REQUEST.TLS('opp_product_exists')
    opp_obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, opp_id)
    REQUEST.db.execute("""SELECT price, amount from opp_products WHERE opp_id=%(opp_id)d""" % locals())
    res = REQUEST.db.fetchall()
    sum = 0.0
    for row in res:
        sum = sum + row[0]*row[1]
    opp_obj.set('amount', sum)
    opp_obj.save()
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    output.append("""
<SCRIPT type="text/javascript">
<!--
window.opener.location.href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s";
window.close();
// -->
</SCRIPT>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)