MY_MENU_ID=0

import _Conf, standard_html
from Menus import get_products_menu
import _Access, _InitTypes, _Product, _Utils

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))

    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            prod_obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            prod_obj.delete()

    tls_name = REQUEST.TLS('prod_name')
    tls_group = REQUEST.TLS('prod_group')
    tls_unit = REQUEST.TLS('prod_unit')
    tls_price = REQUEST.TLS('prod_price')
    tls_delete = REQUEST.TLS('tls_delete')
    tls_confirm_del = REQUEST.TLS('email_confirm_del')
    tls_filter = REQUEST.TLS('tls_filter')
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    filter = ""
    search_params = ""
    if REQUEST.form.has_key('filter') and REQUEST.form['filter'].value.decode('UTF8').strip():
        filter = REQUEST.form['filter'].value.decode('UTF8').strip()
        w = _Utils.sql_quote_simple(REQUEST.form['filter'].value.decode('UTF8').strip().lower())
        if len(w)>=3:
            search_params = u""" AND i.item_id in (SELECT item_id FROM fti_search WHERE word = '%s' and fti_type=true)""" % w
        else:
            search_params = u""" AND (
lower(p.product_name) like '%%%s%%' OR 
lower(p.product_group) like '%%%s%%' OR 
lower(p.product_unit) like '%%%s%%' OR 
lower(p.product_price) like '%%%s%%' OR 
lower(p.description) like '%%%s%%')""" % (w,w,w,w,w)


    sortby = [
'product_group ASC, product_name ASC', 'product_group DESC, product_name ASC',
'product_name ASC', 'product_name DESC',
'product_unit ASC', 'product_unit DESC',
'product_price ASC', 'product_price',
]
    DEFAULT_SORTBY = 2
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    sortby_group = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=0">%s</A>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_group)
    sortby_name = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=2">%s</A>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_name)
    sortby_unit = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=4">%s</A>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_unit)
    sortby_price = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=6">%s</A>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_price)
    if sortby_id == 0:
        sortby_group = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=1">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_group)
    elif sortby_id == 1:
        sortby_group = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=0">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_group)
    elif sortby_id == 2:
        sortby_name = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=3">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_name)
    elif sortby_id == 3:
        sortby_name = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=2">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_name)
    elif sortby_id == 4:
        sortby_unit = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=5">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_unit)
    elif sortby_id == 5:
        sortby_unit = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=4">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_unit)
    elif sortby_id == 6:
        sortby_price = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=7">%s</A><SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_price)
    elif sortby_id == 7:
        sortby_price = u"""<A class="blackboldlink" href="%sproducts.py%ssort_by=6">%s</A><SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_PRODUCTS_URL, formstring, tls_price)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PRODUCT])
    if right_param:
        right_param = " AND " + right_param


    QUERY = """SELECT count(*) AS count_all FROM products p, items i WHERE p.product_id=i.item_id %s%s""" % (right_param, search_params)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sproducts.py%sqs=" % (_Conf.BASE_PRODUCTS_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sproducts.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_PRODUCTS_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sproducts.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_PRODUCTS_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    SQL = """SELECT p.*, i.parent_id, i2.item_name as creator_name FROM products p, items i, items i2 WHERE p.product_id=i.item_id and i.creator_id=i2.item_id %s%s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, search_params, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    tls_products = REQUEST.TLS('topmenu_products')
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan=7 width="100%%">
    <TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
    <FORM method="post" action="%(BASE_PRODUCTS_URL)sproducts.py">
      <TR>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
          <TD><span class="t3">%(tls_products)s</span></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdnrk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="3" height="20" border=0 alt=""></TD>
          <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_filter)s:</b>&nbsp;</TD>
          <TD class="th_listing" align="center" nowrap><input type="text" name="filter" class="textfield_filter" value="%(filter)s">&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdnrk2.gif')"><input type="image" src="%(BASE_ICON_URL)sspacer.gif" width="3" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
      </TR>
    </FORM>
    </TABLE>
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD width="1%%"  class="td_listing1">&nbsp;</TD>
  <TD width="32%%" class="td_listing1b">%(sortby_name)s</TD>
  <TD width="32%%" class="td_listing1b">%(sortby_group)s</TD>
  <TD width="20%%" class="td_listing1b">%(sortby_unit)s</TD>
  <TD width="20%%" class="td_listing1b">%(sortby_price)s</TD>
</TR>""" % locals())
    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_PRODUCTS_URL'] = _Conf.BASE_PRODUCTS_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['product_name'] = _Utils.html_quote((item['product_name'] or "").decode('UTF8'))
        item['product_group'] = _Utils.html_quote((item['product_group'] or "").decode('UTF8'))
        item['product_unit'] = _Utils.html_quote((item['product_unit'] or "").decode('UTF8'))
        item['owner'] = (item['creator_name'] or "").decode('UTF8')
        if item['product_price']:
          item['product_price']= c_pre + "%.2f" % item['product_price'] + c_suf
        else: 
          item['product_price']="&nbsp;"
        output.append(u"""
<TR>
  <TD class="td_listing%(class_type)d"><INPUT type="checkbox" name="sel_%(product_id)d"></TD>
  <TD class="td_listing%(class_type)d"><A class="td_listing" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)d">%(product_name)s</A></TD>
  <TD class="td_listing%(class_type)d" nowrap><A class="td_listing" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)d">%(product_group)s</A></TD>
  <TD class="td_listing%(class_type)d">%(product_unit)s</TD>
  <TD class="td_listing%(class_type)d">%(product_price)s</TD>
</TR>""" % item)
    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  <TD width="100%%" align="right"><INPUT type="submit" class="input2" name="_delete" value="%(tls_delete)s" onClick="return confirm('%(tls_confirm_del)s');"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
<BR>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

